# load all data needed to compute score (i.e. gold standard, "toxCompoundsID", "pooled_std" and scores precomputed for submissions in the final leaderboard
load("data/data_sch1.RData")
source("prob_Cidx.R") # could be in functionLeaderboard.R but must be here for the Python script to work
# source all functions needed for scoring
source("functionsLeaderboard_sch1.R")

# some test submissions
load("testSubmissions_sch1.RData")


## function 'computeByCompound' can be used to compute metrics for each submssion for each compound
# example1, compute pearson correlation for a random submission
scoreByCompound<-computeByCompound(submission=randomSubmission1, observed=observed, metric="pearson", keepCompounds=toxCompoundsID)
# example2, compute prob C-index for the best Performer (note: prob C-index computation takes some time)
scoreByCompound<-computeByCompound(submission=bestPerformer, observed=observed, metric="probCindex", keepCompounds=toxCompoundsID, pooled_std=pooled_std)

# function 'computeOverallScores' can be used to compute ranking of submissions and average performances (as in the final lieaderboard)
# takes some time to run because of prob C-index computation
submissions<-list(bestPerformer=bestPerformer, randomSubmission1=randomSubmission1, greatSubmission=greatSubmission)
res <- computeOverallScores(submissions)

# ------------------------------------------------------------------------------------------------
# AUTHOR:      Michael Patrick Menden
# SUPERVISOR:  Julio Saez-Rodriguez
# AFFILIATION: EMBL-EBI
# LIZENS:      GPL
# ------------------------------------------------------------------------------------------------

# Gauss error function
pCIdx_erf <- function(x) {
  2/sqrt(pi) * integrate(f=function(t) {exp(-t^2)}, 0, x)$value
}

# ------------------------------------------------------------------------------------------------
# Cumulative distribution function
pCIdx_CDF <- function(u,v,s) {
  0.5 * (1 + pCIdx_erf(abs(u-v) / (2*s)))
}

# ------------------------------------------------------------------------------------------------
# Probabilistic C-Index 
# E   => 	Vector of continuous experimentally determined values, e.g. EC10.
# s	=>	Scalar representing the pooled standard deviation for E.
# P	=>	Vector containing the predicted rank of E. 
pCIdx <- function(E,s,P) {
  runningSum <- 0
  n <- 0.5 * length(E) * (length(E)-1)
  for (i in 1:(length(E)-1)) {
    for (j in (i+1):length(E)) {
      if ((E[i]>E[j] & P[i]>P[j]) | (E[i]<E[j] & P[i]<P[j])) {
        runningSum <- runningSum + pCIdx_CDF(E[i], E[j], s)
      } else if ((E[i]>E[j] & P[i]<P[j]) | (E[i]<E[j] & P[i]>P[j])) {
        runningSum <- runningSum + 1 - pCIdx_CDF(E[i], E[j], s)
      } else {
        runningSum <- runningSum + 0.5
      }
    }
  }
  runningSum/n
}

# ------------------------------------------------------------------------------------------------
# Cumulative distribution function
pCIdx_CDF_GS <- function(u,v,s) {
  0.5 * (1 + pCIdx_erf((u-v)/(2*s)))
}

# ------------------------------------------------------------------------------------------------
# Probabilistic C-Index (from gustavo's pseudo code)
# E   =>   Vector of continuous experimentally determined values, e.g. EC10.
# s	=>	Scalar representing the pooled standard deviation for E.
# P	=>	Vector containing the predicted rank of E. 
pCIdx_GS <- function(E,s,P) {
  runningSum <- 0
  n <- 0.5 * length(E) * (length(E)-1)
  for (i in 1:(length(E)-1)) {
    for (j in (i+1):length(E)) {
      if (P[i] > P[j]) {
        runningSum <- runningSum + pCIdx_CDF_GS(E[i], E[j], s)
      } else if (P[i] < P[j]) {
        runningSum <- runningSum + pCIdx_CDF_GS(E[j], E[i], s)
      } else if (P[i] == P[j]) {
        runningSum <- runningSum + 0.5
      }
    }
  }
  runningSum/n
}

# ------------------------------------------------------------------------------------------------
# Pooled standard deviation
# R => matrix of replicates. On the columns are the experimental entities, in the rows are the replicates
pooled_sd <- function(R) {
  v <- apply(R, 2, function(x) var(x, na.rm=T))
  n <- apply(R, 2, function(x) sum(!is.na(x)) - 1)
  v <- v[n>0]
  n <- n[n>0]
  sqrt(sum(n * v) / sum(n))
}

# ------------------------------------------------------------------------------------------------
# Test cases: good prediction should be 1

# ---------------------------
# DEMO: good prediction
# ---------------------------

# experimental value
E <- runif(200)

# generated sparse replicates with noise
nRep <- 3
R <- matrix(NA, nrow=nRep, ncol=length(E))
for (i in 1:nRep) {
  R[i,] <- E + runif(length(E), min=-0.1, max=0.1)
  R[i,sample(200, 10)] <- NA
}

# calculated pooled standard deviation
s <- pooled_sd(R)

# good prediction 
P_good <- rank(E)
pCIdx(E,s,P_good)
pCIdx_GS(E,s,P_good)

# random prediction
P_random <- rank(E[sample(200)])
pCIdx(E,s,P_random)
pCIdx_GS(E,s,P_random)

# inverse prediction
P_inverse <- rank(-E)
pCIdx(E,s,P_inverse)
pCIdx_GS(E,s,P_inverse)

# plot predicted versus observed ranking
plot(E, P_good, ylab="P", col='#0000FF55', pch=16, main='probabilistic C-Index (pC)')
points(E, P_random, col='#FF000055', pch=16)
points(E, P_inverse, col='#FFFF0055', pch=16)
label <- paste(c('good', 'random', 'inverse'), ' (pC=',
               formatC(c(pCIdx(E,s,P_good), pCIdx(E,s,P_random), pCIdx(E,s,P_inverse)), digits=2), ")", sep="")
legend("topleft", title="prediction:", label, pch = 16, col=c('#0000FF55', '#FF000055', '#FFFF0055'))

# compute ranking of teams and average performance, based on the selected metric
# submission: list with one submission per element

computeOverallScores <- function (submissions){
  
  keepCompounds<-toxCompoundsID

  # compute the compoud by compound score for all submission
  # and create a matrix with compounds as columns and submissions as rows
  scores<-list()
  metric<-"pearson"
  scores$pearson<-do.call(rbind, lapply(X=submissions, FUN=computeByCompound, observed=observed, metric=metric, keepCompounds=keepCompounds, pooled_std=pooled_std))
  metric<-"probCindex"
  scores$probCindex<-do.call(rbind, lapply(X=submissions, FUN=computeByCompound, observed=observed, metric=metric, keepCompounds=keepCompounds, pooled_std=pooled_std))
  
  #
  pearson<-list()
  probCindex<-list()
  
  # compute average and best score for each submission across compounds
  pearson$scores.average<-apply(scores$pearson, 1, function(x) mean(x, na.rm=T))
  probCindex$scores.average<-apply(scores$probCindex, 1, function(x) mean(x, na.rm=T))
  
  # the best score is the max value 
  pearson$scores.best<-apply(scores$pearson, 1, function(x) max(x, na.rm=T))
  probCindex$scores.best<-apply(scores$probCindex, 1, function(x) max(x, na.rm=T))

  # consider also the leaderboard scores for the desired metric in order to compute the overall rank
  # have to invert the sign of just computed scores to compute the rank
  pearson$scoresAll<-rbind(-scores$pearson, leaderboardScores$pearson)
  probCindex$scoresAll<-rbind(-scores$probCindex, leaderboardScores$probCindex)
  
  # compute rank of teams for each compound
  pearson$compRanking <- apply(pearson$scoresAll, 2, rank)
  probCindex$compRanking <- apply(probCindex$scoresAll, 2, rank)
  
  #compute the mean ranking of each team across compounds
  pearson$meanRanking <- apply(pearson$compRanking, 1, mean)
  probCindex$meanRanking <- apply(probCindex$compRanking, 1, mean)
  
  #compute the final ranking of each team across compounds
  pearson$finalRanking <- rank(pearson$meanRanking)
  probCindex$finalRanking <- rank(probCindex$meanRanking)
  
  N<-length(submissions)
  meanRank<-apply(cbind(pearson$finalRanking, probCindex$finalRanking),1,mean)
  finalRank<-rank(meanRank)
  summaryScores<-data.frame(meanPCI=probCindex$scores.average, maxPCI=probCindex$scores.best, meanRankPCI=probCindex$meanRanking[1:N], rankPCI=probCindex$finalRanking[1:N],
                      meanPC=pearson$scores.average, maxPC=pearson$scores.best, meanRankPC=pearson$meanRanking[1:N], rankPC=pearson$finalRanking[1:N],
                      meanRank=meanRank[1:N], finalRank=finalRank[1:N])
  
  print(summaryScores)
  
  res<-list(byCompoundScores=scores, summaryScores=summaryScores)
  return(res)
  
}


# compute metrics for each compound of each submission
# INPUT:
# submission: prediction matrix (264 rows, 106 columns)
# observed: test data (264 rows, 106 columns)
# metric: metric to be used, can be "pearson" or "probCindex"
# keepCompounds: specify compounds to use, if NA all compounds are considered, use "toxCompoundsID" to include the compounds used in the Leaderboard
# OUTPUT:
# score computed for each compound
computeByCompound <- function (submission, observed, metric, keepCompounds=NA, pooled_std=NA){
  
  if (!is.na(keepCompounds[1])){
    observed <- observed[,keepCompounds]
    submission <- submission[,keepCompounds]
    pooled_std <- pooled_std[keepCompounds]
  }
  
  # convert to lists with one element per compound
  observed.l<-as.list(as.data.frame(as.matrix(observed), stringsAsFactors=F))
  submission.l<-as.list(as.data.frame(as.matrix(submission), stringsAsFactors=F))
  
  # consider metric as a function and compute it for each compound
  if (metric=="probCindex"){
    pooled_std.l<-as.list(pooled_std)
    metric <- match.fun(metric)
    performance_byCompound<-mapply(metric, observed=observed.l, predicted=submission.l, pooled_std=pooled_std.l)
    
  }else{
    metric <- match.fun(metric)
    performance_byCompound<-mapply(metric, observed=observed.l, predicted=submission.l)
  }
  
  return(performance_byCompound)
}


# fuction to compute the pearson correlation 
pearson <- function(observed, predicted){
  if (!is.na(predicted) && length(unique(predicted))>1){
    cor(observed, predicted, method="pearson")
  }else{
    0
  }
}

# fuction to compute the probCindex
# function to compute prob c-Index
#source("prob_Cidx.R")
probCindex <- function(observed, predicted, pooled_std){
  # compute pCIdx
  pCIdx_GS(observed, pooled_std, rank(predicted, ties.method="random"))
}

# source all functions needed for scoring
source("functionsLeaderboard_sch2.R")

# some test submissions
load("testSubmissions_sch2.RData")

# load all data that I need to compute score (i.e. gold standard and scores precomputed for submissions in the final leaderboard)
load("data/data_sch2.RData")


## function 'computeMetric' can be used to compute metrics for each submssion for predicted median and interquantile distance
# example1, compute pearson correlation for a random submission
scoreByCompound<-computeMetric(submission=randomSubmission1, observed=observed, metric="pearson")
# example2, compute spearman correlation for the best Performer (note: prob C-index computation takes some time)
scoreByCompound<-computeMetric(submission=bestPerformer, observed=observed, metric="spearman")


# function 'computeOverallScores' can be used to compute ranking of submissions and average performances (as in the final lieaderboard)
submissions<-list(bestPerformer=bestPerformer, randomSubmission1=randomSubmission1, greatSubmission=greatSubmission)
res <- computeOverallScores(submissions)

# compute ranking of submissions and average performances
# submission: list with one submission per element

computeOverallScores <- function (submissions){
  
  # compute the score for all submission separately for predicted median and interquantile distance
  # and create a matrix with population parameters (i.e. median and interquantile distance) as columns and submissions as rows
  scores<-list()
  metric<-"pearson"
  scores$pearson<-do.call(rbind, lapply(X=submissions, FUN=computeMetric, observed=observed, metric=metric))
  metric<-"spearman"
  scores$spearman<-do.call(rbind, lapply(X=submissions, FUN=computeMetric, observed=observed, metric=metric))
  
  #
  pearson<-list()
  spearman<-list()
  
  # consider also the leaderboard scores for the desired metric in order to compute the overall rank
  # have to invert the sign of just computed scores to compute the rank
  pearson$scoresAll<-rbind(-scores$pearson, -leaderboardScores$pearson)
  spearman$scoresAll<-rbind(-scores$spearman, -leaderboardScores$spearman)
  
  
  # compute rank of teams separately for median and interquantile distance
  pearson$compRanking <- apply(pearson$scoresAll, 2, rank)
  spearman$compRanking <- apply(spearman$scoresAll, 2, rank)
  
  #compute the mean ranking of each team separately for median and interquantile distance
  pearson$meanRanking <- apply(pearson$compRanking, 1, mean)
  spearman$meanRanking <- apply(spearman$compRanking, 1, mean)
  
  #compute the final ranking of each team separately for median and interquantile distance
  pearson$finalRanking <- rank(pearson$meanRanking)
  spearman$finalRanking <- rank(spearman$meanRanking)
  
  N<-length(submissions)
  
  # compute final rank (as average of the rank using the 2 metrics)
  meanRank<-apply(cbind(pearson$finalRanking, spearman$finalRanking),1,mean)
  finalRank<-rank(meanRank)
  
  summaryScores<-data.frame(rankSC=spearman$finalRanking[1:N], SC_m=scores$spearman[,1], SC_q=scores$spearman[,2],
                            rankPC=pearson$finalRanking[1:N], PC_m=scores$pearson[,1], PC_q=scores$pearson[,2],
                            meanRank=meanRank[1:N], finalRank=finalRank[1:N])
    
  print(summaryScores)
  
  res<-summaryScores
  return(res)
  
}


# compute metrics for each submssion for predicted median and interquantile distance
# INPUT:
# submission: prediction matrix (50 rows, 2 columnds)
# observed: test data (50 rows, 2 columnds)
# metric: metric to be used, can be "pearson" or "spearman"
# OUTPUT:
# score computed for predicted population parameter (i.e. median and interquantile distance)
computeMetric <- function (submission, observed, metric){
  
  # convert to lists with one element per compound
  observed.l<-as.list(as.data.frame(as.matrix(observed), stringsAsFactors=F))
  submission.l<-as.list(as.data.frame(as.matrix(submission), stringsAsFactors=F))
  
  # consider metric as a function and compute it for each compound
  metric <- match.fun(metric)
  performance<-mapply(metric, observed=observed.l, predicted=submission.l)
  
  return(performance)
}


# fuction to compute the pearson correlation 
pearson <- function(observed, predicted){
  if (!is.na(predicted) && length(unique(predicted))>1){
    cor(observed, predicted, method="pearson")
  }else{
    0
  }
}

# fuction to compute the pearson correlation 
spearman <- function(observed, predicted){
  if (!is.na(predicted) && length(unique(predicted))>1){
    cor(observed, predicted, method="spearman")
  }else{
    0
  }
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

rm.na.levels <- function(data, prednames=NULL) {
  factor.names <- names(data)[sapply(1:ncol(data), function(k) {is.factor(data[ , k])})]
  if (!is.null(prednames)) factor.names <- intersect(factor.names , prednames)
  if (length(factor.names) > 0) {
    levels.na.pt <- sapply(1:length(factor.names), function(k) {
        any(levels(data[ , names(data) == factor.names[k]]) == "NA")
    })
    if (any(levels.na.pt)) {
      factor.names <- factor.names[levels.na.pt]
      for (k in 1:length(factor.names)) {
        x <- data[ , names(data) == factor.names[k]]
        levels(x)[levels(x) == "NA"]  <- NA
        data[ , names(data) == factor.names[k]] <- x
      }
    }
  }
  data
}  
extract.factor <- function(data, prednames=NULL) {
  predictorType  <- xfactor.levels <- xfactor.order.levels <- NULL
  xfactor <- names(data)[sapply(1:ncol(data), function(k)
                  {is.factor(data[ , k]) && !is.ordered(data[ , k])})]
  xfactor.order <- names(data)[sapply(1:ncol(data), function(k) {is.ordered(data[ , k])})]
  if (!is.null(prednames)) xfactor <- intersect(xfactor , prednames)
  if (!is.null(prednames)) xfactor.order <- intersect(xfactor.order , prednames)
  if (length(xfactor) > 0) {
    xfactor.levels <- apply(cbind(1:(1+length(xfactor))), 1, function(k) {
        if (k <= length(xfactor)) {
          levels(data[ , names(data) == xfactor[k]])
        }
        else {
          NULL
        }
    })
    xfactor.levels <- xfactor.levels[-(1+length(xfactor))]
  }
  if (length(xfactor.order) > 0 ) {
    xfactor.order.levels <- sapply(1:(1+length(xfactor.order)), function(k) {
        if (k <= length(xfactor.order)) {
          levels(data[ , names(data) == xfactor.order[k]])
        }
        else {
          NULL
        }
    })
    xfactor.order.levels <- xfactor.order.levels[-(1+length(xfactor.order))]
  }
  if (!is.null(prednames)) {
    predictorType <- rep("R", length(prednames))
    if (length(xfactor) > 0) {
      predictorType[is.element(prednames, xfactor)] <- "C"
    }
    if (length(xfactor.order) > 0) {
      predictorType[is.element(prednames, xfactor.order)] <- "I"
    }
  }
  return(list(
    xfactor=xfactor,
    xfactor.order=xfactor.order,
    xfactor.levels=xfactor.levels,
    xfactor.order.levels=xfactor.order.levels,
    predictorType=predictorType
    ))              
}

#' Function to retrain one model originally trained using overall survival and train and evaluate using
#' disease specific survival
#'
#' @author Adam Margolin
#' @export

retrainOSModel <- function(modelEntityId_orig, trainingData=NULL){
  print("**********************************************************")
  print("**********************************************************")
  print(paste("retraining", modelEntityId_orig))
  print("**********************************************************")
  print("**********************************************************")
  
  if(is.null(trainingData)){
    trainingData <- loadMetabricTrainingData()
  }
  modelEntity_orig <- loadEntity(modelEntityId_orig)
  modelEntity_new <- restoreSessionAndCreateNewModelFromOSModel(modelEntity_orig)
  
  modelClass <- class(modelEntity_orig$objects$trainedModel)
  model_new <- new(modelClass)
  model_new$customTrain(trainingData$exprData, trainingData$copyData, trainingData$clinicalFeaturesData, trainingData$clinicalSurvData_ds)
  modelEntity_new <- addObject(modelEntity_new, model_new, "trainedModel")
  storeEntity(modelEntity_new)
}

ConstantTrain <- function(train.name,test.name,save.preds=TRUE,args=list(slope=-.9)) {
	# Returns a constant slope model
	#
	# Args:
	#	train.name: (unused) base name of training dataset
	#	test.name: base name of test dataset
	#   save.preds: save predictions to file? TRUE by default
	#	args: list of additional arguments including "slope", the constant 
	#		prediction
	#
	# Returns:
	#	Two column matrix, ordered by the first column, with first column 
	#   "subject.id" containing test set subject ids and the second column 
	#   "prediction" containing predicted slopes.
	#
	# Example usage:
	#	source("Code/Models/constant_predict.R")
	#	ConstantPredict("","train",list(slope=-.9))
	
	# Extract additional arguments
	slope = args[["slope"]]
		
	ConstantPredict <- function(test.name="test",save.preds=TRUE) {
		# Returns constant slope prediction for each subject
		#
		# Args:
		#	test.name: base name of test dataset
		#   save.preds: save predictions to file? TRUE by default
		#
		# Returns:
		#	Two column matrix, ordered by the first column, with first column 
		#   "subject.id" containing test set subject ids and the second column 
		#   "prediction" containing predicted slopes.
		
		# Get test data
		dataset <- GetRawData(test.name)
	
		# Form constant predictions
		subject.id<-unique(dataset$subject.id)

		predictions <- cbind(subject.id,rep(slope,length(subject.id)))
		colnames(predictions) <- c("subject.id","prediction")
	
		if(save.preds) {
			# Write predictions to file
			out.file = sprintf("Predictions/Constant_%g-%s.txt",slope,test.name)
			WritePredictions(predictions, out.file)
		}
		return(predictions)
	}
	return(ConstantPredict)
}

#' Package-local cache if we ever want to stash anything in a cache specific to this package
.cache <- new.env(parent=emptyenv())

#' Package-local cache getter
#'
#' @param key the key of the value to be returned
#' @return the value for that key or null
.getCache <-
		function(key)
{
	.cache[[key]]
}

#' Package-local cache setter
#'
#' @param key the key of the value to be cached
#' @param value the value to be cached
.setCache <-
		function(key, value)
{
	.cache[[key]] <- value
}

#' Package-local cache deleter
#'
#' @param key the key of the key/value pair to be deleted from the cache
.deleteCache <-
		function(keys)
{
	indx <- which(keys %in% ls(.cache))
	if(length(indx) > 0)
		rm(list=keys[indx], envir=.cache)
}

#' Package defaults
.onLoad <-
		function(libname, pkgname)
{
	.setCache("debug", FALSE)
}

setRefClass(Class = "PredictiveModel")

#' LinearModel
#'
#' Base class for linear models, adding a getCoefficients method to PredictiveModel
#'
#' @author Adam Margolin
#' @export
LinearModel <- setRefClass(Class="LinearModel",
                           contains="PredictiveModel",
                               methods = list(
                                  getCoefficients <- function(){
                                }
                              )
                           )

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

find.interaction <- function (
    object,# 
    predictorNames = NULL,#
    method = c("maxsubtree", "vimp")[1],#
    sorted = TRUE,#
    npred = NULL,#
    subset = NULL,#                              
    nrep  = 1,#
    rough = FALSE,#
    importance = c("randomsplit", "permute")[1],#
    seed = NULL,#
    do.trace = FALSE,#
    ...) {
    if (is.null(object)) stop("Object is empty!")
    if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2    &
        sum(inherits(object, c("rsf", "forest"), TRUE) == c(1, 2)) != 2)
       stop("This function only works for objects of class `(rsf, grow)' or '(rsf, forest)'.")
    if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) == 2) {
      if (is.null(object$forest)) 
        stop("Forest is empty!  Re-run grow call with forest set to 'TRUE'.")
    }
    if (method != "maxsubtree" &  method != "vimp")
       stop("Invalid choice for 'method':  " + importance)
    if (importance != "randomsplit" &  importance != "permute")
       stop("Invalid choice for 'importance':  " + importance)
    n.event  <- length(unique(na.omit(object$cens)[na.omit(object$cens) > 0]))
    if (n.event > 1) n.event <- n.event + 1
    cov.names <- object$predictorNames
    n.interact <- n.cov <- length(cov.names)
    if (!is.null(predictorNames)) {
      if (sum(is.element(cov.names, predictorNames)) == 0) {
           cat("Variables do not match original analysis:","\n")
           print(cov.names)
           stop()
      }
      predictorNames <- unique(predictorNames[is.element(predictorNames, cov.names)])
      if (length(predictorNames) == 1)
        stop("Pairwise comparisons require more than one candidate variable.")
      cov.names <- predictorNames
      n.interact <- length(predictorNames)
    }
    if (sorted) {
      if (!is.null(object$importance)) {
        if (n.event == 1) {
          o.r <- order(object$importance, decreasing = TRUE)
        }
        else {
          o.r <- order(object$importance[1, ], decreasing = TRUE)
        }
        cov.names <- cov.names[o.r]
      }
    }
    if (!is.null(npred)) {
      n.interact <- min(n.cov, max(round(npred), 1))
    }
    if (n.interact == 1) stop("Pairwise comparisons require more than one candidate variable.")
    if (method == "vimp") {
      rownames.interact.imp <- NULL
      interact.imp <- vector("list", n.event)
      for (k in 1:(n.interact-1)) {
        n.joint.cov <- n.interact-k
        imp <- matrix(0,1+n.joint.cov, n.event)
        imp.joint <- matrix(0,n.joint.cov, n.event)
        for (l in (k+1):n.interact) {
          cat("Pairing",cov.names[k],"with",cov.names[l],"\n")
          for (m in 1:nrep) {
            rsfOutput  <-  vimp(object, cov.names[c(k,l)], importance=importance,
                     subset=subset, joint=FALSE, rough=rough, seed=seed, do.trace=do.trace)
            rsfOutput.joint  <-  vimp(object, cov.names[c(k,l)], importance=importance,
                     subset=subset, rough=rough, seed=seed, do.trace=do.trace)
            imp[1,] <- imp[1,]+rbind(rsfOutput$importance)[,1]
            imp[l-k+1,] <- imp[l-k+1,]+rbind(rsfOutput$importance)[,2]
            imp.joint[l-k,] <- imp.joint[l-k,]+rsfOutput.joint$importance
          }
        }
        imp[1,] <- imp[1,]/n.joint.cov
        imp <- imp/nrep
        imp.joint <- imp.joint/nrep
        for (N in 1:n.event) {
          interact.imp[[N]] <- rbind(interact.imp[[N]],
                 cbind(imp.joint[,N],(imp[1,N]+imp[,N])[-1],imp.joint[,N]-(imp[1,N]+imp[,N])[-1]))
        }
        rownames.interact.imp <- c(rownames.interact.imp,
                                 paste(cov.names[k],":",cov.names[(k+1):n.interact],
                                 sep=""))
      }
      if (n.event == 1) {
        interact.imp <- interact.imp[[1]]
        colnames(interact.imp) <- c("Paired","Additive","Difference")
        rownames(interact.imp) <- rownames.interact.imp
      }
      else {
        for (N in 1:n.event) {
          colnames(interact.imp[[N]]) <- c("Paired","Additive","Difference")
          rownames(interact.imp[[N]]) <- rownames.interact.imp
        }
        names(interact.imp) <- c("CHF", paste("condCHF.", 1:(n.event - 1), sep = ""))
      }
      n.pairs <- length(rownames.interact.imp)
      cat("\n")
      cat("                      Technique used: ", method,              "\n", sep="")
      cat("                    No. of variables: ", n.cov,               "\n", sep="")
      cat("           Variables sorted by VIMP?: ", sorted,              "\n", sep="")
      cat("   No. of variables used for pairing: ", n.interact,          "\n", sep="")
      cat("    Total no. of paired interactions: ", n.pairs,             "\n", sep="")
      cat("            Monte Carlo replications: ", nrep,                "\n", sep="")
      cat("    Type of noising up used for VIMP: ", importance,          "\n", sep="")
      cat("                  Fast approximation: ", rough,               "\n", sep="")
      cat("\n")
      if (n.event == 1) print(round(interact.imp,4)) else print(interact.imp)
      invisible(interact.imp)
    }
    else {
      v <- max.subtree(object, sub.order = TRUE, max.order = 1)
      subOrder <- v$subOrder
      if (sorted) {
        o.r <- order(diag(subOrder), decreasing = FALSE)
        subOrder <- subOrder[o.r, o.r]
      }
      cov.pt <- is.element(colnames(subOrder), cov.names[1:n.interact])
      subOrder <- subOrder[cov.pt, cov.pt]
      cat("\n")
      cat("                      Technique used: ", method,              "\n", sep="")
      cat("                    No. of variables: ", n.cov,               "\n", sep="")
      cat("  Variables sorted by minimal depth?: ", sorted,              "\n", sep="")
      cat("\n")
      print(round(subOrder, 2))
      invisible(subOrder)
    }
}

GenCvData<-function(data.name,num.cv,random.seed="123") {

	# Generates and saves cross validation datasets for an input dataset in
	# paste("Data/",data.name,".rda",sep="")
	#
	# Args: 
	# 	data.name: base name of RDA file in Data folder; file must contain a
	#   	single variable; the variable must be a dataframe with the column 'subject.id'
	#	num.cv: number of cross-validation folds
	#	random.seed: seed to set before generating random numbers
	#
	# Example usage: 
	#	source("Code/CV/gen_cv_data.R")
	#	GenCvData("train",10)
		
	#Check to see if cv split datasets already exist
	cv.train.list<-list()
	cv.test.list<-list()
	for (fold in 1:num.cv) {
		cv.train.list[[fold]]<-sprintf("Data/%s-cv%s_%sof%d.rda",data.name,
			"train",fold,num.cv)
		cv.test.list[[fold]]<-sprintf("Data/%s-cv%s_%sof%d.rda",data.name,
			"test",fold,num.cv)
	}
	filename.list<-c(cv.train.list,cv.test.list)
	check<-sapply(filename.list,file.exists)
	if (all(check)) {
		print("CV splits already generated")
		return()
	}

	# Load original dataset
	rda.filename <- paste("Data/",data.name,".rda",sep="")
	# Keep track of name of variable loaded
	variable.name <- load(rda.filename)

	# Assign loaded variable a standard name
	all.data <- get(variable.name)

	# Find the unique subject ids and sort them
	ids <- sort(unique(all.data$subject.id))
	
	# Set random seed to guarantee reproducibility of results
	set.seed(random.seed)
	
	# Randomly permute subject ids
	ids <- sample(ids)
	
	# Randomly partition subject ids into num.cv segments of roughly equal size
	cv.ids <- split(ids,1:num.cv)
	
	# Create cv test and train datasets for each CV fold
	for (fold in names(cv.ids)) {
		# Create test dataset for this fold
		SaveCvData(data.name, "test", fold, num.cv, variable.name,
			all.data[all.data$subject.id %in% cv.ids[[fold]],])
		# Create training dataset for this fold
		SaveCvData(data.name, "train", fold, num.cv, variable.name,
			all.data[!(all.data$subject.id %in% cv.ids[[fold]]),])
	}
}

SaveCvData <- function(data.name, data.type, fold, num.cv, variable.name, cv.data) {
	# Saves cross-validation dataset to file
	#
	# Args:
	# 	data.name: base name of RDA file in Data folder
	#	data.type: "train" or "test"
	#	fold: string representation of cross-validation fold number
	#	num.cv: number of cross-validation folds
	#	variable.name: name of variable to which cv.data should be assigned
	#	cv.data: cross-validation dataset to save
	
	filename <- sprintf("Data/%s-cv%s_%sof%d.rda",data.name,data.type,fold,num.cv)
	print(paste("Saving dataset to",filename))
	# Assign dataset in correct variable name
	assign(variable.name, cv.data)
	# Save dataset
	save(list = variable.name, file = filename)
}

# fancy scatterplots  (J. Fox)

# 2010-09-05: J. Fox: changed color choice
# 2010-09-16: fixed point color when col is length 1
# 2010-12-19: J. Fox: added argument legend.coords to place legend.
# 2011-01-15: J. Fox: If x is a factor, calls Boxplot()
# 2011-03-08: J. Fox: changed col argument
# 2012-04-18: J. Fox: fixed labels argument in scatterplot.formula().
# 2012-04-24: J. Fox: further fix to labels
# 2012-09-12: J. Fox: modified treatment of smoother; added loessLine(), gamLine(), quantregLine(). 
# 2012-09-17: S. Weisberg:  smoothers moved to scatterplotSmoothers.R, defaults changed
# 2012-09-19: J. Fox: restored smooth and span arguments for backwards compatibility
# 2013-02-07: S. Weisberg:  modifed call to showLabels to work correctly with groups
# 2014-09-04: J. Fox: empty groups produce warning rather than error
# 2015-07-17: J. Fox: improved above-plot legends.
# 2015-08-05: J. Fox: fixed sp()

reg <- function(reg.line, x, y, col, lwd, lty, log.x, log.y){
    if(log.x) x <- log(x)
    if(log.y) y <- log(y)
    mod <- reg.line(y ~ x)
    y.hat <- fitted.values(mod)
    x <- model.matrix(mod)[, 2]
    min <- which.min(x)
    max <- which.max(x)
    if (!log.x){
        x1 <- x[min]
        x2 <- x[max]
    }
    else {
        x1 <- exp(x[min])
        x2 <- exp(x[max])
    }
    if (!log.y){
        y1 <- y.hat[min]
        y2 <- y.hat[max]
    }
    else {
        y1 <- exp(y.hat[min])
        y2 <- exp(y.hat[max])
    }
    lines(c(x1, x2), c(y1, y2), lwd=lwd, col=col, lty=lty)
}

find.legend.columns <- function(n, target=min(4, n)){
  rem <- n %% target
  if (rem != 0 && rem < target/2) target <- target - 1
  target
}

scatterplot <- function(x, ...){
    UseMethod("scatterplot", x)
}

scatterplot.formula <- function (formula, data, subset, xlab, ylab, legend.title, legend.coords, labels, ...) {
    na.save <- options(na.action=na.omit)
    on.exit(options(na.save))
    na.pass <- function(dframe) dframe
    m <- match.call(expand.dots=FALSE)
    if (is.matrix(eval(m$data, sys.frame(sys.parent())))) 
        m$data <- as.data.frame(data)
    m$na.action <- na.pass
    m$legend.coords <- m$legend.title <- m$labels <- m$xlab <- m$ylab <- m$... <- NULL
    m[[1]] <- as.name("model.frame")
    if (!inherits(formula, "formula") | length(formula) != 3) 
        stop("invalid formula")    
    formula <- as.character(c(formula))
    formula <- as.formula(sub("\\|", "+", formula))
    m$formula <- formula
    if (missing(data)){ 
        X <- na.omit(eval(m, parent.frame()))
        if (missing(labels)) labels <- gsub("X", "", row.names(X)) 
    }
    else{
        X <- eval(m, parent.frame())
        if (missing(labels)) labels <- row.names(X)
    }
    names <- names(X)
    if (missing(xlab)) xlab <- names[2]
    if (missing(ylab)) ylab <- names[1]
    if (ncol(X) == 2) scatterplot(X[,2], X[,1], xlab=xlab, ylab=ylab, 
                                  labels=labels, ...)
    else {
        if (missing(legend.title)) legend.title <- names[3]
        scatterplot(X[,2], X[,1], groups=X[,3], xlab=xlab, ylab=ylab,  
                    legend.title=legend.title, legend.coords=legend.coords, labels=labels, ...)
    }
}

scatterplot.default <- function(x, y, smoother=loessLine, smoother.args=list(), smooth, span,
                                spread=!by.groups, reg.line=lm,
                                boxplots=if (by.groups) "" else "xy",
                                xlab=deparse(substitute(x)), ylab=deparse(substitute(y)), las=par("las"),
                                lwd=1, lty=1,
                                labels, id.method = "mahal", 
                                id.n = if(id.method[1]=="identify") length(x) else 0, 
                                id.cex = 1, id.col = palette()[1],
                                log="", jitter=list(), xlim=NULL, ylim=NULL,
                                cex=par("cex"), cex.axis=par("cex.axis"), cex.lab=par("cex.lab"), 
                                cex.main=par("cex.main"), cex.sub=par("cex.sub"), 
                                groups, by.groups=!missing(groups), 
                                legend.title=deparse(substitute(groups)), legend.coords, legend.columns,
                                ellipse=FALSE, levels=c(.5, .95), robust=TRUE,
                                col=if (n.groups == 1) palette()[3:1] else rep(palette(), length=n.groups),
                                pch=1:n.groups, 
                                legend.plot=!missing(groups), reset.par=TRUE, grid=TRUE, ...){
    logged <- function(axis=c("x", "y")){
        axis <- match.arg(axis)
        0 != length(grep(axis, log))
    }
    hbox <- function(x){
        if (logged("x")){
            log.x <- "x"
            .x <- log(x)        
        }
        else {
            log.x <- ""
            .x <- x
        }
        plot(x, seq(0, 1, length=length(x)), type="n", axes=FALSE, xlab="", ylab="", log=log.x, xlim=xlim)
        res <- boxplot.stats(.x, coef = 1.5, do.conf=FALSE)
        if (logged("x")){
            res$stats <- exp(res$stats)
            if (!is.null(res$out)) res$out <- exp(res$out)
        }
        LW <- res$stats[1]
        Q1 <- res$stats[2]
        M <- res$stats[3]
        Q3 <- res$stats[4]
        UW <- res$stats[5]
        lines(c(Q1, Q1, Q3, Q3, Q1), c(0, 1, 1, 0, 0))
        lines(c(M, M), c(0, 1))
        lines(c(LW, Q1), c(.5, .5))
        lines(c(Q3, UW), c(.5, .5))
        if (!is.null(res$out)) points(res$out, rep(.5, length(res$out)), cex=cex)
    }
    vbox <- function(y){
        if (logged("y")){
            log.y <- "y"
            .y <- log(y)
        }
        else {
            log.y <- ""
            .y <- y
        }
        plot(seq(0, 1, length=length(y)), y, type="n", axes=FALSE, xlab="", ylab="", log=log.y, ylim=ylim)
        res <- boxplot.stats(.y, coef = 1.5, do.conf=FALSE)
        if (logged("y")){
            res$stats <- exp(res$stats)
            if (!is.null(res$out)) res$out <- exp(res$out)
        }
        LW <- res$stats[1]
        Q1 <- res$stats[2]
        M <- res$stats[3]
        Q3 <- res$stats[4]
        UW <- res$stats[5]
        lines(c(0, 1, 1, 0, 0), c(Q1, Q1, Q3, Q3, Q1))
        lines(c(0, 1), c(M, M))
        lines(c(.5, .5), c(LW, Q1))
        lines(c(.5, .5), c(Q3, UW))
        if (!is.null(res$out)) points(rep(.5, length(res$out)), res$out, cex=cex)
    }
    # force evaluation of some arguments
    by.groups
    legend.plot
    legend.title
    # smooth and span for backwards compatibility
    if (!missing(smooth)) {
        smoother <- if (isTRUE(smooth)) loessLine else FALSE
    }
    if (!missing(span)) smoother.args$span <- span
    if (is.character(family)) family <- eval(parse(text=family))
    if (missing(labels)){
        labels <- if (is.null(names(y)))
            seq(along=y)
        else names(y)
    }
    if (length(labels) != length(y)) stop("labels argument is the wrong length")
    if (is.factor(x)) {
        if (!(id.method %in% c("y", "identify", "none"))) id.method <- "y"
        return(Boxplot(y, x, id.method="y", labels=labels, xlab=xlab, ylab=ylab))
    }
    mar <- par("mar")
    mfcol <- par("mfcol")
    if (reset.par) on.exit(par(mar=mar, mfcol=mfcol))
    if( FALSE == boxplots) boxplots <- ""
    if (!missing(groups)){
        data <- na.omit(data.frame(groups, x, y, labels, stringsAsFactors=FALSE))
        groups <- data[,1]
        if (!is.factor(groups)) groups <- as.factor(groups)
        .x <- data[,2]
        .y <- data[,3]
        labels <- data[,4]
        top <- if (legend.plot && missing(legend.coords)){
            if (missing(legend.columns)) legend.columns <- find.legend.columns(nlevels(groups))
            4 + ceiling(nlevels(groups))/legend.columns
        }
        else mar[3]
        if (legend.plot && !missing(legend.coords) && missing(legend.columns)){
          legend.columns <- 1
        }
    }
    else {
        .x <- x
        .y <- y
        top <- mar[3]
        groups <- factor(rep(1, length(.x)))
    }
    xbox <- length(grep("x", boxplots)) > 0
    ybox <- length(grep("y", boxplots)) > 0
    if (xbox && ybox)
        layout(matrix(c(1, 0, 3, 2), 2, 2),
               widths = c(5, 95),
               heights= c(95, 5))
    else if (ybox)
        layout(matrix(c(1, 2),1, 2),
               widths = c(5, 95),
               heights= 100)
    else if (xbox)
        layout(matrix(c(2, 1), 2, 1),
               widths = 100,
               heights= c(95, 5))
    else layout (matrix(1, 1, 1),
                 widths=100, heights=100)
    par(mar=c(mar[1], 0, top, 0))
    if (ybox > 0) vbox(.y) 
    par(mar=c(0, mar[2], 0, mar[4]))
    if (xbox > 0) hbox(.x) 
    par(mar=c(mar[1:2], top, mar[4]))
    plot(.x, .y, xlab=xlab, ylab=ylab, las=las, log=log, cex=cex, cex.axis=cex.axis, cex.lab=cex.lab,
         cex.main=cex.main, cex.sub=cex.sub, type="n", xlim=xlim, ylim=ylim, ...)
    if(grid){
        grid(lty=1, equilogs=FALSE)
        box()}
    n.groups <- length(levels(groups))
    if (n.groups > length(col)) stop("number of groups exceeds number of available colors")
    if (length(col) == 1) col <- rep(col, 3)
    indices <- NULL
    range.x <- if (logged("x")) range(log(.x), na.rm=TRUE) else range(.x, na.rm=TRUE)
    counts <- table(groups)
    if (any(counts == 0)){
        levels <- levels(groups)
        warning("the following groups are empty: ", paste(levels[counts == 0], collapse=", "))
    }
    for (i in 1:n.groups){
        if (counts[i] == 0) next
        subs <- groups == levels(groups)[i]
        points(if (is.null(jitter$x) || jitter$x == 0) .x[subs] else jitter(.x[subs], factor=jitter$x), 
               if (is.null(jitter$y) || jitter$y == 0) .y[subs] else jitter(.y[subs], factor=jitter$y), 
               pch=pch[i], col=col[if (n.groups == 1) 3 else i], cex=cex)
        if (by.groups){
            if (is.function(smoother)) smoother(.x[subs], .y[subs], col=col[i], 
                                                log.x=logged("x"), log.y=logged("y"), spread=spread, smoother.args=smoother.args)
            if (is.function(reg.line)) reg(reg.line, .x[subs], .y[subs], lty=lty, lwd=lwd, log.x=logged("x"), log.y=logged("y"), col=col[i])
            if (ellipse) {
                X <- na.omit(data.frame(x=.x[subs], y=.y[subs]))
                if (logged("x")) X$x <- log(x)
                if (logged("y")) X$y <- log(y)
                with(X, dataEllipse(x, y, plot.points=FALSE, lwd=1, log=log,
                                    levels=levels, col=col[i], robust=robust))
            }
            if (id.method[1] != "identify")
                indices <- c(indices,
                     showLabels(.x[subs], .y[subs], labels=labels[subs], id.method=id.method,
                     id.n=id.n, id.cex=id.cex, id.col=col[i], all=list(labels=labels, subs=subs)))
#            if (id.method[1] != "identify") indices <- c(indices,
#                                                         showLabels(.x[subs], .y[subs], labels=labels[subs], id.method=id.method,
#                                                                    id.n=id.n, id.cex=id.cex, id.col=col[i]))
        }}
    if (!by.groups){
        if (is.function(smoother)) smoother(.x, .y, col=col[2], 
                                            log.x=logged("x"), log.y=logged("y"), spread, smoother.args=smoother.args)
        if (is.function(reg.line)) reg(reg.line, .x, .y, lty=lty, lwd=lwd, log.x=logged("x"), log.y=logged("y"), col=col[1])
        if (ellipse) {
            X <- na.omit(data.frame(x=.x, y=.y))
            if (logged("x")) X$x <- log(X$x)
            if (logged("y")) X$y <- log(X$y)
            with(X, dataEllipse(x, y, plot.points=FALSE, lwd=1, log=log, levels=levels, col=col[1],
                                robust=robust))
        }
        if (id.method[1] != "identify") indices <- showLabels(
            .x, .y, labels=labels, 
            id.method=id.method, id.n=id.n, id.cex=id.cex, id.col=id.col)
    }
    if (legend.plot) {
        xpd <- par(xpd=TRUE)
        on.exit(par(xpd=xpd), add=TRUE)
        usr <- par("usr")
        if (missing(legend.coords)){
            legend.x <- if (logged("x")) 10^(usr[1]) else usr[1]
            legend.y <- if (logged("y")) 10^(usr[4] + 1.2*top*strheight("x")) else usr[4] + 1.2*top*strheight("x")
            legend.coords <- list(x=legend.x, y=legend.y)
        }
        legend(legend.coords, legend=levels(groups)[counts > 0], 
               pch=pch[counts > 0], col=col[1:n.groups][counts > 0], pt.cex=cex, cex=cex.lab, 
               title=legend.title, bg="white", ncol=legend.columns)
    }
    if (id.method[1] == "identify") indices <- showLabels(.x, .y, labels, 
                                                          id.method=id.method, id.n=length(.x), id.cex=id.cex, id.col=id.col)
    if (is.null(indices)) invisible(indices) else if (is.numeric(indices)) sort(indices) else indices
} 

sp <- function(x, ...)  UseMethod("scatterplot", x)

####1. Process Training Data
face_t=face_process_fun(tdat);
hand_t=hand_process_fun(tdat);
body_t=body_process_fun(tdat);
leg_t=leg_process_fun(tdat);
chest_t=chest_process_fun(tdat);
ALSFRS_t=ALSFRS_process_fun(tdat,face_t,hand_t,body_t,leg_t,chest_t);
three_m_slope_t=cal_three_month_slope_fun(ALSFRS_t);
onset_t=onset_process_fun(tdat);
family_hist_t=family_hist_process_fun(tdat);
fvc_t=fvc_process_fun(tdat);
svc_t=svc_process_fun(tdat);
fvc_slope_t=cal_slope_fvc_fun(fvc_t);
svc_slope_t=cal_slope_svc_fun(svc_t);
vc_slope_t=comb_vc_slope_fun(tdat,fvc_slope_t,svc_slope_t);
demo_t=demographic_process_fun(tdat);
group_t=treatment_group_process_fun(tdat);
weight_t=weight_process_fun(tdat);
weight_slope_t=cal_weight_slope_fun(weight_t);
uric_acid_t=uric_acid_process_fun(tdat);
RR_t=RR_process_fun(tdat);
pulse_t=pulse_process_fun(tdat);
RR_slope_t=cal_RR_slope_fun(RR_t);
pulse_slope_t=cal_pulse_slope_fun(pulse_t);
sodium_t=sodium_process_fun(tdat);

tdat_comb=merge(dat_comb_fun(three_m_slope_t,onset_t,family_hist_t,vc_slope_t,demo_t,weight_slope_t
                                   ,uric_acid_t,group_t,RR_slope_t,pulse_slope_t, sodium_t)
                      ,tdat_slope, by="Pid");  ##combine the predictors
tdat_comb=impute_avg_fun(tdat_comb)  ##impute the missing with average value

#### 3. fit the model 
##3.1 fit the base model
rm_fit=randomForest(slope ~ three_m_slope + first_score + score_three_month + score_three_month_26_abs +
                            face + body + hand + leg + chest + 
                            face_three_m_slope + hand_three_m_slope + body_three_m_slope + leg_three_m_slope + chest_three_m_slope + 
                            onset_delta_log + onset_age + onset_site + onset_slope + onset_diag_delta_diff + onset_diag_missing_ind + 
                            vc_slope + 
                            als_ind + neuro_disease_ind +
                            weight_slope + weight_percentage_slope + 
                            RR_slope + avg_RR + 
                            pulse_slope + avg_pulse 
                    , data=tdat_comb);
save(rm_fit, file="rm_fit");

##3.2 fit the model when fvc data is available
rm_fit1=randomForest(slope ~ three_m_slope + score_three_month + first_score + score_three_month_26_abs +
                            face + body + hand + leg + chest + 
                            face_three_m_slope + hand_three_m_slope + body_three_m_slope + leg_three_m_slope + chest_three_m_slope + 
                            onset_delta_log + onset_age + onset_site + onset_slope + onset_diag_missing_ind +
                            als_ind + neuro_disease_ind + 
                            fvc_slope +
                            weight_slope + weight_percentage_slope +
                            uric_acid_value + uric_acid_value_missing_ind
                    , data=tdat_comb[tdat_comb$fvc_ind==1,]);
save(rm_fit1, file="rm_fit1");

##3.3 fit the model when uric_acid_value is available
rm_fit2=randomForest(slope ~ three_m_slope +  score_three_month_26_abs +
                             onset_delta_log + + onset_diag_delta_diff + onset_diag_missing_ind + 
                             onset_site + 
                             vc_slope + 
                             uric_acid_value 
                    , ntree=1000, corr.bias=T 
                    , data=tdat_comb[tdat_comb$uric_acid_value_missing_ind==0,]);
save(rm_fit2, file="rm_fit2");

##3.4 fit the model when diagnosis delta data is available
rm_fit3=randomForest(slope~three_m_slope +  score_three_month_26_abs +
                     face + body + hand + leg + chest + 
                     face_three_m_slope + hand_three_m_slope + body_three_m_slope + leg_three_m_slope + chest_three_m_slope + 
                     onset_delta_log + onset_age  + onset_diag_delta_diff +
                     vc_slope + 
                     avg_pulse + uric_acid_value + uric_acid_value_missing_ind
                    , data=tdat_comb[tdat_comb$onset_diag_missing_ind==0,]);
save(rm_fit3, file="rm_fit3");

#-------------------------------------------------------------------------------
# Revision history:
# 2009-09-28 by J. Fox 
# 2013-05-21 replaced vif.lm with vif.default and added
#            model.matrix.gls to make gls models work. J. Fox
# 2015-01-13: fixed model.matrix.gls to work with models with formulas as object. J. Fox
#-------------------------------------------------------------------------------

# Generalized Variance-Inflation Factors (Henric Nilsson and John Fox)

vif<-function(mod, ...){
	UseMethod("vif")
}


# vif.lm <- function(mod, ...) {
# 	if (any(is.na(coef(mod)))) 
# 		stop ("there are aliased coefficients in the model")
# 	v <- vcov(mod)
# 	assign <- attributes(model.matrix(mod))$assign
# 	if (names(coefficients(mod)[1]) == "(Intercept)") {
# 		v <- v[-1, -1]
# 		assign <- assign[-1]
# 	}
# 	else warning("No intercept: vifs may not be sensible.")
# 	terms <- labels(terms(mod))
# 	n.terms <- length(terms)
# 	if (n.terms < 2) stop("model contains fewer than 2 terms")
# 	R <- cov2cor(v)
# 	detR <- det(R)
# 	result <- matrix(0, n.terms, 3)
# 	rownames(result) <- terms
# 	colnames(result) <- c("GVIF", "Df", "GVIF^(1/(2*Df))")
# 	for (term in 1:n.terms) {
# 		subs <- which(assign == term)
# 		result[term, 1] <- det(as.matrix(R[subs, subs])) *
# 			det(as.matrix(R[-subs, -subs])) / detR
# 		result[term, 2] <- length(subs)
# 	}
# 	if (all(result[, 2] == 1)) result <- result[, 1]
# 	else result[, 3] <- result[, 1]^(1/(2 * result[, 2]))
# 	result
# }

vif.default <- function(mod, ...) {
    if (any(is.na(coef(mod)))) 
        stop ("there are aliased coefficients in the model")
    v <- vcov(mod)
    assign <- attr(model.matrix(mod), "assign")
    if (names(coefficients(mod)[1]) == "(Intercept)") {
        v <- v[-1, -1]
        assign <- assign[-1]
    }
    else warning("No intercept: vifs may not be sensible.")
    terms <- labels(terms(mod))
    n.terms <- length(terms)
    if (n.terms < 2) stop("model contains fewer than 2 terms")
    R <- cov2cor(v)
    detR <- det(R)
    result <- matrix(0, n.terms, 3)
    rownames(result) <- terms
    colnames(result) <- c("GVIF", "Df", "GVIF^(1/(2*Df))")
    for (term in 1:n.terms) {
        subs <- which(assign == term)
        result[term, 1] <- det(as.matrix(R[subs, subs])) *
            det(as.matrix(R[-subs, -subs])) / detR
        result[term, 2] <- length(subs)
    }
    if (all(result[, 2] == 1)) result <- result[, 1]
    else result[, 3] <- result[, 1]^(1/(2 * result[, 2]))
    result
}

model.matrix.gls <- function(object, ...){
    model.matrix(formula(object), data=eval(object$call$data))
}

# Component + Residual Plots (J. Fox)

# modified 9 October 2009 by J. Fox
# modified 25 November 2009 by S. Weisberg to change 
#   variable specification, layout and point marking
# modified 1 January 2009 by J. Fox
#   to set default id.n=0
# changed showLabels args 15 April 2010 S. Weisberg
# added grid, 10 May 2010
# modified 2 Sept 2010 by S. Weisberg, made colors, axes lables, and
# arguments more consistent with other functions; ... passes args to plot
# and boxplot.
# 16 June 2011 allow layout=NA, in which case the layout is not set in this
#  function, so it is the responsibility of the user
# 14 Sept 2012 use the ScatterplotSmoothers in car
# 19 Sept 2012 restore smooth and span args
# 20 Aug 2013 replace residuals.glm() with residuals(). John

# these functions to be rewritten; simply renamed for now

crp<-function(...) crPlots(...)

crPlots<-function(model, terms= ~ ., layout=NULL, ask, main, ...){
  terms <- if(is.character(terms)) paste("~", terms) else terms
  vform <- update(formula(model), terms)
  if(any(is.na(match(all.vars(vform), all.vars(formula(model))))))
     stop("Only predictors in the formula can be plotted.")
  mf <- attr(model.frame(model), "terms")
  terms <- attr(mf, "term.labels") # this is a list
  vterms <- attr(terms(vform), "term.labels")
	if (any(attr(terms(model),"order")>1)) {
		stop("C+R plots not available for models with interactions.")}
  nt <- length(vterms)
  if (nt == 0) stop("No plots specified")
  if (missing(main)) main <- if (nt == 1) "Component + Residual Plot" else "Component + Residual Plots" 
  if (nt > 1 & (is.null(layout) || is.numeric(layout))) {
    if(is.null(layout)){
         layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2), 
                             c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
    }
    ask <- if(missing(ask) || is.null(ask)) prod(layout)<nt else ask
    op <- par(mfrow=layout, ask=ask, no.readonly=TRUE, 
            oma=c(0, 0, 1.5, 0), mar=c(5, 4, 1, 2) + .1)
    on.exit(par(op))
    }
	if(!is.null(class(model$na.action)) && 
		class(model$na.action) == 'exclude') class(model$na.action) <- 'omit'
  for(term in vterms) 
		crPlot(model, term, ...)
	mtext(side=3, outer=TRUE, main, cex=1.2)
	invisible(0)
	}

	
crPlot<-function (model, ...) {
	UseMethod("crPlot")
}

crPlot.lm<-function(model, variable, 
  id.method = list(abs(residuals(model, type="pearson")), "x"),
  labels, 
  id.n = if(id.method[1]=="identify") Inf else 0,
  id.cex=1, id.col=palette()[1],
  order=1, line=TRUE, smoother=loessLine,
  smoother.args=list(), smooth, span,
  col=palette()[1], col.lines=palette()[-1],
  xlab, ylab, pch=1, lwd=2, grid=TRUE, ...) { 
	# method also works for glm objects
	if(missing(labels)) labels <- names(residuals(model))
    # smooth and span for backwards compatibility
    if (!missing(smooth)) {
        smoother <- if (isTRUE(smooth)) loessLine else FALSE
    }
    if (!missing(span)) smoother.args$span <- span
	if(!is.null(class(model$na.action)) && 
		class(model$na.action) == 'exclude') class(model$na.action) <- 'omit'
	var<-if (is.character(variable) & 1==length(variable)) variable
		else deparse(substitute(variable))
	xlab <- if(!missing(xlab)) xlab else var
	ylab <- if(!missing(ylab)) ylab else
	   paste("Component+Residual(", responseName(model),")", sep="")
	terms<-predictor.names(model)
	if (is.na(match(var, terms))) stop(paste(var,"is not in the model."))
	if (any(attr(terms(model),"order")>1)) {
		stop("C+R plots not available for models with interactions.")
	}
	if (!is.null(model$contrasts[[var]])){
		partial.res<-residuals(model,"partial")
		.x<-model.frame(model)[,var]
		boxplot(partial.res[,var]~.x, xlab=xlab,
			ylab=ylab, ...)
		return(invisible())
	}
	.x<-if (df.terms(model, var)>1) predict(model, type="terms", term=var)
		else model.matrix(model)[,var]
	if (order==1){          # handle first-order separately for efficiency
		partial.res<-residuals(model,"partial")
		plot(.x, partial.res[,var], type="n", xlab=xlab,
      ylab=ylab, ...)
	  if(grid){
      grid(lty=1, equilogs=FALSE)
      box()}
		points(.x, partial.res[,var], col=col, pch=pch)
		if (line) abline(lm(partial.res[,var]~.x), lty=2, lwd=lwd, col=col.lines[1])
	if (is.function(smoother)) {
    smoother(.x, partial.res[,var], col=col.lines[2], log.x=FALSE,
       log.y=FALSE, spread=FALSE, smoother.args=smoother.args)
		}
		showLabels(.x, partial.res[,var], labels=labels, 
            id.method=id.method, id.n=id.n, id.cex=id.cex,
            id.col=id.col)
	}
	else {
		if (df.terms(model, var)>1) 
			stop(paste("Order", order, "C+R plot not available for a term with > 1 df:", var))
		aug.model<-update(model, 
			as.formula(paste(".~.-",var,"+poly(",var,",",order,")")))
		partial.res<-residuals(aug.model, "partial")
		last<-ncol(partial.res)
		plot(.x, partial.res[,last], xlab=xlab, 
			ylab=ylab, type="n", ...)
	  if(grid){
      grid(lty=1, equilogs=FALSE)
      box()}
		points(.x, partial.res[,last], col=col, pch=pch)
		if (line) abline(lm(partial.res[,last]~.x), lty=2, lwd=lwd, col=col.lines[1])
 	  if (is.function(smoother)) {
      smoother(.x, partial.res[, last], col=col.lines[2], log.x=FALSE,
         log.y=FALSE, spread=FALSE, smoother.args=smoother.args)
		}
		showLabels(.x, partial.res[,last], labels=labels, 
            id.method=id.method, id.n=id.n, id.cex=id.cex,
            id.col=id.col)
	}          
}

# fancy scatterplot matrices (J. Fox)

# 2010-09-04: J. Fox: changed color choice
# 2010-09-16: fixed point color when col is length 1
# 2011-03-08: J. Fox: changed col argument
# 2012-04-18: J. Fox: fixed labels argument in scatterplotMatrix.formula()
# 2012-09-12: J. Fox: smoother now given as function
# 2012-09-19: J. Fox: restored smooth and span args for backwards compatibility
# 2013-02-08: S. Weisberg: bug-fix for showLabels with groups 
# 2013-08-26: J. Fox: added use argument
# 2014-08-07: J. Fox: plot univariate distributions by group (except for histogram)
# 2014-08-17: J. Fox: report warning rather than error if not enough points in a group
#                     to compute density
# 2014-09-04: J. Fox: empty groups produce warning rather than error

scatterplotMatrix <- function(x, ...){
    UseMethod("scatterplotMatrix")
}

scatterplotMatrix.formula <- function (formula, data=NULL, subset, labels, ...) {
    na.save <- options(na.action=na.omit)
    on.exit(options(na.save))
    na.pass <- function(dframe) dframe
    m <- match.call(expand.dots = FALSE)
    if (is.matrix(eval(m$data, sys.frame(sys.parent())))) 
        m$data <- as.data.frame(data)
    m$labels <- m$formula <- m$... <- NULL
    m$na.action <- na.pass
    m[[1]] <- as.name("model.frame")
    if (!inherits(formula, "formula") | length(formula) != 2) 
        stop("invalid formula")
    rhs <- formula[[2]]
    if ("|" != deparse(rhs[[1]])){
        groups <- FALSE
    }
    else{
        groups <- TRUE
        formula<-as.character(c(formula))
        formula<-as.formula(sub("\\|", "+", formula))   
    }
    m$formula <-formula
    if (missing(data)){ 
        X <- na.omit(eval(m, parent.frame()))
        if (missing(labels)) labels <- gsub("X", "", row.names(X))
    }
    else{
        X <- eval(m, parent.frame())
    }
    if (!groups) scatterplotMatrix(X, labels=labels, ...)
    else{
        ncol<-ncol(X)
        scatterplotMatrix.default(X[, -ncol], groups=X[, ncol], labels=labels, ...)
    }
}

scatterplotMatrix.default <- function(x, var.labels=colnames(x), 
    diagonal=c("density", "boxplot", "histogram", "oned", "qqplot", "none"), adjust=1, nclass,
    plot.points=TRUE, smoother=loessLine, smoother.args=list(),
    smooth, span,
    spread = !by.groups, reg.line=lm,
    transform=FALSE, family=c("bcPower", "yjPower"),
    ellipse=FALSE, levels=c(.5, .95), robust=TRUE,
    groups=NULL, by.groups=FALSE, 
    use=c("complete.obs", "pairwise.complete.obs"),
    labels, id.method="mahal", id.n=0, id.cex=1, id.col=palette()[1],
    col=if (n.groups == 1) palette()[3:1] else rep(palette(), length=n.groups),
    pch=1:n.groups, lwd=1, lty=1, 
    cex=par("cex"), cex.axis=par("cex.axis"), cex.labels=NULL, 
    cex.main=par("cex.main"), 
    legend.plot=length(levels(groups)) > 1, legend.pos=NULL, row1attop=TRUE, ...){
    if (id.method[1] == "identify") stop("interactive point identification not permitted")
    legend.pos # evaluate
    family <- match.arg(family)
    use <- match.arg(use)
    na.action <- if (use == "complete.obs") na.omit else na.pass
    if (missing(labels)){
        labels <- rownames(x)
        if (is.null(labels)) labels <- as.character(seq(length.out=nrow(x)))
    }
    if (!(missing(groups))){
        x <- na.action(data.frame(groups, labels, x, stringsAsFactors=FALSE))
        #      groups <- as.factor(as.character(x[, 1]))
        groups <- x$groups
        if (!is.factor(groups)) groups <- as.factor(as.character(x[,1]))
        labels <- x[, 2]
        x <- x[, -(1:2)]
    }
    else {
        x <- na.action(data.frame(labels, x, stringsAsFactors=FALSE))
        labels <- x[, 1]
        x <- x[, -1]
    }
    if (missing(nclass)) nclass <- "FD"
    legendPlot <- function(position="topright"){
        usr <- par("usr")
        legend(position, bg="white",
            legend=levels(groups), pch=pch, col=col[1:n.groups],
            cex=cex)
    }	
    do.legend <- legend.plot	
    # The following panel function adapted from Richard Heiberger
    panel.density <- function(x, ...){
        if (n.groups > 1){
            levs <- levels(groups)
            for (i in 1:n.groups){
                xx <- x[levs[i] == groups]
                dens.x <- try(density(xx, adjust = adjust, na.rm=TRUE), silent=TRUE)
                if (!inherits(dens.x, "try-error")){
                    lines(dens.x$x, min(x, na.rm=TRUE) + dens.x$y * 
                            diff(range(x, na.rm=TRUE))/diff(range(dens.x$y, na.rm=TRUE)), col=col[i])
                }
                else warning("cannot estimate density for group ", levs[i], "\n",
                    dens.x, "\n")
                rug(xx, col=col[i])
            }
        }
        else {
            dens.x <- density(x, adjust = adjust, na.rm=TRUE)
            lines(dens.x$x, min(x, na.rm=TRUE) + dens.x$y * diff(range(x, na.rm=TRUE))/diff(range(dens.x$y, na.rm=TRUE)))
            rug(x)
        }
        if (do.legend) legendPlot(position=if (is.null(legend.pos)) "topright" else legend.pos)
        do.legend <<- FALSE
    }
    panel.histogram <- function(x, ...){
        par(new=TRUE)
        h.col <- col[1]
        if (h.col == "black") h.col <- "gray"
        hist(x, main="", axes=FALSE, breaks=nclass, col=h.col)
        if (do.legend) legendPlot(position=if (is.null(legend.pos)) "topright" else legend.pos)
        do.legend <<- FALSE
    }
    panel.boxplot <- function(x, ...){
        b.col <- col[1:n.groups]
        b.col[b.col == "black"] <- "gray"
        par(new=TRUE)
        if (n.groups == 1) boxplot(x, axes=FALSE, main="", col=col[1])
        else boxplot(x ~ groups, axes=FALSE, main="", col=b.col)
        if (do.legend) legendPlot(position=if (is.null(legend.pos)) "topright" else legend.pos)
        do.legend <<- FALSE
    }
    # The following panel function adapted from Richard Heiberger
    panel.oned <- function(x, ...) {
        range <- range(x, na.rm=TRUE)
        delta <- diff(range)/50
        y <- mean(range)
        if (n.groups == 1) segments(x - delta, x, x + delta, x, col = col[3])
        else {
            segments(x - delta, x, x + delta, x, col = col[as.numeric(groups)])
        }
        if (do.legend) legendPlot(position=if (is.null(legend.pos)) "bottomright" else legend.pos)
        do.legend <<- FALSE
    }
    panel.qqplot <- function(x, ...){
        par(new=TRUE)
        if (n.groups == 1) qqnorm(x, axes=FALSE, xlab="", ylab="", main="", col=col[3])
        else qqnorm(x, axes=FALSE, xlab="", ylab="", main="", col=col[as.numeric(groups)])
        qqline(x, col=col[1])
        if (do.legend) legendPlot(position=if (is.null(legend.pos)) "bottomright" else legend.pos)
        do.legend <<- FALSE
    }
    panel.blank <- function(x, ...){
        if (do.legend) legendPlot(if (is.null(legend.pos)) "topright" else legend.pos)
        do.legend <<- FALSE
    }
    # smooth and span for backwards compatibility
    if (!missing(smooth)) {
        smoother <- if (isTRUE(smooth)) loessLine else FALSE
    }
    if (!missing(span)) smoother.args$span <- span    
    which.fn <- match(match.arg(diagonal),
        c("density", "boxplot", "histogram", "oned", "qqplot", "none"))
    diag <- list(panel.density, panel.boxplot, panel.histogram, panel.oned, panel.qqplot, panel.blank)[[which.fn]]
    groups <- as.factor(if(missing(groups)) rep(1, length(x[, 1])) else groups)
    counts <- table(groups)
    if (any(counts == 0)){
        levels <- levels(groups)
        warning("the following groups are empty: ", paste(levels[counts == 0], collapse=", "))
        groups <- factor(groups, levels=levels[counts > 0])
    }
    n.groups <- length(levels(groups))
    if (n.groups > length(col)) stop("number of groups exceeds number of available colors")
    if (length(col) == 1) col <- rep(col, 3)
    if (transform != FALSE | length(transform) == ncol(x)){
        if (transform == TRUE & length(transform) == 1){
            transform <- if (by.groups) coef(powerTransform(as.matrix(x) ~ groups, family=family), round=TRUE)
            else coef(powerTransform(x, family=family), round=TRUE)
        }
        for (i in 1:ncol(x)){
            x[, i] <- if (family == "bcPower") 
                bcPower(x[, i], transform[i])
            else yjPower(x[, i], transform[i])
            var.labels[i] <- paste(var.labels[i], "^(", round(transform[i],2), ")", sep="")
        }
    }
    labs <- labels
    pairs(x, labels=var.labels, 
        cex.axis=cex.axis, cex.main=cex.main, cex.labels=cex.labels, cex=cex,
        diag.panel=diag, row1attop = row1attop,
        panel=function(x, y, ...){ 
            for (i in 1:n.groups){
                subs <- groups == levels(groups)[i]
                if (plot.points) points(x[subs], y[subs], pch=pch[i], col=col[if (n.groups == 1) 3 else i], cex=cex)
                if (by.groups){
                    if (is.function(smoother)) smoother(x[subs], y[subs], col=col[i],
                        log.x=FALSE, log.y=FALSE, spread=spread, smoother.args=smoother.args)
                    if (is.function(reg.line)) reg(reg.line, x[subs], y[subs], lty=lty, lwd=lwd, log.x=FALSE, log.y=FALSE, col=col[i])
                    if (ellipse) dataEllipse(x[subs], y[subs], plot.points=FALSE, 
                        levels=levels, col=col[i], robust=robust, lwd=1)
                    showLabels(x[subs], y[subs], labs[subs], id.method=id.method, 
                        id.n=id.n, id.col=col[i], id.cex=id.cex, all=list(labels=labs, subs=subs))
                }
            }
            if (!by.groups){
                if (is.function(reg.line)) abline(reg.line(y ~ x), lty=lty, lwd=lwd, col=col[1])
                if (is.function(smoother)) smoother(x, y, col=col[2], 
                    log.x=FALSE, log.y=FALSE, spread=spread, smoother.args=smoother.args)
                if (ellipse) dataEllipse(x, y, plot.points=FALSE, levels=levels, col=col[1],
                    robust=robust, lwd=1)
                showLabels(x, y, labs, id.method=id.method, 
                    id.n=id.n, id.col=id.col, id.cex=id.cex)
            }
        }, ...
    )
}

spm <- function(x, ...){
    scatterplotMatrix(x, ...)
} 

#' PredictiveModelFeatureEvaluator
#'
#' Not implemented yet. A class to evaluate the significance of a feature list returned from a predictive model
#'
#' @author Adam Margolin
#' @export

PredictiveModelFeatureEvaluator <- setRefClass(Class = "PredictiveModelFeatureEvaluator",
                          fields=c("referenceFeatures", "significantFeatures"),
                          methods = list(
                            initialize = function(referenceFeatures, significantFeatures, ...){
                              .self$referenceFeatures = referenceFeatures
                              .self$significantFeatures = significantFeatures
                              
                              return(.self)
                            },
                            
                            gsea = function(){
                              
                            }
                            )
                            )

# Utility functions (J. Fox)

# 16 March 2010 changed 'vars' argument to 'terms'
# 28 June 2010 added df.terms.surveg and model.matrix.survreg
# 15 November 2010 added squeezeBlanks
# 21 January 2011 added functions to support mixed models
# 2012-04-08 added exists.method
# 2012-06-23: added call to globalVariables(). John
# 2012-12-10: added .carEnv to avoid warnings in R > 2.16.0
# 2013-06020: added .merMod methods to df.residual() and has.intercept(). John
# 2014-05-16: added .multinom method for has.intercept(). John
# 2014-08-19: added package.installed() function, unexported. John
# 2014-11-02: termsToMf fixed, Sandy
# 2015-01-13: fixed model.matrix.lme() to work with model with formula as object. John
# 2015-01-27: .carEnv now lives in the global environment. John

#if (getRversion() >= "2.15.1") globalVariables(c(".boot.sample", ".boot.indices"))

.carEnv <- new.env(parent=globalenv())

# function to find "nice" numbers

nice <- function(x, direction=c("round", "down", "up"), lead.digits=1){
	direction <- match.arg(direction)
	if (length(x) > 1) return(sapply(x, nice, direction=direction, lead.digits=lead.digits))
	if (x == 0) return(0)
	power.10 <- floor(log(abs(x),10))
	if (lead.digits > 1) power.10 <- power.10 - lead.digits + 1
	lead.digit <- switch(direction,
		round=round(abs(x)/10^power.10),
		down=floor(abs(x)/10^power.10),
		up=ceiling(abs(x)/10^power.10))
	sign(x)*lead.digit*10^power.10
}

has.intercept <- function (model, ...) {
	UseMethod("has.intercept")
}

has.intercept.default <- function(model, ...) any(names(coefficients(model))=="(Intercept)")

has.intercept.multinom <- function(model, ...) {
  nms <- names(coef(model))
  any(grepl("\\(Intercept\\)", nms))
}
  
term.names <- function (model, ...) {
	UseMethod("term.names")
}

term.names.default <- function (model, ...) {
	term.names <- labels(terms(model))
	if (has.intercept(model)) c("(Intercept)", term.names)
	else term.names
}

predictor.names <- function(model, ...) {
	UseMethod("predictor.names")
}

predictor.names.default <- function(model, ...){
	predictors <- attr(terms(model), "variables")
	as.character(predictors[3:length(predictors)])
}

responseName <- function (model, ...) {
	UseMethod("responseName")
}

responseName.default <- function (model, ...) deparse(attr(terms(model), "variables")[[2]])

response <- function(model, ...) {
	UseMethod("response")
}

response.default <- function (model, ...) model.response(model.frame(model))

is.aliased <- function(model){
	!is.null(alias(model)$Complete)
}

df.terms <- function(model, term, ...){
	UseMethod("df.terms")
}

df.terms.default <- function(model, term, ...){
	if (is.aliased(model)) stop("Model has aliased term(s); df ambiguous.")
	if (!missing(term) && 1 == length(term)){
		assign <- attr(model.matrix(model), "assign")
		which.term <- which(term == labels(terms(model)))
		if (0 == length(which.term)) stop(paste(term, "is not in the model."))
		sum(assign == which.term)
	}
	else {
		terms <- if (missing(term)) labels(terms(model)) else term
		result <- numeric(0)
		for (term in terms) result <- c(result, Recall(model, term))
		names(result) <- terms
		result
	}
}

df.terms.multinom <- function (model, term, ...){
	nlev <- length(model$lev)
	if (!missing(term) && 1 == length(term)) {
		assign <- attr(model.matrix(model), "assign")
		which.term <- which(term == labels(terms(model)))
		if (0 == length(which.term))
			stop(paste(term, "is not in the model."))
		sum(assign == which.term) * (nlev - 1)
	}
	else {
		terms <- if (missing(term))
				labels(terms(model))
			else term
		result <- numeric(0)
		for (term in terms) result <- c(result, Recall(model,
					term))
		names(result) <- terms
		result
	}
}

df.terms.polr <- function (model, term, ...){
	if (!missing(term) && 1 == length(term)) {
		assign <- attr(model.matrix(model), "assign")
		which.term <- which(term == labels(terms(model)))
		if (0 == length(which.term))
			stop(paste(term, "is not in the model."))
		sum(assign == which.term)
	}
	else {
		terms <- if (missing(term))
				labels(terms(model))
			else term
		result <- numeric(0)
		for (term in terms) result <- c(result, Recall(model,
					term))
		names(result) <- terms
		result
	}
}

df.terms.survreg <- function(model, term, ...){
	if (is.aliased(model)) stop("Model has aliased term(s); df ambiguous.")
	if (!missing(term) && 1 == length(term)){
		assign <- attr(model.matrix(model, data=model.frame(model)), "assign")
		which.term <- which(term == labels(terms(model)))
		if (0 == length(which.term)) stop(paste(term, "is not in the model."))
		sum(assign == which.term)
	}
	else {
		terms <- if (missing(term)) labels(terms(model)) else term
		result <- numeric(0)
		for (term in terms) result <- c(result, Recall(model, term))
		names(result) <- terms
		result
	}
}

model.matrix.survreg <- function(object, ...) model.matrix.default(object, model.frame(object))

mfrow <- function(n, max.plots=0){
	# number of rows and columns for array of n plots
	if (max.plots != 0 && n > max.plots)
		stop(paste("number of plots =",n," exceeds maximum =", max.plots))
	rows <- round(sqrt(n))
	cols <- ceiling(n/rows)
	c(rows, cols)
}

inv <- function(x) solve(x)

coefnames2bs <- function(g, para.names, parameterPrefix="b"){
	metas <- c("(", ")", "[", "]", "{", "}", ".", "*", "+", "^", "$", ":", "|")
	metas2 <- paste("\\", metas, sep="")
	metas3 <- paste("\\\\", metas, sep="")
	for (i in seq(along=metas))
		para.names <- gsub(metas2[i], metas3[i], para.names) # fix up metacharacters
	para.order <- order(nchar(para.names), decreasing=TRUE) 
	para.names <- para.names[para.order] # avoid partial-name substitution
	std.names <- if ("(Intercept)" %in% para.names)
				paste(parameterPrefix, 0:(length(para.names) - 1), sep = "")
			else paste(parameterPrefix, 1:length(para.names), sep = "")
	std.names.ordered <- std.names[para.order]
	for (i in seq(along=para.names)){
		g <- gsub(para.names[i], std.names.ordered[i], g) 
	}
	list(g=g, std.names=std.names)
}


showLabelsScatter <- function(x, y, labels, id.var = NULL,
	id.method = c("mahal", "identify", "none"), log="", id.cex=.75, id.n=3, id.col=palette()[1], 
	range.x=range(.x), show=TRUE) {
	id.method <- match.arg(id.method)
	if (id.method == "none" || id.n == 0 || !show) return(invisible(NULL))
	if(id.n > 0L) {
		if (missing(labels))
			labels <- if (!is.null(id.var)) names(id.var)
				else as.character(seq(along=x))
		getPoints <- function(z) {
			names(z) <- labels
			iid <- seq(length=id.n)
			zs <- z[order(-z)[iid]]
			match(names(zs), labels)
		}
		logged <- function(axis=c("x", "y")){
			axis <- match.arg(axis)
			0 != length(grep(axis, log))
		}
		valid <- complete.cases(x, y)
		x <- x[valid]
		y <- y[valid]
		labels <- labels[valid]
		if (length(id.var) == length(valid)) 
			id.var <- id.var[valid]
		.x <- if (logged("x")) log(x) else x
		.y <- if (logged("y")) log(y) else y
		ind <- if (!is.null(id.var)) {
				if (length(id.var) == length(x)) order(-abs(id.var))[1L:id.n] 
				else if(is.character(id.var)) match(id.var, labels) else id.var
			}
			else switch(id.method,
					x = getPoints(abs(.x - mean(.x))),
					y = getPoints(abs(.y - mean(.y))),
					xy = union(getPoints(abs(.x - mean(.x))),
						getPoints(abs(.y - mean(.y)))),
					mahal= getPoints(rowSums(qr.Q(qr(cbind(1, .x, .y))) ^ 2)))
		ind <- na.omit(ind)
		if (length(ind) == 0) return(invisible(NULL))
		labpos <- c(4, 2)[1 + as.numeric(.x > mean(range.x))]
		text(x[ind], y[ind], labels[ind], cex = id.cex, xpd = TRUE,
			pos = labpos[ind], offset = 0.25, col=id.col)
		return(labels[ind])
	} 
}


#  outerLegend, written by S. Weisberg Feb 2010
#  outerLegend function
#  puts a legend in the margin, either at the upper left (margin = 3)
#  the default or upper right side otherwise
#  all the args from legend are used except for x, y, and xpd which are
#  set in the function.
#  offset is a fraction of the plot width or height to locate the legend
outerLegend <- function(..., margin=3, offset=0, adjust=FALSE){
   lims <- par("usr")
   if (margin == 3) {
      x0 <- lims[1] + offset*(lims[2]-lims[1])
      y0 <- lims[4] }
   else {
      x0 <- lims[2] + offset*(lims[2]-lims[1])
      y0 <- lims[4]
   }
   leg <- legend(x0, y0, ... , xpd=TRUE, plot=FALSE)
   if (margin == 3) {
      y0 <- y0 + leg$rect$h
      if(adjust == TRUE) x0 <- x0 - leg$text$x[1]
   }
   legend(x0, y0, ... , xpd=TRUE)
   }
   
# added by J. Fox 18 Nov 2010

squeezeBlanks <- function(text){
	gsub(" *", "",  text)
}

# added by J. Fox 21 Jan 2011 to support mixed models

df.residual.mer <- function(object, ...) NULL

df.residual.merMod <- function(object, ...) NULL

df.residual.lme <- function(object, ...) Inf

has.intercept.mer <- function(model){
	any(names(fixef(model))=="(Intercept)")
}

has.intercept.merMod <- function(model){
    any(names(fixef(model))=="(Intercept)")
}
	
model.matrix.lme <- function(object, ...){
	model.matrix(formula(object), eval(object$call$data))
}

# added by J. Fox 2012-04-08 to use in deltaMethod.default()

exists.method <- function(generic, object, default=TRUE, strict=FALSE){
	classes <- class(object)
	if (default) classes <- c(classes, "default")
	if (strict) classes <- classes[1]
	any(paste(generic, ".", classes, sep="") %in%
					as.character(methods(generic)))
}

     
# Used by marginalModelPlots, residualPlots added 2012-09-24
plotArrayLegend <- function(
      location=c("top", "none", "separate"),
      items, col.items, lty.items, lwd.items, title="legend",
      pch=1:length(items)) {
   if(location== "none") return()
   n <- length(items)
   if(location == "top" ) { # add legend
      usr <- par("usr")
      coords <-list(x=usr[1], y=usr[3])
      leg <- legend( coords, items,
                col=col.items, pch=pch,
                bty="n", cex=1, xpd=NA, plot=FALSE)
      coords <- list(x = usr[1], y=usr[4] + leg$rect$h)
      legend( coords, items,
         col=col.items, pch=pch, bty="n", cex=1, xpd=NA)
  }
  if(location == "separate") {
    plot(0:1, 0:1, xaxt="n", yaxt="n", xlab="", ylab="", type="n")
    bg <- par()$bg
    legend("center", items,
          lty=lty.items, lwd=lwd.items, fill=col.items, border=col.items,,
          col=col.items, box.col=par()$bg,
          title=title)
  }
}

termsToMf <- function(model, terms){ 
  gform <- function(formula) {
    if (is.null(formula)){
        return(list(vars=formula, groups=NULL))
    }
    has.response <- length(formula) == 3
    rhs <- if(has.response) formula[[3]] else formula[[2]]
# either a single variable or '.' on the RHS
    if (length(rhs) == 1){
        return(list(vars=formula, groups=NULL))
    }
    if (length(rhs) != 3) stop("incorrectly formatted 'terms' argument")
# check for "|", indicating grouping
    if(deparse(rhs[[1]] == "|")) {
      if(length(rhs[[3]]) > 1) stop("Only one conditioning variable is permitted")
      groups <- as.formula(paste("~", deparse(rhs[[3]])))
      rhs <- rhs[[2]]
    } else groups <- NULL 
    vars <- as.formula(paste("~ ", deparse(rhs)))
    list(vars=vars, groups=groups)
  }
  terms <- gform(as.formula(terms))
  mf.vars <- try(update(model, terms$vars, method="model.frame"),
     silent=TRUE)
# This second test is used for models like m1 <- lm(longley) which
# fail the first test because update doesn't work
  if(class(mf.vars) == "try-error")
       mf.vars <- try(update(model, terms$vars,
               method="model.frame", data=model.frame(model)), silent=TRUE)
  if(class(mf.vars) == "try-error") stop("argument 'terms' not interpretable.")
  if(!is.null(terms$groups)){
     mf.groups <- try(update(model, terms$groups, method="model.frame"), silent=TRUE)
     if(class(mf.groups) == "try-error")
       mf.groups <- try(update(model, terms$groups,
               method="model.frame", data=model.frame(model)), silent=TRUE)
     if(class(mf.groups) == "try-error") stop("argument 'terms' not interpretable.")
  } else {mf.groups <- NULL}
  list(mf.vars=mf.vars, mf.groups=mf.groups)
  }

# the following function isn't exported, tests for existance of a package:

package.installed <- function(package){
  package <- as.character(substitute(package))
  result <- try(find.package(package), silent=TRUE)
  !class(result) ==  "try-error"
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

rsf2rfz <- function(object, forestName = NULL, ...) {
  rsfForest <- checkForestObject(object)
  if (is.null(forestName)) {
    stop("RSF forest name is NULL.  Please provide a valid name for the forest .rfz file.")
  }
  if (nchar(forestName) > 4) {
    if (substr(forestName, nchar(forestName)-3, nchar(forestName)) == ".rfz") {
      forestName <- substr(forestName, 1, nchar(forestName)-4)
    }
  }
  nativeArray <- rsfForest$nativeArray
  timeInterest <- rsfForest$timeInterest
  formula <- rsfForest$formula
  forestSeed <- rsfForest$seed
  predictorNames <- rsfForest$predictorNames
  get.factor <- extract.factor(rsfForest$predictors, predictorNames)
  predictorTypes <- get.factor$predictorType
  nativeFactorArray <- rsfForest$nativeFactorArray
  numTrees <- length(as.vector(unique(nativeArray$treeID)))
  rootString <- getRootString()
  pmmlDoc <- xmlTreeParse(rootString, asText=TRUE)
  pmmlRoot <- xmlRoot(pmmlDoc)
  pmmlRoot <- append.XMLNode(pmmlRoot, getDataDictNode(predictorNames=predictorNames, predictorTypes=predictorTypes))
  write.table(nativeArray, 
              paste(forestName, ".txt", sep=""), quote = FALSE)
  write.table(nativeFactorArray, 
                paste(forestName, ".factor.txt", sep=""), col.names=FALSE, quote = FALSE)
  xmlFile <- file(paste(forestName, ".xml", sep=""), open="w")
  saveXML(pmmlRoot, xmlFile)
  close(xmlFile)
  zipCommand <- paste("zip", sep=" ",
    paste(forestName, ".rfz", sep=""),
    paste(forestName, ".txt", sep=""),
    paste(forestName, ".factor.txt", sep=""),
    paste(forestName, ".xml", sep="")) 
  system(command = zipCommand)
  unlink(paste(forestName, ".txt", sep=""))
  unlink(paste(forestName, ".factor.txt", sep=""))
  unlink(paste(forestName, ".xml", sep=""))
}
checkForestObject <- function(object) {
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2    &
      sum(inherits(object, c("rsf", "forest"), TRUE) == c(1, 2)) != 2) {
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, forest)'")
  }
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) == 2) {
    if (is.null(object$forest)) {
      stop("Forest is empty!  Re-run grow call with forest set to 'TRUE'.")
    }
    rsfForest <- object$forest
  }
  else {
    rsfForest <- object
  }
  if (is.null(rsfForest$nativeArray)) {
    stop("RSF nativeArray content is NULL.  Please ensure the object is valid.")
  }
  if (is.null(rsfForest$timeInterest)) {
    stop("RSF timeInterest content is NULL.  Please ensure the object is valid.")
  }
  if (is.null(rsfForest$formula)) {
    stop("RSF formula content is NULL.  Please ensure the object is valid.")
  }
  if (is.null(rsfForest$seed)) {
    stop("RSF forestSeed content is NULL.  Please ensure the object is valid.")
  }
  if (is.null(rsfForest$predictorNames)) {
    stop("RSF predictorNames content is NULL.  Please ensure the object is valid.")
  }
  if (is.null(rsfForest$predictors)) {
    stop("RSF predictors content is NULL.  Please ensure the object is valid.")
  }
  return (rsfForest)
}
getRootString <- function() {
  rootString <- 
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
         <PMML version=\"3.1\" xmlns=\"http://www.dmg.org/PMML-3_1\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">
           <Header copyright=\"Copyright 2008, Cleveland Clinic\" description=\"Random Survival Forest Tree Model\">
              <Application name=\"Random Survival Forest\" version=\"3.0\"/>
           </Header>
         </PMML>
       "
  return (rootString)
}
getDataDictNode <-  function(predictorNames, predictorTypes) {
  dataDictNode <- xmlNode("DataDictionary", attrs=c(numberOfFields=length(predictorNames)))
  for (k in 1:length(predictorNames)) {
    if (predictorTypes[k] == "C") {
      dataDictNode <- append.XMLNode(dataDictNode, xmlNode("DataField", attrs=c(name=predictorNames[k], optype="categorical", dataType="string")))
    }
    if (predictorTypes[k] == "I") {
      dataDictNode <- append.XMLNode(dataDictNode, xmlNode("DataField", attrs=c(name=predictorNames[k], optype="ordinal", dataType="integer")))
    }
    if (predictorTypes[k] == "R") {
      dataDictNode <- append.XMLNode(dataDictNode, xmlNode("DataField", attrs=c(name=predictorNames[k], optype="continuous", dataType="double")))
    }
  }
  return (dataDictNode)
}

ScriptPath='../..'
SubmissionDataPath='../../OriginalSubmissions'
##AML
##AlgorithmList=c('2DhistsSVM', 'acgt', 'admire-lvq', 'BAD', 'bcb', 'biolobe', 'cihc', 'daltons', 'EMMIXCYTOM', 'epd', 'fivebyfive', 'flowBin', 'flowPeakssvm', 'flowType', 'flowType-FeaLect', 'giano6', 'GS', 'jkjg', 'PBSC', 'predictor', 'RandomSpheres', 'rnigroup', 'scrph1', 'si', 'sib-vital-it', 'SORT', 'SPADE', 'team21', 'uqs')
##For nature immunology
##AlgorithmList=c('2DhistsSVM', 'admire-lvq', 'bcb', 'biolobe', 'cihc', 'daltons', 'DREAM-A', 'DREAM-B', 'DREAM-C', 'DREAM-D', 'EMMIXCYTOM', 'fivebyfive', 'flowBin', 'flowPeakssvm', 'flowType', 'flowType-FeaLect', 'jkjg', 'PBSC', 'RandomSpheres', 'scrph1', 'SPCA+GLM', 'SPADE', 'team21', 'uqs')
##For nature methods
AlgorithmList=c('2DhistsSVM', 'admire-lvq', 'bcb', 'biolobe', 'cihc', 'daltons', 'DREAM-A', 'DREAM-B', 'DREAM-C', 'DREAM-D', 'EMMIXCYTOM', 'fivebyfive', 'flowBin', 'flowPeakssvm', 'flowType', 'flowType-FeaLect', 'jkjg', 'PBSC', 'RandomSpheres', 'SPCA+GLM', 'SPADE', 'team21', 'uqs')
Dream=c(0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,1,1,1,0,1,0,1,1,1,1,0,1,1)
##AlgorithmList=AlgorithmList[which(Dream==0)]

##parse the metadata
MetaData <- read.csv('../../Data/AML/AMLTraining.csv',stringsAsFactors=FALSE)
##find the testset samples
TestSetMetaData <- which(is.na(MetaData[,'Label']))
TestSet <- unique(MetaData[TestSetMetaData,'SampleNumber'])
##index of the testset samples
TestSetIndex <- unlist(lapply(TestSet,function(x){which(x==MetaData[,'SampleNumber'])[1]}))

##Extract the labels
Labels=matrix('', length(AlgorithmList), length(TestSetIndex));
for (i in 1:length(AlgorithmList)){
  CSV=read.csv(sprintf('%s/%s/%s-AML.csv',SubmissionDataPath,AlgorithmList[i],AlgorithmList[i]),stringsAsFactors=FALSE)
  Labels[i,] <- CSV[TestSetIndex,'Label']  
}

Labels=t(Labels)

##read the complete metadata
CorrectMetaData <- read.csv('../../Data/AML/AML.csv',stringsAsFactors=FALSE)
CorrectLabels=CorrectMetaData[TestSetIndex,'Label']
CorrectLabels[which(CorrectLabels=='aml')]=1
CorrectLabels[which(CorrectLabels=='normal')]=0
CorrectLabels=as.integer(CorrectLabels)

##construct the labels 1:AML 0:normal
Labels[which(Labels=='AML')]=1
Labels[which(Labels=='aml')]=1
Labels[which(Labels=='normal')]=0
Labels=matrix(as.integer(Labels),dim(Labels))

##calculated sensitivity, specificity, and F-measure
sens=vector()
acc=vector()
spec=vector()
fmeasure <- vector()
recall <- vector()
precision<-vector()
##cil=vector()
##cih=vector()
for (i in 1:length(AlgorithmList)){
  neg <- which(CorrectLabels==0)
  TN <- length(which(CorrectLabels[neg]==Labels[neg,i]))
  FP <- length(which(CorrectLabels[neg]!=Labels[neg,i]))
  pos <- which(CorrectLabels!=0)
  TP <- length(which(CorrectLabels[pos]==Labels[pos,i]))
  FN <- length(which(CorrectLabels[pos]!=Labels[pos,i]))
  acc[i] <- (TP+TN)/(TP+TN+FP+FN)
  sens[i] <- TP/(TP+FP)
  spec[i] <- TP/(TP+FN)
  fmeasure[i] <- sens[i]*spec[i]*2/(sens[i]+spec[i])
  recall[i] <- TP / 20
  precision[i] <-TP /20
  ##temp=bootStrap(Labels[,i], CorrectLabels, 1000)
  ##cil[i]=temp[1]
  ##cih[i]=temp[2]
}

##create the latex table
Ndigits=2
mat=cbind(format(sens, digits=Ndigits), format(spec, digits=Ndigits), format(acc, digits=Ndigits), format(fmeasure, digits=Ndigits))
rownames(mat) <- AlgorithmList
##colnames(mat) <- c('Sensitivity', 'Specificity', 'Accuracy', 'Fmeasure', 'Fmeasure CI')
colnames(mat) <- c('Sensitivity', 'Specificity', 'Accuracy', 'Fmeasure')

library(xtable)
print(xtable(mat, label='t2AML', caption='Challenge 1'), caption.placement='top')

##create the Fmeasure barplots
postscript('../../DisplayItems/AMLFmeasures.eps', horizontal=FALSE)
par(mfrow=c(2,1))
index=order(fmeasure,decreasing=TRUE)
index2 <- which(fmeasure[index]==max(fmeasure))
index[index2] <- index[index2][sort(AlgorithmList[index[index2]], index.return=TRUE, decreasing=FALSE)$ix]
bp=barplot(fmeasure[index]-0.4, names.arg=NA, offset=0.4, xlab='Algorithms', ylab='F-measures', xaxt='n', bty='l')
text(bp+0.1, par("usr")[3]+max(fmeasure-0.4)/40, srt = 90, adj = 0, labels = AlgorithmList[index], xpd = TRUE)
axis(1, at=bp, labels=FALSE)
dev.off()

##create the misclassification barplots
MisClassifications <- Labels*0;
for (j in 1:dim(Labels)[2]){
  MisClassifications[,j]=as.integer(Labels[,j]!=CorrectLabels)
}
##MisClassifications=MisClassifications/dim(MisClassifications)[2]
postscript('../../DisplayItems/AMLMisClassifications.eps', horizontal=FALSE)
par(mar=c(6,6,4,2))
par(mfrow=c(3,1))
bp=barplot(rowSums(MisClassifications), col=CorrectLabels+1, xlab='SampleNumber', ylab='Mis-classifications', axes=FALSE,cex.lab=2)
legend(1, max(rowSums(MisClassifications)), legend=c('Normal', 'AML'), col=1:2, lwd=4,box.col=0,cex=2)
axis(2,cex.axis=2)
axis(1, at=bp[c(2,100,which.max(rowSums(MisClassifications)))], labels=c(181,284,340),cex.axis=2)
par(mgp=c(4,1,0))
title(sub='(A) Mis-classifications',cex.sub=2)
dev.off()

#' Perform cross validation on a preditive model, this method support both caret models and PredictiveModels
#'
#' @param featureData
#' @param responseData
#' @param method either an instance of PredictiveModel or a string holding the name of one of the machine learning methods that caret supports
#' @param numFolds defaults to 5
#' @param trControl defaults to defaultTrainControl
#' @return a list of PredictiveModelPerformance one per fold
#' @seealso defaultTrainControl
#' @author Adam Margolin
#' @export
crossValidatePredictiveModel <- 
		function(featureData, responseData, model, numFolds = 5, trControl = defaultTrainControl(), ...){
  
  #-----------------------------------------------------------------------
  # Split the data into training and test partitions
  # -----------------------------------------------------------------------
  set.seed(2)
  foldIndices <- createFolds(featureData[,1], k = numFolds, list = TRUE)
  
  message("Training partitions")

  modelResults <- foreach(fold = foldIndices) %dopar% {
    foldModel <- model$copy()
    foldModel$customTrain(featureData[-fold,], responseData[-fold], trControl = trControl, ...)
    return(foldModel)
  }
  
  foldTestPredictions <- foreach(i=1:numFolds) %do% modelResults[[i]]$customPredict(featureData[foldIndices[[i]],])
  testPredictions <- do.call("c", foldTestPredictions)
  
  foldTrainPredictions <- foreach(i=1:numFolds) %do% modelResults[[i]]$customPredict(featureData[-foldIndices[[i]],])
  trainPredictions <- do.call("c", foldTrainPredictions)
  
  foldTestObservations <- foreach(i=1:numFolds) %do% responseData[foldIndices[[i]]]
  testObservations <- do.call("c", foldTestObservations)
  
  foldTrainObservations <- foreach(i=1:numFolds) %do% responseData[-foldIndices[[i]]]
  trainObservations <- do.call("c", foldTrainObservations)
  
  res <- list(trainPredictions = trainPredictions, trainObservations = trainObservations,
              testPredictions = testPredictions, testObservations = testObservations)
  
  return(res)
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

plot.error.rsf <- function (x, sorted = TRUE, ...) {
  if (sum(inherits(x, c("rsf", "grow"), TRUE) == c(1, 2)) != 2 &
      sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) != 2)
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, predict)'.")
    if (is.null(x$importance)) x$importance <- NA
    if (all(is.na(x$err.rate)) & all(is.na(x$importance))) return()
    if (all(is.na(x$importance))) {
      if (x$ntree > 1 & !all(is.na(x$err.rate))) {
        old.par <- par(no.readonly = TRUE)
        err <- rbind(x$err.rate)  
        par(mfrow = c(1,1))
        plot.err(err)
        par(old.par)      
      }
    }
    else {
      old.par <- par(no.readonly = TRUE)
      err <- rbind(x$err.rate)  
      imp <- t(rbind(x$importance))
      n.pred <- nrow(imp)
      if (sorted) pred.order <- order(imp[, 1]) else pred.order <- n.pred:1
      if (ncol(imp) == 1) max.pred <- 100 else max.pred <- 80/ncol(imp)
      if (n.pred > max.pred) {
        dotchart.labels <- rep("", n.pred)
        pretty.pt <- pretty(1:n.pred, n = max.pred)
        pretty.pt <- pretty.pt[pretty.pt > 0 & pretty.pt < n.pred]
        dotchart.labels[pretty.pt] <- x$predictorNames[pred.order][pretty.pt]
      }
      else {
        dotchart.labels <- x$predictorNames[pred.order]
      }
      if (x$ntree > 1 & !all(is.na(x$err.rate))) par(mfrow = c(1,2)) else par(mfrow = c(1,1))
      if (x$ntree > 1 & !all(is.na(x$err.rate))) {
        plot.err(err)
      }
      if (ncol(imp) > 1) { 
        colnames(imp) <- c("CHF", paste("cond CHF", 1:(ncol(imp)-1), "          "))
        imp.out <- imp[rev(pred.order),, drop = FALSE]
        colnames(imp.out) <- c("CHF", paste("condCHF.", 1:(ncol(imp)-1), sep=""))
        dotChart(imp[pred.order,, drop = FALSE], dotchart.labels)
      }
      if (ncol(imp) == 1) {
        dotChart(imp[pred.order, ], dotchart.labels)
        if (!is.null(x$predictorWt) & length(unique(x$predictorWt)) > 1 ) {
          if (length(unique(x$predictorWt)) == 1) x$predictorWt <- 1
          imp.out=as.data.frame(cbind(imp,imp/max(abs(imp),na.rm=T) ,x$predictorWt),
                            row.names=x$predictorNames)[rev(pred.order),]
          if (nrow(imp.out) == 1) imp.out[1 , 2] <- 1
          colnames(imp.out) <- c("Importance","Relative Imp","predictorWt")
        }
        else {
          imp.out=as.data.frame(cbind(imp,imp/max(abs(imp),na.rm=T)),
                            row.names=x$predictorNames)[rev(pred.order),]
          if (nrow(imp.out) == 1) imp.out[1 , 2] <- 1
          colnames(imp.out) <- c("Importance","Relative Imp")
        }
      }
      cat("\n")
      print(round(imp.out[1:min(n.pred, max.pred),, drop = FALSE],4), justify="right", print.gap=3)
      par(old.par)      
    } 
}
plot.err <- function(err) {
  matplot(1:ncol(err), t(err),
          xlab = "Number of Trees",
          ylab = "Error Rate",
          type = c("p", "l")[1 + 1 * (ncol(err) > 1)], pch = 16, lty = 1,
          lwd = c(3, 1.5)[1 + 1 * (nrow(err) > 10)])
  if (nrow(err) > 1) {
    legend("topright",
           legend = c("CHF", paste("cond CHF   ", 1:(nrow(err)-1), " ")),
           col = 1:nrow(err), lty = 1, xjust = 1,
           lwd = c(3, 1.5)[1 + 1 * (nrow(err) > 10)],
           cex = c(1, 0.75)[1 + 1 * (nrow(err) > 10)])
  }
}
dotChart <- function(x, labels = NULL) {
    if (!is.null(dim(x))) {
      ncol  <- ncol(x)
      x.dot <- NULL
      for (k in ncol(x):1) {x.dot <- c(x.dot, x[, k])}
      gcolor <- 1:ncol
    }
    else {
      x.dot <- x
      gcolor <- par("fg")
    }
    y.dot <- dot.chart.main(x, labels = labels, cex=0.90, pch="", lwd = 2, lcolor = "white", gcolor = gcolor)
    segments(rep(max(0, min(x.dot, na.rm = TRUE)) - 1e-6, length(y.dot)),
             y.dot, x.dot, y.dot, col=c(2,4)[1 + 1*(x.dot>0)], lwd = 4)
    if (min(x.dot, na.rm = TRUE) < 0) abline(v=0, lwd = 2, lty = 2, col = 1)
    mtext("Variable Importance", side = 1, line = 3, cex = 1)
  }
dot.chart.main <- function (x, labels = NULL, groups = NULL, gdata = NULL, cex = par("cex"), 
    pch = 21, gpch = 21, bg = par("bg"), color = par("fg"), gcolor = par("fg"), 
    lcolor = "gray", xlim = range(x[is.finite(x)]), main = NULL, 
    xlab = NULL, ylab = NULL, ...) 
{
    opar <- par("mai", "mar", "cex", "yaxs")
    on.exit(par(opar))
    par(cex = cex, yaxs = "i")
    if (!is.numeric(x)) 
        stop("'x' must be a numeric vector or matrix")
    n <- length(x)
    if (is.matrix(x)) {
        if (is.null(labels)) 
            labels <- rownames(x)
        if (is.null(labels)) 
            labels <- as.character(1:nrow(x))
        labels <- rep(labels, length.out = n)
        if (is.null(groups)) 
            groups <- col(x, as.factor = TRUE)
        glabels <- levels(groups)
    }
    else {
        if (is.null(labels)) 
            labels <- names(x)
        glabels <- if (!is.null(groups)) 
            levels(groups)
    }
    plot.new()
    linch <- if (!is.null(labels)) 
        max(strwidth(labels, "inch"), na.rm = TRUE)
    else 0
    if (is.null(glabels)) {
        ginch <- 0
        goffset <- 0
    }
    else {
        ginch <- max(strwidth(glabels, "inch"), na.rm = TRUE)
        goffset <- 0.4
    }
    if (!(is.null(labels) && is.null(glabels))) {
        nmai <- par("mai")
        nmai[2] <- nmai[4] + max(linch + goffset, ginch) + 0.1
        par(mai = nmai)
    }
    if (is.null(groups)) {
        o <- 1:n
        y <- o
        ylim <- c(0, n + 1)
    }
    else {
        o <- sort.list(as.numeric(groups), decreasing = TRUE)
        x <- x[o]
        groups <- groups[o]
        color <- rep(color, length.out = length(groups))[o]
        lcolor <- rep(lcolor, length.out = length(groups))[o]
        offset <- cumsum(c(0, diff(as.numeric(groups)) != 0))
        y <- 1:n + 2 * offset
        ylim <- range(0, y + 2)
    }
    plot.window(xlim = xlim, ylim = ylim, log = "")
    lheight <- par("csi")
    if (!is.null(labels)) {
        linch <- max(strwidth(labels, "inch"), na.rm = TRUE)
        loffset <- (linch + 0.1)/lheight
        labs <- labels[o]
        mtext(labs, side = 2, line = loffset, at = y, adj = 0, 
            col = color, las = 2, cex = cex, ...)
    }
    abline(h = y, lty = "dotted", col = lcolor)
    points(x, y, pch = pch, col = color, bg = bg)
    if (!is.null(groups)) {
        gpos <- rev(cumsum(rev(tapply(groups, groups, length)) + 
            2) - 1)
        ginch <- max(strwidth(glabels, "inch"), na.rm = TRUE)
        goffset <- (max(linch + 0.2, ginch, na.rm = TRUE) + 0.1)/lheight
        mtext(glabels, side = 2, line = goffset, at = gpos, adj = 0, 
            col = gcolor, las = 2, cex = cex, ...)
        if (!is.null(gdata)) {
            abline(h = gpos, lty = "dotted")
            points(gdata, gpos, pch = gpch, col = gcolor, bg = bg, 
                ...)
        }
    }
    axis(1)
    box()
    title(main = main, xlab = xlab, ylab = ylab, ...)
    invisible(y)
  }
plot.error <- plot.error.rsf

##
##  Validate and score AD Challenge submissions
############################################################
suppressMessages(require(pROC))
suppressMessages(require(epiR))


DATA_DIR = "data/scoring"

## cache the scoring data so we don't keep re-reading it
SCORING_DATA_CACHE = list()

## read either a csv or tab delimited file and return a data frame
read_delim_or_csv <- function(path) {
    if (grepl('.csv$', path)) {
        read.csv(path, stringsAsFactors=FALSE)
    } else {
        read.table(path, header=TRUE, quote="\"", fill=TRUE, stringsAsFactors=FALSE)
    }
}

## get the scoring data from cache or read from disk
read_scoring_data <- function(filename) {
    if (!(filename %in% names(SCORING_DATA_CACHE))) {
        SCORING_DATA_CACHE[[filename]] <- read_delim_or_csv(file.path(DATA_DIR, filename))
    }
    return(SCORING_DATA_CACHE[[filename]])
}



## parameters:
##   expected: a data.frame with the expected dimensions and column identifiers
##         df: the data.frame to be validated
##
## returns a list of two elements:
##      valid: TRUE / FALSE
##    message: a string
validate_data_frame <- function(expected, df) {
    if (any (is.na(df))) {
        return(list(valid=FALSE, message=sprintf(
            "Data format is invalid: all subjects must be predicted")))
    }

    ## Either exceptions or returning a list works, not
    ## sure which is better, yet.

    if (!all(colnames(expected)==colnames(df))) {
        return(list(valid=FALSE, message=sprintf(
            "Column names of submission were (%s) but should be (%s).",
            paste(colnames(df), collapse=", "),
            paste(colnames(expected), collapse=", "))))
    }

    if (!all(dim(expected)==dim(df))) {
        return(list(valid=FALSE, message=sprintf(
            "Dimensions of submission (%s) are not as expected (%s).",
            paste(dim(df), collapse=', '),
            paste(dim(expected), collapse=', '))))
    }

    return(list(valid=TRUE, message="OK"))
}

validate_projids <- function(expected, df) {
    if (!setequal(df$projid, expected$projid)) {
        return(list(
            valid=FALSE,
            message=sprintf("The projid column contained unrecognized identifiers: \"%s\". The expected identifiers look like these: \"%s\".",
                paste(head(setdiff(df$projid, expected$projid)), collapse=", "),
                paste(head(expected$projid), collapse=", "))))
    }

    return(list(valid=TRUE, message="OK"))
}

validate_sample_ids <- function(expected_ids, submitted_ids) {
    if (!setequal(submitted_ids, expected_ids)) {
        return(list(
            valid=FALSE,
            message=sprintf("The ID column contained unrecognized sample identifiers: \"%s\". The expected identifiers look like these: \"%s\".",
                paste(head(setdiff(submitted_ids, expected_ids)), collapse=", "),
                paste(head(expected_ids), collapse=", "))))
    }

    return(list(valid=TRUE, message="OK"))
}


validate_q1 <- function(submission_path, expected_filename) {
    df = read_delim_or_csv(submission_path)
    expected = read_scoring_data(expected_filename)
    result = validate_data_frame(expected, df)
    if (!result$valid) {
        return(result)
    }

    result = validate_projids(expected, df)
    if (!result$valid) {
        return(result)
    }

    ## check for zero variance predictions
    result$valid = var(df$delta_MMSE_clin) > 0 && var(df$delta_MMSE_clin_gen) > 0
    if (!result$valid) {
        result$message = paste(
            "Your prediction has zero variance, which means your submission can't be scored.",
            "Submissions are scored by correlation with the observed values for change in MMSE, but correlation is",
            "undefined when either of the correlates has zero variance.")
    }

    return(result)
}

validate_q2 <- function(submission_path, expected_filename) {
    df = read_delim_or_csv(submission_path)
    expected = read_scoring_data(expected_filename)
    result = validate_data_frame(expected, df)

    if (!result$valid) {
        return(result)
    }

    result = validate_projids(expected, df)

    if (!result$valid) {
        return(result)
    }

    ## check that the Discordance column is either Concordant or Discordant
    allowed_values = c('concordant', 'discordant')
    lower_cased_discordance = tolower(df$Discordance)
    result$valid = all(lower_cased_discordance %in% allowed_values)
    if (!result$valid) {
        result$message = sprintf("Unrecognized values in the Discordance column: (%s). Allowed values are (%s).",
            paste(setdiff(lower_cased_discordance, allowed_values), collapse=','),
            paste(allowed_values, collapse=','))
    }

    return(result)
}

validate_q3 <- function(submission_path, expected_filename) {
    df = read_delim_or_csv(submission_path)
    expected = read_scoring_data(expected_filename)

    result = validate_data_frame(expected, df)
    if (!result$valid) {
        return(result)
    }

    ## fix for lower case sample IDs ex: "sample8" which should be "Sample8"
    df$ID <- gsub("sample", "Sample", df$ID)

    result = validate_sample_ids(expected$ID, df$ID)
    if (!result$valid) {
        return(result)
    }

    ## check that Diagnoses all come from the set of allowed values
    # TODO do we allow NAs?
    diagnosis_values = c('CN', 'MCI', 'AD')
    result$valid = all(df$Diagnosis %in% diagnosis_values)
    if (!result$valid) {
        result$message = sprintf("Unrecognized values in the Diagnosis column: (%s). Allowed values are (%s).",
            paste(setdiff(df$Diagnosis, diagnosis_values), collapse=','),
            paste(diagnosis_values, collapse=','))
    }

    return(result)
}



# Question 1 - Predict change in MMSE at 24 months ------------------------

Q1_score = function (predicted, observed) {
    # predicted: a data.frame with two columns, ROSMAP ID and MMSE at 24 month predictions
    # observed: a data.frame with ROSMAP ID (rosmap.id) and actual MMSE at 24 month (mmse.24)

    # combine data
    combined.df <- merge (predicted, observed, by='projid')

    # calculate correlations
    corr_pearson_clin <- with (combined.df, cor(delta_MMSE_clin, MMSEm24-MMSEbl))
    if (is.na (corr_pearson_clin)) stop ("Unable to match subject identifiers")

    corr_pearson_clin_gen <- with (combined.df, cor(delta_MMSE_clin_gen, MMSEm24-MMSEbl))
    if (is.na (corr_pearson_clin_gen)) stop ("Unable to match subject identifiers")

    corr_spearman_clin <- with (combined.df, cor(delta_MMSE_clin, MMSEm24-MMSEbl, method="spearman"))
    if (is.na (corr_spearman_clin)) stop ("Unable to match subject identifiers")

    corr_spearman_clin_gen <- with (combined.df, cor(delta_MMSE_clin_gen, MMSEm24-MMSEbl, method="spearman"))
    if (is.na (corr_spearman_clin_gen)) stop ("Unable to match subject identifiers")

    list(correlation_pearson_clin=corr_pearson_clin,
         correlation_pearson_clin_gen=corr_pearson_clin_gen,
         correlation_spearman_clin=corr_spearman_clin,
         correlation_spearman_clin_gen=corr_spearman_clin_gen)
}


mean_rank = function (df) {
    ranks <- as.data.frame(lapply(df, function(x) {rank(-x)}))
    mean_rank <- apply(ranks, 1, mean)
    final_rank <- rank(mean_rank)

    results <- data.frame(mean_rank=mean_rank, final_rank=final_rank)
    rownames(results) <- rownames(df)

    return(results)
}


# Question 2 - Discordance ------------------------------------------------

Q2_score = function (predicted, observed) {
    # predicted should be a data.frame with ROSMAP ID and discordance probability predictions
    # observed is a data.frame for testing with ROSMAP ID (rosmap.id) and discordance indicator (disc.ind)

    # combine data
    combined.df <- merge (predicted, observed, by='projid')

    # > colnames(predicted)
    # [1] "projid"      "Rank"        "Confidence"  "Discordance"
    # > colnames(observed)
    #  [1] "id"                        "AGE"
    #  [3] "PTEDUCAT"                  "sex"
    #  [5] "APOE4"                     "MMSE"
    #  [7] "niareagansc"               "actual_discordance"
    #  [9] "discordance_probability"   "prediction_rank"
    # [11] "discordance_prediction"    "projid"
    # [13] "actual_discordance_string"

    # calculate metrics
    # Brier's score
    q2.brier <- with (combined.df, mean ((Confidence - actual_discordance)^2))
    if (is.na (q2.brier)) stop ("Unable to match subject identifiers")
    # AUC and CI
    q2.auc <- with (combined.df, as.numeric (roc(actual_discordance ~ Confidence)$auc))#, ci = TRUE))
    if (is.na (q2.auc)) stop ("Unable to match subject identifiers")
    ## Somer's D
    q2.s <- 2*(q2.auc - 0.5)

    balancedAccuracy <- function(pred,true){
        pred <- as.numeric(pred)
        true <- as.numeric(true)
        if(sum(!unique((c(pred,true)))%in%c(0,1))>0) stop ("Undiscovered matching error: recode")
        res <- table(pred,true)
        tp <- sum((pred==1)&(true==1))
        tn <- sum((pred==0)&(true==0))
        return(0.5*tp/(sum(true==1))+0.5*tn/(sum(true==0)))
    }

    ## Accuracy: according to the AD Challenge wiki, 1=Discordant and 0=Concordant
    predicted_discordance <- tolower(combined.df$Discordance) == "discordant"
    q2.balancedAccuracy <- balancedAccuracy(predicted_discordance,combined.df$actual_discordance)

    #logDeviance <- function(confidence,true){
    #    if((min(confidence,na.rm=T)<0)|(max(confidence>1,na.rm=T))|(sum(is.na(confidence)>0))) stop ("Undiscovered matching error: recode")
    #    ld <- -2*sum(log(confidence[true==1]))
    #    ld <- ld-2*sum(log(1-confidence[true==0]))
    #    return(ld)
    #}

    #q2.logDeviance <- with(combined.df, logDeviance(Confidence,actual_discordance))

    list(brier=q2.brier, auc=q2.auc, somer=q2.s, accuracy=q2.balancedAccuracy)
}


# Question 3 - Predict change in MMSE from image features -----------------

Q3_score <- function (predicted, observed) {

    ## fix for lower case sample IDs ex: "sample8" which should be "Sample8"
    predicted$ID <- gsub("sample", "Sample", predicted$ID)

    combined = merge(predicted, observed, by.x='ID', by.y='Sample.ID')
    if (nrow(combined) != nrow(observed)) {
        stop("Sample IDs don't match up")
    }

    ## predicted colnames = "ID", "MMSE", "Diagnosis"
    ## observed colnames = "Sample.ID", ...,  "MMSE_Total", ..., "V1.Conclusion.Disease_Status", ...

    ## compute two statistics on the MMSE
    pearson_mmse = cor(combined$MMSE, combined$MMSE_Total, method="pearson")
    ccc_mmse = epi.ccc(combined$MMSE, combined$MMSE_Total, ci="z-transform", conf.level=0.95)

    percent_correct_diagnosis = sum(combined$Diagnosis==combined$V1.Conclusion.Disease_Status) / nrow(combined) * 100.0

    list(pearson_mmse=pearson_mmse,
         ccc_mmse=ccc_mmse$rho.c$est,
         percent_correct_diagnosis=percent_correct_diagnosis)
}


score_q1 <- function(submission_path, observed_path) {
    predicted = read_delim_or_csv(submission_path)
    observed = read_scoring_data(observed_path) #"q1.rosmap.csv")
    Q1_score(predicted, observed)
}

score_q2 <- function(submission_path, observed_path) {
    predicted = read_delim_or_csv(submission_path)
    observed = read_scoring_data(observed_path) #"q2.observed.txt")
    Q2_score(predicted, observed)
}

score_q3 <- function(submission_path, observed_path) {
    predicted = read_delim_or_csv(submission_path)
    observed = read_scoring_data(observed_path) #"q3.observed.csv")
    Q3_score(predicted, observed)
}

# October 1, 2014 mcPlots, by S. Weisberg and J. Fox
# 'mc' stands for Marginal and Conditional:  for the specified regressor X in model 
# The 'marginal' plot is of Y vs X with Y and X both centered
# The 'conditional plot is the added-variable plot e(Y|rest) vs e(X|rest)
# If 'overlaid=TRUE', the default, both plots are overlayed
# If 'overlaid=FALSE', then the plots are side-by-side
# The 'overlaid' plot is similar to the initial and final frame of an ARES plot
# Cook and Weisberg (1989), "Regression diagnostics with dynamic graphics", Technometrics, 31, 277.
# This plot would benefit from animation.

mcPlots <- function(model, terms=~., layout=NULL, ask, overlaid=TRUE, ...){
	terms <- if(is.character(terms)) paste("~",terms) else terms
	vform <- update(formula(model),terms)
	if(any(is.na(match(all.vars(vform), all.vars(formula(model))))))
		stop("Only predictors in the formula can be plotted.")
	terms.model <- attr(attr(model.frame(model), "terms"), "term.labels")
	terms.vform <- attr(terms(vform), "term.labels")
	terms.used <- match(terms.vform, terms.model)
	mm <- model.matrix(model) 
	model.names <- attributes(mm)$dimnames[[2]]
	model.assign <- attributes(mm)$assign
	good <- model.names[!is.na(match(model.assign, terms.used))]
#	if (intercept) good <- c("(Intercept)", good)
  if(attr(attr(model.frame(model), "terms"), "intercept") == 0)
    stop("Error---the 'lm' object must have an intercept")
	nt <- length(good)
	if (nt == 0) stop("No plots specified")
#	if (missing(main)) main <- if (nt == 1) paste("Marginal/Conditional Plot:", good) else 
#                                                "Marginal/Conditional Plots"
  if (nt == 0) stop("No plots specified")
  if(overlaid){
    if (nt > 1 & (is.null(layout) || is.numeric(layout))) {
      if(is.null(layout)){
        layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2), 
                         c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
      }
      ask <- if(missing(ask) || is.null(ask)) prod(layout)<nt else ask
      op <- par(mfrow=layout, ask=ask, no.readonly=TRUE, 
                oma=c(0, 0, 1.5, 0), mar=c(5, 4, 1, 2) + .1)
      on.exit(par(op))
    }
  } else{
    if (nt >= 1 & (is.null(layout) || is.numeric(layout))) {
      if(is.null(layout)){
        layout <- switch(min(nt, 4), c(1, 2), c(2, 2), c(3, 2), c(4, 2))
      }
      ask <- if(missing(ask) || is.null(ask)) layout[1] < nt else ask
      op <- par(mfrow=layout, ask=ask, no.readonly=TRUE, 
                oma=c(0, 0, 1.5, 0), mar=c(5, 4, 1, 2) + .1)
      on.exit(par(op))
    }
  }
	for (term in good) mcPlot(model, term, new=FALSE, overlaid=overlaid, ...)
#	mtext(side=3,outer=TRUE,main, cex=1.2)
}



mcPlot <-  function(model, ...) UseMethod("mcPlot")

mcPlot.lm <- function(model, variable,
                      id.method = list(abs(residuals(model, type="pearson")), "x"),
                      labels, 
                      id.n = if(id.method[1]=="identify") Inf else 0,
                      id.cex=1, id.col=palette()[1],
                      col.marginal="blue", col.conditional="red", col.arrows="gray",
                      pch = c(16,1), lwd = 2, grid=TRUE,   ###removed arg main
                      ellipse=FALSE, ellipse.args=list(levels=0.5), 
                      overlaid=TRUE, new=TRUE, ...){
  variable <- if (is.character(variable) & 1 == length(variable))
                 variable  else deparse(substitute(variable))
  if(new && !overlaid) {
    op <- par(mfrow=c(1,2))
    on.exit(par(op))
  }
  if(missing(labels)) 
    labels <- names(residuals(model)[!is.na(residuals(model))])
  else deparse(substitute(variable))
  if(attr(attr(model.frame(model), "terms"), "intercept") == 0)
    stop("Error---the 'lm' object must have an intercept")
  mod.mat <- model.matrix(model)
  var.names <- colnames(mod.mat)
  var <- which(variable == var.names)
  if (0 == length(var))
    stop(paste(variable, "is not a column of the model matrix."))
  response <- response(model)
  responseName <- responseName(model)
  if (is.null(weights(model)))
    wt <- rep(1, length(response))
  else wt <- weights(model)
  res0 <- lm(cbind(mod.mat[, var], response) ~ 1, weights=wt)$residual
  res  <- lsfit(mod.mat[, -var], cbind(mod.mat[, var], response),
               wt = wt, intercept = FALSE)$residuals
  xlab <- paste(var.names[var], "| others") 
  ylab <- paste(responseName, " | others")  
  xlm <- c( min(res0[, 1], res[, 1]), max(res0[, 1], res[, 1]))
  ylm <- c( min(res0[, 2], res[, 2]), max(res0[, 2], res[, 2]))
  if(overlaid){ 
     plot(res[, 1], res[, 2], xlab = xlab, ylab = ylab, type="n", 
          main=paste("Marginal/Conditional plot of", var.names[var]),
          xlim=xlm, ylim=ylm,  ...)
     if(grid){
       grid(lty=1, equilogs=FALSE)
       box()}     
     points(res0[, 1], res0[, 2], pch=pch[1], col=col.marginal)
     points(res[, 1], res[, 2], col=col.conditional, pch=pch[2], ...)
     arrows(res0[, 1], res0[, 2], res[, 1], res[, 2], length=0.125, col=col.arrows)
     abline(lsfit(res0[, 1], res0[, 2], wt = wt), col = col.marginal, lwd = lwd)
     abline(lsfit(res[, 1], res[, 2], wt = wt), col = col.conditional, lwd = lwd)
     if (ellipse) {
       ellipse.args1 <- c(list(res0, add=TRUE, plot.points=FALSE, col=col.marginal), ellipse.args)
       do.call(dataEllipse, ellipse.args1)
       ellipse.args1 <- c(list(res, add=TRUE, plot.points=FALSE, col=col.conditional), ellipse.args)
       do.call(dataEllipse, ellipse.args1)
     }
     showLabels(res0[, 1],res0[, 2], labels=labels, 
              id.method=id.method, id.n=id.n, id.cex=id.cex, 
              id.col=id.col)
    colnames(res) <- c(var.names[var], responseName)
    rownames(res) <- rownames(mod.mat)
    invisible(res)} 
  else { # side.by.side plots
    plot(res0[, 1], res0[, 2], type="n", 
          xlab = paste("Centered", var.names[var], sep=" "), 
          ylab = paste("Centered", responseName, sep=" "), 
          main=paste("Marginal plot of", var.names[var]),
          xlim=xlm, ylim=ylm,  ...)
    if(grid){
       grid(lty=1, equilogs=FALSE)
       box()}     
    points(res0[, 1], res0[, 2], pch=pch[1], col=col.marginal)
    abline(lsfit(res0[, 1], res0[, 2], wt = wt), col = col.marginal, lwd = lwd)
    if (ellipse) {
      ellipse.args1 <- c(list(res0, add=TRUE, plot.points=FALSE, col=col.marginal), ellipse.args)
      do.call(dataEllipse, ellipse.args1)
    }
    showLabels(res0[, 1],res0[, 2], labels=labels, 
               id.method=id.method, id.n=id.n, id.cex=id.cex, 
               id.col=id.col)
    colnames(res) <- c(var.names[var], responseName)
    rownames(res) <- rownames(mod.mat)    
    plot(res[, 1], res[, 2], xlab = xlab, ylab = ylab, type="n", 
         main=paste("Added-Variable plot of", var.names[var]),
         xlim=xlm, ylim=ylm,  ...)
    if(grid){
      grid(lty=1, equilogs=FALSE)
      box()}
    points(res[, 1], res[, 2], col=col.conditional, pch=pch[2], ...)
    abline(lsfit(res[, 1], res[, 2], wt = wt), col = col.conditional, lwd = lwd)
    if (ellipse) {
       ellipse.args1 <- c(list(res, add=TRUE, plot.points=FALSE, col=col.conditional), ellipse.args)
       do.call(dataEllipse, ellipse.args1)
     }
    showLabels(res[, 1],res[, 2], labels=labels, 
                id.method=id.method, id.n=id.n, id.cex=id.cex, 
                id.col=id.col)
    invisible(res)}      
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

impute.rsf <- function(formula,#
                       data = NULL,#
                       ntree = 1000,#
                       mtry = NULL,#
                       nodesize = NULL,#
                       splitrule = NULL,#
                       nsplit = 0,#
                       big.data = FALSE,#
                       nimpute = 1,#
                       predictorWt = NULL,#
                       seed = NULL,#
                       do.trace = FALSE,#
                       ...)
{
  importance <- c("randomsplit", "permute", "none")[3]
  na.action <- c("na.omit", "na.impute")[2]
  forest <- FALSE
  proximity <- FALSE
  varUsed <- NULL
  split.depth <- FALSE
  class(data) <- c("data.frame", "impute.only")
  object <- rsf(formula = formula, data = data, ntree = ntree, mtry = mtry, nodesize = nodesize,
                splitrule = splitrule, nsplit = nsplit, big.data = big.data,
                nimpute = nimpute, predictorWt = predictorWt, seed = seed, do.trace = do.trace,
                importance = importance, na.action = na.action, forest = forest,
                proximity = proximity, varUsed = varUsed, split.depth = split.depth,
                impute.only = TRUE)
  imputed.data <- cbind(cens = object$cens, time = object$time, object$predictors)
  if (!is.null(object$imputedIndv)) {
    imputed.data[object$imputedIndv, ] <- object$imputedData
  }
  colnames(imputed.data)[c(2,1)] <- all.vars(object$formula)[1:2]
  invisible(imputed.data) 
}

setRefClass(Class = "PredictiveModel")

#' RSFmodel
#'
#' Constructs a predictive survival model using a random forest algorithm.
#'
#' @author Gaurav Pandey
#' @export

RSFmodel <- setRefClass(Class = "RSFmodel",
                        contains = "PredictiveModel",
                        fields=c("model","numFeatures","numTrees"),
                         
                         methods = list(
                           initialize = function(nFeatures=100,nTrees=10){
                             #                                    .self$family=family
                             .self$numFeatures = nFeatures;
                             .self$numTrees = nTrees;
                             return(.self)
                           },
                           
                           customTrain = function(exprData, copyData, clinicalFeaturesData, clinicalSurvData,  ...){
                             featureData <-t(createAggregateFeatureDataSet(list(expr = exprData, copy = copyData)))
                             allfeature_sd <- apply(featureData, 2, sd, na.rm=TRUE)
                             sorted_sd <- sort(allfeature_sd, decreasing=TRUE)
                             sorting_index <- order(allfeature_sd, na.last=TRUE, decreasing=TRUE)
                             data_for_model <- data.frame(featureData[,sorting_index[1:numFeatures]],time=clinicalSurvData[,"time"],status=clinicalSurvData[,"status"])                           
                             .self$model <- rsf(Surv(time,status)~., data=data_for_model, ntree=numTrees, big.data=TRUE)
                             
                           },
                           
                           customPredict = function(exprData, copyData, clinicalFeaturesData){
                                                                featureData <-t(createAggregateFeatureDataSet(list(expr = exprData, copy = copyData)))
                             data_for_test <- data.frame(featureData, pData(clinicalFeaturesData))
                             data_for_test$lymphnodes = factor(data_for_test$lymphnodes)
                             data_for_test$histology = factor(data_for_test$histology)
                             data_for_test$HER2 = factor(data_for_test$HER2)
                             data_for_test$ER = factor(data_for_test$ER)
                             data_for_test$PR = factor(data_for_test$PR)
                             data_for_test$ERPR = factor(data_for_test$ERPR)
                             
                             result <- predict(.self$model, data_for_test)
                             predictedResponse <- result$mortality
                             return(predictedResponse)
                           }
                           )
                         )

# Modified Nov. 24, 2009 by S. Weisberg to use showLabels
#   rather than showExtremes
# 11 & 20 January 2010: changed lty=3 to lty=1 for fitted curve. J. Fox
# 14 April 2010: set id.n = 0. J. Fox
# 15 April 2010; rewrite showLabels
# 25 May 2010 added grid() to plots, S. Weisberg
# 15 August 2010, fixed so col= works correctly with plot, but not Boxplot
# 15 August 2010, deleted pch= argument, as it wasn't used
# 17 January 2011, allow spline terms; plot against
#   predict(model, type="terms")[[term.name]]
# 1 February 2011 default for AsIs changed to TRUE
# 31 March 2011 tukeyNonaddTest updated to check that yhat^2 is not 
#   a linear combination of other predictors (as in 1-way anova).
# 6 April 2011 omit printing lack-of-fit if no lack-of-fit test is possible
# 16 June 2011 allow layout=NA, in which case the layout is not set in this
#  function, so it is the responsibility of the user
# 10 Feb 2013:  adjusted colinearity check in tukeyNonaddTest
# 21 March 2013:  fixed nonconstant variance test with missing values for glms
# 11 July 2013:  wording changes
# 11 July 2013:  'groups' arg for residualPlot and residualPlots.
# 19 July 2014:  type='rstudent' fixed
# 7 October 2014: trapped error resulting from groups= when n<3

residualPlots <- function(model, ...){UseMethod("residualPlots")}

residualPlots.default <- function(model, terms= ~ . , 
     layout=NULL, ask, main="", 
     fitted=TRUE, AsIs=TRUE, plot=TRUE, tests=TRUE, groups, ...){
  mf <- if(!is.null(terms)) termsToMf(model, terms) else NULL
  groups <- if (!missing(groups)) {
      termsToMf(model, as.formula(paste("~",
           deparse(substitute(groups)))))$mf.vars[, 2, drop=FALSE]
      } else {
      if(is.null(mf$mf.groups)) NULL else
                  mf$mf.groups[, 2, drop=FALSE]
      }  
  mf <- mf$mf.vars
  vform <- update(formula(model), attr(mf, "terms"))
  if(any(is.na(match(all.vars(vform), all.vars(formula(model))))))
     stop("Only regressors in the formula can be plotted.")
  terms <- attr(mf, "term.labels") # this is a list
  vterms <- attr(terms(vform), "term.labels")
# drop interactions (order > 1)
  vterms <- setdiff(vterms, terms[attr(mf, "order") > 1])
# keep only terms that are numeric or integer or factors or poly
  good <- NULL
  for (term in vterms) if(
      (AsIs == TRUE & inherits(model$model[[term]], "AsIs")) |
      inherits(model$model[[term]], "numeric") |
      inherits(model$model[[term]], "integer") |
      (inherits(model$model[[term]], "factor") & is.null(groups)) |
      inherits(model$model[[term]], "matrix") |
      inherits(model$model[[term]], "poly")) good <- c(good, term)
  nt <- length(good) + fitted
  nr <- 0  
  if (nt == 0) stop("No plots specified")
  if (nt > 1 & plot == TRUE & (is.null(layout) || is.numeric(layout))) {
    if(is.null(layout)){
         layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2), 
                             c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
    }
    ask <- if(missing(ask) || is.null(ask)) prod(layout)<nt else ask
    op <- par(mfrow=layout, ask=ask, no.readonly=TRUE, 
            oma=c(0, 0, 1.5, 0), mar=c(5, 4, 1, 2) + .1)
    on.exit(par(op))
    }
  ans <- NULL       
  if(!is.null(good)){
    for (term in good){
     nr <- nr + 1
     qtest <- if(is.null(groups))
                 residualPlot(model, term, plot=plot, ...) else
                 residualPlot(model, term, plot=plot, groups=groups, ...)
     if(!is.null(qtest)){
        ans <- rbind(ans, qtest)
        row.names(ans)[nr] <- term}
    } }   
  # Tukey's test
  if (fitted == TRUE){      
   tuk <- if(is.null(groups))
             residualPlot(model, "fitted", plot=plot, ...) else
             residualPlot(model, "fitted", plot=plot, groups=groups, ...)
   if (!is.null(tuk)  & class(model)[1] == "lm"){
      ans <- rbind(ans, tuk)
      row.names(ans)[nr + 1] <- "Tukey test"
      ans[nr + 1, 2] <- 2*pnorm(abs(ans[nr + 1, 1]), lower.tail=FALSE)}} 
  if(plot == TRUE) mtext(side=3, outer=TRUE, main, cex=1.2)
  if(!is.null(ans)) {
     dimnames(ans)[[2]] <- c("Test stat", "Pr(>|t|)")
     return(if(tests == FALSE | !is.null(groups)) invisible(ans) else
        if(all(is.na(ans))) warning("No possible lack-of-fit tests") else 
        round(ans, 3)) } else
  invisible(NULL)
  }
  
residualPlots.lm <- function(model, ...) {
 residualPlots.default(model, ...)
 }
  
residualPlots.glm <- function(model, ...) {
 residualPlots.default(model, ...)
 }

residualPlot <- function(model, ...) UseMethod("residualPlot")

residualPlot.default <- function(model, variable = "fitted", type = "pearson",
                 groups, 
                 plot = TRUE,
                 linear = TRUE,     
                 quadratic = if(missing(groups)) TRUE else FALSE, 
                 smoother=NULL, smoother.args=list(), 
                 col.smooth=palette()[3],
                 labels, 
                 id.method = "r", 
                 id.n = if(id.method[1]=="identify") Inf else 0,
                 id.cex=1, id.col=palette()[1], 
                 col = palette()[1], col.quad = palette()[2],
                 pch=1,
                 xlab, ylab, lwd = 1, lty = 1,  
                 grid=TRUE, key=!missing(groups), ...) {
 string.capitalize <- function(string) {
     paste(toupper(substring(string, 1, 1)), substring(string, 2), sep="")}
 if(missing(labels)) 
      labels <- names(residuals(model)[!is.na(residuals(model))])
 ylab <- if(!missing(ylab)) ylab else
         paste(string.capitalize(type), "residuals")
 column <- match(variable, names(model$model))
 if(is.na(column) && variable != "fitted")
   stop(paste(variable, "is not a regressor in the mean function"))
 horiz <- if(variable == "fitted") predict(model) else model$model[[column]]
 lab <- if(variable == "fitted") {
    if(inherits(model, "glm")) 
       "Linear Predictor" else "Fitted values"} else variable
 lab <- if(!missing(xlab)) xlab else lab
 if(class(horiz)[1] == "ordered") horiz <- factor(horiz, ordered=FALSE)
 ans <-
   if(inherits(horiz, "poly")) {
       horiz <- horiz[ , 1]
       lab <- paste("Linear part of", lab)
       c(NA, NA)}
   else if (inherits(horiz, "matrix")) {
       horiz <- try(predict(model, type="terms"), silent=TRUE)
       if(class(horiz) == "try-error") 
          stop("Could not plot spline terms") 
       warning("Splines replaced by a fitted linear combination")
       horiz <- horiz[ , variable]
       c(NA, NA)
       }
   else if (inherits(horiz, "factor")) c(NA, NA)
   else residCurvTest(model, variable)
# are there groups
 if(!missing(groups)){
   if(is.data.frame(groups)){
      groups.name <- names(groups)[1]
      groups <- groups[, 1, drop=TRUE]
      }  else 
      groups.name <- deparse(substitute(groups))
   groups <- if(class(groups)[1] == "factor") groups else factor(groups, ordered=FALSE)
   if(key){ 
     mar3 <- 1.1 + length(levels(groups))
     op <- par(mar=c(5.1, 4.1, mar3, 2.1))
     on.exit(par(op))
     }   
   colors <- if(length(col) >=length(levels(groups))) col else palette()
   col <- colors[as.numeric(groups)]
   pchs <- if(length(pch) >= length(levels(groups))) pch else 1:length(levels(groups))
   pch <-  pchs[as.numeric(groups)] 
 }
 theResiduals <- switch(type, "rstudent"=rstudent(model), 
               "rstandard"=rstandard(model), residuals(model, type=type))
 if(plot==TRUE){
  if(class(horiz) == "factor") {
     idm <- if(is.list(id.method)) {
            lapply(id.method, function(x) if(x[1]=="xy") "y" else x)} else {
            if(id.method[1] == "xy") "y"}    
     Boxplot(theResiduals, horiz, xlab=lab, ylab=ylab, labels=labels, 
            id.method=idm, id.n=id.n, id.cex=id.cex,  
            id.col=id.col, ...) 
     abline(h=0, lty=2) } else 
     {    
     plot(horiz, theResiduals, xlab=lab, ylab=ylab, type="n", ...)
	   if(grid){
       grid(lty=1, equilogs=FALSE)
       box()}
     points(horiz, theResiduals, col=col, pch=pch, ...)
     if(linear){
        if(missing(groups)){abline(h=0, lty=2, lwd=2)} else {
        for (g in 1:length(levels(groups)))
             try(abline(lm(theResiduals ~ horiz, 
                       subset=groups==levels(groups)[g]), lty=2, lwd=2,
                       col=colors[g]), silent=TRUE)
        }}
     if(quadratic){
       new <- seq(min(horiz), max(horiz), length=200)
       if(missing(groups)){
          if(length(unique(horiz)) > 2){
             lm2 <- lm(theResiduals ~ poly(horiz, 2))
             lines(new, predict(lm2, list(horiz=new)), lty=1, lwd=2, col=col.quad)
             }} else {
          for (g in 1:length(levels(groups))){
             if(length(unique(horiz)) > 2){
             lm2 <- lm(theResiduals~poly(horiz, 2),
                subset=groups==levels(groups)[g])
             lines(new, predict(lm2, list(horiz=new)), lty=1, lwd=1.5, col=colors[g])
             }}}}
     if(is.function(smoother))
       if(missing(groups)){
       smoother(horiz, theResiduals, col.smooth, log.x=FALSE, log.y=FALSE,
          spread=FALSE, smoother.args=smoother.args)} else
       for (g in 1:length(levels(groups))){
          sel <- groups == levels(groups)[g]
          smoother(horiz[sel], theResiduals[sel], colors[g], log.x=FALSE, log.y=FALSE,
             spread=FALSE, smoother.args=smoother.args)}
     if(key & !missing(groups)){
       items <- paste(groups.name, levels(groups), sep= " = ")
       plotArrayLegend("top", items=items, col.items=colors, pch=pchs)
       }
     showLabels(horiz, theResiduals, labels=labels, 
            id.method=id.method, id.n=id.n, id.cex=id.cex, 
            id.col=id.col)  
        }
      }  
  invisible(ans)}
 
residCurvTest <- function(model, variable) {UseMethod("residCurvTest")}
residCurvTest.lm <- function(model, variable) {
 if(variable == "fitted") tukeyNonaddTest(model) else {
  if(is.na(match(variable, attr(model$terms, "term.labels"))))
     stop(paste(variable, "is not a term in the mean function")) else {
     xsqres <- qr.resid(model$qr, model.frame(model)[[variable]]^2)
     r <- residuals(model, type="pearson")
     m1 <- lm(r ~ xsqres, weights=weights(model))
     df.correction <- sqrt((df.residual(model)-1) / df.residual(m1))
     test <- summary(m1)$coef[2, 3] * df.correction
     c(Test=test, Pvalue=2 * pt(-abs(test), df.residual(model)-1))
     }}}

residCurvTest.glm <- function(model, variable) {
 if(variable == "fitted") c(NA, NA) else {
  if(is.na(match(variable, attr(model$terms, "term.labels"))))
     stop(paste(variable, "is not a term in the mean function")) else {
     newmod <- paste(" ~ . + I(", variable, "^2)")
     m2 <- update(model, newmod, start=NULL)
     c(Test= test<-deviance(model)-deviance(m2), Pvalue=1-pchisq(test, 1))
}}}

residCurvTest.negbin <- function(model, variable) {
  if(variable == "fitted") c(NA, NA) else {
    if(is.na(match(variable, attr(model$terms, "term.labels"))))
      stop(paste(variable, "is not a term in the mean function")) else {
        newmod <- paste(" ~ . + I(", variable, "^2)")
        m2 <- update(model, newmod, start=NULL)
        c(Test= test<-m2$twologlik - model$twologlik, Pvalue=1-pchisq(test, 1))
      }}}
     
tukeyNonaddTest <- function(model){
 tol <- model$qr$tol
 qr <- model$qr
 fitsq <- predict(model, type="response")^2
 fitsq <- qr.resid(qr, fitsq/sqrt(sum(fitsq^2)))
 if(sd(fitsq) < tol) {
    return(c(Test=NA, Pvalue=NA))
 } else {
    r <- residuals(model, type="pearson")
    m1 <- lm(r ~ fitsq, weights=weights(model))
    df.correction <- sqrt((df.residual(model) - 1)/df.residual(m1))
    tukey <- summary(m1)$coef[2, 3] * df.correction
    c(Test=tukey, Pvalue=2*pnorm(-abs(tukey)))
    }
 }
 

 
residualPlot.lm <- function(model, ...) {
  residualPlot.default(model, ...)
  }
  
residualPlot.glm <- function(model, variable = "fitted", type = "pearson", 
                 plot = TRUE, quadratic = FALSE, 
                 smoother = loessLine, smoother.args=list(k=3), ...) {
  residualPlot.default(model, variable=variable, type=type, plot=plot, 
                 quadratic=quadratic, smoother=smoother, 
                 smoother.args=smoother.args, ...)
  }

#' PredictiveModelPerformance
#'
#' A class implementing various performance evaluation methods upon PredictiveModelResults
#'
#' @seealso PredictiveModelResults
#' @author Adam Margolin
#' @export
PredictiveModelPerformance <- setRefClass(Class = 'PredictiveModelPerformance',
                                          
	  fields = list(foldResults='list',
                  trainPredictions="numeric",
                  trainObservations="numeric",
                  testPredictions="numeric",
                  testObservations="numeric"
                  ),
                                          
    methods = list(
        initialize = function(foldResults, ...){
            .self$foldResults <- foldResults
            
            .self$trainPredictions <- do.call("c", foldResults$trainPredictions)
            .self$trainObservations <- do.call("c", foldResults$trainObservations)
            .self$testPredictions <- do.call("c", foldResults$testPredictions)
            .self$testObservations <- do.call("c", foldResults$testObservations)
          
            return(.self)
        },
        
        getR2 = function(){
#             return(cor(.self$testPredAndObs$pred, .self$testPredAndObs$obs) ^ 2)
        },
        
        getTestError = function(){
#           return((.self$testPredAndObs$pred - .self$testPredAndObs$obs) ^ 2)
        },
        
        plotPredAndObs = function(){
          .plotHelper(
                  trainPred=.self$trainPredAndObs$pred,
                  trainObs=.self$trainPredAndObs$obs,
                  testPred=.self$testPredAndObs$pred,
                  testObs=.self$testPredAndObs$obs)          
        }
    )
	)


.plotHelper <- function(trainPred, trainObs, testPred, testObs) {
  par(mfrow=c(2,1))
  plot(
       trainPred,
       trainObs,
       main='predicted versus observed for training data',
       xlab='predicted',
       ylab='observed')
  plot(
       testPred,
       testObs,
       main='predicted versus observed for test data',
       xlab='predicted',
       ylab='observed')
}

### R code from vignette source 'predictiveModelingDemo.Rnw'

###################################################
### code chunk number 1: loadlib
###################################################
library(predictiveModeling)

# Change the values of these variables 
myName <- Sys.getenv("USER")
myWorkingDirectory <- "."

setwd(myWorkingDirectory)


###################################################
### code chunk number 2: fakeLogin (eval = FALSE)
###################################################
library(synapseClient)
synapseLogin()

project <- Project(list(
  name=paste("Machine Learning Results - ", myName)
  ))
project <- createEntity(project)

onWeb(project)

analysis <- Analysis(list(
    name="Elastic net versus custom methods",
    description="Several Machine Learning methods run upon CCLE Data with Sanger Drug Response",
    parentId=propertyValue(project, "id")
    ))
analysis <- createEntity(analysis)

dataset <- Dataset(list(
  name="Analysis Plots",
  parentId=propertyValue(project, "id")
  ))
dataset <- createEntity(dataset)


###################################################
### code chunk number 3: fakeLoadData (eval = FALSE)
###################################################
## 
#### Load Data from Synapse ####
idExpressionLayer <- "48344"
expressionLayer <- loadEntity(idExpressionLayer)
exprSet <- expressionLayer$objects$exprSet

idCopyLayer <- "48339"
copyLayer <- loadEntity(idCopyLayer)
copySet <- copyLayer$objects$copySet

idOncomapLayer <- "48341"
oncomapLayer <- loadEntity(idOncomapLayer)
oncomapSet <- oncomapLayer$objects$oncomapSet

idSangerLayer <- "48337"
sangerLayer <- loadEntity(idSangerLayer)
sangerADF <- sangerLayer$objects$sangerADF


###################################################
### code chunk number 4: realLoadData
###################################################
# data(demoData)


###################################################
### code chunk number 5: exploreSangerData
###################################################
print(colnames(pData(sangerADF)))


###################################################
### code chunk number 6: aggregateFeatures
###################################################
ds_features_cn_mut_ccle <- createAggregateFeatureDataSet(list(copy = copySet, mut = oncomapSet))
checkEquals(nrow(ds_features_cn_mut_ccle), nrow(exprs(copySet)) + nrow(exprs(oncomapSet)))


###################################################
### code chunk number 7: intersectFeaturesAndResponse
###################################################
dataSets_ccleFeaturesCnMut_sangerChems <- createFeatureAndResponseDataList(ds_features_cn_mut_ccle, sangerADF)

ls(dataSets_ccleFeaturesCnMut_sangerChems)
checkEquals(colnames(dataSets_ccleFeaturesCnMut_sangerChems$featureData), colnames(dataSets_ccleFeaturesCnMut_sangerChems$responseData))


###################################################
### code chunk number 8: normalizeData
###################################################
featureData_scaled <- t(scale(t(dataSets_ccleFeaturesCnMut_sangerChems$featureData)))
responseData_scaled <- t(scale(t(dataSets_ccleFeaturesCnMut_sangerChems$responseData["PLX4720",,drop=FALSE])))

print(dim(featureData_scaled))
print(dim(responseData_scaled))


###################################################
### code chunk number 9: brafMutBoxplot
###################################################
boxplot(as.numeric(responseData_scaled) ~ featureData_scaled["BRAF_mut",], names = c("BRAF WT", "BRAF Mut"), ylab="PLX4720 IC50", col="blue")


###################################################
### code chunk number 10: trainElasticNetModel
###################################################
predictiveModel_eNet <- CaretModel$new(modelType = "glmnet")
predictiveModel_eNet$train(t(featureData_scaled), t(responseData_scaled), tuneGrid=createENetTuneGrid(alphas=1))


###################################################
### code chunk number 11: evaluateElasticNetTuningParameter
###################################################
caretModel_eNet <- predictiveModel_eNet$rawCaretModel()
print(plot(caretModel_eNet))
print(caretModel_eNet$finalModel$tuneValue)


###################################################
### code chunk number 12: plotElasticNetHeatmap
###################################################
coefs_eNet <- caretModel_eNet$finalModel$beta[, ncol(caretModel_eNet$finalModel$beta)]
outputFileElasticNet <- 'PLX4720_ElasticNetModel.jpg'
plotPredictiveModelHeatmap(coefs_eNet, featureData_scaled, responseData_scaled, outputFile=outputFileElasticNet)


###################################################
### code chunk number 13: storeElasticNet (eval = FALSE)
###################################################
elasticNetLayer <- Layer(list(
                            name="ElasticNet Results for PLX4720",
                            type="M", 
                            parentId=propertyValue(dataset, "id")))
elasticNetLayer <- addFile(elasticNetLayer, outputFileElasticNet)
storeEntity(elasticNetLayer)
## 
## step1 <- stopStep()
## onWeb(step1)
## 
## propertyValue(step1, 'name') <- "Single run using elastic net"
## propertyValue(step1, 'description') <- "I found that ... looked very interesting due to ..."
## step1 <- updateEntity(step1)
## 
## step2 <- startStep(analysis)
## propertyValue(step2, 'name') <- "Cross validation using elastic net"
## propertyValue(step2, 'input') <- propertyValue(step1, "input")
## step2 <- updateEntity(step2)
## 
## onWeb(analysis)
## 
## 


###################################################
### code chunk number 14: crossValidateElasticNet
###################################################
cvResults_eNet <- crossValidatePredictiveModel(t(featureData_scaled), t(responseData_scaled), model=CaretModel$new(modelType="glmnet"), tuneGrid=createENetTuneGrid(alphas=1), numFolds=3)


###################################################
### code chunk number 15: plotElasticNetPredAndObs
###################################################
cvResults_eNet$plotPredAndObs()


###################################################
### code chunk number 16: crossValidateElasticNet
###################################################
cvResults_eNet_lowLambda <- crossValidatePredictiveModel(t(featureData_scaled), t(responseData_scaled), model=CaretModel$new(modelType="glmnet"), tuneGrid=createENetTuneGrid(alphas=1, lambdas=c(2e-10, 1e-10)), numFolds=3)

cvResults_eNet_lowLambda$plotPredAndObs()


###################################################
### code chunk number 17: boxplot_eNet_vs_eNetLowLambda
###################################################
boxplot(cvResults_eNet$getTestError(), cvResults_eNet_lowLambda$getTestError(), log="y", names = c("ENet", "ENet Low Lambda"), ylab="Test Errors", col="blue")
t.test(cvResults_eNet$getTestError(), cvResults_eNet_lowLambda$getTestError())


###################################################
### code chunk number 18: fitMostCorrFeaturesModel
###################################################
predictiveModel_mostCorr <- MostCorrelatedFeatures$new()
predictiveModel_mostCorr$train(t(featureData_scaled), t(responseData_scaled))

outputFileMostCorr <- 'PLX4720_MostCorrModel.jpg'
coefs_mostCorr <- predictiveModel_mostCorr$coefficients[2:length(predictiveModel_mostCorr$coefficients)]
plotPredictiveModelHeatmap(coefs_mostCorr, featureData_scaled, responseData_scaled, outputFile=outputFileMostCorr)


###################################################
### code chunk number 19: plotMostCorrFeaturesModelPredAndObs
###################################################
cvResults_mostCorr <- crossValidatePredictiveModel(t(featureData_scaled), t(responseData_scaled), model=MostCorrelatedFeatures$new(), numFolds=3)
cvResults_mostCorr$plotPredAndObs()


###################################################
### code chunk number 20: boxplot_eNet_vs_eNetLowLambda_vs_mostCorrFeatures
###################################################
cvResults_eNet$getR2()
cvResults_eNet_lowLambda$getR2()
cvResults_mostCorr$getR2()

boxplot(cvResults_eNet$getTestError(), cvResults_eNet_lowLambda$getTestError(), cvResults_mostCorr$getTestError(), log="y", names = c("ENet", "ENet Low Lambda", "Multiple Regression"), ylab="Test Error", col="blue")


###################################################
### code chunk number 21: sessionInfo
###################################################
toLatex(sessionInfo())

install.packages("digest")
#install.packages("nnet", repos=NULL,type="source")
install.packages("BayesTree")
install.packages("Code",repos=NULL,type="source")
install.packages("Models",repos=NULL,type="source")

library("digest")
library("BayesTree")
library("Code")
library("Models")
#library("glmnet")

# Load modified version of bart.R
# source("Models/R/bart.R")

#model<-RandomForestTrain("train",args=list(R=10))
#model<-GlmnetTrain("train",args=list(R=10,pls=TRUE))
#model<-GbmTrain("train")
#predictions<-model("test")

# Save any prior random number generator seed
#old.seed <- .Random.seed
# Set random number generator seed for reproducibility
new.seed <- 9438
set.seed(new.seed)
# test.name<-"val"
test.name<-"test"
# Train model
features = c("static","alsfrs","fvc","svc","vital")
slope.features = c("alsfrs","fvc","svc","vital")
# args=list(test.name=test.name,R=10,pls=FALSE,prune=FALSE,std=FALSE,
# Setting test.name=NULL so that NAs are not imputed with the test set
args=list(test.name=NULL,R=10,pls=FALSE,prune=FALSE,std=FALSE,
	features=features,slope.features=slope.features)
model <- BartTrain(train.name="traintest",target=NULL,args=args)
# model <- GlmnetTrain(train.name="traintest",target=NULL,args=args)

# Form predictions on test set
predictions<-model(test.name)

# Write predictions to file
write.table(predictions[order(predictions[,1]),], file="predicted.out", 
	append=FALSE, quote=TRUE, sep=",",
	col.names=FALSE, row.names=FALSE, qmethod="escape")
	
# Restore prior RNG seed
#.Random.seed <- old.seed

# Boot:  A reimplementation of bootCase using the 'boot' package to do the
#  work.  The main function 'Boot' creates the 'statistic' argument to
#  'boot', and passes this function to 'boot'
# For the call b1 <- Boot(m1) and b2 <- bootCase(m1),
#   b2 was the returned bootstaps; this is in b1$t
# b1 is of class c("Boot", "boot", so ALL the 'boot' generic methods work
# 'Boot' has new generic methods 'summary', 'confint' and 'hist'

# notes:  See Davison and Hinkley Chapters 6 and 7.
# Boot.lm, method="case" is the simple case resampling
#             method="residual" uses algorithm 6.3, p. 271
#               The use of weights comes from using 'pearson' residuals
#               This is equivalent to alg. 6.1, p262, unweighted
# Boot.glm method="case" as for lm
#             method="residual" not implemented.  Too problematic.
# May 23, 2012 Sanford Weisberg sandy@umn.edu
# June 1, 2012:  changed from class c("Boot", "boot") to just class "boot"
# 2012-12-10 replaced .GlobalEnv with .carEnv to avoid warnings
# 2013-07-08 changed .carEnv to car:::.carEnv so 'boot' could find the environment
# 4014-08-17: added calls to requireNamespace() and :: where necessary. J. Fox
# 2015-01-27 .carEnv now in global environment. John
# 2015-02-20: fixed coding error in Boot.nls(). John

Boot <- function(object, f, labels, R=999, method){UseMethod("Boot")}

Boot.default <- function(object, f=coef, labels=names(coef(object)),
                     R=999, method=c("case", "residual")) {
  if(!(requireNamespace("boot"))) stop("The 'boot' package is missing")
  f0 <- f(object)
  if(length(labels) != length(f0)) labels <- paste("V", seq(length(f0)), sep="")
  method <- match.arg(method)
  if(method=="case") {
     boot.f <- function(data, indices, .fn) {
      assign(".boot.indices", indices, envir=.carEnv)
      mod <- update(object, subset=get(".boot.indices", envir=.carEnv))
      if(mod$qr$rank != object$qr$rank){
            out <- .fn(object)
            out <- rep(NA, length(out)) } else  {out <- .fn(mod)}
     out
     }
    } else {
    boot.f <- function(data, indices, .fn) {
      first <- all(indices == seq(length(indices)))
      res <- if(first) object$residuals else
                  residuals(object, type="pearson")/sqrt(1 - hatvalues(object))
      res <- if(!first) (res - mean(res)) else res
      val <- fitted(object) + res[indices]
      if (!is.null(object$na.action)){
            pad <- object$na.action
            attr(pad, "class") <- "exclude" 
            val <- naresid(pad, val)
            }
      assign(".y.boot", val, envir=.carEnv)
      mod <- update(object, get(".y.boot", envir=.carEnv) ~ .)
      if(mod$qr$rank != object$qr$rank){
            out <- .fn(object)
            out <- rep(NA, length(out)) } else  {out <- .fn(mod)}
      out
      }
  } 
  b <- boot::boot(data.frame(update(object, model=TRUE)$model), boot.f, R, .fn=f)
  colnames(b$t) <- labels
  if(exists(".y.boot", envir=.carEnv))
     remove(".y.boot", envir=.carEnv)
  if(exists(".boot.indices", envir=.carEnv))
     remove(".boot.indices", envir=.carEnv)
  b
  }
  
Boot.lm <- function(object, f=coef, labels=names(coef(object)),
                     R=999, method=c("case", "residual"))
   Boot.default(object, f, labels, R, method)
  
Boot.glm <- function(object, f=coef, labels=names(coef(object)),
                     R=999, method=c("case", "residual")) {
  method <- match.arg(method)
  if(method=="case") { Boot.default(object, f, labels, R, method)
    } else {
    stop("Residual bootstrap not implemented in the 'car' function Boot.
  Use the 'boot' function in the 'boot' package to write
  your own version of residual bootstrap for a glm.")
   }
  }
  
Boot.nls <- function(object, f=coef, labels=names(coef(object)),
                     R=999, method=c("case", "residual")) {
  if(!(requireNamespace("boot"))) stop("The 'boot' package is missing")
  f0 <- f(object)
  if(length(labels) != length(f0)) labels <- paste("V", seq(length(f0)), sep="")
  method <- match.arg(method)
  opt<-options(show.error.messages = FALSE)
  if(method=="case") {
     boot.f <- function(data, indices, .fn) {
         assign(".boot.indices", indices, envir=.carEnv)
         mod <- try(update(object, subset=get(".boot.indices", envir=.carEnv),
                 start=coef(object)))
         if(class(mod) == "try-error"){
            out <- .fn(object)
            out <- rep(NA, length(out)) } else  {out <- .fn(mod)}
     out
     }
    } else {
    boot.f <- function(data, indices, .fn) {
      first <- all(indices == seq(length(indices)))
      res <- residuals(object)
      val <- fitted(object) + res[indices]
      if (!is.null(object$na.action)){
            pad <- object$na.action
            attr(pad, "class") <- "exclude"
            val <- naresid(pad, val)
            }
      assign(".y.boot", val, envir=.carEnv)
      mod <- try(update(object, get(".y.boot", envir=.carEnv) ~ .,
             start=coef(object)))
      if(class(mod) == "try-error"){
            out <- .fn(object)
            out <- rep(NA, length(out)) } else  {out <- .fn(mod)}
      out
      }
  }
  b <- boot::boot(data.frame(update(object, model=TRUE)$model), boot.f, R, .fn=f)
  colnames(b$t) <- labels
  if(exists(".y.boot", envir=.carEnv))
     remove(".y.boot", envir=.carEnv)
  if(exists(".boot.indices", envir=.carEnv))
     remove(".boot.indices", envir=.carEnv)
  options(opt)
  d <- dim(na.omit(b$t))[1]
  if(d != R)
   cat( paste("\n","Number of bootstraps was", d, "out of", R, "attempted", "\n"))
  b
  }

confint.boot <- function(object, parm, level = 0.95,
    type = c("bca", "norm", "basic", "perc", "all"), ...){
  if (!requireNamespace("boot")) "boot package is missing"
  cl <- match.call()
  type <- match.arg(type)
  if(type=="all") stop("Use 'boot.ci' if you want to see 'all' types")
  types <-   c("bca", "norm", "basic", "perc")
  typelab <- c("bca", "normal",   "basic", "percent")[match(type, types)]
  nn <- colnames(object$t)
  names(nn) <- nn
  parm <- if(missing(parm)) which(!is.na(object$t0)) else parm
  out <- list()
  for (j in 1:length(parm)){
   out[[j]] <- boot::boot.ci(object, conf=level, type=type, index=parm[j], ...)
  }
  levs <- unlist(lapply(level, function(x) c( (1-x)/2, 1 - (1-x)/2)))
  ints <- matrix(0, nrow=length(parm), ncol=length(levs))
  rownames(ints) <- nn[parm]
  for (j in 1:length(parm)){
    which <- if(typelab=="normal") 2:3 else 4:5
    ints[j, ] <- as.vector(t(out[[j]][[typelab]][, which]))
  }
  or <- order(levs)
  levs <- levs[or]
  ints <- ints[, or, drop=FALSE]
  colnames(ints) <- paste(round(100*levs, 1), " %",sep="")
  attr(ints,"type") <- typelab
  class(ints) <- c("confint.boot", class(ints))
  ints
}
print.confint.boot <- function(x, ...) {
  cat("Bootstrap quantiles, type = ", attr(x, "type"), "\n\n")
  print(as.data.frame(x), ...)
  }


summary.boot <- function (object, parm, high.moments = FALSE, 
    extremes=FALSE, ...)
{
    cl <- match.call()
    skew1 <- function(x){
       x <- x[!is.na(x)]
       xbar <- mean(x)
       sum((x-xbar)^3)/(length(x) * sd(x)^3)
       }
    kurtosis1 <- function (x) {
       x <- x[!is.na(x)]
       xbar <- mean(x)
       sum((x - xbar)^4)/(length(x) * sd(x)^4) - 3
       }
    not.aliased <-  !is.na(object$t0)
    boots <- object$t[ , not.aliased, drop=FALSE ]
    nc <- if(is.matrix(boots)) ncol(boots) else 1
    stats <- matrix(rep(NA, nc * 10), ncol = 10)
    rownames(stats) <- colnames(boots)
    stats[, 1] <- apply(boots, 2, function(x) sum(!is.na(x))) # num. obs
    stats[, 2] <- object$t0[not.aliased]  # point estimate
    stats[, 3] <- apply(boots, 2, function(x) mean(x, na.rm=TRUE)) - stats[, 2]
    stats[, 5] <- apply(boots, 2, function(x) median(x, na.rm=TRUE))
    stats[, 4] <- apply(boots, 2, function(x) sd(x, na.rm=TRUE))
    stats[, 6] <- apply(boots, 2, function(x) min(x, na.rm=TRUE))
    stats[, 7] <- apply(boots, 2, function(x) max(x, na.rm=TRUE))
    stats[, 8] <- stats[, 7] - stats[, 6]
    stats[, 9] <- apply(boots, 2, skew1)
    stats[, 10] <- apply(boots, 2, kurtosis1)
    colnames(stats) <- c(
      "R", "original", "bootBias", "bootSE", "bootMed", "bootMin",
     "bootMax", "bootRange", "bootSkew", "bootKurtosis")
    stats <- as.data.frame(stats)
    class(stats) <- c("summary.boot", "data.frame")
    use <- rep(TRUE, 10)
    if (high.moments == FALSE) use[9:10] <- FALSE
    if (extremes==FALSE) use[6:8] <- FALSE
    parm <- if(missing(parm)) 1:dim(stats)[1] else parm
    return(stats[parm , use])
}
print.summary.boot <- 
   function(x, digits = max(getOption("digits") - 2, 3), ...)
{
    print.data.frame(x, digits=digits, ...)
}

hist.boot <- function(x, parm, layout=NULL, ask, main="", freq=FALSE,
      estPoint = TRUE, point.col="black", point.lty=2, point.lwd=2,
      estDensity = !freq, den.col="blue", den.lty=1, den.lwd=2,
      estNormal = !freq,  nor.col="red",   nor.lty=2, nor.lwd=2,
      ci=c("bca", "none", "percentile"), level=0.95,
      legend=c("top", "none", "separate"), box=TRUE, ...){
  not.aliased <- which(!is.na(x$t0))
  ci <- match.arg(ci)
  legend <- match.arg(legend)
  pe <- x$t0[not.aliased]
  if(is.null(names(pe))) names(pe) <- colnames(x$t)
  if(missing(parm)) parm <- not.aliased
  nt <- length(parm) + if(legend == "separate") 1 else 0
  if (nt > 1 & (is.null(layout) || is.numeric(layout))) {
    if(is.null(layout)){
         layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2),
                             c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
    }
    ask <- if(missing(ask) || is.null(ask)) prod(layout) < nt else ask
    oma3 <- if(legend == "top") 0.5 + estPoint + estDensity + estNormal
              else 1.5
    op <- par(mfrow=layout, ask=ask, no.readonly=TRUE,
            oma=c(0, 0, oma3, 0), mar=c(5, 4, 1, 2) + .1)
    on.exit(par(op))
    }
  if(ci != "none") clim <- confint(x, method=ci, level=level)
  pn <- colnames(x$t)
  names(pn) <- pn
  what <- c(estNormal & !freq, estDensity & !freq, ci != "none", estPoint)
  for (j in parm){
# determine the range of the y-axis
       z <- na.omit(x$t[, j])
       h <- hist(z, plot=FALSE)
       d <- density(z)
       n <- pnorm(0)/(sd <- sd(z))
       m <- if(freq == FALSE) max(h$density, d$y, n) else max(h$counts)
       plot(h, xlab=pn[j], freq=freq,
            main=if(length(parm)==1) main else "", ylim=c(0, m), ...)
       if(estDensity & !freq){
          lines(d, col=den.col, lty=den.lty, lwd=den.lwd)
          }
       if(estNormal & !freq){
          z <- na.omit(x$t[, j])
          xx <- seq(-4, 4, length=400)
          xbar <- mean(z)
          sd <- sd(z)
          lines( xbar + sd*xx, dnorm(xx)/sd, col=nor.col, lty=nor.lty,
              lwd=nor.lwd)
          }
       if(ci != "none") lines( clim[j ,], c(0, 0), lwd=4)
       if(estPoint) abline(v=pe[j], lty=point.lty, col=point.col, lwd=point.lwd)
       if(box) box()
       if( j == parm[1] & legend == "top" ) { # add legend
		        usr <- par("usr")
		        legend.coords <- list(x=usr[1], y=usr[4] + 1.3 * (1 + sum(what)) *strheight("N"))
            legend( legend.coords,
             c("Normal Density", "Kernel Density",
             paste(ci, " ", round(100*level), "% CI", sep=""),
                   "Obs. Value")[what],
             lty=c(nor.lty, den.lty, 1, point.lty)[what],
             col=c(nor.col, den.col, "black", point.col)[what],
             fill=c(nor.col, den.col, "black", point.col)[what],
             lwd=c(2, 2, 4, 2)[what],
             border=c(nor.col, den.col, "black", point.col)[what],
             bty="n", cex=0.9, xpd=NA)#, #horiz=TRUE, offset=
		}
  }
  mtext(side=3, outer=TRUE, main, cex=1.2)
  if(legend == "separate") {
    plot(0:1, 0:1, xaxt="n", yaxt="n", xlab="", ylab="", type="n")
    use <- (1:4)[c( estNormal, estDensity, TRUE, ci != "none")]
    curves <- c("fitted normal density", "Kernel density est",
              paste(100*level, "% ", ci, " confidence interval", sep=""),
              "Observed value of statistic")
    colors <- c(nor.col, den.col, "black", point.col)
    lines <- c(nor.lty, den.lty, 1, point.lty)
    widths<- c(nor.lwd, den.lwd, 2, point.lty)
    legend("center", curves[use], lty=lines[use], lwd=widths[use],
          col=colors[use], box.col=par()$bg,
          title="Bootstrap histograms")
  }
  invisible(NULL)
  }
  

  

#' convertDataFrameToFeatureMatrix
#'
#' Convert a data frame to a numeric feature matrix that can be used as features in a predictive model 
#' Numeric features are left as numeric. Character or factor features are converted to binary features if
#' they have 2 unique values or if there are more than 2 unique values it is expanded to a binary feature
#' for each possible value.
#'
#' @author Adam Margolin
#' @export

convertDataFrameToFeatureMatrix <- function(dataFrame){
  if(is(dataFrame, "AnnotatedDataFrame")){
    dataFrame <- dataFrame@data
  }
  
  featureMatrix <- c()
  for (colCtr in 1:ncol(dataFrame)){
    featureMatrix <- cbind(featureMatrix, convertDataFrameColumnToFeatures(dataFrame[, colCtr], colnames(dataFrame)[colCtr]))
  }
  colnames(featureMatrix) <- make.names(colnames(featureMatrix))
  return(featureMatrix)
}

convertDataFrameColumnToFeatures <- function(dfColumn, colName){
  features <- matrix(NA, nrow=length(dfColumn), ncol=1)
  colnames(features) <- colName
  if (is.numeric(dfColumn)){
    print(paste("leaving", colName, "as numeric"))
    features[,1] <- dfColumn
  }else if (is.character(dfColumn)){
    factorLevels <- unique(dfColumn)
    if(length(factorLevels) == 2){
      print(paste("converting", colName, "to binary"))
      features[dfColumn == factorLevels[1]] <- 0
      features[dfColumn == factorLevels[2]] <- 1
    }else{
      print(paste("converting", colName, "to factors"))
      features <- matrix(0, nrow=length(dfColumn), ncol=length(factorLevels))
      curColNames <- c()
      for (factorCtr in 1:length(factorLevels)){
        curFactorLevel <- factorLevels[factorCtr]
        features[dfColumn==curFactorLevel, factorCtr] <- 1
        curColNames[factorCtr] <- paste(colName, curFactorLevel, sep="_")
      }
      colnames(features) <- curColNames
    }
  }else if (is.factor(dfColumn)){
    print("factors not yet supported")
  }else {
    print("error converting data.frame to features. Unknown column type")
  }
  
  return(features)
}

#
#
# This is the code for scoring submissions to the DREAM 9 Broad Challenge.
#
# Author: brucehoff and mehmetgonen
#
###############################################################################

library(RJSONIO)
library(synapseClient)

# page size for retrieving submissions
PAGE_SIZE<-100
# batch size for uploading submission status updates
BATCH_SIZE<-500

SUBCHALLENGE2_FEATURE_COUNT<-10
SUBCHALLENGE3_FEATURE_COUNT<-100

#### phase 1 (legacy)
#evaluationId1<-"2468319"
#evaluationId2<-"2468322"
#evaluationId3<-"2482339"

#measuredDataId<-"syn2468461"

#prioritizedGeneListId<-"syn2482403"
#copyNumberFeatureListId<-"syn2482674"
#expressionFeatureListId<-"syn2482675"
####

#### phase 3 (legacy)
#evaluationId1<-"2571160"
#evaluationId2<-"2571162"
#evaluationId3<-"2571164"

#measuredDataId<-"syn2582441"

#prioritizedGeneListId<-"syn2598397"
#copyNumberFeatureListId<-"syn2598376"
#expressionFeatureListId<-"syn2598381"
####

evaluationId1<-"2571166"
evaluationId2<-"2571168"
evaluationId3<-"2571170"

measuredDataId<-"syn2660068"

prioritizedGeneListId<-"syn2660067"
copyNumberFeatureListId<-"syn2660065"
expressionFeatureListId<-"syn2660066"
hybridMutationFeatureListId<-"syn2660220"

readMeasuredFile<-function(id) {
  synEntity<-synGet(id, ifcollision="keep.local")
  filePath<-getFileLocation(synEntity)
  measuredData<-parsePredictionFile(filePath)
  return (measuredData)
}

parsePredictionFile<-function(filePath) {  
  fileContent<-read.table(filePath, header=TRUE, sep="\t", skip=2, stringsAsFactors=FALSE)
  geneNames<-as.character(fileContent[,1])
  cellLineNames<-colnames(fileContent)[-2:-1]
  predictionData<-t(fileContent[,-2:-1])
  colnames(predictionData)<-geneNames
  rownames(predictionData)<-cellLineNames
  return (predictionData)
}

readFeatureFile<-function(id) {
  synEntity<-synGet(id)
  filePath<-getFileLocation(synEntity)
  featureData<-parseFeatureFile(filePath)
  return (featureData)
}

parseFeatureFile<-function(filePath) {
  fileContent<-read.csv(filePath, header=FALSE, sep="\t", stringsAsFactors=FALSE)
  featureData<-as.matrix(fileContent)
  return (featureData)
}

calculateScore<-function(measuredData, predictedData) {
  geneCount<-ncol(measuredData)
  correlationPerGene<-matrix(0, 1, geneCount)
  for (g in 1:geneCount) {
    correlationPerGene[g]<-cor(measuredData[,g], predictedData[,g], method="spearman")
  }
  score<-mean(correlationPerGene)
  return (score)
}

validate1<-function(evaluation) {
  total<-1e+10
  offset<-0
  statusesToUpdate<-list()

  while(offset<total) {
    submissionBundles<-synRestGET(sprintf("/evaluation/%s/submission/bundle/all?limit=%s&offset=%s&status=%s", evaluation$id, PAGE_SIZE, offset, "RECEIVED")) 
    total<-submissionBundles$totalNumberOfResults
    offset<-offset+PAGE_SIZE
    page<-submissionBundles$results
    if (length(page)>0) {
      measuredData<-readMeasuredFile(measuredDataId)
      for (i in 1:length(page)) {
        submission<-synGetSubmission(page[[i]]$submission$id, ifcollision="keep.local")
        filePath<-getFileLocation(submission)
        directoryPath<-dirname(filePath)
        checkSubmission<-try(
{
  stopifnot(length(list.files(directoryPath, pattern="\\.gct$")) == 1)
  predictedData<-parsePredictionFile(filePath)
  stopifnot(setequal(rownames(measuredData), rownames(predictedData)))
  stopifnot(setequal(colnames(measuredData), colnames(predictedData)))
  predictedData<-predictedData[rownames(measuredData), colnames(measuredData)]
}, silent=TRUE)
          checkScoring<-try(
{
if (!inherits(checkSubmission, "try-error")) {
  stopifnot(sum(apply(predictedData, 2, sd) == 0) == 0)
}
} , silent=TRUE)
        isValid<-!inherits(checkSubmission, "try-error") & !inherits(checkScoring, "try-error")
        subStatus<-page[[i]]$submissionStatus
        if (isValid) {
          newStatus<-"VALIDATED"
        } else {
          if (inherits(checkSubmission, "try-error")) {
            newStatus<-"INVALID"
            sendMessage(list(submission$userId), paste0("Invalid submission for ", evaluation$name), paste0("Your submission for ", evaluation$name, " with synapse id ", submission$entityId, " is invalid. Please check the submission format at https://www.synapse.org/#!Synapse:syn2384331/wiki/64275 and try again.")) 
          }
          if (inherits(checkScoring, "try-error")) {
            newStatus<-"REJECTED"
            sendMessage(list(submission$userId), paste0("Rejected submission for ", evaluation$name), paste0("Your submission for ", evaluation$name, " with synapse id ", submission$entityId, " is rejected due to zero standard deviation over gene essentiality predictions for some of the genes, which makes Spearman correlation calculation impossible.")) 
          }
        }
        subStatus$status<-newStatus
        subStatus$annotations<-generateAnnotations(submission, NA)
        statusesToUpdate[[length(statusesToUpdate)+1]]<-subStatus
      }
    }
  }
  updateSubmissionStatusBatch(evaluation, statusesToUpdate)
}

validate2<-function(evaluation) {
  total<-1e+10
  offset<-0
  statusesToUpdate<-list()

  while(offset<total) {
    submissionBundles<-synRestGET(sprintf("/evaluation/%s/submission/bundle/all?limit=%s&offset=%s&status=%s", evaluation$id, PAGE_SIZE, offset, "RECEIVED")) 
    total<-submissionBundles$totalNumberOfResults
    offset<-offset+PAGE_SIZE
    page<-submissionBundles$results
    if (length(page)>0) {
      measuredData<-readMeasuredFile(measuredDataId)
      copyNumberFeatureList<-readFeatureFile(copyNumberFeatureListId)
      expressionFeatureList<-readFeatureFile(expressionFeatureListId)
      hybridMutationFeatureList<-readFeatureFile(hybridMutationFeatureListId)
      combinedFeatureList<-union(union(copyNumberFeatureList, expressionFeatureList), union(hybridMutationFeatureList, NA))
      prioritizedGeneList<-readFeatureFile(prioritizedGeneListId)
      measuredData<-measuredData[,prioritizedGeneList]
      for (i in 1:length(page)) {
        submission<-synGetSubmission(page[[i]]$submission$id, ifcollision="keep.local")
        filePath<-getFileLocation(submission)
        directoryPath<-dirname(filePath)
        checkSubmission<-try(
{
  stopifnot(length(list.files(directoryPath, pattern="\\.zip$")) == 1)
  extractPath<-paste0(directoryPath, "/content")
  unzip(filePath, junkpaths=T, exdir=extractPath)
  stopifnot(length(list.files(extractPath, pattern="\\.gct$")) == 1)
  predictedPath<-list.files(extractPath, pattern="\\.gct$", full.names=TRUE)[1]
  predictedData<-parsePredictionFile(predictedPath)
  stopifnot(setequal(rownames(measuredData), rownames(predictedData)))
  stopifnot(setequal(colnames(measuredData), colnames(predictedData)))
  predictedData<-predictedData[rownames(measuredData), colnames(measuredData)]
  stopifnot(length(list.files(extractPath, pattern="\\.txt$")) == 1)
  featurePath<-list.files(extractPath, pattern="\\.txt$", full.names=TRUE)[1]
  featureData<-parseFeatureFile(featurePath)
  stopifnot(nrow(featureData) == length(prioritizedGeneList))
  stopifnot(ncol(featureData) == SUBCHALLENGE2_FEATURE_COUNT + 1)
  stopifnot(length(which(featureData[,-1] %in% combinedFeatureList)) == length(prioritizedGeneList) * SUBCHALLENGE2_FEATURE_COUNT)
}, silent=TRUE)
      checkScoring<-try(
{
  if (!inherits(checkSubmission, "try-error")) {
    stopifnot(sum(apply(predictedData, 2, sd) == 0) == 0)
  }
} , silent=TRUE)
        isValid<-!inherits(checkSubmission, "try-error") & !inherits(checkScoring, "try-error")
        subStatus<-page[[i]]$submissionStatus
        if (isValid) {
          newStatus<-"VALIDATED"
        } else {
          if (inherits(checkSubmission, "try-error")) {
            newStatus<-"INVALID"
            sendMessage(list(submission$userId), paste0("Invalid submission for ", evaluation$name), paste0("Your submission for ", evaluation$name, " with synapse id ", submission$entityId, " is invalid. Please check the submission format at https://www.synapse.org/#!Synapse:syn2384331/wiki/64275 and try again.")) 
          }
          if (inherits(checkScoring, "try-error")) {
            newStatus<-"REJECTED"
            sendMessage(list(submission$userId), paste0("Rejected submission for ", evaluation$name), paste0("Your submission for ", evaluation$name, " with synapse id ", submission$entityId, " is rejected due to zero standard deviation over gene essentiality predictions for some of the genes, which makes Spearman correlation calculation impossible."))
          }
        }
        subStatus$status<-newStatus
        subStatus$annotations<-generateAnnotations(submission, NA)
        statusesToUpdate[[length(statusesToUpdate)+1]]<-subStatus
      }
    }
  }
updateSubmissionStatusBatch(evaluation, statusesToUpdate)
}

validate3<-function(evaluation) {
  total<-1e+10
  offset<-0
  statusesToUpdate<-list()
  
  while(offset<total) {
    submissionBundles<-synRestGET(sprintf("/evaluation/%s/submission/bundle/all?limit=%s&offset=%s&status=%s", evaluation$id, PAGE_SIZE, offset, "RECEIVED")) 
    total<-submissionBundles$totalNumberOfResults
    offset<-offset+PAGE_SIZE
    page<-submissionBundles$results
    if (length(page)>0) {
      measuredData<-readMeasuredFile(measuredDataId)
      copyNumberFeatureList<-readFeatureFile(copyNumberFeatureListId)
      expressionFeatureList<-readFeatureFile(expressionFeatureListId)
      hybridMutationFeatureList<-readFeatureFile(hybridMutationFeatureListId)
      combinedFeatureList<-union(union(copyNumberFeatureList, expressionFeatureList), union(hybridMutationFeatureList, NA))
      prioritizedGeneList<-readFeatureFile(prioritizedGeneListId)
      measuredData<-measuredData[,prioritizedGeneList]
      for (i in 1:length(page)) {
        submission<-synGetSubmission(page[[i]]$submission$id, ifcollision="keep.local")
        filePath<-getFileLocation(submission)
        directoryPath<-dirname(filePath)
        checkSubmission<-try(
{
  stopifnot(length(list.files(directoryPath, pattern="\\.zip$")) == 1)
  extractPath<-paste0(directoryPath, "/content")
  unzip(filePath, junkpaths=T, exdir=extractPath)
  stopifnot(length(list.files(extractPath, pattern="\\.gct$")) == 1)
  predictedPath<-list.files(extractPath, pattern="\\.gct$", full.names=TRUE)[1]
  predictedData<-parsePredictionFile(predictedPath)
  stopifnot(setequal(rownames(measuredData), rownames(predictedData)))
  stopifnot(setequal(colnames(measuredData), colnames(predictedData)))
  predictedData<-predictedData[rownames(measuredData), colnames(measuredData)]
  stopifnot(length(list.files(extractPath, pattern="\\.txt$")) == 1)
  featurePath<-list.files(extractPath, pattern="\\.txt$", full.names=TRUE)[1]
  featureData<-parseFeatureFile(featurePath)
  stopifnot(length(featureData) == SUBCHALLENGE3_FEATURE_COUNT)
  stopifnot(length(which(featureData %in% combinedFeatureList)) == SUBCHALLENGE3_FEATURE_COUNT)
}, silent=TRUE)
checkScoring<-try(
{
  if (!inherits(checkSubmission, "try-error")) {
    stopifnot(sum(apply(predictedData, 2, sd) == 0) == 0)
  }
} , silent=TRUE)
        isValid<-!inherits(checkSubmission, "try-error") & !inherits(checkScoring, "try-error")
        subStatus<-page[[i]]$submissionStatus
        if (isValid) {
          newStatus<-"VALIDATED"
        } else {
          if (inherits(checkSubmission, "try-error")) {
            newStatus<-"INVALID"
            sendMessage(list(submission$userId), paste0("Invalid submission for ", evaluation$name), paste0("Your submission for ", evaluation$name, " with synapse id ", submission$entityId, " is invalid. Please check the submission format at https://www.synapse.org/#!Synapse:syn2384331/wiki/64275 and try again.")) 
          }
          if (inherits(checkScoring, "try-error")) {
            newStatus<-"REJECTED"
            sendMessage(list(submission$userId), paste0("Rejected submission for ", evaluation$name), paste0("Your submission for ", evaluation$name, " with synapse id ", submission$entityId, " is rejected due to zero standard deviation over gene essentiality predictions for some of the genes, which makes Spearman correlation calculation impossible."))
          }
        }
        subStatus$status<-newStatus
        subStatus$annotations<-generateAnnotations(submission, NA)
        statusesToUpdate[[length(statusesToUpdate)+1]]<-subStatus
      }
    }
  }
updateSubmissionStatusBatch(evaluation, statusesToUpdate)
}

BATCH_UPLOAD_RETRY_COUNT<-3

updateSubmissionStatusBatch<-function(evaluation, statusesToUpdate) {
  for (retry in 1:BATCH_UPLOAD_RETRY_COUNT) {
    tryCatch(
{
  batchToken<-NULL
  offset<-0
  while (offset<length(statusesToUpdate)) {
    batch<-statusesToUpdate[(offset+1):min(offset+BATCH_SIZE, length(statusesToUpdate))]
    updateBatch<-list(
      statuses=batch, 
      isFirstBatch=(offset==0), 
      isLastBatch=(offset+BATCH_SIZE>=length(statusesToUpdate)),
      batchToken=batchToken
    )
    response<-synRestPUT(sprintf("/evaluation/%s/statusBatch",evaluation$id), updateBatch)
    batchToken<-response$nextUploadToken
    offset<-offset+BATCH_SIZE
  } # end while offset loop
  break
}, 
error=function(e){
  # on 412 ConflictingUpdateException we want to retry
  if (regexpr("412", e, fixed=TRUE)>0) {
    # will retry
  } else {
    stop(e)
  }
}
    )
if (retry<BATCH_UPLOAD_RETRY_COUNT) message("Encountered 412 error, will retry batch upload.")
  }
}

score1<-function(evaluation, submissionStateToFilter) {
  total<-1e+10
  offset<-0
  statusesToUpdate<-list()

  while(offset<total) {
    submissionBundles<-synRestGET(sprintf("/evaluation/%s/submission/bundle/all?limit=%s&offset=%s&status=%s", evaluation$id, PAGE_SIZE, offset, submissionStateToFilter)) 
    total<-submissionBundles$totalNumberOfResults
    offset<-offset+PAGE_SIZE
    page<-submissionBundles$results
    if (length(page)>0) {
      measuredData<-readMeasuredFile(measuredDataId)
      for (i in 1:length(page)) {
        submission<-synGetSubmission(page[[i]]$submission$id, ifcollision="keep.local")
        filePath<-getFileLocation(submission)
        predictedData<-parsePredictionFile(filePath)
        predictedData<-predictedData[rownames(measuredData), colnames(measuredData)]
        score<-calculateScore(measuredData, predictedData)
        subStatus<-page[[i]]$submissionStatus
        subStatus$status<-"SCORED"
        subStatus$annotations<-generateAnnotations(submission, score)
        statusesToUpdate[[length(statusesToUpdate)+1]]<-subStatus
      }
    }
  }
  updateSubmissionStatusBatch(evaluation, statusesToUpdate)
  message(sprintf("Retrieved and scored %s submission(s) for %s.", length(statusesToUpdate), evaluation$name))
}

score2<-function(evaluation, submissionStateToFilter) {
  total<-1e+10
  offset<-0
  statusesToUpdate<-list()
  
  while(offset<total) {
    submissionBundles<-synRestGET(sprintf("/evaluation/%s/submission/bundle/all?limit=%s&offset=%s&status=%s", evaluation$id, PAGE_SIZE, offset, submissionStateToFilter)) 
    total<-submissionBundles$totalNumberOfResults
    offset<-offset+PAGE_SIZE
    page<-submissionBundles$results
    if (length(page)>0) {
      measuredData<-readMeasuredFile(measuredDataId)  
      prioritizedGeneList<-readFeatureFile(prioritizedGeneListId)
      measuredData<-measuredData[,prioritizedGeneList]
      for (i in 1:length(page)) {
        submission<-synGetSubmission(page[[i]]$submission$id, ifcollision="keep.local")
        filePath<-getFileLocation(submission)
        directoryPath<-dirname(filePath)
        extractPath<-paste0(directoryPath, "/content")
        unzip(filePath, junkpaths=T, exdir=extractPath)
        predictedPath<-list.files(extractPath, pattern="\\.gct$", full.names=TRUE)[1]
        predictedData<-parsePredictionFile(predictedPath)
        predictedData<-predictedData[rownames(measuredData), colnames(measuredData)]
        score<-calculateScore(measuredData, predictedData)
        subStatus<-page[[i]]$submissionStatus
        subStatus$status<-"SCORED"
        subStatus$annotations<-generateAnnotations(submission, score)
        statusesToUpdate[[length(statusesToUpdate)+1]]<-subStatus
      }
    }
  }
  updateSubmissionStatusBatch(evaluation, statusesToUpdate)
  message(sprintf("Retrieved and scored %s submission(s) for %s.", length(statusesToUpdate), evaluation$name))
}

score3<-function(evaluation, submissionStateToFilter) {
  total<-1e+10
  offset<-0
  statusesToUpdate<-list()
  
  while(offset<total) {
    submissionBundles<-synRestGET(sprintf("/evaluation/%s/submission/bundle/all?limit=%s&offset=%s&status=%s", evaluation$id, PAGE_SIZE, offset, submissionStateToFilter)) 
    total<-submissionBundles$totalNumberOfResults
    offset<-offset+PAGE_SIZE
    page<-submissionBundles$results
    if (length(page)>0) {
      measuredData<-readMeasuredFile(measuredDataId)  
      prioritizedGeneList<-readFeatureFile(prioritizedGeneListId)
      measuredData<-measuredData[,prioritizedGeneList]
      for (i in 1:length(page)) {
        submission<-synGetSubmission(page[[i]]$submission$id, ifcollision="keep.local")
        filePath<-getFileLocation(submission)
        directoryPath<-dirname(filePath)
        extractPath<-paste0(directoryPath, "/content")
        unzip(filePath, junkpaths=T, exdir=extractPath)
        predictedPath<-list.files(extractPath, pattern="\\.gct$", full.names=TRUE)[1]
        predictedData<-parsePredictionFile(predictedPath)
        predictedData<-predictedData[rownames(measuredData), colnames(measuredData)]
        score<-calculateScore(measuredData, predictedData)
        subStatus<-page[[i]]$submissionStatus
        subStatus$status<-"SCORED"
        subStatus$annotations<-generateAnnotations(submission, score)
        statusesToUpdate[[length(statusesToUpdate)+1]]<-subStatus
      }
    }
  }
  updateSubmissionStatusBatch(evaluation, statusesToUpdate)
  message(sprintf("Retrieved and scored %s submission(s) for %s.", length(statusesToUpdate), evaluation$name))
}

generateAnnotations<-function(submission, score) {
  teamName<-submission$submitterAlias
  if (is.null(teamName)) {
    teamName<-synGetUserProfile(submission$userId)$userName 
  }
  list(
    stringAnnos=list(
      list(key="SubmissionName", value=submission$name, isPrivate=FALSE),
      list(key="Team", value=teamName, isPrivate=FALSE),
      list(key="userIdPublic", value=submission$userId, isPrivate=FALSE),
      list(key="createdOnPublic", value=submission$createdOn, isPrivate=FALSE)
    ),
    doubleAnnos=list(
      list(key="score", value=score, isPrivate=FALSE)
    )
  )
}

scoringApplication<-function() {
  synapseLogin()
  
  evaluation1<-synGetEvaluation(evaluationId1)  
  validate1(evaluation1)
  score1(evaluation1, "VALIDATED")
  
  evaluation2<-synGetEvaluation(evaluationId2)
  validate2(evaluation2)
  score2(evaluation2, "VALIDATED")
  
  evaluation3<-synGetEvaluation(evaluationId3)
  validate3(evaluation3)
  score3(evaluation3, "VALIDATED")
}

scoringApplication()

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

predict.rsf <- function(
    object = NULL,#
    test = NULL,#
    importance = c("randomsplit", "permute", "none")[1],#
    na.action = c("na.omit", "na.impute")[1],#
    outcome = c("train", "test")[1],#
    proximity = FALSE,#
    split.depth = FALSE,#
    seed = NULL,#
    do.trace = FALSE,#
    ...)
{
  if (is.null(object)) stop("Object is empty!")
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2    &
      sum(inherits(object, c("rsf", "forest"), TRUE) == c(1, 2)) != 2  &
      sum(inherits(object, c("rsf", "partial"), TRUE) == c(1, 2)) != 2 &
      sum(inherits(object, c("rsf", "partial.rough"), TRUE) == c(1, 2)) != 2)
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, forest)'")
  big.data <- F
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) == 2) {
    if (is.null(object$forest)) 
      stop("Forest is empty!  Re-run grow call with forest set to 'TRUE'.")
    if (inherits(object, c("rsf", "grow", "bigdata"), TRUE) [3] == 3) big.data <- T
    object <- object$forest
  }
  if (is.null(test)) stop("test data is null.")
  if (!is.data.frame(test)) stop("test data must be a data frame.")
  if (length(which(outcome == c("train", "test"))) != 1) stop("invalid outcome specified:", outcome) 
  if (importance == TRUE)  importance <- "permute"
  if (importance == FALSE) importance <- "none"    
  predictedOutcomeBits <- 0
  if (sum(inherits(object, c("rsf", "partial"), TRUE) == c(1, 2)) == 2 |
      sum(inherits(object, c("rsf", "partial.rough"), TRUE) == c(1, 2)) == 2) {
    if (sum(inherits(object, c("rsf", "partial.rough"), TRUE) == c(1, 2)) == 2) {
      class(object) <- c("rsf", "partial")
      predictedOutcomeBits <- 2^14
    }
    test <- as.data.frame(data.matrix(test))
    predictorsTest <- as.matrix(test)
    rownames(predictorsTest) <- colnames(predictorsTest) <- NULL
    Time <- rep(-1, nrow(predictorsTest))
    Cens <- rep(-1, nrow(predictorsTest))
    performance <- FALSE
    importance <- "none"
    remove(test)
  }
  get.factor <- extract.factor(object$predictors)
  xfactor <- get.factor$xfactor
  xfactor.levels <- get.factor$xfactor.levels
  xfactor.order <- get.factor$xfactor.order
  xfactor.order.levels <- get.factor$xfactor.order.levels
  if (!(sum(inherits(object, c("rsf", "partial"), TRUE) == c(1, 2)) == 2)) {
    fNames <- all.vars(object$formula, max.names=1e7)
    test <- test[, is.element(names(test), fNames)]
    if (is.null(dim(test))) {
      test <- cbind(test)
      colnames(test) <- fNames[-c(1,2)]
    }
    test <- rm.na.levels(test, fNames[-c(1,2)])
    get.factor <- extract.factor(test, fNames[-c(1,2)])
    xfactor.test <- get.factor$xfactor
    xfactor.order.test <- get.factor$xfactor.order
    if (!setequal(xfactor, xfactor.test))
      stop("(unordered) factors from test data do not match original training data")
    if (!setequal(xfactor.order, xfactor.order.test))
      stop("ordered factors from test data do not match original training data")
    if ((ncol(test) - sum(is.element(fNames[1:2], names(test)))) != (length(fNames) - 2)) {
      stop("test data does not match original training data")
    }
    if (length(xfactor) > 0) {
      for (k in 1:length(xfactor)) {
        xk.train <- object$predictors[ , names(object$predictors) == xfactor[k] ]
        xk.test.org <- xk.test <- xk.naomit.test <- test[ , names(test) == xfactor[k] ]
        if (na.action == "na.omit") {
          xk.naomit.test <- na.omit(test)[ , names(test) == xfactor[k] ]
        }
        if (length(na.omit(setdiff(unique(xk.naomit.test) , unique(xk.train)))) > 0)
          stop("(unordered) factor labels in test data differ from training data")
        levels(xk.test) <- xfactor.levels[[k]]
        for (l in 1:length(xk.test)) { xk.test[l] <- xk.test.org[l] }
        test[ , names(test) == xfactor[k] ] <- xk.test
      }
    }
    if (length(xfactor.order) > 0) {
      for (k in 1:length(xfactor.order)) {
        xk.train <- object$predictors[ , names(object$predictors) == xfactor.order[k] ]
        xk.test.org <- xk.test <- xk.naomit.test <- test[ , names(test) == xfactor.order[k] ]
        if (na.action == "na.omit") {
          xk.naomit.test <- na.omit(test)[ , names(test) == xfactor.order[k] ]
        }
        if (length(na.omit(setdiff(unique(xk.naomit.test) , unique(xk.train)))) > 0)
          stop("ordered factor labels in test data differ from training data")
        levels(xk.test) <- xfactor.order.levels[[k]]
        for (l in 1:length(xk.test)) { xk.test[l] <- xk.test.org[l] }
        test[ , names(test) == xfactor.order[k] ] <- xk.test
      }
    }
    if (sum(is.element(names(test), fNames[1:2])) == 2) {
      if (!big.data) {
        ftermLabels <- c(fNames[1:2], attr(terms(object$formula), "term.labels"))
      }
      else {
        ftermLabels <- fNames
      }
    }
    else {
      if (!big.data) {
        ftermLabels <- attr(terms(object$formula), "term.labels")
      }
      else {
        ftermLabels <- fNames[-c(1:2)]
      }
    }
    if (na.action != "na.omit" & na.action != "na.impute") na.action <- "na.omit"
    if (!big.data) {
      test <- as.data.frame(data.matrix(test))
      old.na.action <- options()$na.action
      na.keep <- function(x){ x }
      na.takeOut <- function(x){ na.omit(x) }
      if (na.action == "na.omit") options(na.action=na.takeOut) else options(na.action=na.keep)
      all.na <- all(is.na(test))
      if (all.na) test <- rbind(0, test)
      test <- as.data.frame(model.matrix(as.formula(paste("~ -1 +",
                            paste(ftermLabels, collapse="+"))), test))
      if (all.na) test <- test[-1, ]
      options(na.action=old.na.action)
      if (nrow(test) == 0)
        stop("No records in the NA-processed test data.  Consider imputing using na.impute.")
    }
    else { 
      test <- test[ , is.element(names(test), ftermLabels)]
      test <- as.data.frame(data.matrix(test))
      if (na.action == "na.omit") {
        test <- na.omit(test)
        if (nrow(test) == 0)
          stop("No records in the NA-processed test data.  Consider imputing using na.impute.")
      }
    }
    predictorsTest  <- as.matrix(test[,is.element(names(test), object$predictorNames)])
    if (length(object$predictorNames) > 1) {
      sort.col <- NULL
      for (k in 1:length(object$predictorNames)) {
        sort.col[k] <- which(colnames(predictorsTest) == object$predictorNames[k])
      }
      if (nrow(predictorsTest) > 1) {
        predictorsTest <- predictorsTest[ , sort.col]
      }
      else {
        predictorsTest <- rbind(predictorsTest[ , sort.col])
      }
    }    
    rownames(predictorsTest) <- colnames(predictorsTest) <- NULL
    if (sum(is.element(fNames[1:2], names(test))) == 2) {
      Time <- test[, is.element(names(test), fNames[1])]
      Cens <- test[, is.element(names(test), fNames[2])]
      eventType <- unique(na.omit(Cens))
      if (sum(eventType >= 0) != length(eventType)) {
        stop("censoring variable must be coded as NA, 0, or greater than 0")    
      }
      if (!all(is.na(Time))) {
        if (!all(na.omit(Time) > 0)) stop("time must be strictly positive")
      }
      performance <- TRUE
      if (length(setdiff(na.omit(Cens), na.omit(object$cens))) > 1) {
        stop("event types in test data do not match training data")
      }
    }
    else {
      Time <- rep(-1, nrow(predictorsTest))
      Cens <- rep(-1, nrow(predictorsTest))
      performance <- FALSE
      importance <- "none"
    }
    remove(test)
  }
  n.event <- length(unique(na.omit(object$cens)[na.omit(object$cens) > 0]))
  if (n.event > 1) n.event <- n.event + 1
  if (outcome == "train") {
    predictors <- as.matrix(data.matrix(object$predictors))
    time <- object$time
    cens <- object$cens
  }
  else {
    if (!performance) stop("survival data missing in the test set: outcome='test' cannot be used")
    predictors <- predictorsTest
    time <- Time
    cens <- Cens
    newobject <- object
    newobject$time <- time
    newobject$cens <- cens
    newobject$predictors <- predictors
    newobject$outcome <- "test"
    vimp.out <- vimp(newobject, joint = FALSE)
    rm(newobject)
    VIMP <- vimp.out$importance
    ERR <- vimp.out$err.rate
    if (n.event > 1) ERR <- cbind(vimp.out$err.rate)
  }
  rownames(predictors) <- colnames(predictors) <- NULL
  predictorType <- rep("R", ncol(predictorsTest))
  if (length(xfactor) > 0) {
    predictorType[is.element(object$predictorNames, xfactor)] <- "C"
  }
  if (length(xfactor.order) > 0) {
    predictorType[is.element(object$predictorNames, xfactor.order)] <- "I"
  }
  tunique <- object$timeInterest
  ntree <- length(unique(object$nativeArray[,1]))
  Risk <- apply(cbind(1:length(tunique)),
                1,
                function(i, tau, tunq){sum(tau >= tunq[i])},
                tau = na.omit(time), tunq = tunique)
  Risk <- Risk - c(Risk[-1] , 0)
  if (is.null(seed) || abs(seed)<1) seed <- runif(1,1,1e6)
  seed <- -round(abs(seed))
  if (!is.logical(do.trace)) {
    if (do.trace >= 1){
      do.trace <- 2^24 *round(do.trace) + 1
    }
    else {
      do.trace <- 0
    }
  }
  else {
    do.trace <- 1 * do.trace
  }
  if (importance == "none") {
    importance.bits <- 0
  }
  else if (importance == "permute") {
    importance.bits <- 2048 + 0
  }
  else if (importance == "randomsplit") {
    importance.bits <- 2048 + 512
  }
  else {
    stop("Invalid choice for 'importance' option:  ", importance)
  }
  if (outcome == "test") {
    importance.bits <- 0
  }
  nativeOutput <- .Call("rsfPredict",
                        as.integer(do.trace),
                        as.integer(predictedOutcomeBits +
                                   importance.bits +
                                   (8 * (if (proximity) 1 else 0)) +
                                   (4 * (if (performance) 1 else 0)) + 
                                   (2^15 * (if (split.depth) 1 else 0)) +
                                   (2^17 * (if (outcome == "test") 1 else 0))),
                        as.integer(seed),
                        as.integer(ntree),
                        as.integer(nrow(predictors)),
                        as.double(time),
                        as.double(cens),
                        as.integer(ncol(predictors)),
                        as.numeric(predictors),
                        as.integer(nrow(predictorsTest)),
                        as.double(Time),
                        as.double(Cens),
                        as.numeric(predictorsTest),
                        as.integer(length(object$timeInterest)),
                        as.double(object$timeInterest),
                        as.integer((object$nativeArray)$treeID),
                        as.integer((object$nativeArray)$nodeID),
                        as.integer((object$nativeArray)$parmID),
                        as.double((object$nativeArray)$contPT),
                        as.integer((object$nativeArray)$mwcpSZ),                        
                        as.integer(object$nativeFactorArray),                        
                        as.integer(object$seed),
                        as.character(predictorType))
  remove(predictors)
  if(is.null(nativeOutput)) {
    stop("Error occurred in algorithm.  Please turn trace on for further analysis.")
  }
  nMiss <- sum(is.na(Cens) | is.na(Time) | apply(predictorsTest, 1, function(x){any(is.na(x))}))
  if (nMiss > 0) {
    imputedData <- matrix(nativeOutput$imputation, nrow = nMiss, byrow = FALSE)
    imputedIndv <- imputedData[,1]
    imputedData <- as.matrix(imputedData[,-1])
    if (nMiss == 1) imputedData <- t(imputedData)
  }
  predictorsTest <- as.data.frame(predictorsTest)
  colnames(predictorsTest) <- object$predictorNames
  if (nMiss > 0) {
    imputedData <- as.data.frame(imputedData)
    colnames(imputedData) <- c(fNames[2], fNames[1], object$predictorNames)
  }
  if (length(xfactor) > 0) {
    for (k in 1:length(xfactor)) {
      ptk <- (colnames(predictorsTest) == xfactor[k])
      factor.k <- xfactor.levels[[k]][predictorsTest[ , ptk ]]
      labels.k <- xfactor.levels[[k]][sort(unique(predictorsTest[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL)  
      if (length(setdiff(xfactor.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      predictorsTest[ , ptk] <- xk
    }
  }
  if (length(xfactor.order) > 0) {
    for (k in 1:length(xfactor.order)) {
      ptk <- (colnames(predictorsTest) == xfactor.order[k])
      factor.k <- xfactor.order.levels[[k]][predictorsTest[ , ptk ]]
      labels.k <- xfactor.order.levels[[k]][sort(unique(predictorsTest[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL, ordered = TRUE)
      if (length(setdiff(xfactor.order.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.order.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      predictorsTest[ , ptk] <- xk
    }
  }
  if (length(xfactor) > 0 & nMiss > 0) {
    for (k in 1:length(xfactor)) {
      ptk <- (colnames(imputedData) == xfactor[k])
      factor.k <- xfactor.levels[[k]][imputedData[ , ptk ]]
      labels.k <- xfactor.levels[[k]][sort(unique(imputedData[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL)  
      if (length(setdiff(xfactor.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      imputedData[ , ptk] <- xk
    }
  }
  if (length(xfactor.order) > 0 & nMiss > 0) {
    for (k in 1:length(xfactor.order)) {
      ptk <- (colnames(imputedData) == xfactor.order[k])
      factor.k <- xfactor.order.levels[[k]][imputedData[ , ptk ]]
      labels.k <- xfactor.order.levels[[k]][sort(unique(imputedData[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL, ordered = TRUE)
      if (length(setdiff(xfactor.order.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.order.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      imputedData[ , ptk] <- xk
    }
  }
  if (n.event > 1) {    
    ens.names <- list(NULL, NULL, c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")))
    err.names <- list(c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")), NULL)
    vimp.names <- list(c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")), object$predictorNames)
    poe.names <- list(paste("event.", 1:(n.event - 1), sep = ""), NULL)
  }
  else {
    ens.names <- list(NULL, NULL, NULL)
    err.names <- list(NULL, NULL)
    vimp.names <- list(NULL, object$predictorNames)
  }
  if ((predictedOutcomeBits == 0)) {
    mortality <- apply(rbind(array(nativeOutput$fullEnsemble, c(length(Cens), length(object$timeInterest),
      n.event))[,,1]), 1, function(x, wt) {sum(x*wt , na.rm = TRUE)}, wt = Risk)
  }
  else {
    mortality <- array(nativeOutput$fullEnsemble, c(length(Cens), length(object$timeInterest),
      n.event))[,1,1]
  }
  if (outcome == "train") {
    if (performance) {
      ERR <- matrix(nativeOutput$performance, ncol=ntree, byrow=TRUE,
                    dimnames=err.names)[1:n.event, ]
    }
    else {
     ERR <- NULL
   }
  }
  make.vec <- function(x) {
    if (!is.null(dim(x)) && nrow(x) == 1) {
      x.names <- colnames(x)
      x <- c(x)
      names(x) <- x.names
      x
    }
    else {
      x
    }
  }
  if (outcome == "train") {
    if (importance != "none" & performance) {
      VIMP <- make.vec(matrix(nativeOutput$importance, ncol=length(object$predictorNames),
                    byrow=TRUE, dimnames = vimp.names)[1:n.event,, drop = FALSE] -
        matrix(nativeOutput$performance, ncol=ntree, byrow=TRUE,
                    dimnames = err.names)[1:n.event, ntree])
    }
    else {
      VIMP <- NULL
    }
  }
  rsfOutput <- list(
    call = match.call(),
    forest = object,
    ntree = ntree,
    leaf.count = nativeOutput$leafCount,
    timeInterest = object$timeInterest,
    n = length(Cens),
    ndead = (if (performance) sum(Cens == 1 , na.rm = T) else NULL),
    time =  (if (performance) Time else NULL),
    cens =  (if (performance) Cens else NULL),
    predictorNames = object$predictorNames,
    predictors = predictorsTest,
    ensemble = (if (predictedOutcomeBits == 0) 
      array(nativeOutput$fullEnsemble, c(length(Cens), length(object$timeInterest),
      n.event), dimnames = ens.names)[,,1:n.event] else NULL),
    poe = (if (!is.null(nativeOutput$fullPOE)) matrix(nativeOutput$fullPOE,
      ncol=length(Cens), byrow=TRUE, dimnames=poe.names) else NULL),
    mortality = mortality,
    err.rate = ERR,
    importance = VIMP,
    proximity = nativeOutput$proximity,
    imputedIndv = (if (nMiss>0) imputedIndv else NULL),
    imputedData = (if (nMiss>0) imputedData else NULL),
    splitDepth  = (if (split.depth) matrix(nativeOutput$splitDepth,
                    nrow = length(Cens), byrow=FALSE) else NULL)
  )
  class(rsfOutput) <- c("rsf", "predict")
  return(rsfOutput)
}

#' PredictiveModel
#'
#' Base class for predictive models. Defines customTrain() and customPredict() methods.
#'
#' @author Adam Margolin
#' @export
PredictiveModel <- setRefClass(Class="PredictiveModel",
                               methods = list(
                                  customTrain = function(featureData, responseData){ 
                                  },

                                  customPredict = function(featureData){
                                  }
                               )
                              
                               )

library(MASS)

# =========================
# GENERAL PURPOSE FUNCTIONS
# =========================


# Transforms a single category of the dataset to sensible columns, instead of related rows
# In other words, this joins all data with the same patient or test_id together into a single row
# @param category the category number
# @param group_by how a single row in the dataset can be identified (patient or patient+test_id)
# @param keys columns will be used, with names(keys) as names of the columns, and the values matching the "key" column
rows.to.form <- function(data,category,group_by,keys)
{
        # Only the data of the current category
        print.expr(paste("finding category", category),cat_data <- data$category==category)
        
        # separate in columns and keys, discarding original
        print.expr("assigning category to values", col_data <- data[cat_data,c(group_by,"value")])
        print.expr("assigning category to keys", kdata <- data[cat_data,"key"])
        
        # Make for more efficient merging by using only existing patients/test ids
        col_data <- factorize.cols(col_data,group_by)
        # One value per column, use unique
        print.expr("indexing",index <- data.frame(unique(col_data[,group_by])))
        # for merging, the names should match
        names(index)=group_by
        
        # Merge each key into a new column
        rdata <- index
        for (k in names(keys)) {
                # all.x=TRUE: Left outer join: the index should always be the same, but the values may be NA
                # 
                print.expr(paste("merging key", k), rdata <- merge(rdata,col_data[kdata==keys[k],],by=group_by,all.x=TRUE,stringsAsFactors=FALSE,sort=FALSE))
        }
        names(rdata)=c(group_by,names(keys))
        return(rdata)
}

# Use factors for all given columns, so that they are "indexed"
factorize.cols <- function(data,cols)
{
        for (col in cols) {
                data[,col] <- factor(data[,col])
        }
        return(data)
}

# Use numeric values for all given columns
# Note that any empty or textual values will result in NA
numerize.cols <- function(data,cols)
{
        for (col in cols) {
                data[,col] <- as.numeric(data[,col])
        }
        return(data)
}

# Print a string, execute an expression and measure the time taken
print.expr <- function(text, expr)
{
        cat(text, ": ", sep="")
        cat(system.time(expr)[[3]], "s\n")
}

# Order data by given factor columns
order.numeric <- function(data,col)
{
        return(data[order(as.numeric(levels(data[,col]))[data[,col]]),])
}

#Write all the different values that occur for a given test to file
write.test.results.to.file <- function(lab,test,outfile)
{
        cat(unique(lab[lab$test==test,"result"]),sep="\n",file=outfile)
}

# all.deltas <- function(data)
# {
#         deltas <- data[data$key %in% c(1203,1225,1234,1236,1200,1417,1418,1190,1174,1267,1456),]
#         deltas[deltas$value=="","value"]="0"
#         deltas <- as.numeric(levels(deltas$value))[deltas$value]
#         month3deltas<-deltas[deltas>=0&deltas<=90]
#         return(deltas)
# }

# Make an interpolation between the tests that we have to a given number of bins
interpolate.tests <- function(name, tests, bins=7)
{
        xs <- as.numeric(names(tests))
        ys <- as.numeric(tests)
        
        # With 7 bins, you have equal bins with 0-12, 13-25, 26-38, 39-51, 52-64, 65-77, 78-90
        # To actually get the middle value (-0.5), realize that the combined size is 91,
        # and because we then have range 1-91, subtract 1.
        target_xs <- round((1:bins - 0.5)*91/bins)-1
        # Linearly interpolate the values between the bins, at the edges use
        # the nearest available value (rule=2)
        target_ys <- (approx(xs, ys, target_xs, rule=2))$y
        # Sensible name: a name plus the delta used for the bin
        names(target_ys) = paste(name, target_xs, sep=".")
        return(target_ys)
}

convert.unit <- function(data,test,oldunit, unit, factor)
{
	old <- data$unit==oldunit & data$test==test
	old[is.na(old)] <- FALSE
	data$result[old] <- data$result[old]*factor
	data$unit[old] <- unit
	return(data)
}

convert.units <- function(data, oldunit, unit, factor)
{
	old <- data$unit==oldunit
	old[is.na(old)] <- FALSE
	data$result[old] <- data$result[old]*factor
	data$unit[old] <- unit
	return(data)
}

# Do a linear fit of the results to the delta's. It will return name.x0 as
# intercept (bias), name.x1 as a slope and name.var as variance compared to
# that slope. As with lm, it will return NA for name.x1 if there is only one
# delta and result given
fit.linear <- function(name,delta,result)
{
	delta <- as.array(delta)
	result <- as.array(result)
	if (length(delta) == 0) {
		ret <- c(NA, NA, NA)
	} else {
		fit <- lm(result~delta)
		# var = sqrt(sum (y_i - x0 - x1 x_i)^2 / (n - 1))
		ret <- c(fit$coefficients[[1]], fit$coefficients[[2]], sqrt(sum((fit$residuals)^2)/(length(delta)-1)))
	}
	names(ret)<-c(paste(name,".x0",sep=""), paste(name,".x1",sep=""),paste(name,".var",sep=""))
	return(ret)
}

add.col.fit <- function(name, comb, ldata)
{
	addcol <- function(patient) {
		data <- ldata[[patient]]
		cols <- unique(data[!is.na(data[,name]),c("delta",name)])
		return(fit.linear(name,cols[,"delta"],cols[,name]))
	}
	return(data.frame(comb,t(sapply(comb$patient,addcol))))
}

add.test.fit <- function(name, comb, ldata)
{
	addcol <- function(patient) {
		data <- ldata[[patient]]
		cols <- unique(data[data$test==name&!is.na(data$result),c("delta","result")])
		return(fit.linear(name,cols$delta,cols$result))
	}
	return(data.frame(comb,t(sapply(comb$patient,addcol))))
}
numeric.cols  <- function(data)
{
	# All columns except the patient column
	cols <- setdiff(which(sapply(data,is.numeric)&!all(is.na(data))),c(1))
	names(cols) <- names(data)[cols]
	return(cols)
}

na.to.mean <- function(data)
{
	# Remove columns with only NA
	data <- data[,!all(is.na(data))]
	# only apply to numeric columns
	vars <- numeric.cols(data)
	
	for (name in vars) {
		# For NA values, take the mean of the other values
		data[is.na(data[,name]),name] <- mean(data[,name],na.rm=TRUE)
	}
	return(data)
}

generic.fit <- function(data, signif)
{
	vars <- numeric.cols(data)
	inset <- signif %in% names(vars)
	if (!all(inset)) {
		print(cat("warning: fit excludes ", signif[!inset]))
	}
	signif <- signif[inset]
	formula <- as.formula(paste("data$slope ~", paste(paste("data$", signif, sep=""), collapse=" + ")))
	return (rlm(formula=formula, data=data))
}

top.cor <- function(data, ratio=0.96)
{
	vars <- setdiff(numeric.cols(data),c("slope"))
	corr <- cor(data[,vars],data$slope)
	rowcorr <- rownames(corr)
	corrm <- rowcorr!="slope"&!is.na(corr)
	corr <- abs(corr[corrm])
	rowcorr <- rowcorr[corrm]
	return(rowcorr[corr >= quantile(corr, probs=ratio)])
}

top.cor.sampled <- function(data, samples=10, ratio=0.96)
{
	allrows <- rownames(data)
	rows <- rownames(data)
	res <- vector("list",10)
	len <- length(rows)/samples
	for (i in 1:samples) {
		s <- sample(rows, len)
		si <- setdiff(allrows, s)
		res[[i]] <- top.cor(data[si,], ratio)

		rows <- setdiff(rows, s)
	}
	return(res)
}

rm.cols <- function(data, cols)
{
	return(data[,setdiff(names(data),cols)])
}

score <- function(slope,pred)
{
	rmsd <- sqrt(sum((slope-pred)^2/length(pred)))
	cat(paste("RMSD:", rmsd, "\n"))
	sc <- -8*log10(rmsd)
	cat(paste("Score:", sc, "\n"))
	return(sc)
}
# =======================
# FORM CREATION FUNCTIONS
# =======================

# Create the Demographics data table
demographics.form <- function(data)
{
        keys <- c(
                "age"=1257,
                "sex"=1205,
                "ethnicity"=1204,
                "race.asian"=1207,
                "race.black"=1208,
                "race.caucasian"=1211,
                "race.unknown"=1210,
                "race.other"=1393,
                "race.other.specify"=1394)
        # Category: 144, Demographics. Group by patient.
        ddata <- rows.to.form(data,144,"patient",keys)
        
        # Convert known values to 1 and 2.
        ddata$sex[ddata$sex=="Male"] <- 1
        ddata$sex[ddata$sex=="Female"] <- 2
        
        # All other data is categorical
        fcols <- c("patient","race.other.specify")
        ddata <- factorize.cols(ddata, fcols)

        # Treat numerical data as such
        ncols <- setdiff(names(keys),fcols)
        ddata <- numerize.cols(ddata, ncols)
        # coerce to 0 for all but sex and age
        ncols <- setdiff(ncols,c("sex","age"))
        ddata[,ncols][is.na(ddata[,ncols])]=0

        return(ddata)
}

# Create the Laboratory Data table
laboratory.form <- function(data)
{
        keys <- c(
                "delta"=1234,
                "test"=1250,
                "result"=1251,
                "unit"=1252)
        # Category: 146, Laboratory Data. Group the results by patient and test_id.
        lab_data <- rows.to.form(data,146,c("patient","test_id"),keys)
        # Treat categorical data as such
        fcols <- c("patient","test","unit")
        lab_data <- factorize.cols(lab_data, fcols)

        # Numerize delta
        lab_data$delta[lab_data$delta==""] = 0
        lab_data$delta <- as.numeric(lab_data$delta)
        
        return(lab_data)
}

# Returns all lab test results that are done on almost all patients
remove.small.lab.samples <- function(lab_data)
{
        np <- nlevels(lab_data$patient)
        tests <- levels(lab_data$test)
        # Find the total frequency of the test, and assume that the number of patients
        # should be at most 110% the number of tests.
        print.expr("calculating frequent lab tests", frequent_tests<-tests[table(lab_data$test)*1.1 >= np])
        freq_ldata <- lab_data[lab_data$test %in% frequent_tests,]
        # make sure to re-index the test names
        print.expr("reindexing", freq_ldata <- factorize.cols(freq_ldata, c("test_id","test","unit")))
        return(freq_ldata)
}

clean.laboratory.form <- function(lab_data)
{
        # Unfortunately not all the results are numeric, otherwise we could take as.numeric(lab_data$result)
        # Removing worst offenders
        lab_data <- lab_data[lab_data$test!="Urine Blood"&lab_data$test!="Urine Casts"&lab_data$test!="RBC Morphology"&lab_data$test!="Urine RBC"&lab_data$test!="Urine WBC"&lab_data$test!="International Normalized Ratio (clotting)"&lab_data$test!="Urine Specific Gravity",]
        lab_data$test <- factor(lab_data$test)

        # First round removing NA
        print.expr("first removal of null values",lab_data <- lab_data[!is.na(lab_data$result),])
        
        # If there is a ">" or "<" sign (why?!) take some higher or lower value
        print.expr("find < or > char", first_char <- sapply(lab_data$result, function(s) substring(s, 1, 1)))
        has_lt <- first_char == "<"
        has_gt <- first_char == ">"
        # Add/subtract 0.1, seems a reasonable value from some of the tests
        lab_data$result[has_gt] <- 0.1 + as.numeric(sapply(lab_data$result[has_gt], function(s) substring(s,2)))
        lab_data$result[has_lt] <- -0.1 + as.numeric(sapply(lab_data$result[has_lt], function(s) substring(s,2)))
        
        # Remove % char, divide by 100 if the unit is not percentage, is this correct?
        print.expr("finding percentages", has_pct <- sapply(lab_data$result, function(s) substring(s, nchar(s)) == "%"))
        print.expr("removing percentages", lab_data$result[has_pct] <- as.numeric(sapply(lab_data$result[has_pct], function(s) substring(s,1,nchar(s)-1))))
        
        # Cleaned the data enough, convert to numeric
        # NN, ND, +, 37.0 U/L, A,  will be coerced to NA (which I guess is fine?)
        print.expr("convert results to numeric",lab_data$result <- as.numeric(lab_data$result))
        lab_data$result[has_pct&(lab_data$unit!="%")] <- lab_data$result[has_pct&(lab_data$unit!="%")]/100.0
        
        # Remove all unparsable data
        print.expr("removing unparsable data",lab_data <- lab_data[!is.na(lab_data$result),])

        return(lab_data)
}

lab.convert.units <- function(data)
{
	# Make sure the levels we assign are possible
	data$unit <- factor(data$unit, levels=unique(c(levels(data$unit),"10E9/l","u/l","g/l","mmol/l","per mm3","%","umol/l","nmol/l","pmol/l","")))
	data$unit[is.na(data$unit)] <- ""

	# Unrealistic red blood cell values are cast to another unit (per mm3)
	data$unit[data$test=="Red Blood Cells (RBC)"&data$result>=100&data$unit=="10E12/L"]<-"per mm3"

	# Following units appear to be erroneous
	data <- data[data$test!="Albumin"   |data$unit!="%",]
	data <- data[data$test!="Hemoglobin"|data$unit!="mg/L",]
	data <- data[data$test!="Protein"   |data$unit!="mEq/L",]
	data <- data[data$test!="Prothrombin Time (clotting)",]
	data <- data[data$test!="Urine Glucose",]

	# This is the same, but it is better to use the same upper/lower case
	data$unit[data$unit %in% c("10E3/mm3","10E9/L")]              <- "10E9/l"
	data$unit[data$unit %in% c("IU/L","iu/l","iu/L","U/L","u/L")] <- "u/l"
	data$unit[data$unit %in% c("G/L","g/L","G/l")]                <- "g/l"
	data$unit[data$unit %in% c("mmol/L","MMOL/L")]                <- "mmol/l"
	data$unit[data$unit=="umol/L"]                                <- "umol/l"
	data$unit[data$unit=="nmol/L"]                                <- "nmol/l"
	data$unit[data$unit=="pmol/L"]                                <- "pmol/l"

	# Convert between metric units
	data <- convert.units(data, "g/dL",     "g/l",    10.0)
	data <- convert.units(data, "10E12/L",  "10E9/l", 1/1000.0)
	data <- convert.units(data, "per mm3",  "10E9/l", 1/1000.0)
	data <- convert.units(data, "10E6/mm3", "10E9/l", 1000.0)
	data <- convert.units(data, "V/V",      "%",      100.0)
	
	celltest <- c("Basophils","Eosinophils","Lymphocytes","Neutrophils","Monocytes")
	# Removing all g/L if the type is one of nogram
	nogram <- c(celltest, "White Blood Cells (WBC)", "Platelets")
	data <- data[!(data$unit=="g/l"&(data$test %in% nogram)),]

	# If listed as percentage and it is a cell test, compute as percentage of WBC
	cellP <- data$unit=="%"&(data$test %in% celltest)
	wbc <- data[data$test=="White Blood Cells (WBC)",c("patient","delta","result")]
	wbc <- wbc[!duplicated(wbc[,c("patient","delta")]),]
	cellMerge <- merge(data[cellP,c("patient","delta","result")],wbc,by=c("patient","delta"),all.x=TRUE)
	data[cellP,"result"]<-cellMerge$result.x*cellMerge$result.y/100.0
	data[cellP,"unit"  ]<-"10E9/l"
	
	data <- convert.unit(data, "Triglycerides",     "g/l",   "mmol/l", 1/1.13)
	data <- convert.unit(data, "Total Cholesterol", "g/l",   "mmol/l", 2.59)
	data <- convert.unit(data, "Urea",              "mg/dL", "mmol/l", 0.357)
	data <- convert.unit(data, "Urea",              "g/l",   "mmol/l", 35.7/2.14)
	data <- convert.unit(data, "Uric Acid",         "mg/dL", "umol/l", 59.48)
	data <- convert.unit(data, "Protein",           "g/dL",  "g/l",    10)
	data <- convert.unit(data, "Hemoglobin",        "g/l",   "mmol/l", 0.06206)
	data <- convert.unit(data, "Hematocrit",        "1",     "%",      100.0)
	data <- convert.unit(data, "Free T3",           "pmol/l","nmol/l", 1/1000.0)
	data <- convert.unit(data, "Bilirubin (total)", "mg/L",  "umol/l", 1.71)
	data <- convert.unit(data, "Calcium",           "mEq/L", "mmol/l", 0.5)
	data <- convert.unit(data, "Calcium",           "mg/L",  "mmol/l", 0.025)
	data <- convert.unit(data, "Creatine Kinase",   "mIU/L", "u/l",    1)
	data <- convert.unit(data, "Creatinine",        "mg/L",  "umol/l", 8.84)
	data <- convert.unit(data, "Glucose",           "g/l",   "mmol/l", 5.55)
	data <- convert.unit(data, "Phosphorus",        "mg/L",  "mmol/l", 0.0323)
	
	data <- convert.units(data, "mg/L",     "g/l",    1/1000.0)
	
	data$unit[data$unit=="mEq/L"] <- "mmol/l"
	
	data$unit <- factor(data$unit)

	# Diff: Free T3
	
	return(data)
}

alsfr.form <- function(data)
{
        keys <- c(
                "delta"=1225,
                "Total"=1228,
                "R.Total"=1229,
                "T01"=1213,
                "T02"=1215,
                "T03"=1216,
                "T04"=1217,
                "T05a"=1218,
                "T05b"=1219,
                "T06"=1220,
                "T07"=1221,
                "T08"=1222,
                "T09"=1223,
                "T10"=1214,
                "R1"=1230,
                "R2"=1231,
                "R3"=1232)
        use_data <- data[data$category==145,]
        use_data$value <- as.numeric(use_data$value)
        als_data <- rows.to.form(use_data,145,c("patient","test_id"),keys)
        als_data <- factorize.cols(als_data,c("patient","test_id"))
        
        # Set default delta to 0
        als_data$delta[als_data$delta==""] = 0
        
        # All keys are numeric
        als_data <- numerize.cols(als_data,names(keys))
        
        # Replace 05a and 05b with column 05a (<-05a|05b) and column with.gastronomy indicating whether 05b was used.
        fiveA_NA <- is.na(als_data$T05a)
        als_data$T05a[fiveA_NA]<-als_data$T05b[fiveA_NA]
        exceptFiveB <- setdiff(names(als_data),c("T05b"))
        als_data <- data.frame(als_data[,exceptFiveB],"with.gastronomy"=as.numeric(fiveA_NA))

        # Replace 10 with column R1 (Dyspnea) if it is applicable
        ten_NA <- is.na(als_data$T10)
        als_data$T10[ten_NA] <- als_data$R1[ten_NA]

		# Recalculate total
		als_data$Total <- rowSums(als_data[,c("T01","T02","T03","T04","T05a","T06","T07","T08","T09","T10")])

        return(als_data)
}

vital.form <- function(data)
{
        keys <- c(
                "delta"=1174, # total 13020 measurements; for 0 <= delta <= 90: 5857 measurements: 6.5/patient
                "blood.pressure.dia"=1169,
                "blood.pressure.dia.standing"=1446,
                #"blood.pressure.dia.standing.base"=1428,
                #"blood.pressure.dia.standing.end"=1440,
                "blood.pressure.dia.supine"=1444,
                #"blood.pressure.dia.supine.base"=1430,
                #"blood.pressure.dia.supine.end"=1442,
                #"blood.pressure.dia.unit"=1410, # always "MMHG"
                "blood.pressure.sys"=1170,
                "blood.pressure.sys.standing"=1447,
                #"blood.pressure.sys.standing.base"=1429,
                #"blood.pressure.sys.standing.end"=1441,
                "blood.pressure.sys.supine"=1445,
                #"blood.pressure.sys.supine.base"=1431,
                #"blood.pressure.sys.supine.end"=1443,
                #"blood.pressure.sys.unit"=1413, # always "MMHG"
                "height"=1171, # measured for 518 patients
                "height.unit"=1181, # values: {"": 691, "CM": 552, "Centimeters": 74, "Inches": 12} default is CM if not measured
                "pulse"=1175,
                "pulse.standing"=1434,
                #"pulse.standing.base"=1438,
                #"pulse.standing.end"=1436,
                "pulse.supine"=1433,
                #"pulse.supine.base"=1437,
                #"pulse.supine.end"=1435,
                #"pulse.unit"=1411, # always "BEATS/MIN"
                "respiratory"=1176,
                #"respiratory.unit"=1412, # always "BREATHS/MIN"
                "weight"=1178,
                #"weight.base"=1432,
                #"weight.end"=1439,
                "weight.unit"=1180 # values: {"": 462, "2": 621, "Kilograms": 10393, "Pounds": 120}
                )
        vital_data <- rows.to.form(data,183,c("patient","test_id"),keys)

        # Set default delta to 0
        vital_data$delta[vital_data$delta==""] = 0

        # factorize categorical data
        fcols <- c("patient","test_id","height.unit","weight.unit")
        vital_data <- factorize.cols(vital_data,fcols)
        
        # all other columns are numeric
        ncols <- setdiff(names(keys),fcols)
        vital_data <- numerize.cols(vital_data,ncols)
        
        # Convert inches to centimeters
        inches <- !is.na(vital_data$height.unit)&vital_data$height.unit=="Inches"
        vital_data$height[inches]<-vital_data$height[inches]*2.54

        # Convert pounds to kilograms
        pounds <- !is.na(vital_data$weight.unit)&vital_data$weight.unit=="Pounds"
        vital_data$weight[pounds]<-vital_data$weight[pounds]*0.45359237
        
        # remove the units
        vital_data <- vital_data[,setdiff(names(vital_data),c("height.unit","weight.unit"))]

        # Some tests are completely empty, except for the delta which we set forcibly
        lcols <- length(ncols)-1
        vital_data <- vital_data[rowSums(is.na(vital_data))<lcols,]
	
	# Convert all values to non-supine and non-standing, by taking the average between the two, and subtracting
	# the difference with the mean of the non-supine/non-standing.
	# Diastolic
	# standing = 84.19274, supine = 82.70044, non = 81.05476; (standing + supine) / 2 - non = 2.39183
	noblood <- is.na(vital_data$blood.pressure.dia)&!is.na(vital_data$blood.pressure.dia.supine)&!is.na(vital_data$blood.pressure.dia.standing)
	vital_data$blood.pressure.dia[noblood]<-(vital_data$blood.pressure.dia.standing[noblood]+vital_data$blood.pressure.dia.supine[noblood])/2-2.39183

	# Systolic
	# standing = 134.7334, supine = 133.344, non = 130.5034; (standing + supine) / 2 - non = 3.5353
	noblood <- is.na(vital_data$blood.pressure.sys)&!is.na(vital_data$blood.pressure.sys.supine)&!is.na(vital_data$blood.pressure.sys.standing)
	vital_data$blood.pressure.sys[noblood]<-(vital_data$blood.pressure.sys.standing[noblood]+vital_data$blood.pressure.sys.supine[noblood])/2-3.5353
	
	# Pulse
	# standing = 79.5434, supine = 74.6895, non = 76.85084; (standing + supine) / 2 - non = 0.26561
	nopulse <- is.na(vital_data$pulse)&!is.na(vital_data$pulse.supine)&!is.na(vital_data$pulse.standing)
	vital_data$pulse[nopulse]<-(vital_data$pulse.standing[nopulse]+vital_data$pulse.supine[nopulse])/2-3.5353
	
	# Remove the columns
	vital_data <- vital_data[,setdiff(names(vital_data),c("blood.pressure.dia.standing","blood.pressure.dia.supine","blood.pressure.sys.standing","blood.pressure.sys.supine","pulse.standing","pulse.supine"))]

	# Set height the same for the same patient
	vital_data <- merge(vital_data[,setdiff(names(vital_data),c("height"))],vital_data[!is.na(vital_data$height),c("patient","height")],all.x=TRUE,by=c("patient"))
	# bmi = kg/(m*m) = kg/(cm/100*cm/100) = 100*100*kg/(cm*cm)
	vital_data <- data.frame(vital_data, "bmi"=10000*vital_data$weight/(vital_data$height*vital_data$height))
	
	return(vital_data)
}

forms.combine <- function(vital,vital_forced,als_hist,als,demography,test)
{
	# Combine only patients with als data
	patients <- unique(als$patient)
	# Split the dataset into one dataset per patient
	als3m <- als[als$delta<=91,]
	ldata <- split(als3m, als3m$patient)

	# Start with only the patient ID
	comb <- data.frame(patient=patients)

	print.expr("adding ALSFR score", comb <- add.col.fit("Total", comb, ldata))
	print.expr("adding ALSFR1 score", comb <- add.col.fit("T01", comb, ldata))
	print.expr("adding ALSFR2 score", comb <- add.col.fit("T02", comb, ldata))
	print.expr("adding ALSFR3 score", comb <- add.col.fit("T03", comb, ldata))
	print.expr("adding ALSFR4 score", comb <- add.col.fit("T04", comb, ldata))
	print.expr("adding ALSFR5a score", comb <- add.col.fit("T05a", comb, ldata))
	print.expr("adding ALSFR6 score", comb <- add.col.fit("T06", comb, ldata))
	print.expr("adding ALSFR7 score", comb <- add.col.fit("T07", comb, ldata))
	print.expr("adding ALSFR8 score", comb <- add.col.fit("T08", comb, ldata))
	print.expr("adding ALSFR9 score", comb <- add.col.fit("T09", comb, ldata))
	print.expr("adding ALSFR10 score", comb <- add.col.fit("T10", comb, ldata))
	
	# Add age
	demography$patient <- factor(demography$patient, levels(als$patient))
	print.expr("adding age and sex", comb <- merge(comb,demography[,c("patient","age","sex")],by=c("patient"),all=TRUE))

	# Split the dataset into one dataset per patient
	vital$patient <- factor(vital$patient, levels(als$patient))
	vital3m <- vital[vital$delta <= 91,]
	print.expr("splitting vital data into patients", ldata <- split(vital3m,vital3m$patient))

	print.expr("adding blood pressure diastolic", comb <- add.col.fit("blood.pressure.dia", comb, ldata))
	print.expr("adding blood pressure systolic", comb <- add.col.fit("blood.pressure.sys", comb, ldata))
	print.expr("adding pulse", comb <- add.col.fit("pulse", comb, ldata))
	print.expr("adding respiratory", comb <- add.col.fit("respiratory", comb, ldata))
	print.expr("adding bmi", comb <- add.col.fit("bmi", comb, ldata))
	
	# Use the same levels as vital, so the split doesn't get permutated
	vital_forced$patient <- factor(vital_forced$patient, levels(als$patient))
	vital_forced3m <- vital_forced[vital_forced$delta <= 91,]
	print.expr("splitting vital_forced data into patients", ldata <- split(vital_forced3m,vital_forced3m$patient))
	
	print.expr("adding vital forced (subject.liters)", comb <- add.col.fit("subject.liters", comb, ldata))
	
	als_hist$patient <- factor(als_hist$patient, levels(als$patient))
	comb <- merge(comb,als_hist[,c("patient","onset.delta","onset.location","diagnosis.delta")],by=c("patient"),all=TRUE)
	
	test3m <- test[test$delta <= 91,]
	test3m$patient <- factor(test3m$patient, levels(als$patient))
	test3m$test <- factor(test3m$test)
	print.expr("splitting lab data into patients", ldata <- split(test3m,test3m$patient))
	
	for (name in levels(test3m$test)) {
		print.expr(paste("adding lab test",name), comb <- add.test.fit(name, comb, ldata))
	}
	
	#slopes$patient <- factor(slopes$patient, levels(als$patient))
	#comb <- merge(comb,by=c("patient"),all=TRUE)
	
	# fam$patient <- factor(fam$patient, levels(fam$patient))
	# comb <- merge(comb, fam[,c("patient","disease")],all.x=TRUE,by="patient")
	
	
	return (comb)
}

forms.exp.combine <- function(vital,vital_forced,als_hist,als,demography,test,fam)
{
	is.pos <- function (x) all(is.na(x)|x>=0)
	# Combine only patients with als data
	patients <- unique(als$patient)
	# Split the dataset into one dataset per patient
	usenames <- c("Total","T01","T02","T03","T04","T05a","T06","T07","T08","T09","T10")
	als3m <- als[als$delta<=91&apply(als[,usenames],1,is.pos),]
	als3m[,usenames] <- log(als3m[,usenames]+1)
	
	ldata <- split(als3m, als3m$patient)

	# Start with only the patient ID
	comb <- data.frame(patient=patients)

	print.expr("adding ALSFR score", comb <- add.col.fit("Total", comb, ldata))
	print.expr("adding ALSFR1 score", comb <- add.col.fit("T01", comb, ldata))
	print.expr("adding ALSFR2 score", comb <- add.col.fit("T02", comb, ldata))
	print.expr("adding ALSFR3 score", comb <- add.col.fit("T03", comb, ldata))
	print.expr("adding ALSFR4 score", comb <- add.col.fit("T04", comb, ldata))
	print.expr("adding ALSFR5a score", comb <- add.col.fit("T05a", comb, ldata))
	print.expr("adding ALSFR6 score", comb <- add.col.fit("T06", comb, ldata))
	print.expr("adding ALSFR7 score", comb <- add.col.fit("T07", comb, ldata))
	print.expr("adding ALSFR8 score", comb <- add.col.fit("T08", comb, ldata))
	print.expr("adding ALSFR9 score", comb <- add.col.fit("T09", comb, ldata))
	print.expr("adding ALSFR10 score", comb <- add.col.fit("T10", comb, ldata))
	
	# Add age
	demography$patient <- factor(demography$patient, levels(als$patient))
	print.expr("adding age and sex", comb <- merge(comb,demography[,c("patient","age","sex")],by=c("patient"),all=TRUE))

	# Split the dataset into one dataset per patient
	vital$patient <- factor(vital$patient, levels(als$patient))
	usenames <- c("blood.pressure.dia","blood.pressure.sys","pulse","respiratory","bmi")
	vital3m <- vital[vital$delta <= 91&apply(vital[,usenames], 1, is.pos),]
	vital3m[,usenames] <- log(vital3m[,usenames]+1)
	
	print.expr("splitting vital data into patients", ldata <- split(vital3m,vital3m$patient))

	print.expr("adding blood pressure diastolic", comb <- add.col.fit("blood.pressure.dia", comb, ldata))
	print.expr("adding blood pressure systolic", comb <- add.col.fit("blood.pressure.sys", comb, ldata))
	print.expr("adding pulse", comb <- add.col.fit("pulse", comb, ldata))
	print.expr("adding respiratory", comb <- add.col.fit("respiratory", comb, ldata))
	print.expr("adding bmi", comb <- add.col.fit("bmi", comb, ldata))
	
	# Use the same levels as vital, so the split doesn't get permutated
	vital_forced$patient <- factor(vital_forced$patient, levels(als$patient))
	vital_forced3m <- vital_forced[vital_forced$delta <= 91&!is.na(vital_forced$subject.liters)&vital_forced$subject.liters>=0,]
	vital_forced3m$subject.liters <- log(vital_forced3m$subject.liters+1)
	
	print.expr("splitting vital_forced data into patients", ldata <- split(vital_forced3m,vital_forced3m$patient))
	
	print.expr("adding vital forced (subject.liters)", comb <- add.col.fit("subject.liters", comb, ldata))
	
	als_hist$patient <- factor(als_hist$patient, levels(als$patient))
	comb <- merge(comb,als_hist[,c("patient","onset.delta","onset.location","diagnosis.delta")],by=c("patient"),all=TRUE)
	
	test3m <- test[test$delta <= 91&!is.na(test$result)&test$result >= 0,]
	test3m$patient <- factor(test3m$patient, levels(als$patient))
	test3m$test <- factor(test3m$test)
	test3m$result <- log(test3m$result+1)
	
	print.expr("splitting lab data into patients", ldata <- split(test3m,test3m$patient))
	
	for (name in levels(test3m$test)) {
		print.expr(paste("adding lab test",name), comb <- add.test.fit(name, comb, ldata))
	}
	
	# fam$patient <- factor(fam$patient, levels(fam$patient))
	# comb <- merge(comb, fam[,c("patient","disease")],all.x=TRUE,by="patient")
	
	return (comb)
}

vital.forced.form <- function(data)
{
        keys <- c(
                "delta"=1190,
                "subject.liters"=1185,
                "subject.normal"=1188,
                "unit"=1405)
        vital_data <- rows.to.form(data,149,c("patient","test_id"),keys)
        if (nrow(vital_data)==0) return(vital_data)

        # Set default delta to 0
        vital_data$delta[vital_data$delta==""] = 0

        # factorize categorical data
        fcols <- c("patient","test_id","unit")
        vital_data <- factorize.cols(vital_data,fcols)
        
        # all other columns are numeric
        ncols <- setdiff(names(keys),fcols)
        vital_data <- numerize.cols(vital_data,ncols)
        
        # Some tests are completely empty, except for the delta which we set forcibly
        lcols <- length(ncols)-1
        vital_data <- vital_data[rowSums(is.na(vital_data))<lcols,]
        
        return(vital_data)
}

vital.slow.form <- function(data)
{
        keys <- c(
                "delta"=1267,
                "subject.liters"=1262)
        vital_data <- rows.to.form(data,212,c("patient","test_id"),keys)
        if (nrow(vital_data)==0) return(vital_data)

        # Set default delta to 0
        vital_data$delta[vital_data$delta==""] = 0

        # factorize categorical data
        fcols <- c("patient","test_id")
        vital_data <- factorize.cols(vital_data,fcols)
        
        # all other columns are numeric
        ncols <- setdiff(names(keys),fcols)
        vital_data <- numerize.cols(vital_data,ncols)
        
        # Some tests are completely empty, except for the delta which we set forcibly
        lcols <- length(ncols)-1
        vital_data <- vital_data[rowSums(is.na(vital_data))<lcols,]
        
        return(vital_data)
}

treatment.form <- function(data)
{
        keys <- c(
                "delta"=1456,
                "study.arm"=1454) # in delta <= 90: {ACTIVE: 110, PLACEBO: 119}
        treatment_data <- rows.to.form(data,217,c("patient","test_id"),keys)

        # Set default delta to 0
        treatment_data$delta[treatment_data$delta==""] = 0

        # factorize categorical data
        fcols <- c("patient","test_id","study.arm")
        treatment_data <- factorize.cols(treatment_data,fcols)
                
        # all other columns are numeric
        ncols <- setdiff(names(keys),fcols)
        treatment_data <- numerize.cols(treatment_data,ncols)
        return(treatment_data)
}

family.form <- function(data)
{
        keys <- c(
                "delta"=1236,
                "disease"=1419,
                "disease.specify"=1420,
                "aunt"=1288,
                "aunt.m"=1289,
                "aunt.p"=1290,
                "cousin"=1291,
                "cousin.m"=1292,
                "cousin.p"=1293,
                "father"=1294,
                "grandfather"=1295,
                "grandfather.m"=1296,
                "grandfather.p"=1297,
                "grandmother"=1298,
                "grandmother.m"=1299,
                "grandmother.p"=1300,
                "mother"=1301,
                "nephew"=1302,
                "niece"=1305,
                "sibling"=1309,
                "uncle"=1311,
                "uncle.m"=1312,
                "uncle.p"=1313,
                "son"=1424,
                "daughter"=1425,
                "sister"=1426,
                "brother"=1427
                )
        family_data <- rows.to.form(data,147,c("patient","test_id"),keys)
        if (nrow(family_data)==0) return(family_data)
        
        # Set default values to 0 (find indices where =="", and replace by 0)
        family_data[family_data==""] = 0

        # Diseases can not be numbers
        family_data$disease[family_data$disease==0]=NA
        family_data$disease.specify[family_data$disease.specify==0]=NA

        # factorize categorical data
        fcols <- c("patient","test_id","disease","disease.specify")
        family_data <- factorize.cols(family_data,fcols)
        
        # all other columns are numeric
        ncols <- setdiff(names(keys),fcols)
        family_data <- numerize.cols(family_data,ncols)
        return(family_data)
}

als.hist.form <- function(data,demography)
{
        keys <- c(
                "delta"=1200,
                "symptom"=1247,
                "location"=1249,
                "diagnosis.delta"=1418,
                "onset.delta"=1417,
                "onset.location"=1416,
                "onset.age"=1245
                )
        als_data <- rows.to.form(data,148,c("patient","test_id"),keys)

        # delta's and age are numeric
        ncols <- c("delta", "onset.delta", "diagnosis.delta", "onset.age")
        als_data <- numerize.cols(als_data,ncols)

        # factorize categorical data
        fcols <- setdiff(c("patient","test_id",names(keys)),ncols)
        als_data <- factorize.cols(als_data,fcols)
        
        # onset age can be deduced from onset delta and current age
        deduce_onset <- !is.na(als_data$onset.delta)
        if (sum(deduce_onset) > 0) als_data$onset.age[deduce_onset] <- demography$age[match(als_data$patient[deduce_onset],demography$patient)]+als_data$onset.delta[deduce_onset]/365

        # Merge the data of the ALS symptom with the ALS onset
        onset <- which(!is.na(als_data$onset.location)&is.na(als_data$symptom))
        if (length(onset)>0) {
                diagnosis <- match(als_data$patient[onset],als_data$patient[!is.na(als_data$symptom)])
                onset<-onset[!is.na(diagnosis)]
                diagnosis<-diagnosis[!is.na(diagnosis)]
                if (length(onset)>0) {
                        print.expr(paste("merging symptom",length(diagnosis),"times"),als_data[onset,c("symptom","location","diagnosis.delta","onset.delta","onset.age")] <- als_data[diagnosis,c("symptom","location","diagnosis.delta","onset.delta","onset.age")])
                }
        }

        # Merge the data of the ALS onset delta with the ALS onset
        onset <- which(!is.na(als_data$onset.location)&is.na(als_data$onset.delta))
        if (length(onset)>0) {
                diagnosis <- match(als_data$patient[onset],als_data$patient[!is.na(als_data$onset.delta)])
                onset<-onset[!is.na(diagnosis)]
                diagnosis<-diagnosis[!is.na(diagnosis)]
                if (length(onset)>0) {
                        print.expr(paste("merging onset delta",length(diagnosis),"times"),als_data[onset,c("symptom","location","diagnosis.delta","onset.delta","onset.age")] <- als_data[diagnosis,c("symptom","location","diagnosis.delta","onset.delta","onset.age")])
                }
        }
        
        #ASSUME: site 1 is bulbar, site 3 is limb (seems possible given the ratio 1:5)
        als_data$onset.location[als_data$onset.location=="1"] = "Onset: Bulbar"
        als_data$onset.location[als_data$onset.location=="3"] = "Onset: Limb"
        als_data <- als_data[!is.na(als_data$onset.location),]
        als_data$onset.location <- factor(als_data$onset.location)
        
        return(als_data)
}

comb.select.disease <- function(comb, disease)
{
	comb <- comb[comb$disease %in% c(disease),]
	return(na.to.mean(comb))
}


comb.select.location <- function(comb, location)
{
	comb <- comb[comb$onset.location %in% c(location),]
	return(na.to.mean(comb))
}

combL.fit <- function(comb)
{
	return(generic.fit(comb,
		c(	"Total.x1",
			"subject.liters.x1",
			"bmi.x1",
			"sex")))
}

combL.fit2 <- function(comb)
{
	return(generic.fit(comb,
		c(	"diagnosis.delta",
			"T07.x1",
			"T01.x1",
			"T03.var",
			"T08.x1")))
}

combL.predict <- function(comb)
{
	return(predict.lin(comb,c(
			"intercept"=-0.50153,
			"Total.x1"=3.09764,
			"subject.liters.x1"=18.93059,
			"bmi.x1"=6.61562,
			"sex"=-0.04605)))
}
combL.predict2 <- function(comb)
{
	return(predict.lin(comb,
		c(	"intercept"=-0.6674658,
			"diagnosis.delta"=-0.0002468,
			"T07.x1"=5.1697039,
			"T01.x1"=1.9618256,
			"T03.var"=-0.1512376,
			"T08.x1"=2.6373339)))
}

combB.fit <- function(comb)
{
	return(generic.fit(comb,
		c(	"Total.x1",
			"sex",
			"subject.liters.x1",
			"ALT.SGPT..var",
			"Phosphorus.x0")))
}
combB.fit2 <- function(comb)
{
	return(generic.fit(comb,
		c(	"pulse.x0",
			"pulse.var",
			"Eosinophils.x1",
			"T02.x1",
			"subject.liters.x1",
			"T09.x0",
			"T06.x0",
			"T04.x0",
			"Neutrophils.x0",
			"Urine.Protein.x1")))
}

combB.predict <- function(comb)
{
	return(predict.lin(comb,c(
		"intercept"=0.39038,
		"Total.x1"=3.01256,
		"sex"=-0.10471,
		"subject.liters.x1"=13.30749,
		"ALT.SGPT..var"=-0.02484,
        "Phosphorus.x0"=-0.69917)))
}

combB.predict2 <- function(comb)
{
	return(predict.lin(comb,
		c(	"intercept"=0.117583,
			"pulse.x0"=-0.008143,
			"pulse.var"=-0.009881,
			"Eosinophils.x1"=-0.887195,
			"T02.x1"=4.218051,
			"subject.liters.x1"=20.565352,
			"T09.x0"=-0.091629,
			"T06.x0"=-0.059793,
			"T04.x0"=0.082821,
			"Neutrophils.x0"=0.008111,
			"Urine.Protein.x1"=34.081285)))
}


combALS.fit <- function(comb)
{
	return(predict.lin(comb,
		c(	"intercept"=-0.142438,
			"Total.x1"=2.735344,
			"Triglycerides.x0"=-0.031742,
			"Triglycerides.var"=-0.202933)))
}

combALS.predict <- function(comb)
{
	return(generic.fit(comb,
		c(	"Total.x1",
			"diagnosis.delta",
			"Hemoglobin.x1",
			"Lymphocytes.var",
			"Triglycerides.x0",
			"Triglycerides.var",
			"White.Blood.Cells..WBC..x0")))
}

comb.fit <- function(comb)
{
	return(generic.fit(comb,
		c("T01.x0",
		"T01.x1",
		"T02.x1",
		"T03.x0",
		"T04.x0",
		"T05a.x0",
		"T06.x0",
		"T07.x1",
		"subject.liters.x0",
		"Neutrophils.x1",
		"White.Blood.Cells..WBC..x1")))
}

comb.predict <- function(comb)
{
	return(predict.lin(comb,
		c(	"intercept"=-1.10594,
			"Total.x1"=3.20421,
			"pulse.x1"=0.22059,
			"subject.liters.x1"=19.90935,
			"subject.liters.var"=-0.08518,
			"bmi.x1"=5.61068,
			"Neutrophils.x0"=0.02421,
			"Uric.Acid.x0"=0.00152)))
}


comb.predict2 <- function(comb)
{
	return(predict.lin(comb,
		c(	"intercept"=-0.86879,
			"T01.x0"=0.11186,
			"T01.x1"=10.41918,
			"T02.x1"=4.37366,
			"T03.x0"=-0.01953,
			"T04.x0"=-0.11065,
			"T05a.x0"=0.04916,
			"T06.x0"=0.04697,
			"T07.x1"=4.97646,
			"subject.liters.x0"=-0.00560,
			"Neutrophils.x1"=-0.57059,
			"White.Blood.Cells..WBC..x1"=0.40878)))
}

combF.predict <- function(comb)
{
	return(predict.lin(comb,
		c( "intercept"=1.617100e-01,
			"Total.x1"=4.161613e+00,
			"blood.pressure.dia.x0"=-9.825584e-03,
			"T10.x0"=1.562558e-01,
			"Basophils.x0"=-5.216157e-02,
			"Potassium.x0"=-2.116200e-01,
			"Total.var"=1.388601e-01,
			"Triglycerides.x1"=-1.174815e+01,
			"Alkaline.Phosphatase.x1"=-8.116062e-02,
			"Lymphocytes.x1"=-1.158547e+00,
			"T02.x1"=7.359569e+00,
			"Creatine.Kinase.x1"=4.197933e-02,
			"Platelets.x1"=1.065751e-01,
			"Glucose.x0"=5.333003e-02,
			"Monocytes.x1"=1.449043e+00,
			"pulse.var"=-1.656332e-02,
			"subject.liters.x1"=2.605422e+01,
			"diagnosis.delta"=-2.051913e-04
		)))
}

combLmF.predict <- function(comb)
{
     return(predict.lin(comb,
		c( 	"intercept"=-0.1897731449,
			"T04.x0"=-0.0896295849,
			"subject.liters.x1"=11.8989467388,
			"T07.x1"=4.0783058441,
			"T05a.var"=-0.3509283856,
			"pulse.x0"=-0.0040043895,
			"T01.var"=-0.2750455812,
			"diagnosis.delta"=-0.0002986005,
			"Creatinine.x1"=0.1961481627,
			"T06.x0"=0.0810978301)))
}

combBmMF.predict <- function(comb)
{
	return(predict.lin(comb,
		c("intercept"=-5.935106553,
			"Creatine.Kinase.var"=-0.000871967,
			"Sodium.x0"=0.050248814,
			"Phosphorus.x0"=-1.065114372,
			"Creatinine.x1"=1.281682557,
			"HbA1c..Glycated.Hemoglobin..var"=0.487879827,
			"T01.var"=-0.052466644,
			"pulse.x1"=0.641234430,
			"blood.pressure.sys.var"=0.009670242,
			"blood.pressure.dia.x1"=-0.384179508,
			"respiratory.x0"=-0.023440651,
			"Phosphorus.var"=-2.192648195,
			"T07.var"=-0.417501935,
			"Urea.x1"=-2.964874863,
			"Urea.x0"=-0.033962445,
			"age"=0.007980462,
			"T09.x0"=-0.088722714,
			"T01.x1"=17.360637376)))
}

combBpM.predict <- function(comb)
{
	return(predict.lin(comb,c(
		"intercept"=3.90729192,
		"Eosinophils.x1"=3.84766215,
		"Urea.x1"=49.63752237,
		"ALT.SGPT..x0"=-0.01530378,
		"Bilirubin..total..x1"=4.57874734,
		"Protein.x0"=0.04377333,
		"Calcium.var"=6.06262130,
		"Calcium.x0"=-2.30667079,
		"Absolute.Lymphocyte.Count.x1"=-66.94497539,
		"Absolute.Basophil.Count.var"=6.75488938,
		"Potassium.x0"=-0.48723787,
		"T06.var"=-0.62430820,
		"T03.var"=0.50490272,
		"Potassium.var"=-1.42687051,
		"Amylase.x1"=0.25756856,
		"Creatinine.x1"=0.67373900,
		"T01.x1"=4.89163489)))
		
}

combF.fit <- function(comb)
{
	return(generic.fit(comb,
		c(  "Total.x1",
			"blood.pressure.dia.x0",
			"T10.x0",
			"Basophils.x0",
			"Potassium.x0",
			"Total.var",
			"Triglycerides.x1",
			"Alkaline.Phosphatase.x1",
			"Lymphocytes.x1",
			"T02.x1",
			"Creatine.Kinase.x1",
			"Platelets.x1",
			"Glucose.x0",
			"Monocytes.x1",
			"pulse.var",
			"subject.liters.x1",
			"diagnosis.delta"
		)))
}

combLmF.fit <- function(comb) {
	  return(generic.fit(comb,
	 c(
	 "T04.x0",
			 "subject.liters.x1",
	
	
	 "T07.x1",
	
	
	 "T05a.var",
	
	
	 "pulse.x0",
	
	
	 "T01.x0",
	
	
	 "T09.x0",
	
	
	 "T01.var",
	
	
	 "diagnosis.delta",
	
	
	 "Creatinine.x1",
	
	
	 "T06.x0"))) }
combBmMF.fit <- function(comb)
{
	return(generic.fit(comb,
		c(	"Creatine.Kinase.var",
			"Sodium.x0",
			"Phosphorus.x0",
			"Creatinine.x1",
			"HbA1c..Glycated.Hemoglobin..var",
			"T01.var",
			"pulse.x1",
			"blood.pressure.sys.var",
			"blood.pressure.dia.x1",
			"respiratory.x0",
			"Phosphorus.var",
			"T07.var",
			"Urea.x1",
			"Urea.x0",
			"age",
			"T09.x0",
			"T01.x1")))
}

combBpM.fit <- function(comb)
{
	return(generic.fit(comb,c(
		"Eosinophils.x1",
		"Urea.x1",
		"ALT.SGPT..x0",
		"Bilirubin..total..x1",
		"Protein.x0",
		"Calcium.var",
		"Calcium.x0",
		"Absolute.Lymphocyte.Count.x1",
		"Absolute.Basophil.Count.var",
		"Potassium.x0",
		"T06.var",
		"T03.var",
		"Potassium.var",
		"Amylase.x1",
		"Creatinine.x1",
		"T01.x1")))
		
}

comb.plot <- function(file, comb, fit)
{
	png(file,5600,4800)
	par(mfrow = c(14, 12), pty = "s")
	for( name in setdiff(names(comb),c("patient","slope"))) {
		plot(x=comb[abs(fit$residuals)<0.25,name],y=comb$slope[abs(fit$residuals)<0.25],col="red",xlab=name,ylab="slope")
		points(x=comb[abs(fit$residuals)>=0.25,name],y=comb$slope[abs(fit$residuals)>=0.25],col="blue")
	}
	dev.off()
}

hist.plot <- function(dir,combSlow, combMiddle, combFast)
{
	for( name in setdiff(names(comb),c("patient","slope"))) {
		if (!is.numeric(combSlow[,name])) next
		slow <- combSlow[!is.na(combSlow[,name]),name]
		mid <- combMiddle[!is.na(combMiddle[,name]),name]
		fast <- combFast[!is.na(combFast[,name]),name]
		if (length(slow)==0|length(mid)==0|length(fast)==0) {
			cat("Omitting ", name, "; it is zero\n")
			next
		}
		height <- max(length(slow),length(mid),length(fast))
		xlim <- c(min(slow,mid,fast), max(slow,mid,fast))
		breaks <- seq(from=xlim[[1]],to=xlim[[2]],length.out=6)
		png(paste("~/Dropbox/Work/ALS/",dir,"/",name,".png",sep=""),480,900)
		par(mfrow = c(3, 1), pty = "s")
		hist(x=slow,ylim=c(0,length(slow)*3/4),xlim=xlim,breaks=breaks)
		hist(x=mid,ylim=c(0,length(mid)*3/4),xlim=xlim,breaks=breaks)
		hist(x=fast,ylim=c(0,length(fast)*3/4),xlim=xlim,breaks=breaks)
		dev.off()
	}
}

predict.lin <- function(comb,cols)
{
	pred<-rep(cols["intercept"],nrow(comb))
	
	for (col in intersect(names(comb),setdiff(names(cols),c("intercept")))) {
		pred <- pred + cols[col]*comb[,col]
	}
	return(data.frame("patient"=comb$patient,"prediction"=pred))
}

division <- function(comb)
{
	divisor <- nrow(comb)
	cat("Slow progressors:",length(which(comb$slope > -0.2535620))/divisor)
	cat("\n")
	cat("Medium progressors:",length(which(comb$slope <= -0.2535620 & comb$slope >= -1.0145556))/divisor)
	cat("\n")
	cat("Fast progressors:",length(which(comb$slope < -1.0145556))/divisor)
	cat("\n")
}

rvm.run <- function(comb,samp=297)
{
	s <- sample(1:nrow(comb),samp)
	ns <- setdiff(1:nrow(comb),s)
	r <- rvm(as.matrix(rm.cols(comb,c("slope","patient","onset.location"))[ns,]),comb$slope[ns],karg=list(sigma=0.525739))
	r.pred <- predict(r,as.matrix(rm.cols(comb,c("slope","patient","onset.location"))[s,]))
	return(score(comb$slope[s],r.pred))
}

lin.run <- function(comb,samp=.25)
{
	s <- sample(1:nrow(comb),samp*nrow(comb))
	ns <- setdiff(1:nrow(comb),s)
	cols <- lin.cols.select(comb[s,], comb[ns,],setdiff(names(comb),c("slope","patient","onset.location")),12)
	lin.cols.remove(comb[s,],comb[ns,],cols)
	return(cols)
}


selectcol <- function(col, cols, comb, combTrain, min, minCol) {
	coef <- generic.fit(combTrain,c(cols,col))$coefficients
	names(coef) <- c("intercept",c(cols,col))
	lin.pred <- predict.lin(comb,coef)
	comb <- merge(comb,lin.pred,by="patient",all.x=TRUE)
	res <- sqrt(sum((comb$prediction - comb$slope)^2)/nrow(comb))
	if (!is.na(res)&(res < min)) {
		min <- res
		minCol <- col
	}
	return(c(min,minCol))
}

lin.cols.select <- function(comb,combTrain,fromCols,newCols) {

	totalMin <- Inf
	min <- Inf
	minCol <- NA
	cols <- c()
	for (i in 1:newCols) {
		for (col in setdiff(fromCols,cols)) {
			res <- c(min,minCol)
			tryCatch(res <- selectcol(col, cols, comb, combTrain, min, minCol),error=function (e) 1)
			min <- res[[1]]
			minCol <- res[[2]]
		}
		
		if (!is.na(minCol)) {
			cols <- c(cols,minCol)
			print(paste("Adding column ", minCol, " with new score ", min))
		}
			
	}
	return(cols)
}

# colClasses: the values are character data, so that we can interpret numbers
# Change train.txt to test.txt for testing
print.expr("reading data", testdata <- read.csv("test.txt", header=TRUE, sep='|',col.names=c("patient","category","category_name","test_id","key","key_name","value"),colClasses = c("factor","factor","factor","factor","factor","factor","character")))

# Contains most of the data. Most of this is numeric, so that's good.
# J: we're not converting between different units for the same test, which is not so good.
print.expr("LABORATORY FORM", lab <- laboratory.form(testdata))
print.expr("removing small samples from LABORATORY FORM", lab <- remove.small.lab.samples(lab))
print.expr("cleaning LABORATORY FORM", lab <- clean.laboratory.form(lab))
print.expr("removing rest of small samples from LABORATORY FORM", lab <- remove.small.lab.samples(lab))
print.expr("converting units of the LABORATORY FORM", lab <- lab.convert.units(lab))

# In about half of the cases the sex is unknown, otherwise Male=1, Female=2
# Caucasian race: 886 of 918 = 96,5% is.
# J: Either race is not significant for ALS progression or we should exclude
# other races to remove potential bias.
print.expr("DEMOGRAPHY FORM", demography <- demographics.form(testdata))

# Main problem domain. In the first 90 days, there are about 3.5 data points per patient
# J: I don't know how to handle the difference between ALSF-R and ALSF... (tests 1-10 vs 1-9 + R1-3)
# J: if we play it safe, we could save 4 per patient.
print.expr("ALSFR FORM", als <- alsfr.form(testdata))

# Mainly textual values where the ALS began. Most of the data is discarded,
# one data point per patient is kept with onset in Limb or Bulbar, and how long the onset was
print.expr("ALS History", als_hist <- als.hist.form(testdata,demography))

# In the first 90 days, there are about 3.5 data points per patient
# Has a lot of NA values, there is some differentiation between
# test
# test standing or supine
# test baseline or end
# J: I can't find a pattern in when which type of data is recorded.
print.expr("VITAL FORM", vital <- vital.form(testdata))

# Only a value about subject liters (Trial 1). J: I don't know what it means.
#print.expr("VITAL SLOW FORM", vital_slow <- vital.slow.form(testdata))

# In addition to a value subject liters it also has a value subject normal. J: I don't know what they mean.
print.expr("VITAL FORCED FORM", vital_forced <- vital.forced.form(testdata))

# Contains only treatment$study.arm = PLACEBO/ACTIVE.
# J: we could approximate it with NA = 0, PLACEBO = 1, ACTIVE = 2?
#print.expr("TREATMENT FORM", treatment <- treatment.form(testdata))

# 198 data points, with too little information
# Most diseases occur with the mother or the father (probably because of recollection bias as well)
# J: We probably should ignore this.
#print.expr("FAMILY FORM", fam <- family.form(testdata))

# Don't need the raw data anymore
rm(testdata)

#print.expr("reading training slopes", testslopes <- read.csv("../training_slopes_m3-m12.txt", header=FALSE, sep=',',col.names=c("patient","slope"),colClasses = c("factor","numeric")))
print.expr("Combining forms into one", comb <- forms.combine(vital,vital_forced, als_hist,als, demography,lab))

comb$patient <- as.numeric(levels(comb$patient))[comb$patient]
comb <- na.to.mean(comb)

# Female
comb <- merge(comb, combF.predict(comb[comb$sex==2,]),by="patient",all.x=TRUE)

# Limb
comb <- merge(comb, combLmF.predict(comb[comb$onset.location=="Onset: Limb"&comb$sex!=2,]),by="patient",all.x=TRUE)
comb$prediction.x[is.na(comb$prediction.x)] <- comb$prediction.y[is.na(comb$prediction.x)]
comb <- data.frame(rm.cols(comb,c("prediction.x","prediction.y")),prediction=comb$prediction.x)

# Bulbar, Male
comb <- merge(comb, combBpM.predict(comb[comb$onset.location!="Onset: Limb"&comb$sex==1,]),by="patient",all.x=TRUE)
comb$prediction.x[is.na(comb$prediction.x)] <- comb$prediction.y[is.na(comb$prediction.x)]
comb <- data.frame(rm.cols(comb,c("prediction.x","prediction.y")),prediction=comb$prediction.x)

# Other
comb <- merge(comb, combBmMF.predict(comb[comb$onset.location!="Onset: Limb"&comb$sex!=1&comb$sex!=2,]),by="patient",all.x=TRUE)
comb$prediction.x[is.na(comb$prediction.x)] <- comb$prediction.y[is.na(comb$prediction.x)]
comb <- data.frame(rm.cols(comb,c("prediction.x","prediction.y")),prediction=comb$prediction.x)

#combTestExp <- data.frame(combTestExp,expslope=log(combTestExp$slope+10))

# combALS <- comb.select.disease(comb, "ALS")
# predALS <- combALS.predict(combALS)
#         (Intercept)                    comb$Total.x1             comb$diagnosis.delta               comb$Creatinine.x1               comb$Hemoglobin.x1  
#             0.133670                         2.906221                         0.001867                         0.374064                       -22.294547  
# comb$Lymphocytes.var                comb$Potassium.x1           comb$Triglycerides.var  comb$White.Blood.Cells..WBC..x0  
#            -0.176082                         1.272349                        -0.344356                         0.019038

# Values found by
# fitL <- combL.fit(combL)
# fitB <- combR.fit(combB)
# pruned <- (comb$patient %in% combALS$patient)
# combB <- comb.select.location(comb, c("Onset: Bulbar", "Onset: Limb and Bulbar"))
# predB <- combB.predict(combB)
# pruned <- pruned | (comb$patient %in% combB$patient)
# combL <- comb.select.location(comb, "Onset: Limb")
# predL <- combL.predict(combL)

# patients <- data.frame("patient"=comb$patient[order(comb$patient)])
# Merging limb prediction
# patients <- merge(patients,predL,by=c("patient"),all.x=TRUE)

# Merging Bulbar prediction
# patients <- merge(patients,predB,by=c("patient"),all.x=TRUE)
# patients$prediction.x[is.na(patients$prediction.x)] <- patients$prediction.y[is.na(patients$prediction.x)]
# patients <- data.frame("patient"=patients$patient, "prediction"=patients$prediction.x)

# Merging ALS prediction
# patients <- merge(patients,predALS,by=c("patient"),all.x=TRUE)
# patients$prediction.x[is.na(patients$prediction.x)] <- patients$prediction.y[is.na(patients$prediction.x)]
# patients <- data.frame("patient"=patients$patient, "prediction"=patients$prediction.x)

write.table(comb[order(comb$patient),c("patient","prediction")], file="predicted.out", append=FALSE, quote=TRUE, sep=",", col.names=FALSE, row.names=FALSE, qmethod="escape")

#' SurvivalModelPerformanceCV
#'
#' A class containing a list of SurvivalModelPerformance objects corresponding to the results of each cross validation fold
#'
#' @author Adam Margolin
#' @export

SurvivalModelPerformanceCV <- setRefClass(Class = 'SurvivalModelPerformanceCV',
                                        fields = list(foldResults="list"
                                                      ),
                                        
                                        methods = list(
                                          initialize = function(foldResults, ...){
                                            .self$foldResults <- foldResults
                                          },
                                          
                                          getFoldCIndices = function(){
                                            cIndices <- sapply(.self$foldResults, function(x){x$getExactConcordanceIndex()}) 
                                            return(cIndices)
                                          }
                                          )                                   
                                        )

setRefClass(Class = "Surv")

#' SurvivalModelPerformance
#'
#' A class implementing various performance evaluation methods for the results of a predictive survival model
#'
#' @author Adam Margolin
#' @export

SurvivalModelPerformance <- setRefClass(Class = 'SurvivalModelPerformance',
  fields = c("predictions",
             "observationTime",
             "observationStatus"),
  
  methods = list(
    initialize = function(pred, obs){
      .self$predictions <- pred
      .self$observationTime <- obs[,1]
      .self$observationStatus <- obs[,2]
    },
    
    getConcordanceIndex = function(){
      cIndex <- concordance.index(x=.self$predictions, surv.time=.self$observationTime, 
                        surv.event=.self$observationStatus, na.rm=TRUE, alpha= .05)
    },
    
    getExactConcordanceIndex = function(){
      cIndex <- exactConcordanceIndexV(.self$predictions, Surv(.self$observationTime, .self$observationStatus))
    }
    
  )                                   
)

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

max.subtree.rsf <- function(object, max.order=2, sub.order=FALSE, ...) {
  if (is.null(object)) stop("Object is empty!")
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2    &
      sum(inherits(object, c("rsf", "forest"), TRUE) == c(1, 2)) != 2)
  stop("This function only works for objects of class `(rsf, grow)' or '(rsf, forest)'")
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) == 2) {
    if (is.null(object$forest)) 
      stop("Forest is empty!  Re-run grow call with forest set to 'TRUE'.")
    object <- object$forest
  }
  nativeArray <- object$nativeArray
  if (is.null(nativeArray)) {
    stop("RSF nativeArray content is NULL.  Please ensure the object is valid.")
  }
  predictorNames <- object$predictorNames
  if (is.null(predictorNames)) {
    stop("RSF predictorNames content is NULL.  Please ensure the object is valid.")
  }
  if (is.null(object$predictors)) {
    stop("RSF predictors content is NULL.  Please ensure the object is valid.")
  }
  max.order <- floor(max.order)
  if (max.order < 0) {
    stop("RSF 'max.order' requested for distance order statistic must be an integer greater than zero (0).")
  }
  MAX.DEPTH <- 100
  numTree <- length(as.vector(unique(nativeArray$treeID)))
  numParm <- length(predictorNames)
  subtree <- vector("list", 8)
  names(subtree) <- c("count",
                      "order",
                      "meanSum",
                      "depth",
                      "terminalDepthSum",
                      "subOrder",
                      "subOrderDiag",
                      "nodesAtDepth")
  forestMeanSum     <- rep(0, numParm)
  if (max.order > 0) {
    orderSum    <- matrix(0, nrow=numParm, ncol=max.order)
  }
  else {
    order.tree    <- matrix(NA, nrow=numParm, ncol=numTree)
  }
  recursiveObject <- list(offset = 1,
                          subtree = subtree,
                          diagnostic = 0,
                          diagnostic2 = 0)
  subtreeCountSum  <- rep(0, numParm)
  subOrderSum <- matrix(0, nrow=numParm, ncol=numParm)
  terminalDepth <- rep(0, numTree)
  nodesAtDepthMatrix <- matrix(NA, nrow = MAX.DEPTH, ncol = numTree)
  offsetMark <- 1
  stumpCnt <- 0
  for (b in 1:numTree) {
    recursiveObject$subtree$nodesAtDepth <- rep(NA, MAX.DEPTH)
    recursiveObject$subtree$meanSum <- rep(NA, numParm)
    if (max.order > 0) {
      recursiveObject$subtree$order <- matrix(NA, nrow=numParm, ncol=max.order)
    }
    else {
      recursiveObject$subtree$order <- rep(NA, numParm)
    }
    if (sub.order ==TRUE) {
      recursiveObject$subtree$subOrder <- matrix(1.0, nrow=numParm, ncol=numParm)
      recursiveObject$subtree$subOrderDiag <- rep(NA, numParm)
    }
    recursiveObject$subtree$depth <- 0
    recursiveObject$subtree$terminalDepthSum <- 0
    recursiveObject$subtree$count <- rep(0, numParm)
    rootParmID <- nativeArray$parmID[recursiveObject$offset] 
    offsetMark <- recursiveObject$offset
    recursiveObject <- rsfParseTree(
      recursiveObject,
      max.order,
      sub.order,
      nativeArray,
      b,
      distance=0,
      subtreeFlag=rep(FALSE, numParm))
    if (rootParmID != 0) {
      index <- which(recursiveObject$subtree$count == 0)
      recursiveObject$subtree$meanSum[index] <- recursiveObject$subtree$depth
      forestMeanSum <- forestMeanSum + recursiveObject$subtree$meanSum
      if (max.order > 0) {
        index <- which(is.na(recursiveObject$subtree$order))
        recursiveObject$subtree$order[index] <- recursiveObject$subtree$depth
        orderSum   <- orderSum + recursiveObject$subtree$order
      }
      else {
        index <- which(is.na(recursiveObject$subtree$order))
        recursiveObject$subtree$order[index] <- recursiveObject$subtree$depth
        order.tree[ , b] <- recursiveObject$subtree$order
      }
      subtreeCountSum <- subtreeCountSum + (recursiveObject$subtree$count / ((recursiveObject$offset - offsetMark + 1) / 4))
      terminalDepth[b] <- recursiveObject$subtree$terminalDepthSum / ((recursiveObject$offset - offsetMark + 1) / 2)
      if (sub.order == TRUE) {
        index <- which(recursiveObject$subtree$count > 0)
        diag(recursiveObject$subtree$subOrder)[index] <- recursiveObject$subtree$subOrderDiag[index]
        index <- which(recursiveObject$subtree$count == 0)
        diag(recursiveObject$subtree$subOrder)[index] <- recursiveObject$subtree$depth
        diag(recursiveObject$subtree$subOrder) <-  diag(recursiveObject$subtree$subOrder) / recursiveObject$subtree$depth
        subOrderSum <- subOrderSum + recursiveObject$subtree$subOrder
      }
      nodesAtDepthMatrix[, b] <- recursiveObject$subtree$nodesAtDepth
    }
    else {
      stumpCnt <- stumpCnt + 1
      nodesAtDepthMatrix[, b] <- NA      
    }
  }  
  nameVector <- c("mean",
                  "order",
                  "count",
                  "terminal",
                  "nodesAtDepth",
                  "subOrder")
  result <- vector("list", length(nameVector))
  names(result) <- nameVector
  if(numTree != stumpCnt) {
    result$terminal <- terminalDepth
    result$mean <- forestMeanSum / (numTree - stumpCnt)
    names(result$mean) <- predictorNames
    if (max.order > 0) {
      result$order <- orderSum / (numTree - stumpCnt)
      rownames(result$order) <- predictorNames
    }
    else {
      result$order <- order.tree
      rownames(result$order) <- predictorNames
    }
    result$count <- subtreeCountSum / (numTree - stumpCnt)
    names(result$count) <- predictorNames
    result$nodesAtDepth <- nodesAtDepthMatrix
    if (sub.order == TRUE) {      
      result$subOrder   <- subOrderSum / (numTree - stumpCnt)
      rownames(result$subOrder) <- predictorNames
      colnames(result$subOrder) <- predictorNames
    }
  }
  threshold <- ExactThreshold(result)
  result <- c(result, threshold=threshold)
  return (result)
}
rsfParseTree <- function(recursiveObject,
                         max.order,
                         sub.order,
                         nativeArray,
                         b,
                         distance,
                         subtreeFlag) {
  recursiveObject$diagnostic <- recursiveObject$diagnostic + 1
  if(b != nativeArray$treeID[recursiveObject$offset]) {
    stop("Invalid nativeArray input record (treeID) at ", recursiveObject$offset, ".  Please contact Technical Support.")
  }
  if (distance > 0) {
    if (distance <= length(recursiveObject$subtree$nodesAtDepth)) {    
      if (is.na(recursiveObject$subtree$nodesAtDepth[distance])) {
        recursiveObject$subtree$nodesAtDepth[distance] <- 1
      }
      else {
        recursiveObject$subtree$nodesAtDepth[distance] <- recursiveObject$subtree$nodesAtDepth[distance] + 1
      }
    }
  }
  splitParameter <- nativeArray$parmID[recursiveObject$offset]
  if (splitParameter == 0) {
    terminalFlag <- TRUE
  }
  else if (splitParameter != 0) {
    terminalFlag <- FALSE
  }
  if (!terminalFlag) {
    if (subtreeFlag[splitParameter] == FALSE) {
      recursiveObject$subtree$count[splitParameter] <- recursiveObject$subtree$count[splitParameter] + 1
      if (is.na(recursiveObject$subtree$meanSum[splitParameter])) {
        recursiveObject$subtree$meanSum[splitParameter] <- distance
      }
      else {
        recursiveObject$subtree$meanSum[splitParameter] <- recursiveObject$subtree$meanSum[splitParameter] + distance
      }
      if (max.order > 0) {
        orderVector <- c(recursiveObject$subtree$order[splitParameter, ], distance, NA)
        index <- which.max(is.na(orderVector))
        orderVector[index] <- distance
        sortedVector <- sort(orderVector[1:index])
        if (index <= max.order) {
          orderVector <- c(sortedVector, rep(NA, max.order-index))
        }
        else {
          orderVector <- sortedVector[1:max.order]
        }
        recursiveObject$subtree$order[splitParameter, ] <- orderVector
      }
      else {
        if (is.na(recursiveObject$subtree$order[splitParameter])) {
          recursiveObject$subtree$order[splitParameter] <- distance
        }
        else {
          recursiveObject$subtree$order[splitParameter] <- min(recursiveObject$order[splitParameter], distance)
        }
      }
      subtreeFlag[splitParameter] <- TRUE
      if (sub.order == TRUE) {
        if (is.na(recursiveObject$subtree$subOrderDiag[splitParameter])) {
          recursiveObject$subtree$subOrderDiag[splitParameter] <- distance
        }
        else {
          recursiveObject$subtree$subOrderDiag[splitParameter] <- min(recursiveObject$subtree$subOrderDiag[splitParameter], distance)
        }
        recursive2Object <- list(offset = recursiveObject$offset,
          depth = 0,
          minimumVector = rep(NA, dim(recursiveObject$subtree$subOrder)[2]),
          diagnostic = recursiveObject$diagnostic2)
        subtree2Flag <- rep(FALSE, dim(recursiveObject$subtree$subOrder)[2])        
        subtree2Flag[splitParameter] <- TRUE
        recursive2Object <- rsfParse2Tree(recursive2Object,
          nativeArray,
          b,
          distance=0,
          subtreeFlag=subtree2Flag)
        recursiveObject$diagnostic2 <- recursiveObject$diagnostic2 + recursive2Object$diagnostic
        recursive2Object$minimumVector[splitParameter] <- recursive2Object$depth
        recursive2Object$minimumVector[which(is.na(recursive2Object$minimumVector))] <- recursive2Object$depth
        recursive2Object$minimumVector <- recursive2Object$minimumVector / recursive2Object$depth
        recursiveObject$subtree$subOrder[splitParameter, ] <- pmin(recursiveObject$subtree$subOrder[splitParameter, ], recursive2Object$minimumVector)
      }  
    }  
  }  
  recursiveObject$subtree$depth <- max(recursiveObject$subtree$depth, distance)
  recursiveObject$offset <- recursiveObject$offset + 1
  if (terminalFlag == FALSE) {
    distance <- distance + 1
    recursiveObject <- rsfParseTree(recursiveObject, max.order, sub.order, nativeArray, b, distance, subtreeFlag)
    recursiveObject <- rsfParseTree(recursiveObject, max.order, sub.order, nativeArray, b, distance, subtreeFlag)
  }
  else {
    recursiveObject$subtree$terminalDepthSum <- recursiveObject$subtree$terminalDepthSum + distance
  }
  return (recursiveObject)
}
rsfParse2Tree <- function(recursiveObject,
                          nativeArray,
                          b,
                          distance,
                          subtreeFlag) {
  recursiveObject$diagnostic = recursiveObject$diagnostic + 1
  if(b != nativeArray$treeID[recursiveObject$offset]) {
    stop("Invalid nativeArray input record (treeID) at ", recursiveObject$offset, ".  Please contact Technical Support.")
  }
  splitParameter = nativeArray$parmID[recursiveObject$offset]
  if (splitParameter == 0) {
    terminalFlag = TRUE
  }
  else if (splitParameter != 0) {
    terminalFlag = FALSE
  }
  if (splitParameter != 0) {
    if (subtreeFlag[splitParameter] == FALSE) {
      if (is.na(recursiveObject$minimumVector[splitParameter])) {
        recursiveObject$minimumVector[splitParameter] = distance
      }
      else {
        recursiveObject$minimumVector[splitParameter] = min(recursiveObject$minimumVector[splitParameter], distance)
      }
      subtreeFlag[splitParameter] = TRUE
    }
  }
  recursiveObject$depth = max(recursiveObject$depth, distance)
  distance = distance + 1
  recursiveObject$offset = recursiveObject$offset + 1
  if (terminalFlag == FALSE) {
    recursiveObject = rsfParse2Tree(recursiveObject, nativeArray, b, distance, subtreeFlag)
    recursiveObject = rsfParse2Tree(recursiveObject, nativeArray, b, distance, subtreeFlag)
  }
  return (recursiveObject)
}
  maxDepthProb <- function(p, D, l) {
    if (!is.null(l)) Ld <- 0
    prob <- rep(0, D+1)
    for (d in 0:(D-1)) {
      if (is.null(l)) {
        Ld <- 2^d-1
        ld <- 2^d
      }
      else{
       ld <- l[d+1]
       if (d > 0) Ld <- Ld + l[d] 
      }
      prob.d.1 <- Ld*log(1-1/p)
      prob.d.2 <- ld*(log(1-1/p))
      prob[d+1] <- exp(prob.d.1)*(1-exp(prob.d.2))
    }
    prob[D+1] = 1 - sum(prob[1:D])
    if (prob[D+1] < 0) {
      prob[D+1] <- 0
      prob <- prob/sum(prob)
    }
      prob
  }
  maxDepthStat <- function(pseq, D=NULL, l=NULL) {
    mn <- std <- rep(0, length(pseq))
    if (is.null(D) & is.null(l)) stop("set D or l")
    if (!is.null(l)) {
      D <- length(l)
    }
    D.support <- (0:D)
      for (j in 1:length(pseq)) {
        prob <- maxDepthProb(pseq[j], D=D, l=l)
        mn[j] <- sum(D.support*prob)
        std[j] <- sqrt(sum((D.support^2)*prob) - mn[j]^2)
      }
    return(list(mean=mn, std=std))
  }
  ExactThreshold <- function(v) {
    if (is.null(v$mean)) return(NULL)
    n.at.d <- round(c(1, c(na.omit(apply(v$nodesAtDepth, 1, mean, na.rm=TRUE)))))
    avg.depth <- round(mean(apply(v$nodesAtDepth, 2, function(x){sum(!is.na(x))}), na.rm=TRUE))
    l <- n.at.d[1:max(avg.depth - 1, 1)]
    if (length(v$mean) == 1) {
      return(0)
    }
    else {
      return(maxDepthStat(length(v$mean), l=l)$mean)
    }
  }
max.subtree <-  max.subtree.rsf

setRefClass(Class = "PredictiveModel")

#' CoxModel
#'
#' Simple wrapper for training a cox model via cv.glmnet and implementing the PredictiveModel API
#'
#' @author Adam Margolin
#' @export

CoxModel <- setRefClass(Class = "CoxModel",
                           contains="PredictiveModel",
                           fields="model",
                           methods = list(
                             initialize = function(...){
                               return(.self)
                             },
                             
                             rawCaretModel = function(){
                               return(.self$model)
                             },
                             
                             customTrain = function(featureData, responseData, trControl = defaultTrainControl(),
                                              filterData = TRUE, tuneGrid = NULL){
                                .self$model <- cv.glmnet(featureData,responseData,family = "cox",alpha =1, nfolds=3)
                             },
                             
                             customPredict = function(featureData){
                               predictedResponse <- predict(.self$model, featureData, s="lambda.min")
                               return(predictedResponse)
                             }
                             )
                           )

unitTestScienceOnlineDemo <- function() {
  ### need to load RUnit. How do we load by default?  
  
  ## load the data
  data(demoData)
  
  checkTrue(exists('copyData_ccle'))
  checkTrue(all(rownames(pData(copyData_ccle)) == colnames(exprs(copyData_ccle))))
  checkTrue(exists('oncomapData_ccle'))
  checkTrue(all(rownames(pData(oncomapData_ccle)) == colnames(exprs(oncomapData_ccle))))
  checkTrue(exists('drugData_sanger'))
  
  ## merge our features
  featureData <- createAggregateFeatureDataSet(list(copy = copyData_ccle, mut = oncomapData_ccle))
  featureData <- t(featureData)
  checkEquals(ncol(featureData), nrow(exprs(copyData_ccle)) + nrow(exprs(oncomapData_ccle)))
  
  ## create list with feature and response data with columns in the same order
  dataSets_feature_response <- createFeatureAndResponseDataList(featureData, drugData_sanger)
  checkEquals(rownames(dataSets_feature_response$featureData), rownames(dataSets_feature_response$responseData))  
  
  #### see if we can use caret preProcess function -- for me preProcess(featureData, method = c("center", "scale")) did not work
  ## scale and transpose feature matrix
  featureData_scaled <- scale(dataSets_feature_response$featureData)
  responseData_scaled_matrix <- scale(dataSets_feature_response$responseData[,"PLX4720", drop=FALSE])
  responseData_scaled <- as.numeric(responseData_scaled_matrix)
  names(responseData_scaled) <- rownames(responseData_scaled_matrix)
  
  featureAndResponseData_filtered <- filterPredictiveModelData(featureData_scaled, responseData_scaled,
                                                               filterResponseNas = TRUE, filterFeatureNasBy = "columns", featureVarianceThreshold=0, corPValThresh = .1)
  
  checkEquals(rownames(featureAndResponseData_filtered$featureData), names(featureAndResponseData_filtered$responseData))
  
  ## fit a model
  predictiveModel_eNet <- CaretModel$new(modelType = "glmnet")
  predictiveModel_eNet$customTrain(featureAndResponseData_filtered$featureData, featureAndResponseData_filtered$responseData, tuneGrid=createENetTuneGrid(alphas=1))
  
  ## call plot via CaretModel
  # eNetPredictiveModel$plot() # This member function appears to have been removed... 
  
  model_eNet <- predictiveModel_eNet$rawCaretModel() 
  ## call plot on the raw object returned by caret
  plot(model_eNet)
  
  print(model_eNet$finalModel$tuneValue)
  
  coefs_eNet <- model_eNet$finalModel$beta[, ncol(model_eNet$finalModel$beta)]
 
#### This returns an error when run on Windows 'Error in plot.new() : figure margins too large'
#### It will be rewritten per COMPBIO-3 so there is no point in fixing it for Windows
  plotPredictiveModelHeatmap(coefs_eNet, t(featureAndResponseData_filtered$featureData), featureAndResponseData_filtered$responseData, outputFile="unitTest_plot.jpg")
  
  ## perform machine learing with elastic net
  eNet_cv <- crossValidatePredictiveModel(featureAndResponseData_filtered$featureData, featureAndResponseData_filtered$responseData, 
                                          model=CaretModel$new(modelType="glmnet"), tuneGrid=createENetTuneGrid(alphas=1), numFolds = 3)
  
  plot(eNet_cv$trainPredictions, eNet_cv$trainObservations)
  plot(eNet_cv$testPredictions, eNet_cv$testObservations)
  
  model_glmnet <- GlmnetModel$new()
  model_glmnet$customTrain(featureAndResponseData_filtered$featureData, featureAndResponseData_filtered$responseData, alpha=1)
  
  ## perform machine learning with a custom method (R5, though!)
  MyLassoModel <- setRefClass(Class = "MyLassoModel",
                                  contains = "PredictiveModel", 
                                  fields = c("model"),
                                  methods = list(
                                    customTrain = function(featureData, responseData, ...) {
                                      .self$model <- cv.glmnet(featureData,responseData,family = "gaussian",alpha =1, nfolds=5)
                                    },
                                    
                                    customPredict = function(featureData, ...){
                                      predictedResponse <- predict(.self$model, featureData, s="lambda.min")
                                      return(predictedResponse)
                                    }
                                    )
                                  )
  
  myLassoModel <- MyLassoModel$new()
  myLassoModel$customTrain(featureAndResponseData_filtered$featureData, featureAndResponseData_filtered$responseData)
  plot(myLassoModel$model)
  
  myLassoModel_cv <- crossValidatePredictiveModel(featureAndResponseData_filtered$featureData, featureAndResponseData_filtered$responseData, 
                                                  model=MyLassoModel$new(), numFolds = 3)
  
  plot(myLassoModel_cv$trainPredictions, myLassoModel_cv$trainObservations)
  plot(myLassoModel_cv$testPredictions, myLassoModel_cv$testObservations)
  
  
}

# checked in 2013-06-05 by J. Fox
# 2014-09-04: J. Fox: empty groups produce warning rather than error

densityPlot <- function(x, ...){
    UseMethod("densityPlot")
}

densityPlot.default <- function (x, g, bw="SJ", adjust=1,
    kernel = c("gaussian", "epanechnikov", "rectangular", 
               "triangular", "biweight", "cosine", "optcosine"),
    xlab=deparse(substitute(x)), ylab="Density", 
    col=palette(), lty=seq_along(col), lwd=2, grid=TRUE,
    legend.location="topright", legend.title=deparse(substitute(g)), show.bw=FALSE,
    rug=TRUE, ...) {
    ylab
    if (!is.numeric(x)) stop("argument x must be numeric")
    kernel <- match.arg(kernel)
    if (missing(g)) {
        density <- density(x, bw=bw, adjust=adjust, kernel=kernel)
        if (show.bw) xlab <- paste(xlab, " (bandwidth = ", format(density$bw), ")", sep="")
        plot(density, xlab=xlab, ylab=ylab, main="", type="n", ...)
        if (rug) rug(x)
        if (grid) grid()
        lines(density, lwd=lwd)
    }
    else {
        if (!is.factor(g)) stop("argument g must be a factor")
        counts <- table(g)
        if (any(counts == 0)){
            levels <- levels(g)
            warning("the following groups are empty: ", paste(levels[counts == 0], collapse=", "))
            g <- factor(g, levels=levels[counts != 0])
        }
        legend.title
        valid <- complete.cases(x, g)
        x <- x[valid]
        g <- g[valid]
        levels <- levels(g)
        if (length(bw) == 1) bw <- rep(bw, length(levels))
        if (length(adjust) == 1) adjust <- rep(adjust, length(levels))
        if (length(bw) != length(levels)) stop("number of entries in bw be 1 or must equal number of groups")
        if (length(adjust) != length(levels)) stop("number of entries in adjust must be 1 or must equal number of groups")
        densities <- vector(length(levels), mode="list") 
        names(bw) <- names(adjust) <- names(densities) <- levels
        for (group in levels){
            densities[[group]] <- density(x[g == group], bw=bw[group], 
                                          adjust=adjust[group], kernel=kernel)
        }
        range.x <- range(unlist(lapply(densities, function(den) range(den$x))))
        max.y <- max(sapply(densities, function(den) max(den$y)))
        plot(range.x, c(0, max.y), xlab=xlab, ylab=ylab, type="n", ...)
        if (grid) grid()
        for (i in 1:length(levels)){
            lines(densities[[i]]$x, densities[[i]]$y, lty=lty[i], col=col[i], lwd=lwd)
        }
        if (show.bw){
            bws <- sapply(densities, function(den) den$bw)
            legend <- paste(levels, " (bw = ", format(bws), ")", sep="")
        }
        else legend <- levels
        legend(legend.location, legend=legend, col=col[1:length(levels)], 
               lty=lty, title=legend.title, inset=0.02)
        abline(h=0, col="gray")
        if (rug){
            for (i in 1:length(levels)) rug(x[g == levels[i]], col=col[i])
        }
    }
    return(invisible(NULL))
}

densityPlot.formula <- function(formula, data=NULL, subset, na.action=NULL, xlab, ylab, ...){
    m <- match.call(expand.dots = FALSE)
    if (is.matrix(eval(m$data, parent.frame()))) 
        m$data <- as.data.frame(data)
    m$xlab <- m$ylab <- m$... <- NULL
    m$na.action <- na.action
    m[[1]] <- as.name("model.frame")
    mf <- eval(m, parent.frame())
    if (missing(ylab)) ylab <- "Density"
    if (length(formula) == 3){
        response <- attr(attr(mf, "terms"), "response")
        if (missing(xlab)) xlab <- names(mf)[response]
        g <- mf[, -response]
        densityPlot(mf[[response]], g, xlab=xlab, ylab=ylab, legend.title=names(mf)[-response], ...)
    }
    else if (length(formula) == 2){
        if (missing(xlab)) xlab <- names(mf)
        densityPlot(mf[[1]], xlab=xlab, ylab=ylab,  ...)
    }
    else stop("improper densityPlot formula")   
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

varSel <-
  function(
           formula = NULL,#          
           data = NULL,#
           object = NULL,#      
           method = c("vh", "vhVIMP", "md")[3],#
           ntree = (if (method == "md") 1000 else 500),#
           mvars = (if (!is.null(data) & method != "md") min(1000, round(ncol(data)/5)) else NULL),#
           mtry = (if (!is.null(data) & method == "md") max(sqrt(ncol(data)), ncol(data)/3) else NULL),#
           nodesize = (if (method == "vh" | method == "vhVIMP") 2 else NULL),#
           nsplit = 10,#
           predictorWt = NULL,#
           big.data = FALSE,#
           na.action = c("na.omit", "na.impute")[1],#
           do.trace = 0,#
           always.use = NULL,#  
           nrep = 50,#        
           K = 5,#             
           nstep = 1,#         
           verbose = TRUE,#
           ...)
{
  n.vimp     <- 3      #add top positive n.vimp variables for MD 
  very.big.P <- 5000   #max no. genes in prefiltering for VH
  get.imp <- function(f.o) {
    if (!is.null(dim(f.o$importance))) {
      c(cbind(f.o$importance)[1, ])
    }
    else {
      c(f.o$importance)
    }
  }
  get.imp.all <- function(f.o, pretty = TRUE) {
    if (cr.flag) {
      if (is.null(dim(f.o$importance))) {
        warning("subsampling is coercing a right-censored analysis for CR data\n")
        NA
      }
      else {
        imp.all <- t(f.o$importance)
        if (pretty) colnames(imp.all) <- paste("vimp.", colnames(imp.all), sep = "")
        imp.all
      }
    }
    else {
      imp.all <- cbind(c(f.o$importance))
      if (pretty) colnames(imp.all) <- "vimp"
      imp.all
    }
  }
  get.err <- function(f.o) {
    ntree <- f.o$ntree
    if (!is.null(dim(f.o$err.rate))) {
        cbind(f.o$err.rate)[1, ntree]
    }
    else {
      f.o$err.rate[ntree]
    }
  }
  SD <- function(x) {
    if (all(is.na(x))) {
      NA
    }
    else {
      sd(x, na.rm = TRUE)
    }
  }
  LENGTH <- function(x, y) {
    (length(x) > 0 & length(y) > 0)
  }
  Mtry <- function(x, y) {
    mty <- round((length(x) - length(y))/3)
    if (mty == 0) round(length(x)/3) else mty
  }
  resample <- function(x, size, ...) {
    if(length(x) <= 1) {
      if(!missing(size) && size == 0) x[FALSE] else x
    }
    else {
      sample(x, size, ...)
    }
  }
 cv.folds <- function (n, folds = 10) {
   split(resample(1:n), rep(1:folds, length = n))
 }
 permute.rows <-function(x) {
   n <- nrow(x)
   p <- ncol(x)
   mm <- runif(length(x)) + rep(seq(n) * 10, rep(p, n))
   matrix(t(x)[order(mm)], n, p, byrow = TRUE)
 }
 balanced.folds <- function(y, nfolds = min(min(table(y)), 10)) {
   y[is.na(y)] <- resample(y[!is.na(y)], size = sum(is.na(y)), replace = TRUE)
   totals <- table(y)
   if (length(totals) < 2) {
     return(cv.folds(length(y), nfolds))
   }
   else {
     fmax <- max(totals)
     nfolds <- min(nfolds, fmax)     
     nfolds <- max(nfolds, 2)
     folds <- as.list(seq(nfolds))
     yids <- split(seq(y), y) 
     bigmat <- matrix(NA, ceiling(fmax/nfolds) * nfolds, length(totals))
     for(i in seq(totals)) {
       if(length(yids[[i]])>1){bigmat[seq(totals[i]), i] <- sample(yids[[i]])}
       if(length(yids[[i]])==1){bigmat[seq(totals[i]), i] <- yids[[i]]}
     }
     smallmat <- matrix(bigmat, nrow = nfolds)
     smallmat <- permute.rows(t(smallmat)) 
     res <- vector("list", nfolds)
     for(j in 1:nfolds) {
       jj <- !is.na(smallmat[, j])
       res[[j]] <- smallmat[jj, j]
     }
     return(res)
   }
 }
 rsf.var.hunting <- function(train.id, var.pt, nstep) {
  if (verbose) cat("\t", paste("selecting variables using", mName), "...\n")
  drop.var.pt <- setdiff(var.columns, var.pt)
  if (sum(data[train.id, names(data) == all.vars(rsf.all.f)[2]], na.rm = TRUE) < 2) {
    stop("training data has insufficient deaths: K is probably set too high\n")
  }
  rsf.filter.out  <- rsf(rsf.all.f,
              data=(if (LENGTH(var.pt, drop.var.pt)) data[train.id, -drop.var.pt]
                    else data[train.id, ]),
              ntree = ntree,
              nodesize = nodesize,
              mtry = Mtry(var.columns, drop.var.pt),
              nsplit = nsplit,
              na.action = na.action,
              big.data = TRUE,
              forest = TRUE,
              do.trace = do.trace)
   imp <- get.imp(rsf.filter.out)
   names(imp) <- rsf.filter.out$predictorNames
   if (method == "vhVIMP") {
     VarStrength <- sort(imp, decreasing = TRUE)
     lower.VarStrength <- min(VarStrength) - 1 
     n.lower <- min(2, length(VarStrength))    
     avg.depth <- m.depth <- NA
     sig.vars.old <- names(VarStrength)[1]
   }
   else {
     v <- max.subtree(rsf.filter.out)
     if (is.null(v$order)) { 
       VarStrength <- lower.VarStrength <- 0
       avg.depth <- m.depth <- NA
       sig.vars.old <- names(sort(imp, decreasing = TRUE))[1]
     }
     else {       
       m.depth <- VarStrength <- v$order[, 1]
       avg.depth <- floor(mean(apply(v$nodesAtDepth, 2, function(x){sum(!is.na(x))}), na.rm=TRUE))
       exact.threshold <- v$threshold
       top.vimp <- imp[order(imp, decreasing = TRUE)[min(length(imp), n.vimp)]]
       n.lower <- max(min(2, length(VarStrength)), 
                      sum(VarStrength <= exact.threshold | (imp >= top.vimp & imp > 0)))     
       VarStrength <- max(VarStrength) - VarStrength
       names(m.depth) <- names(VarStrength) <- rsf.filter.out$predictorNames
       VarStrength <- sort(VarStrength, decreasing = TRUE)
       lower.VarStrength <- -1  
       sig.vars.old <- names(VarStrength)[1]
     }
   }
   nstep <- max(round(length(rsf.filter.out$predictorNames)/nstep), 1)
   imp.old <- 0
  for (b in 1:nstep) {
    if (b == 1) {
      if (sum(VarStrength > lower.VarStrength) == 0) {
        sig.vars <- sig.vars.old
        break
      }
      n.upper <- max(which(VarStrength > lower.VarStrength), n.lower)
      threshold <- unique(round(seq(n.lower, n.upper, length = nstep)))
      if (length(threshold) < nstep) {
        threshold <- c(threshold, rep(max(threshold), nstep - length(threshold)))
      }
    }
    sig.vars <- names(VarStrength)[1:threshold[b]]
    if (!is.null(always.use)) {
      sig.vars <- unique(c(sig.vars, always.use))
    }
    if (length(sig.vars) <= 1) { 
      sig.vars <- sig.vars.old
      break
    }
    imp <- get.imp(vimp(rsf.filter.out, sig.vars, joint=TRUE))
    if (verbose) cat("\t iteration: ", b,
                     "  # vars:",     length(sig.vars),
                     "  joint-vimp:",  round(imp, 3),
                     "\r")
    #break when joint vimp no longer increases (strict inequality is a safety feature)
    if (imp  <= imp.old) {
      sig.vars <- sig.vars.old
      break
    }
    else {
      var.pt <- var.columns[match(sig.vars, predictorNames)]
      sig.vars.old <- sig.vars
      imp.old <- imp
    }
  }
  var.pt <- var.columns[match(sig.vars, predictorNames)]
  drop.var.pt <- setdiff(var.columns, var.pt)
  rsf.out  <- rsf(rsf.all.f,
              data=(if (LENGTH(var.pt, drop.var.pt)) data[train.id, -drop.var.pt]
                    else data[train.id, ]),
              ntree = ntree,
              nsplit = nsplit,
              na.action = na.action,                  
              big.data = TRUE,
              forest = TRUE,
              do.trace = do.trace)
  return(list(rsf.out=rsf.out, sig.vars=rsf.out$predictorNames, avg.depth=avg.depth, m.depth=m.depth))
 }
 if (!is.null(object)) {
    if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2) {
       stop("This function only works for objects of class `(rsf, grow)'")
    }
    if (is.null(object$forest)) 
      stop("Forest is empty!  Re-run grow call with forest set to 'TRUE'")
    formula <- object$formula
 }
 else {
    if (is.null(formula) | is.null(data))
      stop("Need to specify 'formula' and 'data'")
 }
 method.names <- c("vh", "vhVIMP", "md")
 method.idx <- which(method.names == method)
 if (length(method.idx) != 1) {
      stop("Invalid method:  ", method)
 }
 fNames <- all.vars(formula, max.names=1e7)
 rsf.all.f <- as.formula(paste("Surv(", fNames[1], ",", fNames[2], ") ~ .", sep=""))
 if (!is.null(object)) {
   data <- as.data.frame(cbind(time = object$time, cens = object$cens, object$predictors))
   colnames(data)[c(1,2)] <- c(fNames[1], fNames[2])
   if (is.null(mvars)) mvars <- min(1000, round(ncol(data)/5))
 }
 if (fNames[3] != ".") {
   data <- data[, is.element(names(data), fNames)]
 }
 if (method == "vh") {
   mName <- "Variable Hunting"
 }
  else if (method == "vhVIMP") {
    mName <- "Variable Hunting (VIMP)"
 }
 else {
   mName <- "Minimal Depth"
 }
 n <- nrow(data)
 P <- ncol(data) - 2
 survival.time <- data[ , names(data) == fNames[1]]
 censoring.status <- data[ , names(data) == fNames[2]]
 eventType <- unique(na.omit(censoring.status))
 eventType <- eventType[eventType > 0]
 cr.flag <- (length(eventType) > 1)
 var.columns <- (1:ncol(data))[-c(which(names(data) == fNames[1]),
             which(names(data) == fNames[2]))]
 predictorNames <- names(data)[var.columns]
 if (!is.null(always.use)) {
   always.use.pt <- var.columns[match(always.use, predictorNames)]
 }
 else {
   always.use.pt <- NULL
 }
 if (!is.null(predictorWt)) {
   if (any(predictorWt < 0) | length(predictorWt) != P | all(predictorWt == 0)) {
     predictorWt <- rep(1/P, P)
   }
   else {
     predictorWt <-predictorWt/sum(predictorWt)
   }
 }
  if (!is.null(mtry)) {
    mtry <- round(mtry)
    if (mtry < 1 | mtry > P) mtry <- max(1, min(mtry, P))
  }
 if (method == "md") {
   if (verbose) cat("minimal depth variable selection ...\n")
   if (!is.null(object)) {
     v <- max.subtree(object)
     pe <- get.err(object)
     ntree <- object$ntree
     mtry <- object$mtry
     nsplit <- object$nsplit
     nodesize <- object$nodesize
     imp <- get.imp(object)
     imp.all <- get.imp.all(object)
     if (is.null(imp)) imp <- rep(0, P)
   }
   else {
     rsf.out <- rsf(rsf.all.f,
                    data,
                    ntree = ntree,
                    mtry = mtry,
                    nsplit = nsplit,
                    nodesize = nodesize,
                    na.action = na.action,
                    big.data = TRUE,
                    forest = TRUE,
                    do.trace = do.trace,
                    predictorWt = predictorWt)
      v <- max.subtree(rsf.out)
      pe <- get.err(rsf.out)
      imp <- get.imp(rsf.out)
      imp.all <- get.imp.all(rsf.out)
      nodesize <- rsf.out$nodesize
      n <- nrow(rsf.out$predictors)
      if (verbose) cat("forest analysis complete ...\n")
   }
   depth <- v$order[, 1]
   top.vimp <- imp[order(imp, decreasing = TRUE)[min(length(imp), n.vimp)]]
   top.var.pt <- (depth <= v$threshold | (imp >= top.vimp & imp > 0))
   modelSize <- sum(top.var.pt)
   o.r.m <- order(depth, decreasing = FALSE)
   top.var.pt <- top.var.pt[o.r.m]
   varselect <- as.data.frame(cbind(depth = depth, vimp = imp.all))[o.r.m, ]
   topvars <- unique(c(always.use, rownames(varselect)[top.var.pt]))
   if (!big.data) {
     if (verbose) cat("finalizing forests ...\n")
     var.pt <- var.columns[match(topvars, predictorNames)]
     var.pt <- unique(c(var.pt, always.use.pt))
     drop.var.pt <- setdiff(var.columns, var.pt)
     rsf.out  <- rsf(rsf.all.f,
               data=(if (LENGTH(var.pt, drop.var.pt)) data[, -drop.var.pt]
                    else data),
               ntree = ntree,
               nsplit = nsplit,
               na.action = na.action,
               big.data = TRUE,
               forest = TRUE,
               do.trace = do.trace)
    }
   else {
     rsf.out <- NULL
   }
   if (verbose) {
     cat("\n\n")
     cat("-----------------------------------------------------------\n")
     cat("var. selection :", mName, "\n")
     cat("no. variables  :", P, "\n")
     cat("no. samples    :", n, "\n")
     cat("no. deaths     :", sum(censoring.status != 0), "\n")
     cat("ntree          :", ntree, "\n")
     cat("nsplit         :", nsplit, "\n")
     if (!is.null(mtry))     cat("mtry           :", mtry, "\n")
     if (!is.null(nodesize)) cat("nodesize       :", nodesize, "\n")
     cat("big data       :", big.data, "\n")
     cat("model size     :", modelSize, "\n")
     cat("PE (full model):", round(mean(100*pe), 4), "\n")
     cat("\n\n")
     cat("Top variables:\n")
     print(round(varselect[top.var.pt, ], 3))
     cat("-----------------------------------------------------------\n")
   }
   return(list(err.rate=pe,
             modelSize=modelSize,
             topvars=topvars,
             varselect=varselect,
             rsf.out=rsf.out
       ))
 }  
 pred.results <- dim.results <- forest.depth <- rep(0, nrep)
 var.signature <- NULL
 var.depth <- matrix(NA, nrep, P)
 var.vimp <- array(NA, c(nrep, P, 1 + (cr.flag)*length(eventType)))
 very.big  <- (P > very.big.P)
 if (mvars < P & very.big & is.null(predictorWt)) {
     if (verbose) cat("Determining selection weights for variables...\n")
     rsf.wts.out  <- rsf(rsf.all.f,
              ntree = max(100, ntree),
              nodesize = max(3, nodesize),
              nsplit = 1,
              data=data,
              na.action = na.action,
              big.data = TRUE)
 }
 for (m in 1:nrep) {
   if (verbose & nrep>1) cat("---------------------  Iteration:", m, "  ---------------------\n")
   all.folds <- balanced.folds(censoring.status, K)
   if (big.data) {
     train.id <- all.folds[[1]]
     test.id <- all.folds[[2]]
   }
   else {
     test.id <- all.folds[[1]]
     train.id <- setdiff(1:n, test.id)
   }
   if (mvars < P & is.null(predictorWt)) {
     if (!very.big) {
        rsf.wts.out  <- rsf(rsf.all.f,
              data=data[train.id, ],
              ntree = min(100, ntree),
              mtry = mtry,
              nsplit = nsplit,
              na.action = na.action,
              big.data = TRUE)
     }
     wts <- pmax(get.imp(rsf.wts.out), 0)
     if (any(wts > 0)) {
       var.pt <- unique(resample(var.columns, mvars, replace = TRUE, prob = wts))
     }
       else {
         var.pt <- var.columns[1:P]
     }
   }
   else {
     var.pt <- var.columns[1:P]
   }
   if (!is.null(predictorWt)) {
     var.pt <- unique(resample(var.columns, mvars, replace = TRUE, prob = predictorWt))
   }
   if (!is.null(always.use)) {
     var.pt <- unique(c(var.pt, always.use.pt))
   }
   object <- rsf.var.hunting(train.id = train.id, var.pt = var.pt, nstep = nstep)
   rsf.out <- object$rsf.out
   sig.vars <- object$sig.vars
   if (method == "vh") {
     forest.depth[m] <- object$avg.depth
     var.depth[m, match(names(object$m.depth), predictorNames)] <- object$m.depth
   }
   #RSF-predictor
   pred.out <- predict(rsf.out,  data[test.id, ])
   pred.results[m] <- get.err(pred.out)
   dim.results[m] <- length(sig.vars)
   var.signature <- c(var.signature, sig.vars)
   #test set vimp
   test.var.pt <- match(pred.out$predictorNames, predictorNames)
   if (m < nrep) {
     var.vimp[m, test.var.pt, ] <- get.imp.all(pred.out, FALSE)
   }
   else {
     imp.all.temp <- get.imp.all(pred.out, TRUE)
     if (!all(is.na(imp.all.temp))) { 
       dimnames(var.vimp) <- list(NULL, NULL, colnames(imp.all.temp))
     }
     var.vimp[m, test.var.pt, ] <- imp.all.temp
   }
   if (verbose) {
     cat("\t                                                                \r")
     cat("\t PE:", round(pred.results[m], 4), "     dim:", dim.results[m], "\n")
   }
 }
 if (is.null(nodesize)) nodesize <- min(3, round(0.632*sum(censoring.status == 1)))
 pred.results <- c(na.omit(pred.results))
 var.freq.all.temp <- 100*tapply(var.signature, var.signature, length)/nrep
 freq.pt <- match(names(var.freq.all.temp), predictorNames)
 var.freq.all <- rep(0, P)
 var.freq.all[freq.pt] <- var.freq.all.temp
 if (method == "vh") {
   var.depth.all <- apply(var.depth, 2, mean, na.rm = T)
 }
 var.vimp.all <- apply(var.vimp, c(2, 3), mean, na.rm = T)
 if (method == "vh") {
   varselect <- cbind(depth = var.depth.all, vimp = var.vimp.all, rel.freq = var.freq.all)
 }
 else {
   varselect <- cbind(vimp = var.vimp.all, rel.freq = var.freq.all)
 }
 o.r.f <- order(var.freq.all, var.vimp.all[, 1], decreasing = TRUE)
 rownames(varselect) <- predictorNames
 varselect <- varselect[o.r.f,, drop = FALSE]
 modelSize <- round(mean(dim.results))  
 topvars <- unique(c(always.use, rownames(varselect)[1:modelSize]))
 if (!big.data) {
   if (verbose) cat("finalizing forests ...\n")
   var.pt <- var.columns[match(rownames(varselect)[1:modelSize], predictorNames)]
   drop.var.pt <- setdiff(var.columns, var.pt)
   rsf.out  <- rsf(rsf.all.f,
               data=(if (LENGTH(var.pt, drop.var.pt)) data[, -drop.var.pt]
                    else data),
               na.action = na.action,
               big.data = TRUE,
               forest = TRUE,
               ntree = ntree,
               nodesize = nodesize,
               nsplit = nsplit,
               do.trace = do.trace)
 }
 else {
   rsf.out <- NULL
 }
 if (verbose) {
   cat("\n\n")
   cat("-----------------------------------------------------------\n")
   cat("var. selection  :", mName, "\n")
   cat("no. variables   :", P, "\n")
   cat("no. samples     :", n, "\n")
   cat("no. deaths      :", sum(censoring.status != 0), "\n")
   cat("K-fold          :", K, "\n")
   cat("no. reps        :", nrep, "\n")
   cat("nstep           :", nstep, "\n")
   cat("ntree           :", ntree, "\n")
   cat("mvars           :", mvars, "\n")
   if (!is.null(mtry))     cat("mtry            :", mtry, "\n")
   if (!is.null(nodesize)) cat("nodesize        :", nodesize, "\n")
   cat("nsplit          :", nsplit, "\n")
   cat("big data        :", big.data, "\n")
   if (method == "vh") {
     cat("depth ratio     :", round(mean(mvars/(2^forest.depth)), 4), "\n")
   }
   cat("model size      :", round(mean(dim.results), 4), "+/-", round(SD(dim.results), 4), "\n")
   cat("PE              :", round(mean(100*pred.results), 4), "+/-", round(SD(100*pred.results), 4), "\n")
   cat("\n\n")
   cat("Top variables:\n")
   print(round(varselect[1:modelSize,, drop = FALSE], 3))
   cat("-----------------------------------------------------------\n")
 }
 return(list(err.rate=pred.results,
             modelSize=modelSize,
             topvars=topvars,
             varselect=varselect,
             rsf.out=rsf.out
       ))
}

# Ellipses (orignally by J. Fox and G. Monette)

# added grid lines, 25 May 2010 by S. Weisberg
# arguments more consistent with other functions; ... passes args to plot, 5 Sept 2010 by J. Fox
# confidenceEllipse.lm and .glm can add to current plot, applying patch from Rafael Laboissiere, 17 Oct 2010 by J. Fox
# added fill and fill.alpha arguments for translucent fills (suggested by Michael Friendly), 14 Nov 2010 by J. Fox
# modified 2 May 2011 by Michael Friendly
#   - allow pivot=TRUE (with warning)
#   - barf on non-symmetric shape
#   - return coordinates of ellipse invisibly
# dataEllipse() and confidenceEllipse() invisibly return coordinates,  3 May 2011 by J. Fox
# Modified 5 May 2011 by Michael Friendly
#   - dataEllipse now honors add=FALSE, plot.points=FALSE
# Modified 16 May 2011 by Michaell Friendly
#   - corrected bug introduced in dataEllipse via allowing pivot=TRUE 
# Modified 7 Aug 2011 by J. Fox: added draw argument
# Modified 28 Nov 2011  by J. Fox (suggested by Michael Friendly):
#   - corrected bug in xlab, ylab in confidenceEllipse()
#   - added dfn argument to .lm and .glm methods for confidenceEllipse()
# Modified 14&16 Dec 2011 by J. Fox (suggested by Michael Friendly) to add weights argument to dataEllipse().
# Modified 2 Feb 2012 by J. Fox: Improved handling of center.pch argument to ellipse() (suggestion of Rob Kushler).
# 16 July 2012 added showLabels to dataEllipse
# 2014-02-16: prevent dataEllipse() from opening a graphics device when draw=FALSE (fixing bug reported by Rafael Laboissiere).

ellipse <- function(center, shape, radius, log="", center.pch=19, center.cex=1.5, segments=51, draw=TRUE, add=draw, 
		xlab="", ylab="", col=palette()[2], lwd=2, fill=FALSE, fill.alpha=0.3,
		grid=TRUE, ...) {
	trans.colors <- function(col, alpha=0.5, names=NULL) {
		# this function by Michael Friendly
		nc <- length(col)
		na <- length(alpha)
		# make lengths conform, filling out to the longest
		if (nc != na) {
			col <- rep(col, length.out=max(nc,na))
			alpha <- rep(alpha, length.out=max(nc,na))
		}
		clr <-rbind(col2rgb(col)/255, alpha=alpha)
		col <- rgb(clr[1,], clr[2,], clr[3,], clr[4,], names=names)
		col
	}
	logged <- function(axis=c("x", "y")){
		axis <- match.arg(axis)
		0 != length(grep(axis, log))
	}
	if (! (is.vector(center) && 2==length(center))) stop("center must be a vector of length 2")
	if (! (is.matrix(shape) && all(2==dim(shape)))) stop("shape must be a 2 by 2 matrix")
	if (max(abs(shape - t(shape)))/max(abs(shape)) > 1e-10) stop("shape must be a symmetric matrix")
	angles <- (0:segments)*2*pi/segments 
	unit.circle <- cbind(cos(angles), sin(angles)) 
#	ellipse <- t(center + radius*t(unit.circle %*% chol(shape,pivot=TRUE))) 
	Q <- chol(shape, pivot=TRUE)
	order <- order(attr(Q, "pivot"))
	ellipse <- t( center + radius*t( unit.circle %*% Q[,order]))
	colnames(ellipse) <- c("x", "y")
	if (logged("x")) ellipse[, "x"] <- exp(ellipse[, "x"])
	if (logged("y")) ellipse[, "y"] <- exp(ellipse[, "y"])
	fill.col <- trans.colors(col, fill.alpha)
	if (draw) {
		if (add) {
			lines(ellipse, col=col, lwd=lwd, ...) 
			if (fill) polygon(ellipse, col=fill.col, border=NA)
		}
		else {
			plot(ellipse, type="n", xlab = xlab, ylab = ylab, ...) 
			if(grid){
				grid(lty=1, equilogs=FALSE)
				box()}
			lines(ellipse, col=col, lwd=lwd, ... )
			if (fill) polygon(ellipse, col=fill.col, border=NA)
		} 	
		if ((center.pch != FALSE) && (!is.null(center.pch))) points(center[1], center[2], pch=center.pch, cex=center.cex, col=col)
	}
	invisible(ellipse)
}


dataEllipse <- function(x, y, groups,
    group.labels=group.levels, ellipse.label,
    weights, log="", levels=c(0.5, 0.95), center.pch=19, 
    center.cex=1.5, draw=TRUE,
    plot.points=draw, add=!plot.points, segments=51, robust=FALSE, 
    xlab=deparse(substitute(x)), ylab=deparse(substitute(y)), 
    col=if (missing(groups)) palette()[1:2] else palette()[1:length(group.levels)],
    pch=if (missing(groups)) 1 else seq(group.levels),
    lwd=2, fill=FALSE, fill.alpha=0.3, grid=TRUE,
    labels, id.method = "mahal", id.n = if(id.method[1]=="identify") Inf else 0,
    id.cex=1, id.col=if (missing(groups)) palette()[1] else palette()(1:length(groups)), 
    ...) {
    label.ellipse <- function(ellipse, label, col, ...){
        # This sub-function from Michael Friendly
        if (cor(ellipse)[1,2] >= 0){         # position label above top right
            index <- which.max(ellipse[,2])
            x <- ellipse[index, 1] + 0.5 * strwidth(label)
            y <- ellipse[index, 2] + 0.5 * strheight("A")
            adj <- c(1, 0) 
        }
        else {                               # position label below bot left
            index <- which.min(ellipse[,2])
            x <- ellipse[index, 1] - 0.5 * strwidth(label)
            y <- ellipse[index, 2] - 0.5 * strheight("A")
            adj <- c(0, 1) 
        }
        text(x, y, label, adj=adj, col=col, ...)
    }
    if(missing(y)){
        if (is.matrix(x) && ncol(x) == 2) {
            if (missing(xlab)) xlab <- colnames(x)[1]
            if (missing(ylab)) ylab <- colnames(x)[2]
            y <- x[,2]
            x <- x[,1]
        }
        else stop("x and y must be vectors, or x must be a 2 column matrix")
    }
    else if(!(is.vector(x) && is.vector(y) && length(x) == length(y)))
        stop("x and y must be vectors of the same length")
    if (missing(weights)) weights <- rep(1, length(x))
    if (length(weights) != length(x)) stop("weights must be of the same length as x and y")
    if (!missing(groups)){
        xlab
        ylab
        if (!is.factor(groups)) stop ("groups must be a factor")
        if (!(length(groups) == length(x))) stop ("groups, x, and y must all be of the same length")
        if(missing(labels)) labels <- seq(length(x))
        valid <- complete.cases(x, y, groups)
        x <- x[valid]
        y <- y[valid]
        weights <- weights[valid]
        groups <- groups[valid]
        labels <- labels[valid]
        group.levels <- levels(groups)
        result <- vector(length(group.levels), mode="list")
        names(result) <- group.levels
        if(draw) {
            if (!add) {
                plot(x, y, type="n", xlab=xlab, ylab=ylab,  ...) 
                if(grid){
                    grid(lty=1, equilogs=FALSE)
                    box()
                }
            }
        }
        for (lev in 1:length(group.levels)){
            level <- group.levels[lev]
            sel <- groups == level
            result[[lev]] <- dataEllipse(x[sel], y[sel],
                weights=weights[sel], log=log, levels=levels, center.pch=center.pch,
                center.cex=center.cex, draw=draw, plot.points=plot.points, add=TRUE, segments=segments,
                robust=robust, col=rep(col[lev], 2), pch=pch[lev], lwd=lwd, fill=fill, fill.alpha=fill.alpha, 
                labels=labels[sel], id.method=id.method, id.n=id.n, id.cex=id.cex, id.col=col[lev], 
                ellipse.label=group.labels[lev], ...)
        }
        return(invisible(result))
    }
    if (length(col) == 1) col <- rep(col, 2)
    if(draw) {
        if (!add) {
            plot(x, y, type="n", xlab=xlab, ylab=ylab,  ...) 
            if(grid){
                grid(lty=1, equilogs=FALSE)
                box()}
        }
        if (plot.points)  points(x, y, col=col[1], pch=pch[1], ...)
    }
    dfn <- 2
    dfd <- length(x) - 1
    if (robust) {
        use <- weights > 0
        v <- cov.trob(cbind(x[use], y[use]), wt=weights[use])
        shape <- v$cov
        center <- v$center
    }
    else {
        v <- cov.wt(cbind(x, y), wt=weights)
        shape <- v$cov
        center <- v$center
    }
    result <- vector("list", length=length(levels))
    names(result) <- levels
    for (i in seq(along=levels)) {
        level <- levels[i]
        radius <- sqrt(dfn * qf(level, dfn, dfd ))
        result[[i]] <- ellipse(center, shape, radius, log=log,
            center.pch=center.pch, center.cex=center.cex, segments=segments, 
            col=col[2], lwd=lwd, fill=fill, fill.alpha=fill.alpha, draw=draw, ...)
        if (!missing(ellipse.label)) {
            lab <- if (length(ellipse.label) < i) ellipse.label[1] else ellipse.label[i]
            label.ellipse(result[[i]], lab, col[2], ...)
        }
    }
    if (missing(labels)) labels <- seq(length(x))
    if (draw) showLabels(x, y, labels=labels,
        id.method=id.method, id.n=id.n, id.cex=id.cex,
        id.col=id.col)
    invisible(if (length(levels) == 1) result[[1]] else result)
}
    
confidenceEllipse <- function (model, ...) {
	UseMethod("confidenceEllipse")
}


confidenceEllipse.lm <- function(model, which.coef, L, levels=0.95, Scheffe=FALSE, dfn,
		center.pch=19, center.cex=1.5, segments=51, xlab, ylab, 
		col=palette()[2], lwd=2, fill=FALSE, fill.alpha=0.3, draw=TRUE, add=!draw, ...){
	if (missing(dfn)) dfn <- if (Scheffe) sum(df.terms(model)) else 2
	dfd <- df.residual(model)
	if (missing(L)){
		which.coef <- if(length(coefficients(model)) == 2) c(1, 2)
				else{
					if (missing(which.coef)){
						if (has.intercept(model)) c(2,3) else c(1, 2)
					} else which.coef
				}
		coef <- coefficients(model)[which.coef]
		if (missing(xlab)) xlab <- paste(names(coef)[1], "coefficient")
		if (missing(ylab)) ylab <-  paste(names(coef)[2], "coefficient")
		shape <- vcov(model)[which.coef, which.coef]
	}
	else {
		res <- makeLinearCombinations(L, coef(model), vcov(model))
		coef <- res$coef
		xlab <- res$xlab
		ylab <- res$ylab
		shape <- res$shape
	}
	levels <- rev(sort(levels))
	result <- vector("list", length=length(levels))
	names(result) <- levels
	for (i in seq(along=levels)){
		level <- levels[i]
		radius <- sqrt(dfn*qf(level, dfn, dfd))
		add.plot <- !level==max(levels) | add
		result[[i]] <- ellipse(coef, shape, radius, add=add.plot, xlab=xlab, ylab=ylab,
				center.pch=center.pch, center.cex=center.cex, segments=segments, 
				col=col, lwd=lwd, fill=fill, fill.alpha=fill.alpha, draw=draw, ...)
	}
	invisible(if (length(levels) == 1) result[[1]] else result)
}


confidenceEllipse.default <- function(model, which.coef, L, levels=0.95, Scheffe=FALSE, dfn,
		center.pch=19, center.cex=1.5, segments=51, xlab, ylab,
		col=palette()[2], lwd=2, fill=FALSE, fill.alpha=0.3, draw=TRUE, add=!draw, ...){
	if (missing(L)){
		which.coef <- if(length(coefficients(model)) == 2) c(1, 2)
				else{
					if (missing(which.coef)){
						if (has.intercept(model)) c(2, 3) else c(1, 2)
					} else which.coef
				}
		coef <- coefficients(model)[which.coef]
		shape <- vcov(model)[which.coef, which.coef]
		xlab <- if (missing(xlab)) paste(names(coef)[1], "coefficient")
		ylab <- if (missing(ylab)) paste(names(coef)[2], "coefficient")
	}
	else {
		res <- makeLinearCombinations(L, coef(model), vcov(model))
		coef <- res$coef
		xlab <- res$xlab
		ylab <- res$ylab
		shape <- res$shape
	}
	df <- if (!missing(dfn)) dfn
			else if (Scheffe) sum(df.terms(model)) else 2
	levels <- rev(sort(levels))
	result <- vector("list", length=length(levels))
	names(result) <- levels
	for (i in seq(along=levels)){
		level <- levels[i]
		radius <- sqrt(qchisq(level, df))
		add.plot <- !level==max(levels) | add
		result[[i]] <- ellipse(coef, shape, radius, add=add.plot, xlab=xlab, ylab=ylab,
				center.pch=center.pch, center.cex=center.cex, segments=segments,
				col=col, lwd=lwd, fill=fill, fill.alpha=fill.alpha, draw=draw, ...)
	}
	invisible(if (length(levels) == 1) result[[1]] else result)
}

confidenceEllipse.glm <- function (model, chisq, ...) {
	sumry <- summary(model)
	if (missing(chisq)) chisq <- is.null(sumry$dispersion)
	if (chisq) confidenceEllipse.default(model, ...)
	else confidenceEllipse.lm(model, ...)
}

makeLinearCombinations <- function(L, coef, V){
	nms <- names(coef)
	if (is.character(L)){
		L <- makeHypothesis(nms, L)
		L <- L[, -ncol(L)]
	}
	if (nrow(L) != 2 || ncol(L) != length(coef))
		stop("the hypothesis matrix is the wrong size")
	coef <- as.vector(L %*% coef)
	shape <- L %*% V %*% t(L)
	L.nms <- printHypothesis(L, c(0, 0), nms)
	names(coef) <- sub(" =.*", "", L.nms)
	xlab <- names(coef)[1]
	ylab <- names(coef)[2]
	list(coef=coef, shape=shape, xlab=xlab, ylab=ylab)
}

#' Function to take a model trained using OS, retore the session and create a new model to be retrained
#' disease specific survival
#'
#' @author Adam Margolin
#' @export

restoreSessionAndCreateNewModelFromOSModel <- function(modelEntity_orig){
  modelEntity_new <- Data(list(name = paste(modelEntity_orig$properties$name, "(RETRAINED)"), 
                               parentId = "syn1419781"))
  ### restore the session from the submitted model using sessionTools
  try(restoredSessionSummary <- modelEntity_orig$objects[["sessionSummary"]])
  try(restorePackages(restoredSessionSummary))
  
  for (curFile in modelEntity_orig$files[grepl(".R$", modelEntity_orig$files)]){
    curFilePath <- paste(modelEntity_orig$cacheDir, curFile, sep="/")
    print(curFilePath)
    source(curFilePath)
    modelEntity_new <- addFile(modelEntity_new, curFilePath)
  }
  
  modelEntity_new$annotations$retrainedFromOS <- TRUE
  
  modelObjectNames_orig <- names(modelEntity_orig$objects)
  modelObjectNames_orig[-which(modelObjectNames_orig %in% c("cvPerformance", "trainedModel"))]
  for (curModelObjectName in modelObjectNames_orig){
    modelEntity_new <- addObject(modelEntity_new, modelEntity_orig$objects[[curModelObjectName]], name=curModelObjectName)  
  }
  
  return(modelEntity_new)
}

#-------------------------------------------------------------------------------
# Revision history:
# 2009-10-29: renamed var argument to .vcov; tidied code. John
# 2010-07-02; added method for survreg and coxph objects.
# 2010-07-02; rewrote default method to permit prarmeter names to have
#   meta-characters 
# 2011-07028  Removed meta-character checks; removed parameterPrefix because
#   it didn't work and caused problems; added parameterNames to restore the
#   utility of parameterPrefix
# 2011-10-02 Fixed bugs in the .survreg and .coxph methods so parameterNames
#   works correctly
# 2012-03-02: fixed abbreviation of envir argument. J. Fox
# 2012-04-08: modfied deltaMethod.default() to use coef and vcov
# 2012-12-10: removed the 'deltaMethodMessageFlag'
# 2013-06-20: added deltaMethod.merMod(). J. Fox
# 2013-06-20: tweaks for lme4. J. Fox
# 2013-07-01: New 'constants' argument for use when called from within a function.
# 2013-07-18: fixed a bug in passing the 'func' argument
#-------------------------------------------------------------------------------

deltaMethod <- function (object, ...) {
	UseMethod("deltaMethod")
}

deltaMethod.default <- function (object, g, vcov., func = g, constants, ...) {
	if (!is.character(g)) 
		stop("The argument 'g' must be a character string")
	if ((exists.method("coef", object, default=FALSE) ||
				(!is.atomic(object) && !is.null(object$coefficients))) 
			&& exists.method("vcov", object, default=FALSE)){
		if (missing(vcov.)) vcov. <- vcov(object)
		object <- coef(object)
	}
	para <- object         
	para.names <- names(para)
	g <- parse(text = g)
	q <- length(para)
	for (i in 1:q) {
		assign(names(para)[i], para[i])
	}
	if(!missing(constants)){
     for (i in seq_along(constants)) assign(names(constants[i]), constants[[i]])}
	est <- eval(g)
	names(est) <- NULL
	gd <- rep(0, q)
	for (i in 1:q) {
		gd[i] <- eval(D(g, names(para)[i]))
	}
	se.est <- as.vector(sqrt(t(gd) %*% vcov. %*% gd))
	data.frame(Estimate = est, SE = se.est, row.names = c(func))
}

deltaMethod.lm <- function (object, g, vcov. = vcov, 
           parameterNames = names(coef(object)), ...) {
#  if( !exists("deltaMethodMessageFlag", envir=.carEnv)){
#     message("deltaMethod arguments have changed, see help(deltaMethod)")
#     assign("deltaMethodMessageFlag", TRUE, envir=.carEnv)
#     }
	para <- coef(object)
	para.names <- parameterNames
	para.names[1] <- gsub("\\(Intercept\\)", "Intercept", para.names[1])
	names(para) <- para.names
	vcov. <- if (is.function(vcov.)) 
			vcov.(object)
		else vcov.
	deltaMethod.default(para, g, vcov.,  ...)
}

# nls has named parameters so parameterNames is ignored
deltaMethod.nls <- function(object, g, vcov.=vcov,...){
	vcov. <- if(is.function(vcov.)) vcov.(object)
	deltaMethod.default(coef(object), g, vcov., ...)   
}

deltaMethod.polr <- function(object,g,vcov.=vcov,...){
	sel <- 1:(length(coef(object)))
	vcov. <- if(is.function(vcov.)) vcov.(object)[sel, sel]
	deltaMethod.lm(object, g, vcov., ...)
}

deltaMethod.multinom <- function(object, g, vcov.=vcov, 
   parameterNames = if(is.matrix(coef(object)))
     colnames(coef(object)) else names(coef(object)), ...){
	out <- NULL
	coefs <- coef(object)
	if (!is.matrix(coefs)) { coefs <- t(as.matrix(coefs)) }
	colnames(coefs) <- parameterNames
	nc <- dim(coefs)[2]
	for (i in 1:dim(coefs)[1]){
		para <- coefs[i, ]
		ans <- deltaMethod(para, g, vcov.(object)[(i - 1) + 1:nc, (i - 1) + 1:nc], ...)
		rownames(ans)[1] <- paste(rownames(coefs)[i], rownames(ans)[1])
		out <- rbind(out,ans)
	}
	out}

# method for survreg objects. 
deltaMethod.survreg <- function(object, g, vcov. = vcov, 
           parameterNames = names(coef(object)), ...) {
 deltaMethod.lm(object, g, vcov., parameterNames , ...) }


 # method for coxph objects.
deltaMethod.coxph <- function(object, g, vcov. = vcov, 
           parameterNames = names(coef(object)), ...) {
 deltaMethod.lm(object, g, vcov.,  parameterNames, ...) }
           
# lmer

deltaMethod.merMod <- function(object, g, vcov. = vcov,
                            parameterNames = names(fixef(object)), ...) {
    deltaMethod.mer(object=object, g=g, vcov.=vcov, 
                       parameterNames=parameterNames, ...)
}
    
deltaMethod.mer <- function(object, g, vcov. = vcov,
           parameterNames = names(fixef(object)), ...) {
  para <- fixef(object)
  names(para) = parameterNames
 	vcov. <- if (is.function(vcov.)) 
			vcov.(object)
		else vcov.
  deltaMethod(para, g, vcov., ...)
  }


#lme
deltaMethod.lme <- function(object, g, vcov. = vcov,
           parameterNames = names(fixef(object)), ...) {
  para <- fixef(object)
  names(para) = parameterNames
 	vcov. <- if (is.function(vcov.)) 
			vcov.(object)
		else vcov.
  deltaMethod(para, g, vcov., ...)
  }
  
# nlsList  lsList
deltaMethod.lmList <- function(object, g, ...) {
  out <- t(sapply(object, function(x) deltaMethod(x, g, ...)))
  rownames(out) <- paste(rownames(out), g)
  out
  }
  

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

plot.ensemble.rsf <- function (x, plots.one.page = TRUE, ...) {
    if (sum(inherits(x, c("rsf", "grow"), TRUE) == c(1, 2)) != 2 &
      sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) != 2)
      stop("This function only works for objects of class `(rsf, grow)' or '(rsf, predict)'.")
    if (sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) == 2) {
      rsfPred <- TRUE
    }
    else {
      rsfPred <- FALSE
    }
    if (is.null(x$ndead)) return()
    if (!is.null(x$imputedIndv)) {
      x$cens[x$imputedIndv]=x$imputedData[,1]
      x$time[x$imputedIndv]=x$imputedData[,2]
    }
    if (x$n < 5 | sum(x$cens) < 2) return()
    if (rsfPred) {
      mort    <- x$mortality
      ensb    <- x$ensemble
      y.lab   <- "Mortality"
      title.1 <- "Ensemble Survival"
      title.2 <- "Mortality vs Time"
    }
    else {
      mort    <- x$oob.mortality
      ensb    <- x$oob.ensemble
      y.lab   <- "OOB Mortality"
      title.1 <- "OOB Ensemble Survival"
      title.2 <- "OOB Mortality vs Time"
    }
    n.event  <- length(unique(na.omit(x$cens)[na.omit(x$cens) > 0]))
    if (n.event > 1) ensb <- ensb[,,1]
    surv.ensb <- t(exp(-ensb))
    surv.mean.ensb <- apply(surv.ensb, 1, mean, na.rm = TRUE)
    if (!rsfPred) {
      Y <- sapply(1:length(x$timeInterest),
                 function(j, tau, t.unq) {sum(tau >= t.unq[j])},
                 tau = x$time,
                 t.unq = x$timeInterest)
      d <- sapply(1:length(x$timeInterest),
                 function(j, d, tau, t.unq) {sum(tau == t.unq[j])},
                 tau = x$time[x$cens != 0],
                 t.unq = x$timeInterest)
      r <- d/(Y+1*(Y == 0))
      surv.aalen <- exp(-cumsum(r))
      sIndex <- function(Ju,Ev) { sapply(1:length(Ev), function(j) {sum(Ju <= Ev[j])}) }
      censTime <- sort(unique(x$time[x$cens == 0]))
      censTime.pt <- sIndex(censTime, x$timeInterest)
      Y <- sapply(1:length(censTime),
                 function(j, tau, t.unq) {sum(tau >= t.unq[j])},
                 tau = x$time,
                 t.unq = censTime)
      d <- sapply(1:length(censTime),
                 function(j, d, tau, t.unq) {sum(tau == t.unq[j])},
                 tau = x$time[x$cens == 0],
                 t.unq = censTime)
      r <- d/(Y+1*(Y == 0))
      cens.aalen <- c(1, exp(-cumsum(r)))[1+censTime.pt]
    }
    if (!rsfPred) {
      brier.wt <- t(apply(cbind(1:x$n),
                   1,
                   function(i, tau, event, t.unq) {
                     pt <- sIndex(t.unq, tau[i])
                     c1 <- 1*(tau[i] <= t.unq & event[i] != 0)/c(1,cens.aalen)[1+pt]
                     c2 <- 1*(tau[i] > t.unq)/cens.aalen
                     (c1 + c2)
                   },
                   tau =  x$time, event = x$cens,
                   t.unq = x$timeInterest))
      delta <- t(apply(cbind(1:x$n),
                   1,
                   function(i, tau, event, t.unq) {1*(tau[i] > t.unq)},
                   tau =  x$time, event = x$cens,
                   t.unq = x$timeInterest)  -  surv.ensb)^2
      brier.score <- matrix(NA, length(x$timeInterest), 4)
      mort.perc   <- c(min(mort, na.rm = TRUE) - 1e-5, quantile(mort, (1:4)/4, na.rm = TRUE))
      for (k in 1:4){
        mort.pt <- (mort > mort.perc[k]) & (mort <= mort.perc[k+1])
        brier.score[, k] <- sapply(1:length(x$timeInterest),
                                  function(j) {mean(brier.wt[mort.pt, j]*delta[mort.pt, j], na.rm = TRUE)})
      }
      brier.score <- cbind(brier.score, sapply(1:length(x$timeInterest),
                                  function(j) {mean(brier.wt[, j]*delta[, j], na.rm = TRUE)}))
    }
    old.par <- par(no.readonly = TRUE)
    if (plots.one.page) {
      if (!rsfPred) par(mfrow = c(2,2)) else par(mfrow = c(1,2))
    }
    else {
      par(mfrow=c(1,1))
    }
    par(cex = 1.0)
    if (x$n > 500) {
        r.pt <- sample(1:x$n, 500, replace = FALSE)
        matplot(x$timeInterest,
                surv.ensb[,r.pt],
                xlab = "Time",
                ylab = title.1,
                type = "l",
                col = 1, 
                lty = 3)
    }
    else {
        matplot(x$timeInterest,
                surv.ensb,
                xlab = "Time",
                ylab = title.1,
                type = "l",
                col = 1,
                lty = 3)
    }
    if (!rsfPred) lines(x$timeInterest, surv.aalen, lty = 1, col = 3, lwd = 3)
    lines(x$timeInterest, surv.mean.ensb, lty = 1, col = 2, lwd = 3)
    rug(x$timeInterest, ticksize=-0.03)
    if (plots.one.page) title(title.1, cex.main = 1.25) 
    if (!rsfPred) {
      plot(surv.aalen,
           surv.mean.ensb,
           xlab = "Nelson-Aalen Survival",
           ylab = title.1,
           type = "l")
      abline(0, 1, col = 2, lty = 2)
      if (plots.one.page) title("Survival", cex.main = 1.25)
    }
    if (!rsfPred) {
      matplot(x$timeInterest, brier.score,
         xlab = "Time",
         ylab = "Score",
         type = "l",
         lwd  = c(rep(1, 4), 2),
         col  = c(rep(1, 4), 2),
         lty  = c(1:4, 1))
      point.x=round(length(x$timeInterest)*c(3,4)/4)
      text(x$timeInterest[point.x],brier.score[point.x,1],"0-25",col=4)
      text(x$timeInterest[point.x],brier.score[point.x,2],"25-50",col=4)
      text(x$timeInterest[point.x],brier.score[point.x,3],"50-75",col=4)
      text(x$timeInterest[point.x],brier.score[point.x,4],"75-100",col=4)
      rug(x$timeInterest, ticksize=0.03)
      if (plots.one.page) title("Brier Score",cex.main = 1.25)
    }
    plot(x$time, mort, xlab = "Time", ylab = y.lab, type = "n")
    if (plots.one.page) title(title.2, cex.main = 1.25)
    if (x$n > 500) cex <- 0.5 else cex <- 0.75
    points(x$time[x$cens == 1], mort[x$cens == 1], pch = 16, col = 4, cex = cex)
    points(x$time[x$cens == 0], mort[x$cens == 0], pch = 16, cex = cex)
    if (sum(x$cens == 1) > 1)
      points(supsmu(x$time[x$cens == 1][order(x$time[x$cens == 1])],
                  mort[x$cens == 1][order(x$time[x$cens == 1])]),
             type = "l",
             lty = 3,
             col = 4,
             cex = cex)
    if (sum(x$cens == 0) > 1)
      points(supsmu(x$time[x$cens == 0][order(x$time[x$cens == 0])],
                  mort[x$cens == 0][order(x$time[x$cens == 0])]),
             type = "l",
             lty = 3,
             cex = cex)
    rug(x$timeInterest, ticksize=-0.03)
    par(old.par)      
}
plot.ensemble <- plot.ensemble.rsf

# This test is only run during R CMD check
# It should invoke all unit tests but no integration tests
require("predictiveModeling") || stop("unable to load predictiveModeling package")
predictiveModeling:::.test()

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

vimp <- function(object = NULL,#
                 predictorNames = NULL,#
                 subset = NULL,#
                 joint = TRUE,#
                 rough = FALSE,#                            
                 importance = c("randomsplit", "permute", "none")[1],#
                 seed = NULL,#
                 do.trace = FALSE,#
                 ...)
{
  if (is.null(object)) stop("Object is empty!")
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2    &
      sum(inherits(object, c("rsf", "forest"), TRUE) == c(1, 2)) != 2)
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, forest)'.")
  if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) == 2) {
    if (is.null(object$forest)) 
      stop("Forest is empty!  Re-run grow call with forest set to 'TRUE'.")
    object <- object$forest
  }
  predictorNames <- unique(predictorNames)
  if (is.null(predictorNames)) {
    predictorNames <- object$predictorNames
  }
  else {
    predictorNames <- intersect(predictorNames, object$predictorNames)
  }
  if (length(predictorNames) == 0)
    stop("predictor names do not match object predictor matrix")
  predictorNames <- apply(cbind(1:length(predictorNames)), 1, function(i) {
                   which(is.element(object$predictorNames, predictorNames[i]))})
  if (is.null(subset)) {
    subset <- 1:nrow(object$predictors)
  }
  else {
    subset <- unique(subset[subset >= 1
                         & subset <= nrow(object$predictors)])
    if (length(subset) == 0) stop("'subset' not set properly.")
  }
  ntree <- length(unique(object$nativeArray[,1]))
  get.factor <- extract.factor(object$predictors, object$predictorNames)
  xfactor <- get.factor$xfactor
  xfactor.order <- get.factor$xfactor.order
  predictorType <- get.factor$predictorType
  object$predictors <- as.matrix(data.matrix(object$predictors))
  rownames(object$predictors) <- colnames(object$predictors) <- NULL
  if (is.null(seed) || abs(seed)<1) seed <- runif(1,1,1e6)
  seed <- -round(abs(seed))
  if (!is.logical(do.trace)) {
    if (do.trace >= 1){
      do.trace <- 2^24 * round(do.trace) + 1
    }
    else {
      do.trace <- 0
    }
  }
  else {
    do.trace <- 1 * do.trace
  }
  if (importance == "none") {
    importanceBits <- 0
  }
  else if (importance == "permute") {
    importanceBits <- 2^11 + 0
  }
  else if (importance == "randomsplit") {
    importanceBits <- 2^11 + 2^9
  }
  else {
    stop("Invalid choice for 'importance' option:  ", importance)
  }
  if (joint == TRUE) {
    importanceBits <- importanceBits + 2^10
  }
  else if (joint == FALSE) {
  }
  else {
    stop("Invalid choice for 'joint' option:  ", joint)
  }
  if (rough == TRUE) {
    predictedOutcomeBits <- 2^14
  }
  else if (rough == FALSE) {
    predictedOutcomeBits <- 0    
  }
  else {
    stop("Invalid choice for 'rough' option:  ", rough)
  }
  if (is.null(object$outcome)) {
    outcomeBits <- 0
  }
  else {
    if (object$outcome == "test") {
      outcomeBits <- 2^17
    }
    else {
      outcomeBits <- 0
    }
  }
  nativeOutput <- .Call("rsfInteraction",
                        as.integer(do.trace),
                        as.integer(predictedOutcomeBits +
                                   importanceBits +
                                   outcomeBits),
                        as.integer(seed),
                        as.integer(ntree),
                        as.integer(nrow(object$predictors)),
                        as.double(object$time),
                        as.double(object$cens),
                        as.integer(ncol(object$predictors)),
                        as.numeric(object$predictors),
                        as.integer(length(object$timeInterest)),
                        as.double(object$timeInterest),
                        as.integer((object$nativeArray)$treeID),
                        as.integer((object$nativeArray)$nodeID),
                        as.integer((object$nativeArray)$parmID),
                        as.double((object$nativeArray)$contPT),
                        as.integer((object$nativeArray)$mwcpSZ),                        
                        as.integer(object$nativeFactorArray),                        
                        as.integer(object$seed),
                        as.character(predictorType),
                        as.integer(length(predictorNames)),
                        as.integer(predictorNames),
                        as.integer(length(subset)),
                        as.integer(subset))
  if(is.null(nativeOutput)) {
    stop("Error occurred in algorithm.  Please turn trace on for further analysis.")
  }
  n.event <- length(unique(na.omit(object$cens)[na.omit(object$cens) > 0]))
  if (n.event > 1) n.event <- n.event + 1
  if (joint) j.names <- "joint" else j.names <- object$predictorNames[predictorNames]
  if (n.event > 1) {    
    err.names <- list(c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")), NULL)
    vimp.names <- list(c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")), j.names)
  }
  else {
    err.names <- list(NULL, NULL)
    vimp.names <- list(NULL, j.names)
  }
  err.rate <- matrix(nativeOutput$performance, ncol=ntree, byrow=T,
                      dimnames=err.names)[1:n.event, ntree, drop = FALSE]
  colnames(err.rate) <- "all.vars"
  if(!is.null(nativeOutput$importance)) {
    err.perturb.rate <- matrix(nativeOutput$importance, ncol=max(1, length(j.names)), 
                             byrow = TRUE, dimnames = vimp.names)[1:n.event,, drop = FALSE]
    importance <- t(sweep(t(err.perturb.rate), 2, err.rate))
  }
  else {
    err.perturb.rate <- importance <- NULL
  }
  make.vec <- function(x) {
    if (!is.null(dim(x)) && nrow(x) == 1) {
      x.names <- colnames(x)
      x <- c(x)
      names(x) <- x.names
      x
    }
    else {
      x
    }
  }
  rsfOutput <- list(
                    err.rate = make.vec(err.rate),
                    err.perturb.rate = make.vec(err.perturb.rate),
                    importance = make.vec(importance)
                    )
 return(rsfOutput)
}

require(utils)
require(sessionTools)

#' Submit a trained model for a breast cancer competition
#'
#' Uploads a trained model and model code to Synapse to be evaluated in the breast cancer competition.
#'
#' @param modelName the name of the model that will be stored in Synapse
#' @param trainedModel object that has been trained using the training data. The customPredict() method of this model
#' will be called with the validation data to evaluate model performance.
#' @param rFiles list of files required to train the model. One of the files must be the class file defining the class of
#' trained model and defining the customTrain() and customPredict() methods. Other files are dependencies required to run
#' customTrain() and customPredict() on the class file.
#' @param cvPerformance optional argument containing an object of class SurvivalModelPerformanceCV as returned by the function
#' crossValidatePredictiveSurvivalModel.
#' @param isPracticeModel binary argument specifying if the model is uploaded to the Synapse dataset containing practice models
#' or models to be scored in the competition. Set to FALSE if you do not want the model to be evaluated.
#'
#' @author Adam Margolin
#' @export

submitCompetitionModel <- function(modelName = NULL, trainedModel=NULL,
                                   rFiles=NULL, cvPerformance=NULL, isPracticeModel = FALSE, parentDatasetId = NULL){
  if (is.null(parentDatasetId)){
    if (isPracticeModel) {
      parentDatasetId <- "syn375517"
    }else{
      parentDatasetId <- "syn1125643"
    }
  }
  
  submittedModelLayer <- Data(list(name = modelName, parentId = parentDatasetId))
  
  for (curRFile in rFiles){
    submittedModelLayer <- addFile(submittedModelLayer, curRFile)
  }
  
  submittedModelLayer <- addObject(submittedModelLayer, trainedModel, "trainedModel")
  submittedModelLayer <- addObject(submittedModelLayer, cvPerformance, "cvPerformance")
  submittedModelLayer <- addObject(submittedModelLayer, sessionSummary(), "sessionSummary")
  
  submittedModelLayer <- storeEntity(submittedModelLayer)
  
  propertyValue(submittedModelLayer, "id")
}

####1. Data Processing
face=face_process_fun(vdat);
hand=hand_process_fun(vdat);
body=body_process_fun(vdat);
leg=leg_process_fun(vdat);
chest=chest_process_fun(vdat);
ALSFRS=ALSFRS_process_fun(vdat,face,hand,body,leg,chest);
three_m_slope=cal_three_month_slope_fun(ALSFRS);
onset=onset_process_fun(vdat);
family_hist=family_hist_process_fun(vdat);
group=treatment_group_process_fun(vdat);
fvc=fvc_process_fun(vdat);
svc=svc_process_fun(vdat);
fvc_slope=cal_slope_fvc_fun(fvc);
svc_slope=cal_slope_svc_fun(svc);
vc_slope=comb_vc_slope_fun(vdat,fvc_slope,svc_slope);
demo=demographic_process_fun(vdat);
weight=weight_process_fun(vdat);
weight_slope=cal_weight_slope_fun(weight);
uric_acid=uric_acid_process_fun(vdat);
RR=RR_process_fun(vdat);
pulse=pulse_process_fun(vdat);
RR_slope=cal_RR_slope_fun(RR);
pulse_slope=cal_pulse_slope_fun(pulse);
sodium=sodium_process_fun(vdat);

####2. combine all the predictors
vdat_comb=dat_comb_fun(three_m_slope,onset,family_hist,vc_slope,demo,weight_slope,uric_acid,group,RR_slope,pulse_slope,sodium)

####3. impute the missing data with average value
vdat_comb=impute_avg_fun(vdat_comb);

####4. load model
#load("rm_fit");
#load("rm_fit1");
#load("rm_fit2");
#load("rm_fit3");

####5. Make prediction and write out results
vdat_comb1=vdat_comb[vdat_comb$fvc_ind==1,];
vdat_comb2=vdat_comb[vdat_comb$uric_acid_value_missing_ind==0 &  !vdat_comb$Pid %in% vdat_comb1$Pid,];
vdat_comb3=vdat_comb[vdat_comb$onset_diag_missing_ind==0 & !vdat_comb$Pid %in% vdat_comb1$Pid & !vdat_comb$Pid %in% vdat_comb2$Pid,];
vdat_comb_base=vdat_comb[!vdat_comb$Pid %in% vdat_comb1$Pid & !vdat_comb$Pid %in% vdat_comb2$Pid & !vdat_comb$Pid %in% vdat_comb3$Pid ,];

dim(vdat_comb)[1];
dim(vdat_comb1)[1]+dim(vdat_comb2)[1]+dim(vdat_comb3)[1]+dim(vdat_comb_base)[1];

slope1=cbind(vdat_comb1$Pid,predict(rm_fit1, newdata=vdat_comb1));
slope2=cbind(vdat_comb2$Pid,predict(rm_fit2, newdata=vdat_comb2));
slope3=cbind(vdat_comb3$Pid,predict(rm_fit3, newdata=vdat_comb3));
slope_base=cbind(vdat_comb_base$Pid,predict(rm_fit, newdata=vdat_comb_base));

slope_comb=as.data.frame(rbind(slope1,slope2,slope3,slope_base));
names(slope_comb)=c("Pid","predicted_slope");

unique_pid=as.data.frame(unique(vdat_comb$Pid));
names(unique_pid)=c("Pid");

predicted=merge(merge(unique_pid, slope_comb, by="Pid", all.x=T), vdat_slope,by="Pid", all.y=T);
predicted=predicted[!duplicated(predicted),]   ##kick out the duplicated predictions if there is any
predicted$predicted_slope[is.na(predicted$predicted_slope)]=rnorm(length(predicted$predicted_slope[is.na(predicted$predicted_slope)]), -0.75, 0.25);  ##in case there is no patients not be predicted
predicted=predicted[order(predicted$Pid),];

write.csv(predicted, file=paste("predicted.csv"));

rslt=cal_score_fun(predicted,2,3);
cat(paste("Model Validation RMSD is: ", rslt[[1]], "\n", sep=""));

# last modified 25 Februrary 2010 by J. Fox
# rewritten 15 April 2010 S Weisberg
# 2013-02-07 S. Weisberg bug fix for use with 'scatterplot' with groups.
#   Added an argument to showLabels1 'all' that gives a list of two
#   elements for the original labels and subset indicator.  See
#   scatterplot.R for an example of its use.
#   If a list of cases to be labelled is supplied, id.n is needed only
#   if all n labels are to be printed.
# 2014-03-12 added new id.method "r" that labels using order(abs(y), decreasing=TRUE)


showLabels <- function(x, y, labels=NULL, id.method="identify",
  id.n = length(x), id.cex=1, id.col=palette()[1],  ...) {
  res <- NULL
  id.method <- if(is.list(id.method)) id.method else list(id.method)
  for (meth in id.method)
     res <- c(res, showLabels1(x, y, labels, meth, id.n, id.cex,
              id.col,  ...))
  return(if(is.null(res)) invisible(res) else res)
  }

showLabels1 <- function(x, y, labels=NULL, id.method="identify",
	id.n = length(x), id.cex=1, id.col=palette()[1], all=NULL, ...) {
# If labels are NULL, try to get the labels from x:
  if (is.null(labels)) labels <- names(x)
	if (is.null(labels)) labels <- paste(seq_along(x))
	if (is.null(id.col)) id.col <- palette()[1]
# logged-axes?
  log.x <- par("xlog")
  log.y <- par("ylog")
# id.method can be any of the following:
#    --- a list of row numbers
#    --- a list of labels
#    --- a vector of n numbers
#    --- a text string:  'identify', 'x', 'y', 'mahal', 'r'
  idmeth <- pmatch(id.method[1], c("x", "y", "mahal", "identify", "r"))
  if(!is.na(idmeth)) idmeth <- c("x", "y", "mahal", "identify", "r")[idmeth]
# if idmeth is NA, then it must be <= n numbers or row names
  id.var <- NULL
  if(is.na(idmeth)){
    if(is.null(all)) all <- list(labels=labels, subs=rep(TRUE, length(labels)))
    names(all$labels) <- all$labels
    if(length(id.method) >= length(x)){
      id.var <- id.method[which(all$subs)]
      id.n <- min(id.n, length(id.var))
      }
    else {
      id.var <- rep(0, length(x))
      names(id.var) <- labels
      inSubset <- all$labels[all$subs] %in% all$labels[id.method]
      id.var[inSubset] <- 1
      id.n <- sum(inSubset)
      }
  }
  else {
# use identify?
     if(idmeth == "identify"){
    	  result <- labels[identify(x, y, labels, n=length(x), cex=id.cex,
                 col=id.col, ...)]
    	  if(length(result) > 0) return(unique(result)) else return(NULL)
     }
# missing values need to be removed
	ismissing <- is.na(x) | is.na(y) | is.na(labels)
	if( any(ismissing) ) {
		x <- x[!ismissing]
		y <- y[!ismissing]
		labels <- labels[!ismissing]
	}
# other methods:
    id.var <- switch(id.method,
					x = if(log.x==TRUE)
                 suppressWarnings(if(all(x) > 0)
								    abs(log(x) - mean(log(x))) else
                    return(invisible(NULL)))  else
                 abs(x - mean(x)),
					y = if(log.y==TRUE)
                 suppressWarnings(if(all(y) > 0)
								    abs(log(y) - mean(log(y))) else
                    return(invisible(NULL)))  else
                 abs(y - mean(y)),
					r = if(log.y==TRUE)
					       suppressWarnings(if(all(y) > 0)
					          abs(log(y)) else
					          return(invisible(NULL)))  else
					          abs(y),
          mahal = if(log.x == TRUE & log.y == TRUE) {
                   suppressWarnings(if(all(x) > 0 & all(y) > 0)
								      rowSums( qr.Q(qr(cbind(1, log(x), log(y))))^2 ) else
                      return(invisible(NULL))) } else {
                  if(log.x == TRUE) {
                   suppressWarnings(if(all(x) > 0 )
								      rowSums( qr.Q(qr(cbind(1, log(x), y)))^2 ) else
                      return(invisible(NULL))) } else {
                  if(log.y == TRUE) {
                     suppressWarnings(if(all(y) > 0 )
								      rowSums( qr.Q(qr(cbind(1, x, log(y))))^2 ) else
                      return(invisible(NULL)))  } else {
                  rowSums( qr.Q(qr(cbind(1, x, y)))^2 ) }}})
     }
# require id.n positive
  if(id.n <= 0L) return(invisible(NULL))
# criterion
  ind <-  order(id.var, decreasing=TRUE)[1L:min(length(id.var), id.n)]
# position
  mid <- mean(if(par("xlog")==TRUE) 10^(par("usr")[1:2]) else
              par("usr")[1:2])
	labpos <- c(4,2)[1+as.numeric(x > mid)]
# print
	for (i in ind) {
		text(x[i], y[i], labels[i], cex = id.cex, xpd = TRUE,
			col = id.col, pos = labpos[i], offset = 0.25, ...)}
  names(ind) <- labels[ind]
  result <- ind
	if (length(result) == 0) return(NULL) else return(result)
}

# Leverage plots (J. Fox)

# last modified 9 October 2009 by J. Fox
# modified 25 November for layout and marking points only
# changed 'vars' to 'terms' 16 March 2010 SW
# 14 April 2010: set id.n = 0. J. Fox
# 15 August 2010 S. Weisberg, added col.lines and col arguments
# 5 Sept 2010 J. Fox, pass ... down to plot() and points() etc.
# 16 June 2011 allow layout=NA, in which case the layout is not set in this
#  function, so it is the responsibility of the user


# these functions to be rewritten; simply renamed for now

leveragePlots <- function(model, terms= ~ ., layout=NULL, ask, 
		main, ...){
	terms <- if(is.character(terms)) paste("~",terms) else terms
	vform <- update(formula(model),terms)
	terms.model <- attr(attr(model.frame(model), "terms"), "term.labels")
	terms.vform <- attr(terms(vform), "term.labels")
	good <- terms.model[match(terms.vform, terms.model)]
	nt <- length(good)
	if (nt == 0) stop("No plots specified")
	if (missing(main)) main <- if (nt == 1) "Leverage Plot" else "Leverage Plots"
  nr <- 0  
  if (nt > 1 & (is.null(layout) || is.numeric(layout))) {
    if(is.null(layout)){
         layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2), 
                             c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
    }
    ask <- if(missing(ask) || is.null(ask)) prod(layout)<nt else ask
    op <- par(mfrow=layout, ask=ask, no.readonly=TRUE, 
            oma=c(0, 0, 1.5, 0), mar=c(5, 4, 1, 2) + .1)
    on.exit(par(op))
    }
	for (term in good) leveragePlot(model, term, main="", ...)
	mtext(side=3,outer=TRUE,main, cex=1.2)
	invisible(0)
}

leveragePlot <- function (model, ...) {
	UseMethod("leveragePlot")
}

leveragePlot.lm <- function(model, term.name,
		id.method = list(abs(residuals(model, type="pearson")), "x"),
		labels, 
		id.n = if(id.method[1]=="identify") Inf else 0,
		id.cex=1, id.col=palette()[1], 
		col=palette()[1], col.lines=palette()[2], lwd=2, 
		xlab, ylab, main="Leverage Plot", grid=TRUE, ...){
	term.name <- if (is.character(term.name) & 1==length(term.name)) term.name
			else deparse(substitute(term.name))
	labels <- if(missing(labels)) labels <- names(residuals(model))
	b <- coefficients(model)
	e <- na.omit(residuals(model))
	p <- length(b)
	I.p <- diag(p)
	term.names <- term.names(model)
	term <- which(term.name==term.names)
	if (0==length(term)) stop(paste(term.name,"is not a term in the model."))
	responseName <- responseName(model)
	intercept <- has.intercept(model)
	assign <- model$assign
	X <- model.matrix(model)
	V <- vcov(model)
	wt <- if (is.null(weights(model))) rep(1, length(X[,1]))
			else weights(model)
	subs <- which(assign==term-intercept)
	hypothesis.matrix <- I.p[subs,]
	L <- if (is.null(dim(hypothesis.matrix))) t(hypothesis.matrix)
			else hypothesis.matrix
	u <- solve(L %*% V %*% t(L)) %*% L %*% b
	v.x <- X %*% V %*% t(L) %*% u
	v.y <- v.x + e
	if (missing(xlab)) xlab <- paste(term.names[term],"| others")
	if (missing(ylab)) ylab <- paste(responseName," | others")
	plot(v.x, v.y, xlab=xlab, ylab=ylab, type="n", ...)
	if(grid){
		grid(lty=1, equilogs=FALSE)
		box()}
	points(v.x, v.y, col=col, ...)	
	abline(lsfit(v.x, v.y, wt=wt), col=col.lines, lwd=lwd)
	showLabels(v.x, v.y, labels=labels, 
			id.method=id.method, id.n=id.n, id.cex=id.cex, 
			id.col=id.col)
}

leveragePlot.glm <- function(model, ...){
	stop("Leverage plot requires an lm object")
}

# Last modified 25 Nov 2009 for point marking
# 18 January 2012 added robust estimation from Pendergast and Sheather

inverseResponsePlot <- function(model, lambda=c(-1, 0, 1), robust=FALSE,
   xlab=NULL, ...)
    UseMethod("inverseResponsePlot")

inverseResponsePlot.lm <- function(model, lambda=c(-1, 0, 1), xlab=NULL, 
       labels = names(residuals(model)), ...) {
  mf <- model$model
  if (is.null(mf)) mf <- update(model, model=TRUE, method="model.frame")
  xlab <- if(is.null(xlab)) names(mf)[1]
  y <- mf[, 1]
  yhat <- predict(model)
  invTranPlot(y, yhat, lambda=lambda, xlab=xlab, labels=labels, ...)
}

invResPlot <- function(model, ...) UseMethod("inverseResponsePlot")


##########NEW
inverseResponsePlot.lm <- function(model, lambda=c(-1, 0, 1), robust=FALSE, 
       xlab=NULL, labels = names(residuals(model)), ...) {
  if(robust == TRUE){
    m <- model$call
    m[[1L]] <- as.name("rlm")
    model <- eval(m, parent.frame())
  }
  mf <- model$model
  if (is.null(mf)) mf <- update(model, model=TRUE, method="model.frame")
  
  xlab <- if(is.null(xlab)) names(mf)[1]
  y <- mf[, 1]
  yhat <- predict(model)
  invTranPlot(y, yhat, lambda=lambda, xlab=xlab, labels=labels, 
       robust=robust, ...)
}

#' MostCorrelatedFeatures
#'
#' Simple example class of a predictive model user the features most correlated with response as the regression coefficients
#' @author Adam Margolin
#' @export

MostCorrelatedFeatures <- setRefClass(Class = "MostCorrelatedFeatures",
                          contains="PredictiveModel",
                          fields=list(coefficients="numeric"),
                          methods = list(
                            initialize = function(...){
                              return(.self)
                            },
                            
                            train = function(featureData, responseData, numFeatures = 200, filterData = TRUE, ...){
                              if(filterData == TRUE){
                                message("filtering data...")
                                processedData <- filterPredictiveModelData(featureData, responseData)
                                featureData <- processedData$featureData
                                responseData <- processedData$responseData
                              }
                              
                              featureCorrs <- apply(featureData, 2, "cor", responseData)
                              topCorrs <- featureCorrs[order(abs(featureCorrs), decreasing=TRUE, na.last=TRUE)[1:numFeatures]]
                              
                              fitCoefs <- lm(responseData ~ featureData[,names(topCorrs)])$coefficients
                              names(fitCoefs)[2:length(fitCoefs)] <- names(topCorrs)
                              fitCoefs <- fitCoefs[which(!is.na(fitCoefs))]
                              .self$coefficients <- fitCoefs
                            },
                            
                            predict = function(featureData){
                              featureNames <- names(.self$coefficients[2:length(.self$coefficients)])
                              predictedResponse <- featureData[,featureNames] %*% .self$coefficients[featureNames]
                              return(predictedResponse)
                            }
                          )
                          )

# This demo uses an unreleased version of caret
# http://dl.dropbox.com/u/10053401/caret_5.06.002.tar.gz

library(predictiveModeling)
data(demoData)


###################################################
### Use data wrangling methods from predictiveModeling 
### to get our data in shape for caret
###################################################
ds_chem_ic50s_sanger <- log10(ds_chem_ic50s_sanger)
print(rownames(ds_chem_ic50s_sanger))

ds_features_cn_mut_ccle <- createAggregateFeatureDataSet(list(copy = ds_copy_ccle, 
                                                              mut = ds_oncomap_ccle))
checkEquals(nrow(ds_features_cn_mut_ccle), nrow(ds_copy_ccle) + nrow(ds_oncomap_ccle))


dataSets_ccleFeaturesCnMut_sangerChems <- createFeatureAndResponseDataList(ds_features_cn_mut_ccle, 
                                                                           ds_chem_ic50s_sanger)
ls(dataSets_ccleFeaturesCnMut_sangerChems)
checkEquals(colnames(dataSets_ccleFeaturesCnMut_sangerChems$featureData), 
            colnames(dataSets_ccleFeaturesCnMut_sangerChems$responseData))


featureData_scaled <- t(scale(t(dataSets_ccleFeaturesCnMut_sangerChems$featureData)))
responseData_scaled <- 
  t(scale(t(dataSets_ccleFeaturesCnMut_sangerChems$responseData["PLX4720",,drop=FALSE])))

print(dim(featureData_scaled))
print(dim(responseData_scaled))


boxplot(as.numeric(responseData_scaled) ~ featureData_scaled["BRAF_mut",], 
        names = c("BRAF WT", "BRAF Mut"), 
        ylab="PLX4720 IC50", col="blue")


processedData <- filterPredictiveModelData(t(featureData_scaled),
                                           t(responseData_scaled))
featureData <- processedData$featureData
responseData <- processedData$responseData

###################################################
### Data is wrangled, now let's fit some models using 
### caret
###################################################

## See the caret Train vignette for more information about these functions and their parameters

trControl <- caret::trainControl(method = "cv", 
                                 number=3, 
                                 returnResamp="all", 
                                 verboseIter=TRUE)

model_eNet <- caret::train(featureData, 
                           responseData,
                           method="glmnet",
                           preProcess = NULL,
                           tuneLength = 4,
                           trControl = trControl,
                           tuneGrid=createENetTuneGrid(alphas=1)
                           )

print(plot(model_eNet))
print(model_eNet)
print(model_eNet$finalModel$tuneValue)

coefs_eNet <- model_eNet$finalModel$beta[, ncol(model_eNet$finalModel$beta)]
outputFileElasticNet <- 'PLX4720_ElasticNetModel.jpg'
plotPredictiveModelHeatmap(coefs_eNet, 
                           featureData_scaled, 
                           responseData_scaled, 
                           outputFile=outputFileElasticNet)


###################################################
### Let's do cross validation on several models, leaving 
### out a subset of the data for test purposes
###################################################

set.seed(2)

inTrain <- createDataPartition(responseData, p = .8, list = FALSE, times = 1)
trainFeatureData <- featureData[inTrain,]
testFeatureData <- featureData[-inTrain,]
trainResponseData <- responseData[inTrain]
testResponseData <- responseData[-inTrain]

# For each model, perform three separate 10-fold cross-validations as the resampling scheme
cvTrainControl <- caret::trainControl(method = "repeatedcv", 
                                      number = 10,
                                      repeats = 3, 
                                      returnResamp="all", 
                                      verboseIter=TRUE)

# model 1: elastic net
eNet_cv <- caret::train(trainFeatureData, 
                        trainResponseData,
                        method="glmnet",
                        preProcess = NULL,
                        tuneLength = 4,
                        trControl = cvTrainControl,
                        tuneGrid=createENetTuneGrid(alphas=1)
                        )

# model 2: low lambda elastic net
eNet_lowLambda_cv <- caret::train(trainFeatureData, 
                                  trainResponseData,
                                  method="glmnet",
                                  preProcess = NULL,
                                  tuneLength = 4,
                                  trControl = cvTrainControl,
                                  tuneGrid=createENetTuneGrid(alphas=1,
                                    lambdas=c(2e-10, 1e-10))
                                  )

# model 3: a custom model implementing a linear model
# TODO this model doesn't make much sense, the tuning grid is not used, the sort method is irrelevant

linearModelTrain <- function(data, parameter, levels, last, ...) {
            message("in linear model train")
            linearModel <- lm(.outcome ~ ., data)
            list(fit=linearModel)
}


linearModelPredict <- function(object, newdata) {
    message("in linear model predict")
    predict(object$fit, newdata) # this calls predict.lm
  
#   testCoefs <- object$fit$coefficients
#   testCoefs <- testCoefs[-1]
#   testCoefs <- testCoefs[!is.na(testCoefs)]
#   testCoefs <- as.matrix(testCoefs)
#   testFeatures <- newdata[, row.names(testCoefs)]
#   prediction <- testFeatures %*% testCoefs
#   prediction <- prediction + object$fit$coefficients[1]
}

linearModelSort <- function(x) {
    message("in linear model sort")
    x[order(x$alpha, x$lambda),]
}

mytrain <- function(...) linearModelTrain(...)
mypredict <- function(...) linearModelPredict(...)
mysort <- function(...) linearModelSort(...)

## If you want to step through your custom methods, uncomment these lines
# debug(linearModelTrain)
# debug(linearModelPredict)
# debug(linearModelSort)

customCvTrainControl <- caret::trainControl(method = "repeatedcv",
                                            number = 2, #10, this takes a long time to run so let's try and make it shorter
                                            repeats = 2, #3,
                                            returnResamp="all", 
                                            verboseIter=TRUE,
                                            custom = list(
                                              parameters = createENetTuneGrid(lambdas=c(0.001, 1), alphas=c(1,1)),
                                              model = mytrain,
                                              prediction = mypredict,
                                              probability = NULL,
                                              sort = mysort))

myLinear_cv <- caret::train(trainFeatureData, 
                            trainResponseData,
                            method="custom",
                            trControl = customCvTrainControl
                            )


###################################################
### Now let's compare their performance
###################################################

# Model 1
eNet_cv_predVals <- extractPrediction(list(eNet_cv), 
                                      testX = testFeatureData, 
                                      testY = testResponseData)

plotObsVsPred(eNet_cv_predVals)

testPred <- subset(eNet_cv_predVals, dataType == "Test")
head(testPred)
ddply(testPred, .(model), defaultSummary)


# Model 2
eNet_lowLambda_cv_predVals <- extractPrediction(list(eNet_lowLambda_cv), 
                                                testX = testFeatureData, 
                                                testY = testResponseData)

plotObsVsPred(eNet_lowLambda_cv_predVals)

testPred <- subset(eNet_lowLambda_cv_predVals, dataType == "Test")
head(testPred)
ddply(testPred, .(model), defaultSummary)


# Models 3
myLinear_cv_predVals <- extractPrediction(list(myLinear_cv), 
                                          testX = testFeatureData, 
                                          testY = testResponseData)

plotObsVsPred(myLinear_cv_predVals)

testPred <- subset(myLinear_cv_predVals, dataType == "Test")
head(testPred)
ddply(testPred, .(model), defaultSummary)

carWeb <-
function (page = c("webpage", "errata", "taskviews"), script, data)
{
    data.page <- "http://socserv.socsci.mcmaster.ca/jfox/Books/Companion/data/"
    script.page <- "http://socserv.socsci.mcmaster.ca/jfox/Books/Companion/scripts/"
    page = match.arg(page)
    urls = c(webpage = "http://socserv.socsci.mcmaster.ca/jfox/Books/Companion/",
        errata = "http://socserv.socsci.mcmaster.ca/jfox/Books/Companion/errata.html",
        taskviews = "http://cran.r-project.org/web/views")
    url <- urls[page]
    if(!missing(data)) {
       dfile <- unlist(strsplit(data, ".", fixed=TRUE))
       if(length(dfile) > 1) dfile <- dfile[1:(length(dfile)-1)]
       dfile <- paste(c(dfile, "txt"), collapse="." )
       url <- paste(data.page, dfile, sep="")}
    if(!missing(script)) {
       sfile <- unlist(strsplit(script, ".", fixed=TRUE))
       if(length(sfile) > 1) sfile <- sfile[1:(length(sfile)-1)]
       sfile <- paste(c(sfile, "R"), collapse="." )
       url <- paste(script.page, sfile, sep="")}   
    browseURL(url)
}

#########################################################################################################
#Goal:	Final submission for The DREAM-Phil Bowen ALS Prediction Prize4Life Challenge
#
#Authors:	Jules van Ligtenberg BSc
#		Rubio Vaughan BSc
#
#Date:	October 16th, 2012
#
#Copyright:	This source code is protected by copyright. Nothing from this source code may be used or
#		reproduced in any form without the written permission of its authors.
#		(authors can be contacted via JulesvanLigtenberg at sign OrcaXL dot nl)
#
#########################################################################################################

options(stringsAsFactors = FALSE) # This must be the first statement!!!
options(digits=12)

DEFAULT_AGE					=   54.88235294
DEFAULT_ALSFRS_R_TOTAL_SLOPE		=   -0.0214912985737     # from  206 instances
DEFAULT_ALSFRS_SLOPE_2			=   -0.0177077896516
DEFAULT_ALSFRS_TOTAL_SLOPE		=   -0.0168363589413     # from  709 instances
DEFAULT_ALSFRS_SECOND_DERIVATIVE	=   -8.60731450365e-05   # from  900 instances
DEFAULT_CLIMBING_STAIRS_SLOPE		=   -0.00359396958658    # from  915 instances
DEFAULT_CUTTING_WITHOUT_SLOPE		=   -0.00197819156783    # from  912 instances
DEFAULT_CUTTING_WITH_SLOPE		=    0.0078125           # from    4 instances
DEFAULT_DELTA_FIRST_ALSFRS_SCORE	=    3.174749
DEFAULT_DRESSING_SLOPE			=   -0.00302021281031    # from  915 instances
DEFAULT_DYSPNEA_SLOPE			=   -0.000580458293431   # from  206 instances
DEFAULT_FIRST_ALSFRS_SCORE		=   31.21572
DEFAULT_LAST_ALSFRS_SCORE		=   29.9770992366        # from  917 instances
DEFAULT_HANDWRITING_SLOPE		=   -0.00178707681463    # from  915 instances
DEFAULT_ONSET_DELTA			= -675.0927
DEFAULT_ORTHOPNEA_SLOPE			=   -0.000388064250533   # from  206 instances
DEFAULT_OTD					=  295.6359223           # Onset to Diagnosis
DEFAULT_RESP_INSUFF_SLOPE		=   -0.000396200139384   # from  206 instances
DEFAULT_RESPIRATORY_SLOPE		=   -0.000851025319924   # from  709 instances
DEFAULT_SALIVATION_SLOPE		=   -0.00111766503241    # from  915 instances!
DEFAULT_SLOPE				=   -0.675323514
DEFAULT_SOO					=    3.109022556         # Site of Onset
DEFAULT_SPEECH_SLOPE			=   -0.00156692130789    # from  915 instances
DEFAULT_SWALLOWING_SLOPE		=   -0.000832087688278   # from  915 instances
DEFAULT_TURNING_IN_BED_SLOPE		=   -0.00135763018862    # from  915 instances
DEFAULT_WALKING_SLOPE			=   -0.00169589770601    # from  915 instances
DEFAULT_WEIGHT				=   74.428057799
DEFAULT_WEIGHT_SLOPE			=   0.0105029045545	 # from 796 instances

# http://www.globalrph.com/conv_si.htm
# http://www.unc.edu/~rowlett/units/scales/clinical_data.html
LABTEST_CONVERSIONS <- matrix(c( 
	"Urine Ph",				"<nounit>",		0,
	"Glucose", 				"mmol/l", 		1,
	"Glucose", 				"g/l", 		5.55,
	"Glucose", 				"mg/dl", 		0.0555,
	"Total Cholesterol",		"mmol/l",		1,
	"Total Cholesterol",		"g/l",		2.59,
	"Total Cholesterol",		"mg/dl",		0.0259,
	"Bicarbonate",			"mmol/l",		1,
	"Bicarbonate",			"meq/l",		1,
	"Albumin",				"g/l",		1, 		# few cases of Unit being '%' are ignored
	"Sodium",				"mmol/l",		1,
	"Sodium",				"meq/l",		1,
	"Hemoglobin",			"mmol/l",		1,
	"Hemoglobin",			"g/l",		0.06206, 	# from discussionboard 1 g/l =  0.06206 mmol/l
	"Hemoglobin",			"mg/l",		0.00006206,
	"Red Blood Cells (RBC)",	"10e12/l",		1, 		# one instance of "per field" is ignored
	"Red Blood Cells (RBC)",	"10e9/l",		0.001, 
	"Red Blood Cells (RBC)",	"per mm3",		0.000001,
	"Red Blood Cells (RBC)",	"10e6/mm3",		1,
	"Calcium",				"mmol/l",		1,
	"Calcium",				"meq/l",		0.5,
	"Calcium",				"mg/dl",		0.25,
	"Calcium",				"mg/l",		0.025,
	"HbA1c (Glycated Hemoglobin)","%",			1,
	"HbA1c (Glycated Hemoglobin)","v/v",		100,
	"Monocytes",			"%",			1, 		# Only '%' is used: it is the most common, proper conversion to other units is unknown
	"Lymphocytes",			"%",			1, 		# Only '%' is used: it is the most common, proper conversion to other units is unknown
	"Hematocrit",			"%",			1,
	"Hematocrit",			"v/v",		100,
	"Hematocrit",			"1",			100,
	"Creatine Kinase",		"iu/l",		1,
	"Creatine Kinase",		"u/l",		1, 		# u/l seems to be the same as iu/l, mIU/L was ignored: 2 cases
	"Neutrophils",			"%",			1, 		# Only "%" is used: it is the most common, proper conversion to other units is unknown
	"Alkaline Phosphatase",		"iu/l",		1,
	"Alkaline Phosphatase",		"u/l",		1, 		# u/l seems to be the same as iu/l
	"Gamma-glutamyltransferase",	"iu/l",		1,
	"Gamma-glutamyltransferase",	"u/l",		1, 		# u/l seems to be the same as iu/l
	"ALT(SGPT)",			"iu/l",		1,
	"ALT(SGPT)",			"u/l",		1, 		# u/l seems to be the same as iu/l
	"Protein",				"g/l",		1,
	"Protein",				"g/dl",		10, 		# one instance of mEq/L ignored
	"White Blood Cells (WBC)",	"10e9/l",		1, 		# "g/L" ignored: no suitable conversion factor found
	"White Blood Cells (WBC)",	"per mm3",		0.001,
	"White Blood Cells (WBC)",	"10e3/mm3",		1,
	"Eosinophils",			"%",			1, 		# Only "%" is used: it is the most common, proper conversion to other units is unknown
	"AST(SGOT)",			"iu/l",		1,
	"AST(SGOT)",			"u/l",		1, 		# u/l seems to be the same as iu/l
	"Chloride", 			"mmol/l",		1,
	"Basophils", 			"%",			1, 		# Only "%" is used: it is the most common, proper conversion to other units is unknown
	"Phosphorus", 			"mmol/l",		1,
	"Phosphorus", 			"mg/dl",		0.323,
	"Phosphorus", 			"mg/l",		3.23,
	"Creatinine", 			"umol/l",		1,
	"Creatinine", 			"mg/dl",		88.4,
	"Creatinine", 			"mg/l",		884,
	"Triglycerides", 			"mmol/l",		1,
	"Triglycerides", 			"mg/dl",		0.0113,
	"Triglycerides", 			"g/l",		1.13,
	"Potassium", 			"mmol/l",		1,
	"Potassium", 			"meq/l",		1,
	"Bilirubin (total)",		"umol/l",		1,
	"Bilirubin (total)",		"mg/dl",		17.1,
	"Bilirubin (total)",		"mg/l",		171,
	# RBC Morphology skipped, seems useless, only value is "NORMAL"
	"Platelets",			"10e9/l",		1, 		# "g/L" ignored: no suitable conversion factor found
	"Platelets",			"per mm3",		0.001,
	"Platelets",			"10e3/mm3",		1,
	"Urea",				"mmol/l",		1, 		# one instance of umol/L ignored
	"Urea",				"mg/dl",		0.357, 
	"Urea",				"g/l",		35.7, 
	"Urine Protein", 			"<nounit>",		0,
	# Urine blood skipped, unknown values
	"Urine Glucose", 			"<nounit>",		0,
	"Blood Urea Nitrogen (BUN)",	"mmol/l",		1,
	# Beta HCG skipped too few numeric values
	"Prothrombin Time (clotting)","%",			1, 		#unable to find conversion from seconds to %	
	#"Urine WBCs" skipped
	#"Urine Casts" skipped see result check_test(test)
	"Free T3",				"nmol/l",		1,
	"Free T3",				"pmol/l",		0.001,
	"Amylase",				"u/l",		1,
	"Amylase",				"iu/l",		1,
	"Absolute Band Neutrophils",	"10e9/l",		1,
	"Urine Specific Gravity",	"<nounit>",		1,
	"Uric Acid", 			"umol/l", 		1,
	"Uric Acid", 			"mg/dl", 		59.48,
	"Lactate Dehydrogenase",	"u/l", 		1,
	"Lactate Dehydrogenase",	"iu/l", 		1,
	# Urine RBCs skipped too few numeric values
	"Thyroid Stimulating Hormone","miu/l",		1, 		# IU/L skipped, only one case found
	"Absolute Basophil Count",	"10e12/l",		1, 		# 10E9/L skipped, values are not 1000 x 10e12/l values!
	"Free T4",				"pmol/l",		1,
	"International Normalized Ratio (clotting)", "1", 1, 
	# Pancreatic Amylase skipped, no data before cutoff
	# Salivary Amylase skipped, no data before cutoff
	"Absolute Eosinophil Count",	"10e9/l",		1,
	"Absolute Monocyte Count",	"10e9/l",		1,
	"Absolute Segmented Neutrophils", "10e9/l",	1,
	"Absolute Total Neutrophils",	"10e9/l",		1,
	"Band Neutrophils",		"%",			1, 		# Only "%" is used: it is the most common, proper conversion to other units is unknown
	# Lithium skipped, only value: "<0.10"    ( 785  times)
	"Segmented Neutrophils",	"%",			1,
	# Urine Ketones skipped, too few numeric values
	# Urine Leukesterase skipped, too few numeric values
	"Absolute Lymphocyte Count",	"10e9/l",		1
	# C-Reactive Protein skipped, only 12 cases and non-numeric values
	# RBC Morphology: Macrocytosis, only 35 cases and non-numeric values
	# RBC Morphology: Anisocytosis, only 36 cases and non-numeric values
	# Hep A Antibody (IgG), only 6 cases, all with same value
	# Hep B Surface Antibody, only 6 cases, all with same value
	# Basophillic Stippling, only 1 case
	# Polychromasia, only 4 cases
	# Mean Corpuscular Volume, only 1 case before cutoff, 8 cases after
	# Activated Partial Thromboplastin Time, only 2 cases all after cutoff
	# Mean Corpuscular Hemoglobin, only 8 cases all after cutoff
	# Mean Corpuscular Hemoglobin Concentration, only 7 cases
	# Anion Gap, only 6 cases all after cutoff
	# RBC Distribution Width, only 5 cases, all after cutoff
	# Bilirubin (Direct), only 6 cases, all after cutoff
	# Bilirubin (Indirect), only 5 cases, all after cutoff
	# Creatine Kinase MM, only 2 cases, all after cutoff
	# Creatine Kinase MB, only 4 cases
	# Urine Bacteria, only 1 case
	# Immuno Electrophoresis, only 2 cases
	# Mean Platelet Volume, only 2 cases, all after cutoff
	# RBC Morphology: Spherocytes, only 1 case
	# Total T3, only 2 cases
	# RBC Morphology: Microcytosis, only 2 cases
	# GAMMA-GLOBULIN, only 2 cases
	# BETA-GLOBULIN, only 2 cases
	# CA 19-9, only 1 case
	# CO2, only 1 case
	# Erythrocyte Sediment skipped, not enough useful data
	# Globulin skipped, not enough useful data
	# Urine HCG skipped, not enough useful data
	# Antinuclear Antibody skipped, not enough useful data
	# Folate skipped, not enough useful data
	# Ferritin skipped, not enough useful data
	# Vitamin B12 skipped, not enough useful data
	# Arterial O2 Fraction skipped, not enough useful data
	# Saturated O2 Fraction skipped, not enough useful data
	# Arterial Ph skipped, not enough useful data
	# Free Thyroxine Index skipped, not enough useful data
	# LDL skipped, not enough useful data
	# T3 Uptake skipped, not enough useful data
	# HDL skipped, not enough useful data
	# Total T4 skipped, not enough useful data
	# Myoglobin skipped, not enough useful data
	# Urine Epithelial Cells skipped, not enough useful data
	# Urine Mucus skipped, not enough useful data
	# Urine Urobilinogen skipped, not enough useful data
	# Urine Hemoglobin skipped, not enough useful data
	# Urine Bilirubins skipped, not enough useful data
	# Urine Appearance skipped, not enough useful data
	# Urine Nitrite skipped, not enough useful data
	# Hep B Core Antibody skipped, not enough useful data
	# Hep B Surface Antigen skipped, not enough useful data
	# Urine Culture skipped, not enough useful data
	# Magnesium skipped, not enough useful data
	# Base Excess skipped, not enough useful data
	# Plasma Ph skipped, not enough useful data
	# Osmolality skipped, not enough useful data
	# Lipase skipped, not enough useful data
	# CO2 Fraction skipped, not enough useful data
	# Partial Thromboplastin Time skipped, not enough useful data
	# ALPHA1-GLOBULIN skipped, not enough useful data
	# ALPHA2-GLOBULIN skipped, not enough useful data
	# Urine Density skipped, not enough useful data
	# Iron skipped, not enough useful data
	# IMMUNOGLOBULIN M skipped, not enough useful data
	# Hep C Antibody skipped, not enough useful data
	# Urine Sodium skipped, not enough useful data
	# Total Cortisol skipped, not enough useful data
	# Urine Osmolality skipped, not enough useful data
	), ncol=3, byrow=TRUE )
LABTEST_CONVERSIONS <- data.frame(LABTEST_CONVERSIONS)
names(LABTEST_CONVERSIONS) <- c("Name", "Unit", "Factor")
LABTEST_CONVERSIONS$Unit <- tolower(LABTEST_CONVERSIONS$Unit) # make sure units are in lowercase

LABTEST_DEFAULTS <- matrix(c( 
    "Urine Protein",        "<nounit>",        0.0869304556355,    -0.000766024405615,    0,    2,    0.0971223021583,    0.0827338129496    # from 278, 118, 278, 278, 278 and 278 instances
 ), ncol=8, byrow=TRUE )
LABTEST_DEFAULTS <- data.frame(LABTEST_DEFAULTS)
names(LABTEST_DEFAULTS) <- c("Name", "Unit", "Mean", "Slope", "Min", "Max", "First", "Last")
LABTEST_DEFAULTS$Unit <- tolower(LABTEST_DEFAULTS$Unit) # make sure units are in lowercase

VITALSIGN_DEFAULTS <- matrix(c(
    "Blood Pressure (Systolic)",        130.022633123,    -0.00625610814798,    80,    220,    132.131226054,    128.20210728,    # from 1044, 1044, 1044, 1044, 1044 and 1044 instances
    "Pulse",        76.8812875888,    0.0115786722986,    18,    144,    74.5670498084,    80.2710727969,    # from 1044, 1044, 1044, 1044, 1044 and 1044 instances
    "Respiratory Rate",        17.5444649071,    0.00283061390403,    6,    40,    16.9324034335,    18.3787553648    # from 932, 932, 932, 932, 932 and 932 instances
	), ncol=7, byrow=TRUE )
VITALSIGN_DEFAULTS <- data.frame(VITALSIGN_DEFAULTS)
names(VITALSIGN_DEFAULTS) <- c("Name", "Mean", "Slope", "Min", "Max", "First", "Last")

FAMILY_HISTORY <- matrix(c(
	"Aunt",				1288,
	"Aunt (Maternal)",		1289,
	"Aunt (Paternal)",		1290,
	"Cousin",				1291,
	"Cousin (Paternal)",		1292,
	"Cousin (Maternal)",		1293,
	"Father",				1294,
	"Grandfather",			1295,
	"Grandfather (Maternal)",	1296,
	"Grandfather (Paternal)",	1297,
	"Grandmother",			1298,
	"Grandmother (Maternal)",	1299,
	"Grandmother (Paternal)",	1300,
	"Mother",				1301,
	"Nephew",				1302,
	"Niece",				1305,
	"Sibling",				1309,
	"Uncle",				1311,
	"Uncle (Maternal)",		1312,
	"Uncle (Paternal)",		1313,
	"Son",				1424,
	"Daughter",				1425,
	"Sister",				1426,
	"Brother",				1427
	), ncol=2, byrow=TRUE )
FAMILY_HISTORY <- data.frame(FAMILY_HISTORY)
names(FAMILY_HISTORY) <- c("Name", "Field_ID")

### Read training data from current directory
testset <- read.table('test.txt', header = TRUE, stringsAsFactors=FALSE ,sep='|', nrows=-1,  quote="")
names(testset) <- c('Subject_ID', 'Form_ID', 'Form_Name', 'Key' , 'Field_ID', 'Field_Name', 'Value')
dataset <- testset
SubjectIDs <- unique(dataset[,"Subject_ID"])


################################
#Functions to submit
################################

################################
# convert_units
################################
convert_units <- function(pDF, pTestName, pDebug){
	if(missing(pDebug)){pDebug <- FALSE}

	if(nrow(pDF) == 0){
		return(pDF)
	}
	
	#make sure the return dataframe has always the correct number of columns
	df <- data.frame(pDF[1,],stringsAsFactors=FALSE)
	df <- df[-1,]

	if(pTestName == "Weight"){
		for(i in 1:nrow(pDF)) {
			value <- pDF[i, "Result"]
			unit <- pDF[i, "Unit"]
			if(tolower(unit) == "pounds") {
				# convert to kilograms
				pDF[i,"Result"] <- as.numeric(as.double(value) * 0.45359233) # http://www.metric-conversions.org
			} else if(tolower(unit) != "kilograms" & unit != 2) {	# assuming 2 to mean Kilograms 
				# Unknown unit: ignore this row
				next
			}
			df <- rbind(df, pDF[i,])
		}
		names(df) <- names(pDF)
		df <- df[,names(df) != "Unit"] # Strip Unit column from the df
		return(df)
	}
	if(pTestName == "Height"){
		for(i in 1:nrow(pDF)) {
			value <- pDF[i, "Result"]
			unit <- pDF[i, "Unit"]
			if(tolower(unit) == "inches") {
				# convert to centimeters
				pDF[i,"Result"] <- as.numeric(as.double(value) * 2.54) # http://www.metric-conversions.org
			} else if(tolower(unit) != "centimeters" & tolower(unit) != "cm") {
				# Unknown unit: ignore this row
				next
			}
			df <- rbind(df, pDF[i,])
		}
		names(df) <- names(pDF)
		df <- df[,names(df) != "Unit"] # Strip Unit column from the df
		return(df)
	}

	if(!(pTestName %in% LABTEST_CONVERSIONS$Name)) {
		# Unknown test
		return(data.frame())
	}

	for(i in 1:nrow(pDF)) {
		if(pDebug) {
			print(pDF[i,])
			flush.console()
		}
		value <- as.numeric(pDF[i, "Result"])
		if(is.na(value)) {
			# Faulty data: ignore this row
			next
		}
		unit <- tolower(pDF[i, "Unit"])
		df_conv <- subset(LABTEST_CONVERSIONS, Name == pTestName & Unit == unit)
		if(pDebug) {
			cat("Unit: ", unit, ", Value: ", value)
			flush.console()
		}
		if(nrow(df_conv) == 0) {
			# Unknown unit: ignore this row
			if(pDebug) {
				cat(" - IGNORED\n")
				flush.console()
			}
			next
		} else {
			if(pDebug) {
				cat(" - CONVERTED\n")
				flush.console()
			}
			conv_factor <- as.numeric(df_conv[1,"Factor"])
			pDF[i,"Result"] <- as.numeric(conv_factor * value)
		}
		df <- rbind(df, pDF[i,])
	}

	names(df) <- names(pDF)
	df <- df[,names(df) != "Unit"] # Strip Unit column from the df
	df
}



################################
# generate_nn_table
################################
#pDefaults BOOLEAN when true a default is supplied for every missing value when false NA is enetered for a missing value (only for a selected number of variables)
generate_nn_table <- function(pDefaults, pDebug){
	if(missing(pDefaults)){pDefaults <- TRUE}
	if(missing(pDebug)){pDebug <- FALSE}
	Train_Table <- data.frame(stringsAsFactors=FALSE)
	i=0
	for(Subject in SubjectIDs){
		colnames <- vector()
		row <- vector()

		df_subject_data <- subset(dataset, Subject_ID == Subject)
		i = i + 1
		if(pDebug){
			cat( "\n", i, " - ", Subject)
			flush.console()
		}

		row <- c(row, Subject)
		colnames <- c(colnames, "Subject_ID")

		#####################################
		##### Demographics #####
		#####################################

		##### ALSFRS Slope (linear regression) #####
		#lineaire regressie: predict_slopes_lr met linear_regression(Subject, 43.0)
		row <- c(row, ((as.double(subset(ALSFRS_slopes, Subject_ID == Subject)[,"Slope"]) * 365.24 / 12) + DEFAULT_SLOPE) / 1.95)
		colnames <- c(colnames, "ALSFRS_Slope")

		##### First ALSFRS Score, Last ALSFRS Score, mean ALSFRS Score #####
		scores <- get_ALSFRS_scores(Subject)
		cutoff_point <- 91
		scores <- subset(scores, as.integer(ALSFRS_Delta) <= cutoff_point)
		if(nrow(scores) > 0) {
			First_ALSFRS_Score <- scores[1, "ALSFRS_Score"]
			Last_ALSFRS_Score <- scores[nrow(scores), "ALSFRS_Score"]
			Mean_ALSFRS_Score <- mean(scores[, "ALSFRS_Score"])
		} else {
			if(pDefaults){
				First_ALSFRS_Score <- DEFAULT_FIRST_ALSFRS_SCORE
				Last_ALSFRS_Score  <- DEFAULT_LAST_ALSFRS_SCORE
				Mean_ALSFRS_Score  <- DEFAULT_FIRST_ALSFRS_SCORE
			}else{
				First_ALSFRS_Score <- NA
				Last_ALSFRS_Score  <- NA
				Mean_ALSFRS_Score  <- NA
			}
		}
		row <- c(row, First_ALSFRS_Score, Last_ALSFRS_Score, Mean_ALSFRS_Score)
		colnames <- c(colnames, "First_ALSFRS_Score", "Last_ALSFRS_Score", "Mean_ALSFRS_Score")

		##### First ALSFRS Score sq, Last ALSFRS Score sq, avg ALSFRS Score sq #####
		First_ALSFRS_Score_sq <- First_ALSFRS_Score^2
		Last_ALSFRS_Score_sq <- Last_ALSFRS_Score^2
		Mean_ALSFRS_Score_sq <- Mean_ALSFRS_Score^2
		row <- c(row, First_ALSFRS_Score_sq, Last_ALSFRS_Score_sq, Mean_ALSFRS_Score_sq)
		colnames <- c(colnames, "First_ALSFRS_Score_sq", "Last_ALSFRS_Score_sq", "Mean_ALSFRS_Score_sq")

		#####################################
		##### Laboratory Data #####
		#####################################
		labtests <- unique(LABTEST_DEFAULTS$Name)
		for(testname in labtests) {
			if(pDefaults){
				test_mean  <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Mean"][1]
				test_slope <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Slope"][1]
				test_first <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "First"][1]
				test_last  <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Last"][1]
				test_min   <- -999999
				test_max   <- -999999
			}else{
				test_mean  <- NA
				test_slope <- NA
				test_first <- NA
				test_last  <- NA
				test_min   <- NA
				test_max   <- NA
			}
			df <- subset(Labtest_data, Subject_ID == Subject & Testname == testname)
			if(nrow(df) > 0) {
				test_mean <- df[1,"Mean"]
				test_slope <- df[1,"Slope"]
				test_first <- df[1,"First"]
				test_last <- df[1,"Last"]
			}
			testname <- gsub("[ -]", "_", testname)
			testname <- gsub("[\\(\\)]", "", testname)
			row <- c(row, test_mean, test_slope, test_first, test_last)
			colnames <- c(colnames, paste(testname, "Mean", sep="_"), paste(testname, "Slope", sep="_"), paste(testname, "First", sep="_"), paste(testname, "Last", sep="_"))
		}

		#####################################
		##### Vital Signs #####
		#####################################
		for(vitalname in VITALSIGN_DEFAULTS$Name) {
			if(pDefaults){
				mean	<- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == vitalname, "Mean"][1]
				slope <- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == vitalname, "Slope"][1]
				first <- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == vitalname, "First"][1]
				last	<- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == vitalname, "Last"][1]
				min   <- -999999
				max   <- -999999
			}else{
				mean	<- NA
				slope	<- NA
				first	<- NA
				last	<- NA
				min	<- NA
				max	<- NA
			}
			df <- subset(Vitalsign_data, Subject_ID == Subject & Name == vitalname)
			if(nrow(df) > 0) {
				mean <- df[1,"Mean"]
				slope <- df[1,"Slope"]
				first <- df[1,"First"]
				last <- df[1,"Last"]
			}
			vitalname <- gsub("[ -]", "_", vitalname)
			vitalname <- gsub("[\\(\\)]", "", vitalname)
			row <- c(row, mean, slope, first, last)
			colnames <- c(colnames, paste(vitalname, "Mean", sep="_"), paste(vitalname, "Slope", sep="_"), paste(vitalname, "First", sep="_"), paste(vitalname, "Last", sep="_"))
		}

		#####################################
		##### Special Attributes #####
		#####################################

		##### Onset Delta #####
		Onset_Delta <- as.numeric(DEFAULT_ONSET_DELTA)
		df <- subset(df_subject_data, Field_ID==1417)
		if(nrow(df)>0){
			Onset_Delta <- mean(as.numeric(df[,"Value"]))
		}
		row <- c(row, Onset_Delta)
		colnames <- c(colnames, "Onset_Delta")

		##### Onset Delta sq #####
		row <- c(row, Onset_Delta^2)
		colnames <- c(colnames, "Onset_Delta_sq")

			
		##### Add row to table #####
		Train_Table <- rbind(Train_Table, row)
	}

	names(Train_Table) <- colnames
	Train_Table
}

get_ALSFRS_scores <- function(pSubject_ID){
	if(missing(pSubject_ID)){
		if(exists("Table_ALSFRS_Score")){
			remove(Table_ALSFRS_Score, envir=globalenv())
		}
		Subset <- unique(subset(dataset, Form_ID==145 & Value!="")) #subset to be used in the rest of the function
	} else {
		if(exists("Table_ALSFRS_Score")){
			cache <- subset(Table_ALSFRS_Score, Subject_ID == pSubject_ID)
			if(nrow(cache) > 0) {
				cache$Subject_ID <- NULL
				return(cache)
			}
		}
		Subset <- unique(subset(dataset, Subject_ID == pSubject_ID & Form_ID==145 & Value!="")) #subset to be used in the rest of the function
	}
	Keys <- unique(subset(Subset, Field_ID==1225)[,4])
	if(length(Keys)!=0){
		scores_df <- data.frame(stringsAsFactors=FALSE)
		for(TheKey in Keys){
			Scores <- subset(Subset, Key==TheKey)
			Subject <- as.integer(Scores[1,1])
			Delta <- as.integer(subset(Scores, Field_ID==1225)[,7])
			# Only use 5a if both 5a and 5b are present
			if(length(subset(Scores, Field_ID==1218 & Value!="")[,1]) > 0 & length(subset(Scores, Field_ID==1219 & Value!="")[,1]) > 0){
				Scores <- subset(Scores, Field_ID!=1219)
			}
			Sum_subset <- subset(Scores, Field_ID!=1225 & Field_ID!=1228 & Field_ID!=1229 & Field_ID!=1231 & Field_ID!=1232)
			if(nrow(Sum_subset) == 10) {
				Score <- sum(as.integer(Sum_subset[,7]))
				scores_df <- rbind(scores_df, c(Subject, Delta, Score))
			}
		}
		scores_df <- data.frame(scores_df[order(scores_df[,1],scores_df[,2]),], row.names=seq_along(scores_df[,1]), stringsAsFactors=FALSE) #row 'numbers' aanharken
		names(scores_df) <- c("Subject_ID", "ALSFRS_Delta", "ALSFRS_Score")
		scores_df <- transform(scores_df, Subject_ID = as.integer(Subject_ID), ALSFRS_Delta = as.integer(ALSFRS_Delta), ALSFRS_Score = as.integer(ALSFRS_Score))
		if(!exists("Table_ALSFRS_Score")){
			Table_ALSFRS_Score <<- data.frame(stringsAsFactors=FALSE)
		}
		Table_ALSFRS_Score <<- rbind(Table_ALSFRS_Score, scores_df) # save result
		if(!missing(pSubject_ID)){
			scores_df$Subject_ID <- NULL # remove Subject_ID column from result if called with a specific Subject_ID
		}
	}
}

################################
#get_values
################################
#preconditions: see get_values + pFilter must make sense (is applied on both fields)
get_values <- function(pSubject_ID, pField_Name1, pField_Name2, pFilter, pSourceTable) {
	if(missing(pSourceTable)) {
		pSourceTable <- dataset
	}
	if(missing(pFilter)) {
		subset_tmp <- subset(pSourceTable, Subject_ID == pSubject_ID & (Field_Name == pField_Name1 | Field_Name == pField_Name2 & Value != ""))
	} else {
		subset_tmp <- subset(pSourceTable, Subject_ID == pSubject_ID & (Field_Name == pField_Name1 | Field_Name == pField_Name2) & Value != pFilter & Value != "")
	}
	Field1_Keys <- subset(subset_tmp, Field_Name == pField_Name1)[,"Key"]
	Field2_Keys <- subset(subset_tmp, Field_Name == pField_Name2)[,"Key"]
	subset_tmp <- subset(subset_tmp, Key %in% Field1_Keys & Key %in% Field2_Keys)
	subset_tmp <- subset_tmp[4:7]
	subset_tmp <- subset_tmp[order(subset_tmp[,1]),]
	unorderd_pairs_tmp <- data.frame(c(subset(subset_tmp, Field_Name==pField_Name1)[,4]), c(subset(subset_tmp, Field_Name==pField_Name2)[,4]), stringsAsFactors=FALSE)
	names(unorderd_pairs_tmp) <- c(pField_Name1, pField_Name2)
	unorderd_pairs_tmp[order(unorderd_pairs_tmp[,1]),]
}

get_values_2 <- function(pSubject_ID, pGroup_Field, pSelect_Field, pResult_Fields, pSourceTable, pSelect_Criteria) {
	if(missing(pSourceTable)) {
		pSourceTable <- dataset
	}
	if(missing(pSelect_Criteria)) {
		subset_tmp <- subset(pSourceTable, Subject_ID == pSubject_ID & 
			(Field_Name == pGroup_Field | Field_Name == pSelect_Field | Field_Name %in% pResult_Fields) & 
			!is.na(Value) & Value != "")
	} else {
		subset_tmp <- subset(pSourceTable, Subject_ID == pSubject_ID & 
			(Field_Name == pGroup_Field | (Field_Name == pSelect_Field & Value == pSelect_Criteria) | Field_Name %in% pResult_Fields) & 
			!is.na(Value) & Value != "")
	}
	Group_Keys <- subset(subset_tmp, Field_Name == pGroup_Field)[,"Key"]
	Select_Keys <- subset(subset_tmp, Field_Name == pSelect_Field)[,"Key"]
	subset_tmp <- subset(subset_tmp, Key %in% Group_Keys & Key %in% Select_Keys)
	for(result_field in pResult_Fields){
		result_field_keys <- subset(subset_tmp, Field_Name == result_field)[,"Key"]
		subset_tmp <- subset(subset_tmp, Key %in% result_field_keys)
	}
	subset_tmp <- subset_tmp[4:7]
	subset_tmp <- subset_tmp[order(subset_tmp[,1]),]
	unorderd_pairs_tmp <- data.frame(c(subset(subset_tmp, Field_Name==pGroup_Field)[,4]), c(subset(subset_tmp, Field_Name==pSelect_Field)[,4]), stringsAsFactors=FALSE)
	names(unorderd_pairs_tmp) <- c(pGroup_Field, pSelect_Field) #early naming for debugging purposes
	for(result_field in pResult_Fields){
		unorderd_pairs_tmp <- cbind(unorderd_pairs_tmp, subset(subset_tmp, Field_Name==result_field)[,4])
	}
	names(unorderd_pairs_tmp) <- c(pGroup_Field, pSelect_Field, pResult_Fields)
	subset <- unorderd_pairs_tmp[order(unorderd_pairs_tmp[,1]),]
	subset
}

#pDefaults BOOLEAN when true a default is supplied for every missing value when false NA is supplies for a missing value
linear_regression <- function(pSubject, pOnset_Score, pDefaults){
	if(missing(pDefaults)){pDefaults <- TRUE}
	scores <- get_ALSFRS_scores(pSubject)
	cutoff_point <- 91
	scores <- subset(scores, as.integer(ALSFRS_Delta) <= cutoff_point)
	if(nrow(scores) < 1) {
		if(pDefaults){
			scores <- rbind(c(DEFAULT_DELTA_FIRST_ALSFRS_SCORE, DEFAULT_FIRST_ALSFRS_SCORE), scores)
		}else{
			scores <- rbind(c(NA, NA), scores)
		}
		names(scores) <- c("ALSFRS_Delta", "ALSFRS_Score")	#namen gaan verloren als aantal rijen nul is geweest
	}
	Onset_Delta_Subset <- subset(dataset, Subject_ID==pSubject & Field_ID==1417) # Field_ID==1417 is onset delta
	Onset_Delta <- min(as.integer(Onset_Delta_Subset[,7]))
	scores <- rbind(c(Onset_Delta, pOnset_Score), scores)
	scores <- data.frame(scores, stringsAsFactors=FALSE)
	res <- lm(scores[,"ALSFRS_Score"] ~ scores[,"ALSFRS_Delta"])
	as.double(coefficients(res)[2])
}

linear_regression_2 <- function(pSubject, pDelta, pValue, pDefault){ 
	cutoff_point <- 91
	df <- get_values(pSubject, pDelta, pValue)
	df <- data.frame(as.numeric(df[,pDelta]),as.numeric(df[,pValue]))
	names(df) <- c("Delta", "Value")
	df <- subset(df, as.integer(Delta) <= cutoff_point)
	df <- df[order(as.numeric(df[,"Delta"])),]
	if(nrow(df) < 2) {
		return(pDefault)
	}
	res <- lm(df[,"Value"] ~ df[,"Delta"])
	as.double(coefficients(res)[2])
}

#special lr for ALSFRS_score
linear_regression_3 <- function(pSubject, pDefault, pDefaults){ 
	cutoff_point <- 91
	scores <- get_ALSFRS_scores(pSubject)
	cutoff_point <- 91
	scores <- subset(scores, as.integer(ALSFRS_Delta) <= cutoff_point)
	if(nrow(scores) < 2) {
		if(pDefaults){
			return(pDefault)
		}else{
			return(NA)
		}
	}
	res <- lm(scores[,"ALSFRS_Score"] ~ scores[,"ALSFRS_Delta"])
	as.double(coefficients(res)[2])
}

predict_earth <- function (pModel, pTable) {
	for(i in 1:ncol(pTable)) {
		pTable[,i] <- as.numeric(pTable[,i])
	}

	if(is.character(pModel)) {
		slopes <- eval(parse(text=paste(
			"with(as.data.frame(pTable),\n",
			pModel,
			")\n", sep = "")))
	} else {
		slopes <- predict(object = pModel, newdata = pTable)
	}

	slopes <- data.frame(pTable$Subject_ID, slopes)
	names(slopes) <- c("Subject_ID", "Slope")
	slopes
}

#pDefaults BOOLEAN when true a default is supplied for every missing value when false NA is enetered for a missing value (for only a selected number of variables)
predict_slopes_lr <- function(pDefaults){
	if(missing(pDefaults)){pDefaults <- TRUE}
	slopes <- data.frame()
	for(Subject in SubjectIDs){
		slope <- linear_regression(Subject, 43.0, pDefaults) 
		df <- subset(get_ALSFRS_scores(Subject), as.numeric(ALSFRS_Delta) <= 91)
		slopes <- rbind(slopes, c(Subject, slope))
	}
	names(slopes) <- c("Subject_ID", "Slope")
	slopes
}

#pDefaults BOOLEAN when true a default is supplied for every missing value when false NA is enetered for a missing value (for only a selected number of variables)
process_labtests <- function(pDefaults, pDebug){
	if(missing(pDefaults)){pDefaults <- TRUE}
	if(missing(pDebug)) { pDebug <- FALSE }
	cutoff_point <- 91
	labtests <- data.frame(stringsAsFactors=FALSE)
	testnames <- LABTEST_DEFAULTS$Name # unique(subset(dataset, Field_ID == 1250)[,"Value"])
	i=0
	for(Subject in SubjectIDs){
		i=i+1
		if(pDebug) { 
			#if(i>20) {break}
			cat("\n\n", i, " - Processing labtests for subject ", Subject, ":\n") 
			cat("\nLabtests\n") 
			flush.console()
		}
		j = 0
		df_subject_data <- subset(dataset, Subject_ID == Subject) 
		for(testname in testnames) {
			j = j + 1
			if(!(testname %in% LABTEST_CONVERSIONS$Name)) {
				next
			}
			if(pDebug) { 
				if(j%%5==0) {
					cat("\n")
				}
				cat("\t", testname) 
				flush.console()
			}
			if(testname %in% LABTEST_CONVERSIONS[LABTEST_CONVERSIONS$Unit == "<nounit>","Name"]) {
				df <- get_values_2(Subject, "Laboratory Delta", "Test Name", "Test Result", df_subject_data, testname)
				names(df) <- c("Delta", "Name", "Result")
				df <- subset(df, as.integer(Delta) <= cutoff_point)
				options(warn=-1) # temporarily ignore warnings from as.numeric
				df$Result <- as.numeric(df$Result)
				options(warn=0) # restore warnings
				df <- subset(df, ! is.na(Result)) # remove all results which couldn't be converted to numeric
			} else {
				df <- get_values_2(Subject, "Laboratory Delta", "Test Name", c("Test Result", "Test Unit"), df_subject_data, testname)
				names(df) <- c("Delta", "Name", "Result", "Unit")
				df <- subset(df, as.integer(Delta) <= cutoff_point)
				options(warn=-1) # temporarily ignore warnings from as.numeric
				df$Result <- as.numeric(df$Result)
				options(warn=0) # restore warnings
				df <- subset(df, ! is.na(Result)) # remove all results which couldn't be converted to numeric
				df <- convert_units(df, testname)
			}
				
			df <- subset(df, !duplicated(Delta)) # remove duplicate results (with identical delta)
			df$Delta <- as.numeric(df$Delta)
			df$Result <- as.numeric(df$Result) ##toch ook maar result weer eens numeriek gemaakt
			df <- df[order(df[,"Delta"]),]
			if(pDefaults){
				mean  <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Mean"][1]
				slope <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Slope"][1]
				first <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "First"][1]
				last  <- LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Last"][1]
			}else{
				mean  <- NA
				slope <- NA
				first <- NA
				last  <- NA
			}
			range_min <- as.numeric(LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Min"][1]) #don't try NULL !
			range_max <- as.numeric(LABTEST_DEFAULTS[LABTEST_DEFAULTS$Name == testname, "Max"][1]) #je kan simpelweg niet genoeg getallen weer numeriek maken
			range <- range_max - range_min
			range_min <- range_min - (1.2 * range) # 20% deviation allowed
			range_max <- range_max + (1.2 * range) # 20% deviation allowed
			if (pDebug){
				df_not_realistic <- subset(df, as.numeric(Result) < range_min | as.numeric(Result) > range_max)
				if(nrow(df_not_realistic)>0){
					cat("The following values where considered not to be realistic and are left out:\n")
					print(df_not_realistic)
				}
			}
			df <- subset(df, as.numeric(Result) >= range_min & as.numeric(Result) <= range_max)
			min <- -999999
			max <- -999999
			if(nrow(df) >= 2) {
				res <- lm(df[,"Result"] ~ df[,"Delta"])
				slope <- as.double(coefficients(res)[2])
			}
			if (nrow(df) > 0) {
				mean <- mean(df[,"Result"])
				min  <- min(df[,"Result"])
				max  <- max(df[,"Result"])
				first <- df[1, "Result"]
				last <- df[nrow(df), "Result"]
			}
			labtests <- rbind(labtests, c(Subject, testname, as.numeric(mean), as.numeric(slope), as.numeric(min), as.numeric(max), as.numeric(first), as.numeric(last)))
		}
	}
	names(labtests) <- c("Subject_ID", "Testname", "Mean", "Slope", "Min", "Max", "First", "Last")
	labtests
}

#pDefaults BOOLEAN when true a default is supplied for every missing value when false NA is enetered for a missing value (for only a selected number of variables)
process_vitalsigns <- function(pDefaults, pDebug){
	if(missing(pDefaults)){pDefaults <- TRUE}
	if(missing(pDebug)) { pDebug <- FALSE }
	cutoff_point <- 91
	vitalsigns <- data.frame(stringsAsFactors=FALSE)
	i=0
	for(Subject in SubjectIDs){
		i=i+1
		if(pDebug) { 
			#if(i>20) {break}
			cat("\n\n", i, " - Processing vital signs for subject ", Subject, ":\n") 
			cat("\nVital Signs\n") 
			flush.console()
		}
		j = 0
		df_subject_data <- subset(dataset, Subject_ID == Subject) 
		for(name in VITALSIGN_DEFAULTS$Name) {
			j = j + 1
			if(pDebug) { 
				if(j%%5==0) {
					cat("\n")
				}
				cat("\t", name) 
				flush.console()
			}
			if(name == "Weight" | name == "Height") {
				if(name == "Weight") {
					df <- get_values_2(Subject, "Vital Signs Delta", name, "Weight Units", df_subject_data)
				} else if(name == "Height") {
					df <- get_values_2(Subject, "Vital Signs Delta", name, "Height Units", df_subject_data)
				}
				names(df) <- c("Delta", "Result", "Unit")
				df <- subset(df, as.integer(Delta) <= cutoff_point)
				options(warn=-1) # temporarily ignore warnings from as.numeric
				df$Result <- as.numeric(df$Result)
				options(warn=0) # restore warnings
				df <- subset(df, ! is.na(Result)) # remove all results which couldn't be converted to numeric
				df <- convert_units(df, name)
			} else {
				df <- get_values_2(Subject, "Vital Signs Delta", name, c(), df_subject_data)
				names(df) <- c("Delta", "Result")
			}
			df <- subset(df, !duplicated(Delta)) # remove duplicate results (with identical delta)
			df$Delta <- as.numeric(df$Delta)
			df$Result <- as.numeric(df$Result) ##toch ook maar result weer eens numeriek gemaakt
			df <- df[order(df[,"Delta"]),]
			if(pDefaults){
				mean  <- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == name, "Mean"][1]
				slope <- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == name, "Slope"][1]
				first <- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == name, "First"][1]
				last  <- VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == name, "Last"][1]
			}else{
				mean  <- NA
				slope <- NA
				first <- NA
				last  <- NA
			}
			range_min <- as.numeric(VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == name, "Min"][1]) #don't try NULL !
			range_max <- as.numeric(VITALSIGN_DEFAULTS[VITALSIGN_DEFAULTS$Name == name, "Max"][1])
			range <- range_max - range_min
			range_min <- range_min - (1.2 * range) # 20% deviation allowed
			range_max <- range_max + (1.2 * range) # 20% deviation allowed
			if (pDebug){
				df_not_realistic <- subset(df, as.numeric(Result) < range_min | as.numeric(Result) > range_max)
				if(nrow(df_not_realistic)>0){
					cat("The following values where considered not to be realistic and are left out (", range_min, ") (", range_max, "):\n")
					print(df_not_realistic)
				}
			}
			df <- subset(df, as.numeric(Result) >= range_min & as.numeric(Result) <= range_max)
			min <- -999999
			max <- -999999
			if(nrow(df) >= 2) {
				res <- lm(df[,"Result"] ~ df[,"Delta"])
				slope <- as.double(coefficients(res)[2])
			}
			if (nrow(df) > 0) {
				mean <- mean(df[,"Result"])
				min  <- min(df[,"Result"])
				max  <- max(df[,"Result"])
				first <- df[1, "Result"]
				last <- df[nrow(df), "Result"]
			}
			vitalsigns <- rbind(vitalsigns, c(Subject, name, as.numeric(mean), as.numeric(slope), as.numeric(min), as.numeric(max), as.numeric(first), as.numeric(last)))
		}
	}
	names(vitalsigns) <- c("Subject_ID", "Name", "Mean", "Slope", "Min", "Max", "First", "Last")
	vitalsigns
}

ps_lr <- function(pDelta, pValue, pDefault){
	slopes <- data.frame()
	for(Subject in SubjectIDs){
		slope <- linear_regression_2(Subject, pDelta, pValue, pDefault) 
		slopes <- rbind(slopes, c(Subject, slope))
	}
	names(slopes) <- c("Subject_ID", "slope")
	slopes
}

n_order <- function(pVar, pFit){
	result <- 0
	pVar <- as.numeric(pVar)
	pFit <- as.numeric(pFit)
	for(i in 1:length(pFit)){
		result <- as.double(result + pFit[i] * (pVar^(i-1)))
	}
	result
}	

### Main ###
options(stringsAsFactors = FALSE) # no factors please

get_ALSFRS_scores()

ALSFRS_slopes <- predict_slopes_lr()

Labtest_data <- process_labtests(TRUE) ##TRUE -> with defaults
Vitalsign_data <- process_vitalsigns(TRUE) ###no DEFAULTS while predicting

NN_Table <- generate_nn_table()          ###learning with defaults

for(i in 1:ncol(NN_Table)) {
	NN_Table[,i] <- as.numeric(NN_Table[,i])
}

#clean run for development

#vars fits and strings
earth_vars <- c(	"ALSFRS_Slope",						"Mean_ALSFRS_Score",						"Pulse_Slope",						"Respiratory_Rate_Slope",
			"Blood_Pressure_Systolic_Slope",			"Onset_Delta_sq",							"Urine_Protein_Mean")

earth_string <- "  -0.55913399\n
			+     1.2053995 * pmax(0,                  ALSFRS_Slope -                   -0.83437939) \n  
			-     1.2289048 * pmax(0,                  ALSFRS_Slope -                   -0.41156389) \n  
			-    0.40843679 * pmax(0,                   -0.41156389 -                  ALSFRS_Slope) \n  
			-   0.059661852 * pmax(0,             Mean_ALSFRS_Score -                         16.25) \n  
			+   0.051514355 * pmax(0,             Mean_ALSFRS_Score -                            24) \n  
			-     6.7378442 * pmax(0,                   Pulse_Slope -                  0.0092453818) \n  
			+ 2.7790788e-07 * pmax(0,                  0.0092453818 -                   Pulse_Slope) \n  
			+     10.379449 * pmax(0,        Respiratory_Rate_Slope -                  -0.015843751) \n  
			-     37.930218 * pmax(0,        Respiratory_Rate_Slope -                  0.0011397663) \n  
			+     26.739187 * pmax(0,        Respiratory_Rate_Slope -                   0.012719355) \n  
			+       2.71924 * pmax(0, Blood_Pressure_Systolic_Slope -                  -0.099598535) \n"
 


predicted_slopes <- predict_earth(earth_string, NN_Table)

### Build an R 'list' (i.e., key:value pairs) containing subjectIDs and slopes
predicted <- list(as.numeric(predicted_slopes[,1]), as.numeric(predicted_slopes[,2]))

### Write out the prediction 
write.table(predicted, file="predicted.out", append=FALSE, quote=TRUE, sep=",", col.names=FALSE, row.names=FALSE, qmethod="escape")



################################
#end main
################################

################################################################################

CvEval<-function(method,raw.data.name,args=list(),num.cv=10) {
	# Computes cv errors for a given prediction method
	#
	# Args:
	#	method: 
	#	raw.data.name:
	#	method.args
	#	num.cv
	#
	# Returns:
	# 	Cross validation error
	#
	# Example usage:
	#	error<-CvEval(RandomForestTrain,"train")
	
	# Generate cv splits
	GenCvData(raw.data.name,num.cv)

	# Get the ground truth prediction model	
	model.truth<-GroundTruthTrain()

	TrainTestRmsd <- function(fold) {
		# For a given CV fold, trains method on training set and computes the RMSD between method's 
		# predictions on the test set and the ground truth on the test set
		
		# Construct train and test set names
		train.name <- sprintf("%s-cv%s_%sof%d", raw.data.name, "train",fold,num.cv)
		test.name <- sprintf("%s-cv%s_%sof%d", raw.data.name, "test",fold,num.cv)
		# Train method and compute error between ground truth and method predictions
		return(Rmsd(model.truth(test.name)[,2], method(train.name,args=args)(test.name)[,2]))
	}
	
	# Get the test errors of method on each train-test split
	split.rmse <- sapply(1:num.cv,TrainTestRmsd)
	print(split.rmse)
	
	# Average MSEs and take square root
	cv.rmse<-sqrt(mean(split.rmse^2))
	print(cv.rmse)
	return(cv.rmse)
}

FileCvEval <- function(method,train.name,method.args,num.cv) {
	# Calculates CV error across a number of cv splits
	#
	# Args:
	#	method: name of method file used to create predictions
	#	train.name: base name of training data used to make splits
	#	method.args: arguments passed into method to make prediction 
	#	num.cv: number of splits 
	#
	# Returns:
	# 	Average RMSD over all cv splits 
	#
	#################################################################
	# Example usage:
	if(FALSE) {
		# Evaluate randomforest
		args <- list(R=1,corr.bias=FALSE,pls=FALSE,prune=FALSE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
		cv.rmsd<-FileCvEval("RandomForestTrain","train",method.args=args,num.cv=10)
		
		# Evaluate glmnet
		args <- list(R=1,pls=FALSE,prune=FALSE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
		cv.rmsd<-FileCvEval("GlmnetTrain","train",method.args=args,num.cv=10)
		
		# Evaluate gbm
		args <- list(R=1,pls=FALSE,prune=FALSE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
		cv.rmsd<-FileCvEval("GbmTrain","train",method.args=args,num.cv=10)

		# Evaluate bagging
		args <- list(R=1,pls=FALSE,prune=FALSE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
		cv.rmsd<-FileCvEval("BaggingTrain","train",method.args=args,num.cv=10)
	

		# Evaluate neural net
		args <- list(R=1,pls=FALSE,prune=TRUE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
		cv.rmsd<-FileCvEval("NnetTrain","train",method.args=args,num.cv=10)
	}
	#################################################################
	# Example usage with residual train:
	if(FALSE) {
		old.method <- "GlmnetTrain"
		old.args <- list(R=1,pls=FALSE,prune=TRUE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
		new.method <- "GbmTrain"
		new.args <- list(R=1,pls=FALSE,prune=TRUE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL)
	 	cv.rmsd<-FileCvEval("Residual","train",method.args=c(old.method,old.args,new.method,new.args),num.cv=10)
	}
	#################################################################
	
	# Get vector of train names corresponding to cv splits
	train.names<-paste(train.name,"-cvtrain_",1:num.cv,"of",num.cv,sep="")
	
	# Get vector of ttest names corresponding to cv splits
	test.names<-paste(train.name,"-cvtest_",1:num.cv,"of",num.cv,sep="")
	
	# Calculate rmses of each train/test split
	rmses<-mapply(FileArgsRmsd,method,train.names,test.names,list(method.args))
	
	# Average MSEs and take square root
	cv.rmse<-sqrt(mean(rmses^2))

	print(paste("CV RMSE:",cv.rmse))
	return(cv.rmse)

}

# October 23, 2009  avPlots by S. Weisberg.  avPlot by John Fox
# 13 January 2010: changed default id.n=3. J. Fox
# 13 March 2010: added intercept argument. J. Fox
# 14 April 2010: set id.n = 0. J. Fox
# 22 April 2010: modified id.n S. Weisberg
# 10 May 2010:  added gridlines
# 25 May 2010:  changed default color scheme
# 5 June 2011: made several modifications, slightly adapting code contributed by M. Friendly (J. Fox):
#   added ellipse, ellipse.args arguments 
#   added main argument to avPlot.lm
#   return x and y residuals invisibly
# 16 June 2011 allow layout=NA, in which case the layout is not set in this
#  function, so it is the responsibility of the user
# 22 Sept 2013 added argument marginal.scale to set xlim and ylim according to xlim and 
#  ylim of marginal plot (S. Weisberg)



avPlots <- function(model, terms=~., intercept=FALSE, layout=NULL, ask, 
		main, ...){
	terms <- if(is.character(terms)) paste("~",terms) else terms
	vform <- update(formula(model),terms)
	if(any(is.na(match(all.vars(vform), all.vars(formula(model))))))
		stop("Only predictors in the formula can be plotted.")
	terms.model <- attr(attr(model.frame(model), "terms"), "term.labels")
	terms.vform <- attr(terms(vform), "term.labels")
	terms.used <- match(terms.vform, terms.model)
	mm <- model.matrix(model) 
	model.names <- attributes(mm)$dimnames[[2]]
	model.assign <- attributes(mm)$assign
	good <- model.names[!is.na(match(model.assign, terms.used))]
	if (intercept) good <- c("(Intercept)", good)
	nt <- length(good)
	if (nt == 0) stop("No plots specified")
	if (missing(main)) main <- if (nt == 1) paste("Added-Variable Plot:", good) else "Added-Variable Plots"
  if (nt == 0) stop("No plots specified")
  if (nt > 1 & (is.null(layout) || is.numeric(layout))) {
    if(is.null(layout)){
         layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2), 
                             c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
    }
    ask <- if(missing(ask) || is.null(ask)) prod(layout)<nt else ask
    op <- par(mfrow=layout, ask=ask, no.readonly=TRUE, 
            oma=c(0, 0, 1.5, 0), mar=c(5, 4, 1, 2) + .1)
    on.exit(par(op))
    }
	res <- as.list(NULL)
	for (term in good) res[[term]] <- avPlot(model, term, main="", ...)
	mtext(side=3,outer=TRUE,main, cex=1.2)
	invisible(res)
}

avp <- function(...) avPlots(...)

avPlot <-  function(model, ...) UseMethod("avPlot")

avPlot.lm <- function(model, variable,
		id.method = list(abs(residuals(model, type="pearson")), "x"),
		labels, 
		id.n = if(id.method[1]=="identify") Inf else 0,
		id.cex=1, id.col=palette()[1],
		col = palette()[1], col.lines = palette()[2],
		xlab, ylab, pch = 1, lwd = 2, main=paste("Added-Variable Plot:", variable), grid=TRUE,
		ellipse=FALSE, ellipse.args=NULL, 
    marginal.scale=FALSE, ...){
	variable <- if (is.character(variable) & 1 == length(variable))
				variable
			else deparse(substitute(variable))
	if(missing(labels)) 
		labels <- names(residuals(model)[!is.na(residuals(model))])
	else deparse(substitute(variable))
	mod.mat <- model.matrix(model)
	var.names <- colnames(mod.mat)
	var <- which(variable == var.names)
	if (0 == length(var))
		stop(paste(variable, "is not a column of the model matrix."))
	response <- response(model)
	responseName <- responseName(model)
	if (is.null(weights(model)))
		wt <- rep(1, length(response))
	else wt <- weights(model)
	res <- lsfit(mod.mat[, -var], cbind(mod.mat[, var], response),
			wt = wt, intercept = FALSE)$residuals
	xlab <- if(missing(xlab)) paste(var.names[var], "| others") else xlab
	ylab <- if(missing(ylab)) paste(responseName, " | others")  else ylab
  adjrange <- function(z, zres, wt){
    wtmean <- sum(z*wt)/sum(wt)
    c(min(z-wtmean, zres), max(z-wtmean, zres))
  }
  xlm <- if(marginal.scale) adjrange(mod.mat[, var], res[, 1], wt) else NA
	ylm <- if(marginal.scale) adjrange(response, res[, 2], wt) else NA
  if(marginal.scale) {
    plot(res[, 1], res[, 2], xlab = xlab, ylab = ylab, type="n", main=main, xlim=xlm, ylim=ylm, ...) 
  } else{
	  plot(res[, 1], res[, 2], xlab = xlab, ylab = ylab, type="n", main=main, ...)
  }
	if(grid){
		grid(lty=1, equilogs=FALSE)
		box()}
	points(res[, 1], res[, 2], col=col, pch=pch, ...)
	abline(lsfit(res[, 1], res[, 2], wt = wt), col = col.lines, lwd = lwd)
	if (ellipse) {
		ellipse.args <- c(list(res, add=TRUE, plot.points=FALSE), ellipse.args)
		do.call(dataEllipse, ellipse.args)
	}
	showLabels(res[, 1],res[, 2], labels=labels, 
			id.method=id.method, id.n=id.n, id.cex=id.cex, 
			id.col=id.col)
	colnames(res) <- c(var.names[var], responseName)
	rownames(res) <- rownames(mod.mat)
	invisible(res)  
}

avPlot.glm <- function(model, variable, 
		id.method = list(abs(residuals(model, type="pearson")), "x"),
		labels,
		id.n = if(id.method[1]=="identify") Inf else 0,
		id.cex=1, id.col=palette()[1], 
		col = palette()[1], col.lines = palette()[2],
		xlab, ylab, pch = 1, lwd = 2,  type=c("Wang", "Weisberg"), 
		main=paste("Added-Variable Plot:", variable), grid=TRUE,
		ellipse=FALSE, ellipse.args=NULL, ...) {
	type<-match.arg(type)
	if(missing(labels)) labels <- names(residuals(model)[!is.na(residuals(model))])
	variable<-if (is.character(variable) & 1==length(variable)) variable
			else deparse(substitute(variable))
	mod.mat<-model.matrix(model)
	var.names<-colnames(mod.mat)
	var<-which(variable==var.names)
	if (0==length(var)) stop(paste(variable,"is not a column of the model matrix."))
	response<-response(model)
	responseName<-responseName(model)
	wt<-model$prior.weights
	mod<-glm(response~mod.mat[,-var]-1, weights=wt, family=family(model))
	res.y<-residuals(mod, type="pearson")
	wt<-if (type=="Wang") wt*model$weights else wt
	res.x<-lsfit(mod.mat[,-var], mod.mat[,var], wt=wt,    
			intercept=FALSE)$residuals
	xlab <- if(missing(xlab)) paste(var.names[var], "| others") else xlab
	ylab <- if(missing(ylab)) paste(responseName, " | others") else ylab
	plot(res.x, res.y, xlab=xlab, type="n", ylab=ylab, main=main, ...)
	if(grid){
		grid(lty=1, equilogs=FALSE)
		box()}
	points(res.x, res.y, col=col, pch=pch, ...)
	abline(lsfit(res.x, res.y, wt=wt), col=col.lines, lwd=lwd)
	if (ellipse) {
		ellipse.args <- c(list(res.x, res.y, add=TRUE, plot.points=FALSE), ellipse.args)
		do.call(dataEllipse, ellipse.args)
	}
	showLabels(res.x,res.y, labels=labels, 
			id.method=id.method, id.n=id.n, id.cex=id.cex, 
			id.col=id.col)
	res <- cbind(res.x, res.y)
	colnames(res) <- c(var.names[var], responseName)
	rownames(res) <- rownames(mod.mat)
	invisible(res)
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

competing.risk <- function (x, plot = TRUE, ...) {
  if (sum(inherits(x, c("rsf", "grow"), TRUE) == c(1, 2)) != 2 &
      sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) != 2)
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, predict)'.")
  if (sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) == 2) {
      rsfPred <- TRUE
    }
    else {
      rsfPred <- FALSE
  }
  if (length(dim(x$ensemble)) == 2) {
    if (rsfPred) {
      ensb <- array(x$ensemble, dim = c(nrow(x$ensemble), ncol(x$ensemble), 1), 1)
    }
    else {
      ensb <- array(x$oob.ensemble, dim = c(nrow(x$oob.ensemble), ncol(x$oob.ensemble), 1), 1)
    }
    n.event <- 1
  }
  else {
    if (rsfPred) ensb <- x$ensemble else ensb <- x$oob.ensemble 
    n.event <- dim(ensb)[3]
  }
  surv.ensb.avg <- apply(exp(-ensb[,, 1]), 2, mean, na.rm = TRUE)
  if (n.event > 1) {
    cif.ensb <- sub.ensb <- array(0, dim = c(dim(ensb)[c(1,2)], n.event - 1))
    cond.mort <- matrix(0, n.event - 1, dim(ensb)[1])
    cif.ensb.avg <- sub.ensb.avg <- csurv.ensb.avg <- NULL
    for (j in 1:(n.event-1)) {
      poe.j <- if (rsfPred) c(x$poe[j, ]) else c(x$oob.poe[j, ]) 
      h.j   <- ensb[,, 1 + j]
      S.j   <- poe.j*exp(-h.j)
      cif.ensb[,, j]   <- poe.j - S.j
      sub.ensb[,, j]   <- S.j
      cond.mort[j, ] <- apply(h.j, 1, sum, na.rm = TRUE)
      cif.ensb.avg    <- cbind(cif.ensb.avg, apply(cif.ensb[,,j], 2, mean, na.rm = TRUE))
      sub.ensb.avg    <- cbind(sub.ensb.avg, apply(S.j, 2, mean, na.rm = TRUE))
      csurv.ensb.avg  <- cbind(csurv.ensb.avg, apply(exp(-h.j), 2, mean, na.rm = TRUE))
    }
    dimnames(cif.ensb)[[3]] <- paste("CIF.", 1:(n.event-1), sep = "")
    dimnames(sub.ensb)[[3]] <- paste("subS.", 1:(n.event-1), sep = "")
    rownames(cond.mort) <- paste("event.", 1:(n.event-1), sep = "")
  }
  matPlot <- function(M, ylab = "Survival (%)", legend = "ensemble survival", pos = 2) {
     m <- dim(cbind(M))[2]
     if (!rsfPred) legend <- paste("oob", legend)     
     if (m > 1) legend <- paste(legend, 1:m, "  ")
     matplot(x$timeInterest, 100*M, xlab = "Time", ylab = ylab, type = "l",
             col = (1:m), lty = 1,
             lwd = c(3, 1.5)[1 + 1 * (m > 10)])
    legend(c("topleft", "topright")[pos], legend = legend, col = (1:m), lty = 1,
           xjust = c(0, 1)[pos],
           lwd = c(3, 1.5)[1 + 1 * (m > 10)],
           cex = c(0.75, 0.65)[1 + 1 * (m > 10)])
  }
  if (plot) {
    if (n.event == 1) {
      old.par <- par(no.readonly = TRUE) 
      matPlot(surv.ensb.avg)
      par(old.par) 
      return(NULL)
    }
    else {
      old.par <- par(no.readonly = TRUE) 
      par(mfrow = c(2,2))
      matPlot(cif.ensb.avg,   "Probability (%)", "ensemble CIF", 1)
      matPlot(sub.ensb.avg,   "Probability (%)", "ensemble subsurvival")
      matPlot(csurv.ensb.avg, "Survival (%)", "ensemble cond. surv.")
      matPlot(surv.ensb.avg)
      par(old.par) 
    }
  }
  if (n.event > 1) {
    invisible(list(cif.ensb = cif.ensb, sub.ensb = sub.ensb, cond.mortality = cond.mort))
  } 
}

####1. Load packages and data processing function
t0=proc.time();
working_dir="Origent Model Document//Slope Model//Slope Model Code"; ## change the directory for where your model sits here!!!
setwd(working_dir); 
install.packages("randomForest");
library(randomForest);

full_data=read.csv("data/PROACT-ALL_FORMS.csv",sep="|", header=F);
full_data_slope=read.table("data/slopes_full.txt", header=F);
names(full_data_slope)=c("Pid","slope");
full_data=full_data[full_data$V1%in%full_data_slope$Pid,];


####2.Model Training and Validation
##2.1 Random split data as training and validation data set (80/20)
pid_all=unique(full_data$V1);
trainInd=sample((1:length(pid_all)),2*round(length(pid_all)/3));
trainPool=rep(F,length(pid_all));
trainPool[trainInd]=T;
pid_t=pid_all[trainPool];
pid_v=pid_all[!trainPool];
tdat=full_data[full_data$V1%in%pid_t,];
vdat=full_data[full_data$V1%in%pid_v,];
tdat_slope=full_data_slope[full_data_slope$Pid%in%pid_t,];
vdat_slope=full_data_slope[full_data_slope$Pid%in%pid_v,];
    
##2.2 Train and Validation
source("code/data_process_fun.R");  
source("code/training.R");
source("code/validation.R");  
    
    
##3 Remove the object generate in the validation and clean memory
#rm(list=ls());
#gc();
    

# influence index plot  written 9 Dec 09 by S. Weisberg
# 21 Jan 10: added wrapper influenceIndexPlot(). J. Fox
# 30 March 10: bug-fixes and changed arguments, S. Weisberg
# 15 October 13:  Bug-fix on labelling x-axis

influenceIndexPlot <- function(model, ...)
	{UseMethod("infIndexPlot")}

infIndexPlot <- function(model, ...)
         {UseMethod("infIndexPlot")}

infIndexPlot.lm <- function(model,
     vars=c("Cook", "Studentized", "Bonf", "hat"), 
     main="Diagnostic Plots",
     labels, id.method = "y", 
     id.n = if(id.method[1]=="identify") Inf else 0,
     id.cex=1, id.col=palette()[1], grid=TRUE, ...) {
   what <- pmatch(tolower(vars), 
                  tolower(c("Cook", "Studentized", "Bonf", "hat")))
   if(length(what) < 1) stop("Nothing to plot")
   names <- c("Cook's distance", "Studentized residuals",
           "Bonferroni p-value", "hat-values")
# check for row.names, and use them if they are numeric.
   if(missing(labels)) labels <-  row.names(model$model)
   op <- par(mfrow=c(length(what), 1), mar=c(1, 4, 0, 2) + .0,
             mgp=c(2, 1, 0), oma=c(6, 0, 6, 0))
   oldwarn <- options()$warn
   options(warn=-1)
   xaxis <- as.numeric(row.names(model$model))
   options(warn=oldwarn)
   if (any (is.na(xaxis))) xaxis <- 1:length(xaxis)
   on.exit(par(op))
   outlier.t.test <- pmin(outlierTest(model, order=FALSE, n.max=length(xaxis),
      cutoff=length(xaxis))$bonf.p, 1)
   nplots <- length(what)
   plotnum <- 0
   for (j in what){
      plotnum <- plotnum + 1 
      y <- switch(j, cooks.distance(model), rstudent(model),
                     outlier.t.test, hatvalues(model))
      plot(xaxis, y, type="n", ylab=names[j], xlab="", xaxt="n", tck=0.1, ...)
	    if(grid){
        grid(lty=1, equilogs=FALSE)
        box()}
      if(j==3) {
            for (k in which(y < 1)) lines(c(xaxis[k], xaxis[k]), c(1, y[k]))}
          else {
            points(xaxis, y, type="h", ...)}  
      points(xaxis, y, type="p", ...)  
      if (j == 2) abline(h=0, lty=2 )
      axis(1, labels= ifelse(plotnum < nplots, FALSE, TRUE))
      showLabels(xaxis, y, labels=labels,
            id.method=id.method, id.n=id.n, id.cex=id.cex,
            id.col=id.col)
    }
    mtext(side=3, outer=TRUE ,main, cex=1.2, line=1)
    mtext(side=1, outer=TRUE, "Index", line=3)
   invisible()
}

#' Function to retrain all models originally trained using overall survival and train and evaluate using
#' disease specific survival
#'
#' @author Adam Margolin
#' @export
#' 
retrainAllOSModels <- function(){
  trainingData <- loadMetabricTrainingData()
  
  submittedModelIds_orig <- synapseQuery("SELECT id FROM entity WHERE entity.parentId == 'syn1125643'")
  
  for (modelCtr in 1:nrow(submittedModelIds_orig)){
    curModelId_orig <- submittedModelIds_orig$entity.id[modelCtr]
    print(paste("Retraining", modelCtr, "of", nrow(submittedModelIds_orig), ":", curModelId_orig))
    try( retrainOSModel(curModelId_orig) )
  }
}

####################1. Arithmetic Function
##1.1 Function to combine data with missing values. 
na_plus_fun=function(x,y){
    z=x
    for (i in (1:length(x))){if (is.na(x[i])){z[i]=y[i]} }
    for (i in (1:length(y))){if (is.na(y[i])){z[i]=x[i]} }  
    for (i in (1:length(x))){if (!is.na(x[i]) & !is.na(y[i])){z[i]=(x[i]+y[i])/2} }
return(z)
}

##1.2 Function to impute average for the numeric variable and most common value to impute for factor variable
impute_avg_fun=function(dat){
    for (i in (1:dim(dat)[2])){
        ##numeric variable
        if(is.numeric(dat[,i])){dat[is.na(dat[,i]),i]=mean(dat[,i],na.rm=T)}
        ##factor variable
        if(is.factor(dat[,i])){
            ux=unique(dat[!is.na(dat[,i]),i])
            dat[is.na(dat[,i]),i]=ux[which.max(tabulate(match(dat[!is.na(dat[,i]),i], ux)))]
            #dat[is.na(dat[,i]),i]='UNKOWN'
        }
    }
    return(dat)
}

####################2. Data Process Function Definition
##2.1 Function to process demographic data
demographic_process_fun=function(dat){
    unique_id=as.data.frame(unique(dat$V1))
    names(unique_id)=c("Pid")
    age=dat[dat$V5==1257,c(1,7)]
    names(age)=c("Pid","age")
    age$age=as.numeric(as.character(age$age))
    race=dat[dat$V5%in%c(1207,1208,1210,1211) & dat$V7!='',][,c(1,6)]
    names(race)=c("Pid","race")
    race$race=as.character(race$race)
    race$race[race$race=='Race - Black/African American']='African_American'
    race$race[race$race=='Race - Asian']='Asian'
    race$race[race$race=='Race - Caucasian']='Caucasian'
    gender=dat[dat$V5==1205,c(1,7)]
    names(gender)=c("Pid","gender")
    gender$gender=as.character(gender$gender)
    gender$gender[as.character(gender$gender)=='1']='Female'
    gender$gender[as.character(gender$gender)=='2']='Male'
    height=unique(merge(dat[dat$V5==1171,c(1,4,7)], dat[dat$V5==1181,c(4,7)], by="V4")[,2:4])
    names(height)=c("Pid","height","height_unit")
    height$height=as.numeric(as.character(height$height))
    height$height[height$height_unit=="Inches" & !is.na(height$height)]=2.54*height$height[height$height_unit=="Inches" & !is.na(height$height)]
    height$height_unit="CM"
    height=unique(height[!is.na(height$height),])
    height=aggregate(height~Pid+height_unit,data=height,mean)              ###some of the patients has two height values, here use the average one
    demo=merge(merge(merge(merge(unique_id, age, by="Pid", all.x=T),race, by="Pid",all.x=T),gender, by="Pid",all.x=T),height, by="Pid",all.x=T)
    demo$age[is.na(demo$age)]=mean(demo$age,na.rm=T)
    demo$race[is.na(demo$race)]='Caucasian'
    demo$gender[is.na(demo$gender)]='UNKOWN'
    demo$race=as.factor(demo$race)
    demo$gender=as.factor(demo$gender)
    return(demo)
}

##2.2 Function to process treatment group data
treatment_group_process_fun=function(dat){
    unique_id=as.data.frame(unique(dat$V1))
    names(unique_id)=c('V1')
    group=dat[dat$V5==1454,c(1,7)]
    group_delta=dat[dat$V5==1456,c(1,7)]
    group=merge(unique_id,merge(group,group_delta,by="V1"),by='V1',all.x=T)
    names(group)=c("Pid","treatment","group_delta")
    group$group=rep("UNKONW", dim(group)[1])
    group$treatment=as.factor(toupper(as.character(group$treatment)))
    group$group_delta=as.numeric(as.character(group$group_delta))
    group$group[group$treatment=='ACTIVE' & group$group_delta<92]="ACTIVE"
    group$group[group$treatment=='PLACEBO' & group$group_delta<92]="PLACEBO"
    group$group=as.factor(group$group)
    return(group)
}

##2.3 Function to derive the ALS score related with face part muscle
face_process_fun=function(dat){
    Speech_1=dat[dat$V5==1213,c(4,7)]
    Salivation_2=dat[dat$V5==1215,c(4,7)]
    Swallowing_3=dat[dat$V5==1216,c(4,7)]
    face=merge(merge(Speech_1,Salivation_2, by="V4", all.x=T),Swallowing_3, by="V4", all.x=T)
    names(face)=c("id","Speech_1","Salivation_2","Swallowing_3")
    face$Speech_1=as.numeric(as.character(face$Speech_1))
    face$Salivation_2=as.numeric(as.character(face$Salivation_2))
    face$Swallowing_3=as.numeric(as.character(face$Swallowing_3))
    face$face=face$Speech_1+face$Salivation_2+face$Swallowing_3
    return(face)
}

##2.4 Function to derive the ALS score realted with the hand part muscle
hand_process_fun=function(dat){
    Handwriting_4=dat[dat$V5==1217,c(4,7)]
    Cutting_wo_Gastrostomy_5a=dat[dat$V5==1218,c(4,7)]
    Cutting_wo_Gastrostomy_5b=dat[dat$V5==1219,c(4,7)]
    hand=merge(merge(Handwriting_4, Cutting_wo_Gastrostomy_5a, by='V4', all.x=T),Cutting_wo_Gastrostomy_5b, by='V4',all.x=T)
    names(hand)=c("id","Handwriting_4","Cutting_wo_Gastrostomy_5a","Cutting_wo_Gastrostomy_5b")
    hand$Handwriting_4=as.numeric(as.character(hand$Handwriting_4))
    hand$Cutting_wo_Gastrostomy_5a=as.numeric(as.character(hand$Cutting_wo_Gastrostomy_5a))
    hand$Cutting_wo_Gastrostomy_5b=as.numeric(as.character(hand$Cutting_wo_Gastrostomy_5b))
    hand$Cutting_5=na_plus_fun(hand$Cutting_wo_Gastrostomy_5a,hand$Cutting_wo_Gastrostomy_5b)
    hand$hand=hand$Handwriting_4+hand$Cutting_5
    return(hand)
}

##2.5 Function to derive the ALS score related with body part muscle
body_process_fun=function(dat){
    Dressing_Hygiene_6=dat[dat$V5==1220,c(4,7)]
    Turning_in_Bed_7=dat[dat$V5==1221,c(4,7)]
    body=merge(Dressing_Hygiene_6,Turning_in_Bed_7, by='V4', all.x=T)
    names(body)=c("id","Dressing_Hygiene_6","Turning_in_Bed_7")
    body$Dressing_Hygiene_6=as.numeric(as.character(body$Dressing_Hygiene_6))
    body$Turning_in_Bed_7=as.numeric(as.character(body$Turning_in_Bed_7))
    body$body=body$Dressing_Hygiene_6+body$Turning_in_Bed_7
    return(body)
}

##2.6 Function to derive the ALS score related with leg part muscle
leg_process_fun=function(dat){
    Walking_8=dat[dat$V5==1222,c(4,7)]
    Climbing_Stairs_9=dat[dat$V5==1223,c(4,7)]
    leg=merge(Walking_8, Climbing_Stairs_9, by='V4', all.x=T)
    names(leg)=c("id","Walking_8","Climbing_Stairs_9")
    leg$Walking_8=as.numeric(as.character(leg$Walking_8))
    leg$Climbing_Stairs_9=as.numeric(as.character(leg$Climbing_Stairs_9))
    leg$leg=leg$Walking_8+leg$Climbing_Stairs_9
    return(leg)
}

##2.7 Function to derive the ALS score related with chest part muscle
chest_process_fun=function(dat){
    Respiratory=dat[dat$V5==1214,c(4,7)]
    R_1_Dyspnea=dat[dat$V5==1230,c(4,7)]
    R_2_Orthopnea=dat[dat$V5==1231,c(4,7)]
    R_3_Respiratory_Insufficiency=dat[dat$V5==1232,c(4,7)]
    chest=merge(Respiratory,R_3_Respiratory_Insufficiency, by='V4',all=T)
    names(chest)=c("id","Respiratory","R_3_Respiratory_Insufficiency")
    chest$Respiratory=as.numeric(as.character(chest$Respiratory))
    chest$R_3_Respiratory_Insufficiency=as.numeric(as.character(chest$R_3_Respiratory_Insufficiency))
    chest$Respiratory_10=na_plus_fun(chest$Respiratory,chest$R_3_Respiratory_Insufficiency)
    chest$chest=chest$Respiratory_10
    return(chest)
}

##2.8 Function to derive the ALSFRS total score 
ALSFRS_process_fun=function(dat,a,b,c,d,e){
    clinical_id=unique(dat[dat$V2==145, c(1,4)])
    ALSFRS_Delta=dat[dat$V5==1225,c(4,7)]
    ALSFRS_Total=dat[dat$V5==1228,c(4,7)]
    ALSFRS_R_Total=dat[dat$V5==1229,c(4,7)]
    R_1_Dyspnea=dat[dat$V5==1230,c(4,7)]
    R_2_Orthopnea=dat[dat$V5==1231,c(4,7)]
    R_3_Respiratory_Insufficiency=dat[dat$V5==1232,c(4,7)]
    R_score_adjusted=merge(merge(ALSFRS_R_Total,R_2_Orthopnea,by='V4'),R_3_Respiratory_Insufficiency,by='V4')
    R_score_adjusted$R_Adjusted=as.numeric(as.character(R_score_adjusted[,2]))-as.numeric(as.character(R_score_adjusted[,3]))-as.numeric(as.character(R_score_adjusted[,4]))
    ALSFRS=merge(merge(merge(clinical_id, ALSFRS_Delta, by='V4', all.x=T), ALSFRS_Total, by='V4', all.x=T),R_score_adjusted[,c(1,5)], by='V4',all.x=T)
    names(ALSFRS)=c("id","Pid", "ALSFRS_Delta", "ALSFRS", "ALSFRS_R")
    ALSFRS$ALSFRS_Delta=as.numeric(as.character(ALSFRS$ALSFRS_Delta))
    ALSFRS$ALSFRS=as.numeric(as.character(ALSFRS$ALSFRS))
    ALSFRS$ALSFRS_R=as.numeric(as.character(ALSFRS$ALSFRS_R))
  

    ALSFRS$ALSFRS[is.na(ALSFRS$ALSFRS)]=0
    ALSFRS$ALSFRS_R[is.na(ALSFRS$ALSFRS_R)]=0
    ALSFRS=transform(ALSFRS,ALSFRS_comb=ALSFRS+ALSFRS_R)

    ALSFRS=ALSFRS[ALSFRS$ALSFRS_Delta<92,]
    ALSFRS=ALSFRS[!is.na(ALSFRS$Pid),]
    ALSFRS=merge(merge(merge(merge(merge(ALSFRS,a,by="id"),b,by="id"),c,by="id"),d,by="id"),e,by="id")
    
    return(ALSFRS)
}

##2.9 Function to caculate the slope based on the three month score. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one score, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)

cal_three_month_slope_fun=function(dat){
   dat=dat[!is.na(dat$ALSFRS_comb),]
   dat=dat[!is.na(dat$ALSFRS_Delta),]
   a=rep(NA, length(unique(dat$Pid)))
   b=rep(NA, length(unique(dat$Pid)))
   c=rep(NA, length(unique(dat$Pid)))
   d=rep(NA, length(unique(dat$Pid)))
   face=rep(NA, length(unique(dat$Pid)))
   hand=rep(NA, length(unique(dat$Pid)))
   body=rep(NA, length(unique(dat$Pid)))
   leg=rep(NA, length(unique(dat$Pid)))
   chest=rep(NA, length(unique(dat$Pid)))
   Speech_1=rep(NA, length(unique(dat$Pid)))
   Salivation_2=rep(NA, length(unique(dat$Pid)))
   Swallowing_3=rep(NA, length(unique(dat$Pid)))
   Handwriting_4=rep(NA, length(unique(dat$Pid)))
   Cutting_5=rep(NA, length(unique(dat$Pid)))
   Dressing_Hygiene_6=rep(NA, length(unique(dat$Pid)))
   Turning_in_Bed_7=rep(NA, length(unique(dat$Pid)))
   Walking_8=rep(NA, length(unique(dat$Pid)))
   Climbing_Stairs_9=rep(NA, length(unique(dat$Pid)))
   Respiratory_10=rep(NA, length(unique(dat$Pid)))
   face_slope=rep(NA, length(unique(dat$Pid)))
   hand_slope=rep(NA, length(unique(dat$Pid)))
   body_slope=rep(NA, length(unique(dat$Pid)))
   leg_slope=rep(NA, length(unique(dat$Pid)))
   chest_slope=rep(NA, length(unique(dat$Pid)))

   for (i in (1:length(unique(dat$Pid)))){
    min_delta=min(dat$ALSFRS_Delta[dat$Pid==unique(dat$Pid)[i]],na.rm=T)
       max_delta=max(dat$ALSFRS_Delta[dat$Pid==unique(dat$Pid)[i]],na.rm=T)
       min_score=dat$ALSFRS_comb[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==min_delta]
       max_score=dat$ALSFRS_comb[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       face[i]=dat$face[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       face_min=dat$face[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==min_delta]
       hand[i]=dat$hand[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       hand_min=dat$hand[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==min_delta]
       body[i]=dat$body[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       body_min=dat$body[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==min_delta]
       leg[i]=dat$leg[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       leg_min=dat$leg[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==min_delta]
       chest[i]=dat$chest[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       chest_min=dat$chest[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==min_delta]
       Speech_1[i]=dat$Speech_1[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Salivation_2[i]=dat$Salivation_2[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Swallowing_3[i]=dat$Swallowing_3[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Handwriting_4[i]=dat$Handwriting_4[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Cutting_5[i]=dat$Cutting_5[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Dressing_Hygiene_6[i]=dat$Dressing_Hygiene_6[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Turning_in_Bed_7[i]=dat$Turning_in_Bed_7[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Walking_8[i]=dat$Walking_8[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Climbing_Stairs_9[i]=dat$Climbing_Stairs_9[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]
       Respiratory_10[i]=dat$Respiratory_10[dat$Pid==unique(dat$Pid)[i] & dat$ALSFRS_Delta==max_delta]  
       b[i]=max_score
       c[i]=min_score
       face_slope[i]=(face[i]-face_min)/((max_delta-min_delta+1)/365.24*12)
       hand_slope[i]=(hand[i]-hand_min)/((max_delta-min_delta+1)/365.24*12)
       body_slope[i]=(body[i]-body_min)/((max_delta-min_delta+1)/365.24*12)
       leg_slope[i]=(leg[i]-leg_min)/((max_delta-min_delta+1)/365.24*12)
       chest_slope[i]=(chest[i]-chest_min)/((max_delta-min_delta+1)/365.24*12)


       if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           next
          }
      else{  
           lm_fit=lm(ALSFRS_comb~ALSFRS_Delta,data=dat[dat$Pid==unique(dat$Pid)[i],])
           a[i]=lm_fit$coefficients[2]*365.24/12
           d[i]=sqrt(deviance(lm_fit)/df.residual(lm_fit))
          
          }

   }

   rslt=as.data.frame(cbind(unique(dat$Pid), a,b,c,d,face,hand,body,leg,chest,face_slope,hand_slope,body_slope,leg_slope,chest_slope
                                        ,Speech_1,Salivation_2,Swallowing_3,Handwriting_4,Cutting_5,Dressing_Hygiene_6,Turning_in_Bed_7,Walking_8,Climbing_Stairs_9,Respiratory_10))
   names(rslt)=c("Pid","three_m_slope","score_three_month","first_score", "MSE_three_m_slope", "face","body","hand","leg","chest","face_three_m_slope","hand_three_m_slope"
              ,"body_three_m_slope","leg_three_m_slope","chest_three_m_slope","Speech_1","Salivation_2","Swallowing_3","Handwriting_4","Cutting_5","Dressing_Hygiene_6"
              ,"Turning_in_Bed_7","Walking_8","Climbing_Stairs_9","Respiratory_10")
   rslt$score_three_month_26_abs=abs(rslt$score_three_month-26)
   return(rslt) 
}

## 2.10 Function to get the data for the onset information of the patients: onset delta, onset_site. 
##      For the patients whose onset site is missing, use the mode of this categorical variable ("Limb") to impute. 
onset_process_fun=function(dat){
    onset_delta=unique(dat[dat$V5==1417,c(1,7)])
    names(onset_delta)=c("Pid","onset_delta")
    onset_delta$onset_delta=as.numeric(as.character(onset_delta$onset_delta))
    onset_delta$onset_delta_log=log(-onset_delta$onset_delta)

    onset_site=dat[dat$V5==1416,c(1,7)]
    names(onset_site)=c("Pid","onset_site")
    onset_site$onset_site=as.character(onset_site$onset_site)
    onset_site$onset_site[onset_site$onset_site=='Onset: Bulbar']='Bulbar'
    onset_site$onset_site[onset_site$onset_site=='Onset: Limb']='Limb'
    onset_site$onset_site[onset_site$onset_site=='Onset: Limb and Bulbar']='Both'
    onset_site$onset_site[onset_site$onset_site=='1']='Bulbar'
    onset_site$onset_site[onset_site$onset_site=='3']='Limb'
    onset_site$onset_site[is.na(onset_site$onset_site)]='Limb'

    diag_delta=dat[dat$V5==1418,c(1,7)]
    names(diag_delta)=c("Pid", "diag_delta")
    diag_delta$diag_delta=as.numeric(as.character(diag_delta$diag_delta))

    onset=merge(merge(onset_delta,onset_site, by="Pid"),diag_delta, by="Pid",all.x=T)
    onset$onset_site=as.factor(onset$onset_site)
    onset$onset_diag_delta_diff=onset$diag_delta-onset$onset_delta
    onset$onset_diag_missing_ind=0
    onset$onset_diag_missing_ind[is.na(onset$onset_diag_delta_diff)]=1
    return(onset)
}

## 2.11 Function to get the data for the family disease information of the patients, two variables are defined here. 
##      (1) ALS_ind: 1 if any family member has got ALS before, 0 otherwise;
##      (2) neuro_ind: 1 if any family member has got neurological disease before, 0 otherwise;
family_hist_process_fun=function(dat){
    unique_pid=as.data.frame(unique(dat$V1))
    names(unique_pid)=c("Pid")
    als_pid=as.data.frame(unique(dat$V1[dat$V5==1419 & dat$V7=='ALS']))
    als_pid$als_ind=1
    names(als_pid)=c("Pid","als_ind")
    neuro_disease_pid=as.data.frame(unique(dat$V1[dat$V5==1419]))
    neuro_disease_pid$neuro_disease_ind=1
    names(neuro_disease_pid)=c("Pid","neuro_disease_ind")
    family_hist=merge(merge(unique_pid, als_pid, by="Pid", all.x=T), neuro_disease_pid, by="Pid", all.x=T)
    family_hist$als_ind[is.na(family_hist$als_ind)]=0
    family_hist$neuro_disease_ind[is.na(family_hist$neuro_disease_ind)]=0
    return(family_hist)
}


## 2.12 Function to get the data for the vital RR (Respiratory Rate) information of the patients. 
RR_process_fun=function(dat){
    RR=dat[dat$V5==1176,c(4,7)]
    RR_delta=dat[dat$V5==1174,c(1,4,7)]
    RR=merge(RR_delta,RR,by="V4")
    names(RR)=c("id","Pid","RR_delta","RR")
    RR$RR_delta=as.numeric(as.character(RR$RR_delta))
    RR$RR=as.numeric(as.character(RR$RR))
    RR=RR[!is.na(RR$RR) & !is.na(RR$RR_delta) & RR$RR_delta<92,]
    return(RR)
}

## 2.13 Function to caculate the slope of RR (Respiratory Rate) of the patients, two variables are defined here. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one score, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)
cal_RR_slope_fun=function(dat){
 a=rep(NA, length(unique(dat$Pid)))
 b=rep(NA, length(unique(dat$Pid)))
 d=rep(NA, length(unique(dat$Pid)))
  for (i in (1:length(unique(dat$Pid)))){
      b[i]=mean(dat$RR[dat$Pid==unique(dat$Pid)[i]],na.rm=T)
      if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           ##a[i]=0
           next
          }
      else{  
           lm_fit=lm(RR~RR_delta,data=dat[dat$Pid==unique(dat$Pid)[i],])
           a[i]=lm_fit$coefficients[2]*365.24/12
           d[i]=sqrt(deviance(lm_fit)/df.residual(lm_fit))     
          }
  }
  c=as.data.frame(cbind(unique(dat$Pid), a,b,d))
  names(c)=c("Pid","RR_slope", "avg_RR", "MSE_RR_slope")
  c$RR_slope[is.na(c$RR_slope)]=0
  return(c)
}

## 2.14 Function to get the data for the pulse rate information of the patients 
pulse_process_fun=function(dat){
    pulse=dat[dat$V5==1175,c(4,7)]
    pulse_delta=dat[dat$V5==1174,c(1,4,7)]
    pulse=merge(pulse_delta,pulse,by="V4")
    names(pulse)=c("id","Pid","pulse_delta","pulse")
    pulse$pulse_delta=as.numeric(as.character(pulse$pulse_delta))
    pulse$pulse=as.numeric(as.character(pulse$pulse))
    pulse=pulse[!is.na(pulse$pulse) & !is.na(pulse$pulse_delta) & pulse$pulse_delta<92,]
    return(pulse)
}

## 2.15 Function to caculate the slope of pulse rate of the patients. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one score, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)
cal_pulse_slope_fun=function(dat){
  a=rep(NA, length(unique(dat$Pid)))
  b=rep(NA, length(unique(dat$Pid)))
  d=rep(NA, length(unique(dat$Pid)))
  for (i in (1:length(unique(dat$Pid)))){
      b[i]=mean(dat$pulse[dat$Pid==unique(dat$Pid)[i]],na.rm=T)
      if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           ##a[i]=0
           next
          }
      else{  
            lm_fit=lm(pulse~pulse_delta,data=dat[dat$Pid==unique(dat$Pid)[i],])
            a[i]=lm_fit$coefficients[2]*365.24/12
            d[i]=sqrt(deviance(lm_fit)/df.residual(lm_fit))             
          }
  }
  c=as.data.frame(cbind(unique(dat$Pid), a,b,d))
  names(c)=c("Pid","pulse_slope", "avg_pulse","MSE_pulse_slope")
  c$pulse_slope[is.na(c$pulse_slope)]=0
  return(c)
}



## 2.16 Function to derive the data for the fvc(forced vital capacity) from the original data. 
fvc_process_fun=function(dat){
    fvc=merge(merge(merge(dat[dat$V5==1185,c(1,4,7)], dat[dat$V5==1405,c(4,7)], by="V4",all.x=T), dat[dat$V5==1190,c(4,7)],by="V4",all.x=T),dat[dat$V5==1188,c(4,7)],by="V4",all.x=T)[,c(2:6)]
    names(fvc)=c("Pid","fvc_value","fvc_unit","fvc_delta","fvc_normal")
    fvc$fvc_value=as.numeric(as.character(fvc$fvc_value))
    fvc$fvc_delta=as.numeric(as.character(fvc$fvc_delta))
    fvc$fvc_normal=as.numeric(as.character(fvc$fvc_normal))
    fvc$ratio=fvc$fvc_value/fvc$fvc_normal
    fvc=fvc[fvc$fvc_delta<92 & !is.na(fvc$Pid) & !is.na(fvc$fvc_delta) & !is.na(fvc$fvc_value),]
    fvc=fvc[!is.na(fvc$fvc_delta),]
    fvc=fvc[!is.na(fvc$fvc_value),]
    return(fvc)
}

## 2.17 Function to derive the data for the svc(slow vital capacity) from the original data. 
svc_process_fun=function(dat){
    svc=merge(dat[dat$V5==1262,c(1,4,7)], dat[dat$V5==1267,c(4,7)], by="V4", all=T)[,2:4]
    names(svc)=c("Pid","svc_value","svc_delta")
    svc$svc_value=as.numeric(as.character(svc$svc_value))
    svc$svc_delta=as.numeric(as.character(svc$svc_delta))
    svc=svc[svc$svc_delta<92,]
    svc=svc[!is.na(svc$svc_delta),]
    svc=svc[!is.na(svc$svc_value),]
    return(svc)
}

## 2.18 Function to caculate the slope of fvc rate change of the patients. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one data point before three month, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)
cal_slope_fvc_fun=function(dat){
  a=rep(NA, length(unique(dat$Pid)))
  d=rep(NA, length(unique(dat$Pid)))
  for (i in (1:length(unique(dat$Pid)))){
      if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           ##a[i]=0
           next
          }
      else{  
           lm_fit=lm(fvc_value~fvc_delta,data=dat[dat$Pid==unique(dat$Pid)[i],])
           a[i]=lm_fit$coefficients[2]*365.24/12
            d[i]=sqrt(deviance(lm_fit)/df.residual(lm_fit))
          }
  }
  c=as.data.frame(cbind(unique(dat$Pid), a, d))
  names(c)=c("Pid","fvc_slope", "MSE_fvc_slope")
  ##c$fvc_slope[is.na(c$fvc_slope)]=0
  return(c)
}

## 2.19 Function to caculate the slope of svc rate change of the patients. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one data point before three month, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)
cal_slope_svc_fun=function(dat){
  a=rep(NA, length(unique(dat$Pid)))
  d=rep(NA, length(unique(dat$Pid)))
  for (i in (1:length(unique(dat$Pid)))){
      if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           ##a[i]=0
           next
          }
      else{  
          lm_fit=lm(svc_value~svc_delta,data=dat[dat$Pid==unique(dat$Pid)[i],])
          a[i]=lm_fit$coefficients[2]*365.24/12
          d[i]=sqrt(deviance(lm_fit)/df.residual(lm_fit))
          }
  }
  c=as.data.frame(cbind(unique(dat$Pid), a,d))
  names(c)=c("Pid","svc_slope","MSE_svc_slope")
  ##c$svc_slope[is.na(c$svc_slope)]=0
  return(c)
}

## 2.20 Function to combine the fvc_slope with svc_slope. vc_slope=fvc_slope if fvc_slope is available, otherwise svc_slope.
comb_vc_slope_fun=function(dat,dat1,dat2){
    unique_pid=as.data.frame(unique(dat$V1))
    names(unique_pid)=c("Pid")
    c=merge(dat1,dat2,by="Pid",all=T)
    c$fvc_ind=1
    c$fvc_ind[is.na(c$fvc_slope)]=0
    c$vc_slope=na_plus_fun(c$fvc_slope,c$svc_slope)
    c=merge(unique_pid,c,by="Pid",all.x=T)
    return(c)
}

## 2.21 Function to derive the weight data from original dataset and convert it to the same unit.  
weight_process_fun=function(dat){
    weight=merge(merge(dat[dat$V5==1178,c(1,4,7)],dat[dat$V5==1180,c(4,7)], by="V4", all.x=T), dat[dat$V5==1174,c(4,7)], by="V4")[,2:5]
    names(weight)=c("Pid","weight","weight_unit","weight_delta")
    weight$weight=as.numeric(as.character(weight$weight))
    weight$weight_delta=as.numeric(as.character(weight$weight_delta))
    weight$weight_unit=as.character(weight$weight_unit)
    weight=weight[weight$weight_delta<92 & !is.na(weight$weight) & !is.na(weight$weight_delta) & !is.na(weight$weight_unit),]
    ##weight$weight[weight$weight_unit=="Pounds" & !is.na(weight$weight)]=weight$weight[weight$weight_unit=="Pounds" & !is.na(weight$weight)]*0.453592
    weight$weight[weight$weight_unit=="Pounds"]=weight$weight[weight$weight_unit=="Pounds"]*0.453592
    weight$weight_unit="Kilograms"
    return(weight)
}

## 2.22 Function to caculate the slope of weight change of the patients. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one data point before three month, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)
cal_weight_slope_fun=function(dat){
 a=rep(NA, length(unique(dat$Pid)))
 b=rep(NA, length(unique(dat$Pid)))
 d=rep(NA, length(unique(dat$Pid)))
  for (i in (1:length(unique(dat$Pid)))){
      b[i]=mean(dat$weight[dat$Pid==unique(dat$Pid)[i]],na.rm=T)
      if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           next
          }
      else{  
          lm_fit=lm(weight~weight_delta,data=dat[dat$Pid==unique(dat$Pid)[i],])
          a[i]=lm_fit$coefficients[2]*365.24/12
          d[i]=sqrt(deviance(lm_fit)/df.residual(lm_fit))
          }
  }
  c=as.data.frame(cbind(unique(dat$Pid), a,b,d))
  names(c)=c("Pid","weight_slope", "avg_weight","MSE_weight_slope")
  c$weight_percentage_slope=c$weight_slope/c$avg_weight
  return(c)
}


## 2.23 Function to caculate the slope of BMI (BMI=weight(kg)/height(m)^2) change of the patients. 
##    (1) Slope is defined as the coefficients of a fitted line. 
##    (2) Use MSE (mean square error to measure the fitness and consistency of the score before three month. 
##    (3) For the patients with just one data point before three month, the slope is set to be missing (will be imputed by the average of the three month slope for all the 
##        patients at the final step of data processing.)
cal_BMI_slope_fun=function(dat1,dat2){
 a=rep(NA, length(unique(dat$Pid)))
 b=rep(NA, length(unique(dat$Pid)))
 dat=merge(dat1,dat2, by="Pid")
 dat$BMI=dat$weight/(dat$height)^2
  for (i in (1:length(unique(dat$Pid)))){
      b[i]=mean(dat$BMI[dat$Pid==unique(dat$Pid)[i]],na.rm=T)
      if (dim(dat[dat$Pid==unique(dat$Pid)[i],])[1]==1) {
           a[i]=0
           next
          }
      else{  
           a[i]=(mean(dat$weight[dat$Pid==unique(dat$Pid)[i]]*dat$weight_delta[dat$Pid==unique(dat$Pid)[i]])
                 -mean(dat$weight[dat$Pid==unique(dat$Pid)[i]])*mean(dat$weight_delta[dat$Pid==unique(dat$Pid)[i]]))/var((dat$weight_delta[dat$Pid==unique(dat$Pid)[i]]))*365.24/12

          }
  }
  c=as.data.frame(cbind(unique(dat$Pid), a,b))
  names(c)=c("Pid","weight_slope", "avg_weight")
  c$weight_percentage_slope=c$weight_slope/c$avg_weight
  return(c)
}

## 2.24 Function to caculate the average test value of the uric acid test in the first three month.  
uric_acid_process_fun=function(dat){
    unique_pid=as.data.frame(unique(dat$V1))
    names(unique_pid)=c("Pid")
    clincial_id=dat[dat$V5==1250 & dat$V7=='Uric Acid', c(4,1)] 
    names(clincial_id)=c("clincial_id","Pid")
    test_delta=dat[dat$V5==1234, c(4,7)]
    names(test_delta)=c("clincial_id","uric_acid_test_delta")
    test_value=dat[dat$V5==1251, c(4,7)]
    names(test_value)=c("clincial_id","uric_acid_test_value")
    uric_acid=merge(merge(clincial_id, test_delta, by="clincial_id"), test_value, by="clincial_id")[,c(2:4)]
    uric_acid$uric_acid_test_delta=as.numeric(as.character(uric_acid$uric_acid_test_delta))
    uric_acid$uric_acid_test_value=as.numeric(as.character(uric_acid$uric_acid_test_value))
    uric_acid=uric_acid[uric_acid$uric_acid_test_delta<92,]
    uric_acid=tapply(uric_acid$uric_acid_test_value, uric_acid$Pid, mean)
    mean_uric_acid=as.data.frame(cbind(as.numeric(names(uric_acid)), as.numeric(uric_acid)))
    names(mean_uric_acid)=c("Pid","uric_acid_value")
    mean_uric_acid=merge(unique_pid, mean_uric_acid, by="Pid", all.x=T)
    mean_uric_acid$uric_acid_value_missing_ind[is.na(mean_uric_acid$uric_acid_value)]=1
    mean_uric_acid$uric_acid_value_missing_ind[!is.na(mean_uric_acid$uric_acid_value)]=0
    mean_uric_acid$uric_acid_value[is.na(mean_uric_acid$uric_acid_value)]=0
    return(mean_uric_acid)
}

## 2.25 Function to derive the average sodium lab test value from the first 3 months. 
sodium_process_fun=function(dat){
    unique_pid=as.data.frame(unique(dat$V1))
    names(unique_pid)=c("Pid")
    clincial_id=dat[dat$V5==1250 & dat$V7=='Sodium', c(4,1)] 
    names(clincial_id)=c("clincial_id","Pid")
    test_delta=dat[dat$V5==1234, c(4,7)]
    names(test_delta)=c("clincial_id","sodium_test_delta")
    test_value=dat[dat$V5==1251, c(4,7)]
    names(test_value)=c("clincial_id","sodium_test_value")
    sodium=merge(merge(clincial_id, test_delta, by="clincial_id"), test_value, by="clincial_id")[,c(2:4)]
    sodium$sodium_test_delta=as.numeric(as.character(sodium$sodium_test_delta))
    sodium$sodium_test_value=as.numeric(as.character(sodium$sodium_test_value))
    sodium=sodium[sodium$sodium_test_delta<92,]
    sodium=tapply(sodium$sodium_test_value, sodium$Pid, mean)
    mean_sodium=as.data.frame(cbind(as.numeric(names(sodium)), as.numeric(sodium)))
    names(mean_sodium)=c("Pid","sodium")
    mean_sodium=merge(unique_pid, mean_sodium, by="Pid", all.x=T)
    mean_sodium$sodium[is.na(mean_sodium$sodium)]=mean(mean_sodium$sodium, na.rm=T)
    return(mean_sodium)    
}

## 2.26 Function to comb all the available variable into a master table
dat_comb_fun=function(dat1,dat2,dat3,dat4,dat5,dat6,dat7,dat8,dat9,dat10,dat11){
    c=merge(merge(merge(merge(merge(merge(merge(merge(merge(merge(dat1,dat2,by="Pid",all=T),dat3,by="Pid", all=T),dat4,by="Pid", all=T),dat5,by="Pid",all=T)
       ,dat6,by="Pid",all=T),dat7,by="Pid",all=T),dat8,by="Pid",all=T),dat9, by="Pid",all=T),dat10,by="Pid",all=T),dat11,by="Pid",all=T)
    c$onset_slope=(40-c$first_score)/(c$onset_delta/365.24*12)
    c$onset_age=c$age+c$onset_delta/365
    c$BMI=c$avg_weight/(c$height/100)^2
    c$BMI_missing_ind=0
    c$BMI_missing_ind[is.na(c$BMI)]=1
    c$BMI[is.na(c$BMI)]=0
    c$score_three_month_log=log(c$score_three_month)
    c$RR_missing_ind=0
    c$RR_missing_ind[is.na(c$avg_RR)]=1
    c$pulse_missing_ind=0
    c$pulse_missing_ind[is.na(c$avg_pulse)]=1
    return(c)
}

#### 3 caculate score for cross validation training part
cal_score_fun=function(x,pred_col,actual_col){
    RMSD=sqrt(sum((x[pred_col]-x[actual_col])^2)/dim(x)[1])
    correlation=cor(x[pred_col], x[actual_col], method= c("pearson"))
    ls=list(RMSD, correlation)
    return(ls)
}

# last modified 2009-11-11 by J. Fox

av.plot <- function (...) {
	.Deprecated("avPlot", package="car")
	avPlot(...)
}

av.plots <- function (...) {
	.Deprecated("avPlots", package="car")
	avPlots(...)
}

box.cox <- function (...) {
	.Deprecated("bcPower", package="car")
	bcPower(...)
}

bc <- function (...) {
	.Deprecated("bcPower", package="car")
	bcPower(...)
}

box.cox.powers <- function (...) {
	.Deprecated("powerTransform", package="car")
	powerTransform(...)
}

box.cox.var <- function (...) {
	.Deprecated("boxCoxVariable", package="car")
	boxCoxVariable(...)
}

box.tidwell <- function (...) {
	.Deprecated("boxTidwell", package="car")
	boxTidwell(...)
}

ceres.plot <- function (...) {
	.Deprecated("ceresPlot", package="car")
	ceresPlot(...)
}

ceres.plots <- function (...) {
	.Deprecated("ceresPlots", package="car")
	ceresPlots(...)
}

confidence.ellipse <- function (...) {
	.Deprecated("confidenceEllipse", package="car")
	confidenceEllipse(...)
}

cookd <- function (...) {
	.Deprecated("cooks.distance", package="stats")
	cooks.distance(...)
}

cr.plot <- function (...) {
	.Deprecated("crPlot", package="car")
	crPlot(...)
}

cr.plots <- function (...) {
	.Deprecated("crPlots", package="car")
	crPlots(...)
}

data.ellipse <- function (...) {
	.Deprecated("dataEllipse", package="car")
	dataEllipse(...)
}

durbin.watson <- function (...) {
	.Deprecated("durbinWatsonTest", package="car")
	durbinWatsonTest(...)
}

levene.test <- function (...) {
	.Deprecated("leveneTest", package="car")
	leveneTest(...)
}

leverage.plot <- function (...) {
	.Deprecated("leveragePlot", package="car")
	leveragePlot(...)
}

leverage.plots <- function (...) {
	.Deprecated("leveragePlots", package="car")
	leveragePlots(...)
}

linear.hypothesis <- function (...) {
	.Deprecated("linearHypothesis", package="car")
	linearHypothesis(...)
}

outlier.test <- function (...) {
	.Deprecated("outlierTest", package="car")
	outlierTest(...)
}

ncv.test <- function (...) {
	.Deprecated("ncvTest", package="car")
	ncvTest(...)
}

qq.plot <- function (...) {
	.Deprecated("qqPlot", package="car")
	qqPlot(...)
}

scatterplot.matrix <- function (...) {
	.Deprecated("scatterplotMatrix", package="car")
	scatterplotMatrix(...)
}

spread.level.plot <- function (...) {
	.Deprecated("spreadLevelPlot", package="car")
	spreadLevelPlot(...)
}

# Dependencies
# source("Code/get_alsfrs_data.R")
# source("Code/slopes.R")
# source("Code/write_predictions.R")

GroundTruthTrain <- function(train.name="",target=NULL,args=list()) {
	# Returns a function that predicts the ground-truth (that is, future) slope for 
	# each subject in the dataset.
	#
	# Args:
	#	train.name: (unused) base name of training dataset
	#	target: (unused) target vector; if NULL, future slopes are used as target
	#	args: (unused) list of additional arguments
	#
	# Returns:
	#	A function that predicts the ground-truth given a test name
	#
	# Example usage:
	#	model <- GroundTruthTrain()
	#	predictions<-model("test")
	
	GroundTruthPredict<-function(test.name="test",save.preds=TRUE) {
	# Returns the true future slopes of a test set
	#
	# Args:
	#	test.name: name of dataset
	#	save.preds: save predictions to file? TRUE by default
	#
	# Returns:
	#	Two column matrix, ordered by the first column, with first column 
	#   "subject.id" containing test set subject ids and the second column 
	#   "prediction" containing predicted slopes.
	#
	# Side effects:
	#	Saves predictions to file
		
		# Get alsfrs test data
		data <- GetAlsfrsData(test.name)

		# Get future slopes for each subject
		predictions <- cbind(sort(unique(data$subject.id)), Slopes(data,3,12,"f"))
		colnames(predictions) <- c("subject.id","prediction")
	
		if(save.preds) {
			# Write predictions to file
			out.file = paste("Predictions/GroundTruth-",test.name,".txt",sep="")
			WritePredictions(predictions, out.file)
		}
	
		return(predictions)
	}
	
	return(GroundTruthPredict)
}

setRefClass(Class = "LinearModel")

#' GlmnetModel
#' 
#' Wrapper for elastic net model implemented by glmnet, allowing cv.glmnet to implement the PredictiveModel API
#'
#' @seealso caret
#' @author Adam Margolin
#' @export

GlmnetModel <- setRefClass(Class = "GlmnetModel",
                           contains="LinearModel",
                           fields=c("model","family"),
                           
                           methods = list(
                             initialize = function(family="gaussian", ...){
                               .self$family=family
                               return(.self)
                             },
                             
                             customTrain = function(featureData, responseData,  ...){
                                .self$model <- cv.glmnet(featureData,responseData, family=.self$family, ...)
                             },
                             
                             customPredict = function(featureData){
                               predictedResponse <- predict(.self$model, featureData, s="lambda.min")
                               return(predictedResponse)
                             },
                             
                           
                             getCoefficients = function(){
                               return(coef(.self$model,s = "lambda.min"))                             
                             }
                             )
                           )

# recode function (J. Fox)
# last modified 2014-08-04 by J. Fox

recode <- function(var, recodes, as.factor.result, as.numeric.result=TRUE, levels){
  lo <- -Inf
  hi <- Inf
	recodes <- gsub("\n|\t", " ", recodes)
	recode.list <- rev(strsplit(recodes, ";")[[1]])
	is.fac <- is.factor(var)
	if (missing(as.factor.result)) as.factor.result <- is.fac
	if (is.fac) var <- as.character(var)
	result <- var
	for (term in recode.list){
		if (0 < length(grep(":", term))) {
			range <- strsplit(strsplit(term, "=")[[1]][1],":")
			low <- try(eval(parse(text=range[[1]][1])), silent=TRUE)
            if (class(low) == "try-error"){
                stop("\n  in recode term: ", term, 
                    "\n  message: ", low)
            }
			high <- try(eval(parse(text=range[[1]][2])), silent=TRUE)
		    if (class(high) == "try-error"){
		        stop("\n  in recode term: ", term, 
		            "\n  message: ", high)
		    }
			target <- try(eval(parse(text=strsplit(term, "=")[[1]][2])), silent=TRUE)
		    if (class(target) == "try-error"){
		        stop("\n  in recode term: ", term, 
		            "\n  message: ", target)
		    }
			result[(var >= low) & (var <= high)] <- target
		}
		else if (0 < length(grep("^else=", squeezeBlanks(term)))) {
			target <- try(eval(parse(text=strsplit(term, "=")[[1]][2])), silent=TRUE)
		    if (class(target) == "try-error"){
		        stop("\n  in recode term: ", term, 
		            "\n  message: ", target)
		    }
			result[1:length(var)] <- target
		}
		else {
			set <- try(eval(parse(text=strsplit(term, "=")[[1]][1])), silent=TRUE)
		    if (class(set) == "try-error"){
		        stop("\n  in recode term: ", term, 
		            "\n  message: ", set)
		    }
			target <- try(eval(parse(text=strsplit(term, "=")[[1]][2])), silent=TRUE)
		    if (class(target) == "try-error"){
		        stop("\n  in recode term: ", term, 
		            "\n  message: ", target)
		    }
			for (val in set){
				if (is.na(val)) result[is.na(var)] <- target
				else result[var == val] <- target
			}
		}
	}
	if (as.factor.result) {
		result <- if (!missing(levels)) factor(result, levels=levels) 
			else as.factor(result)
	}
	else if (as.numeric.result && (!is.numeric(result))) {
		result.valid <- na.omit(result)
		opt <- options("warn"=-1)
		result.valid <- as.numeric(result.valid)
		options(opt)
		if (!any(is.na(result.valid))) result <- as.numeric(result)
	}
	result
}

Recode <- function (...) car::recode(...)

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

plot.variable.rsf <- function(
    x,# 
    plots.per.page = 4,#
    granule = 5,#
    sorted = TRUE,#
    type = c("mort", "rel.freq", "surv", "time")[1],#
    partial = FALSE,#
    predictorNames = NULL,#
    npred = NULL,#                 
    npts = 25,#
    subset = NULL,#
    percentile = 50,#
    ...) {
    object <- x
    rm(x)
    if (sum(inherits(object, c("rsf", "grow"), TRUE) == c(1, 2)) != 2 &
        sum(inherits(object, c("rsf", "predict"), TRUE) == c(1, 2)) != 2)
      stop("Function only works for objects of class `(rsf, grow)', '(rsf, predict)'.")
    if (type != "mort" & type != "rel.freq" & type != "surv" & type != "time")
      stop("Invalid choice for 'type:  ", type)
    if (!partial & type == "time") stop("Type 'time' can only be used for partial plots.")
    n.event  <- length(unique(na.omit(object$cens)[na.omit(object$cens) > 0]))
    if (n.event > 1) object$ensemble <- object$ensemble[,,1]
    if (!is.null(subset) & length(unique(subset)) != 0) {
      subset <- subset[subset >=1 & subset <= dim(object$predictors)[1]]
      subset <- unique(subset)
      if (length(subset) == 0) stop("'subset' not set properly.")
      if (length(subset) > 1) {
        object$predictors <- object$predictors[subset, ]
      }
      else {
        object$predictors <- t(as.matrix(object$predictors[subset, ]))
      }
      object$mortality <- object$mortality[subset]
      if (sum(subset) > 1) {
        object$ensemble <- object$ensemble[subset, ]
      }
      else {
        object$ensemble <- t(as.matrix(object$ensemble[subset, ]))
      }
    }
    predictors <- object$predictors
    if (!is.null(object$imputedIndv)) predictors[object$imputedIndv, ] <- object$imputedData[, -c(1:2)]
    if (is.null(predictorNames)) {
      cov.names <- object$predictorNames
    }
    else {
      cov.names <- predictorNames
      if (sum(is.element(object$predictorNames, cov.names)) == 0){
        stop("Coefficient list does not match available predictors:\n", object$predictorNames)
      }
      cov.names <- unique(cov.names[is.element(cov.names, object$predictorNames)])
    }
    n.cov <- length(cov.names)
    if (sorted) {
      if (!is.null(object$importance)) {
        n.cov <- length(cov.names)
        cov.imp <- rep(0, n.cov)
        if (n.event == 1) covImp <- object$importance else covImp <- object$importance[1,]
        for (k in 1:n.cov) {
          cov.imp[k] <- covImp[object$predictorNames == cov.names[k]]
        }
        cov.names <- cov.names[rev(order(cov.imp))]
      }
    }
    if (!is.null(npred)) {
      npred <- max(round(npred), 1)
      n.cov <- min(length(cov.names), npred)
      cov.names <- cov.names[1:n.cov]
    }
    n <- dim(predictors)[1]
    old.par <- par(no.readonly = TRUE)
    if (type == "mort") {
      ylabel <- "mortality"
    }
    else if (type == "rel.freq") {
      ylabel <- "standardized mortality"
    }
    else if (type == "surv") {
      ylabel <- "predicted survival"
    }
    else {
      ylabel <- "predicted survival time"
    }
    if (percentile > 1) percentile <- percentile/100
    if (percentile < 0 || percentile > 1) percentile = 0.5
    if (!partial) {
      if (n > 500) cex <- 0.5 else cex <- 0.75
      plots.per.page <- max(round(min(plots.per.page,n.cov)), 1)
      granule <- max(round(granule),1)
      par(mfrow = c(min(plots.per.page, ceiling(n.cov/plots.per.page)), plots.per.page))
      if (type == "mort") {
        yhat <- object$mortality
      }
      else if (type == "rel.freq") {
        yhat <- object$mortality/max(n, na.omit(object$mortality))
      }
      else {
        yhat <-
          100*exp(-object$ensemble[ , max(which(object$timeInterest <=
                         quantile(object$time, probs = percentile, na.rm = TRUE)))])
      }
      for (k in 1:n.cov) {
        x <- predictors[, object$predictorNames == cov.names[k]]
        x.uniq <- unique(x)
        n.x <- length(x.uniq)
        if (!is.factor(x) & n.x > granule) {
            plot(x,
                 yhat,
                 xlab = cov.names[k],
                 ylab = ylabel,
                 type = "n",
                 cex.lab = 1.5)
            points(x[object$cens == 1], yhat[object$cens == 1],
                   pch = 16, col = 4, cex = cex)
            points(x[object$cens==0], yhat[object$cens == 0],
                   pch = 16, cex = cex)
            lines(lowess(x[!is.na(x)], yhat[!is.na(x)]), col = 2, lwd=3)
        }
        else {
          if (is.factor(x)) x <- factor(x, exclude = NULL)          
          boxplot(yhat ~ x, na.action = "na.omit",
                    xlab = cov.names[k],
                    ylab = ylabel,
                    notch = TRUE,
                    outline = FALSE,
                    data = predictors,
                    col = "bisque",
                    names = rep("", n.x),
                    xaxt = "n",
                    pars = list(cex.lab = 1.5))
          at.pretty <- unique(round(pretty(1:n.x, min(30, n.x))))
          at.pretty <- at.pretty[at.pretty >= 1 & at.pretty <= n.x]
          axis(1,
               at = at.pretty,
               labels = format(sort(x.uniq)[at.pretty], trim = TRUE, digits = 4),
               tick = TRUE)
        }
      }
    }
    else {
      if (is.null(object$forest)) {
        stop("Forest is empty!  Re-run rsf (grow) analysis with forest set to 'TRUE'.")
      }
      plots.per.page <- max(round(min(plots.per.page,n.cov)), 1)
      granule <- max(round(granule),1)
      par(mfrow = c(min(plots.per.page, ceiling(n.cov/plots.per.page)), plots.per.page))
      baseForest <- object$forest
      if (type == "time") {
        class(baseForest) <- c("rsf", "partial.rough")
      }
      else { 
        class(baseForest) <- c("rsf", "partial")
      }
      if (npts < 1) npts <- 1 else npts <- round(npts)
      for (k in 1:n.cov) {
        x <- predictors[, object$predictorNames == cov.names[k]]
        if (is.factor(x)) x <- factor(x, exclude = NULL)          
        n.x <- length(unique(x))
        if (!is.factor(x) & n.x > npts) {
          x.uniq <- sort(unique(x))[unique(as.integer(seq(1, n.x, length = min(npts, n.x))))]
        }
        else {
           x.uniq <- sort(unique(x))
        }
        n.x <- length(x.uniq)
        if (n.x > 25) cex <- 0.5 else cex <- 0.75
        yhat <- yhat.se <- NULL
        newdata.x <- predictors
        for (l in 1:n.x) {
          newdata.x[, object$predictorNames == cov.names[k]] <- rep(x.uniq[l], n)
          if (type == "mort" | type == "rel.freq" | type == "time") {
              pred.temp <- predict.rsf(baseForest, newdata.x)$mortality
          }
          else if (type == "surv") {
            if (n.event == 1) {
              pred.temp <-
               100*exp(-predict.rsf(baseForest, newdata.x)$ensemble[,
                    max(which(object$timeInterest <=
                              quantile(object$time, probs = percentile, na.rm = TRUE)))])
            }
            else {
            pred.temp <-
               100*exp(-predict.rsf(baseForest, newdata.x)$ensemble[,
                    max(which(object$timeInterest <=
                              quantile(object$time, probs = percentile, na.rm = TRUE))),1])
            }
          }
          if (!is.factor(x) & (n.x > granule | n.cov == 1)) {
            yhat <- c(yhat, mean(pred.temp , na.rm = TRUE))
            yhat.se <- c(yhat.se, sd(pred.temp/sqrt(n) , na.rm = TRUE))
          }
          else {
            mean.temp <- mean(pred.temp , na.rm = TRUE)
            pred.temp <- mean.temp + (pred.temp-mean.temp)/sqrt(n)
            yhat <- c(yhat, pred.temp)
          }
        }        
        if (type == "rel.freq") nAdj <- max(n, yhat, na.rm = TRUE)
        if (!is.factor(x) & (n.x > granule | n.cov == 1)) {
          if (type == "rel.freq") {
            yhat <- yhat/nAdj
            yhat.se <- yhat.se/n
          }
          plot(c(min(x), x.uniq, max(x), x.uniq, x.uniq),
               c(NA, yhat, NA, yhat+2*yhat.se, yhat-2*yhat.se),
               xlab = cov.names[k],
               ylab = ylabel,
               type = "n",
               cex.lab = 1.5)
          points(x.uniq, yhat, pch = 16, cex = cex, col = 2)
          if (!is.na(yhat.se) && any(yhat.se > 0)) {
            lines(lowess(x.uniq, yhat+2*yhat.se), lty = 3, col = 2)
            lines(lowess(x.uniq, yhat-2*yhat.se), lty = 3, col = 2)
          }
          lines(lowess(x.uniq, yhat), lty = 2, lwd=2)
          rug(x, ticksize=0.03)
        }
        else {
          if (type != "rel.freq") {
            y.se <- 2
          }
          else {
            yhat <- yhat/nAdj
            y.se <- 2/n
          }
          bxp.call <- boxplot(yhat ~ rep(x.uniq, rep(n, n.x)), range = 2, plot = F)
          boxplot(yhat ~ rep(x.uniq, rep(n, n.x)),
                  xlab = cov.names[k],
                  ylab = ylabel,
                  notch = TRUE,
                  outline = FALSE,
                  range = 2,
                  ylim = c(min(bxp.call$stats[1,], na.rm=TRUE)
                      - y.se,max(bxp.call$stats[5,], na.rm=TRUE) + y.se),
                  data = predictors,
                  col = "bisque",
                  names = rep("",n.x),
                  xaxt = "n",
                  pars = list(cex.lab = 1.5))
          at.pretty <- unique(round(pretty(1:n.x, min(30,n.x))))
          at.pretty <- at.pretty[at.pretty >= 1 & at.pretty <= n.x]
          axis(1,
               at = at.pretty,
               labels = format(sort(x.uniq)[at.pretty], trim = TRUE, digits = 4),
               tick = TRUE)
        }
      }
    }
    par(old.par)
  }
plot.variable <- plot.variable.rsf

#-------------------------------------------------------------------------------
# Revision history:
# 2009-01-05: bug fix in Anova.II.lm(). J. Fox
# 2009-01-16: Cox models with clusters now handled. J. Fox
# 2009-09-16: reworked glm and lm methods to handle aliased parameters. J. Fox
# 2009-09-30: renamed "Anova" to "Analysis of Deviance" in output for some methods. J. Fox
# 2009-12-22: modified Anova.mlm() to handle a user-supplied within-subject model matrix. J. Fox
# 2009-12-28: named the components of P in Anova.III.mlm(). John
# 2010-01-01: Anova.II.mlm() now hands off (again) to Anova.III.mlm() when there
#             is only an intercept in the between-subjects model
# 2010-02-17: Fixed bug that caused some models with aliased coefficients to fail. J. Fox
# 2010-06-14: added wcrossprod and allow use of observation weights in Anova.mlm()
# 2010-06-28: Fixed Anova() tables for coxph and survreg models 
#             (failed because of changes in survival package.
# 2011-01-21: Added functions for mixed models. J. Fox
# 2011-01-25: Fixed Anova.polr() and Anova.multinom() to work with models with only one term. J. Fox
# 2011-05-19: local fixef() to avoid nlme/lme4 issues. J. Fox
# 2011-05-11: changed order of columns in ANOVA tables for mixed models. J. Fox
# 2011-11-27: added Anova.svyglm(). J. Fox
# 2011-12-31: fixed bug in Anova.II(and III).F.glm() when na.exclude used. J. Fox
# 2012-02-28: added test.statistic argument to Anova.mer(). J.Fox
# 2012-03-02: fixed test abbreviation of test.statistic argument to Anova.default()
#             called by other Anova() methods. J. Fox
# 2013-06-17: modified summary.Anova.mlm(), introduced print.summary.Anova.mlm(),
#             adapting code contributed by Gabriel Baud-Bovy. J. Fox
# 2013-06-20: added Anova.merMod() method. J. Fox
# 2013-06-22: tweaks to local fixef(). J. Fox
# 2013-06-22: test argument uniformly uses "Chisq" rather than "chisq". J. Fox
# 2013-08-19: replaced calls to print.anova(). J. Fox
# 2014-08-17: added calls to requireNamespace() and :: where needed (doesn't work for pbkrtest). J. Fox
# 2014-08-18: fixed bugs in Anova.survreg() for types II, III LR tests and Wald tests. J. Fox
# 2014-09-23: added Anova.rlm(). J. Fox
# 2014-10-10: removed MASS:: from calls to polr(). John
# 2014-12-18: check that residual df and SS are nonzero in Anova.lm(). John
# 2015-01-27: vcovAdj() and methods now imported from pbkrtest. John
# 2015-02-18: force evaluation of vcov. when it's a function. John
# 2015-04-30: don't allow error.estimate="dispersion" for F-tests in binomial
#             and Poission GLMs. John
#-------------------------------------------------------------------------------

# Type II and III tests for linear, generalized linear, and other models (J. Fox)

ConjComp <- function(X, Z = diag( nrow(X)), ip = diag(nrow(X))) {
	# This function by Georges Monette
	# finds the conjugate complement of the proj of X in span(Z) wrt
	#    inner product ip
	# - assumes Z is of full column rank
	# - projects X conjugately wrt ip into span Z
	xq <- qr(t(Z) %*% ip %*% X)
	if (xq$rank == 0) return(Z)
	Z %*% qr.Q(xq, complete = TRUE) [ ,-(1:xq$rank)] 
}

relatives <- function(term, names, factors){
	is.relative <- function(term1, term2) {
		all(!(factors[,term1]&(!factors[,term2])))
	}
	if(length(names) == 1) return(NULL)
	which.term <- which(term==names)
	(1:length(names))[-which.term][sapply(names[-which.term], 
					function(term2) is.relative(term, term2))]
}


Anova <- function(mod, ...){
	UseMethod("Anova", mod)
}

# linear models

Anova.lm <- function(mod, error, type=c("II","III", 2, 3), 
		white.adjust=c(FALSE, TRUE, "hc3", "hc0", "hc1", "hc2", "hc4"),
        vcov.=NULL, singular.ok, ...){
    if (is.function(vcov.)) vcov. <- vcov.(mod)
    if (df.residual(mod) == 0) stop("residual df = 0")
    if (deviance(mod) < sqrt(.Machine$double.eps)) stop("residual sum of squares is 0 (within rounding error)")
	type <- as.character(type)
	white.adjust <- as.character(white.adjust)
	type <- match.arg(type)
	white.adjust <- match.arg(white.adjust)
	if (missing(singular.ok)){
		singular.ok <- type == "2" || type == "II"
	}
	if (has.intercept(mod) && length(coef(mod)) == 1 
			&& (type == "2" || type == "II")) {
		type <- "III"
		warning("the model contains only an intercept: Type III test substituted")
	}
	if (white.adjust != "FALSE"){
		if (white.adjust == "TRUE") white.adjust <- "hc3" 
		return(Anova.default(mod, type=type, vcov.=hccm(mod, type=white.adjust), test.statistic="F", 
						singular.ok=singular.ok, ...))
	}
    else if (!is.null(vcov.)) return(Anova.default(mod, type=type, vcov.=vcov., test.statistic="F", 
        singular.ok=singular.ok, ...))
	switch(type,
			II=Anova.II.lm(mod, error, singular.ok=singular.ok, ...),
			III=Anova.III.lm(mod, error, singular.ok=singular.ok, ...),
			"2"=Anova.II.lm(mod, error, singular.ok=singular.ok, ...),
			"3"=Anova.III.lm(mod, error, singular.ok=singular.ok,...))
}

Anova.aov <- function(mod, ...){
	class(mod) <- "lm"
	Anova.lm(mod, ...)
}

Anova.II.lm <- function(mod, error, singular.ok=TRUE, ...){
	if (!missing(error)){
		sumry <- summary(error, corr=FALSE)
		s2 <- sumry$sigma^2
		error.df <- error$df.residual
		error.SS <- s2*error.df
	}
	SS.term <- function(term){
		which.term <- which(term == names)
		subs.term <- which(assign == which.term)
		relatives <- relatives(term, names, fac)
		subs.relatives <- NULL
		for (relative in relatives) 
			subs.relatives <- c(subs.relatives, which(assign == relative))
		hyp.matrix.1 <- I.p[subs.relatives,,drop=FALSE]
		hyp.matrix.1 <- hyp.matrix.1[, not.aliased, drop=FALSE]
		hyp.matrix.2 <- I.p[c(subs.relatives,subs.term),,drop=FALSE]
		hyp.matrix.2 <- hyp.matrix.2[, not.aliased, drop=FALSE]
		hyp.matrix.term <- if (nrow(hyp.matrix.1) == 0) hyp.matrix.2
				else t(ConjComp(t(hyp.matrix.1), t(hyp.matrix.2), vcov(mod)))
		hyp.matrix.term <- hyp.matrix.term[!apply(hyp.matrix.term, 1, 
						function(x) all(x == 0)), , drop=FALSE]
		if (nrow(hyp.matrix.term) == 0)
			return(c(SS=NA, df=0))
		lh <- linearHypothesis(mod, hyp.matrix.term, 
				singular.ok=singular.ok, ...)
		abs(c(SS=lh$"Sum of Sq"[2], df=lh$Df[2]))
	}
	not.aliased <- !is.na(coef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	fac <- attr(mod$terms, "factors")
	intercept <- has.intercept(mod)
	I.p <- diag(length(coefficients(mod)))
	assign <- mod$assign
	assign[!not.aliased] <- NA
	names <- term.names(mod)
	if (intercept) names <-names[-1]
	n.terms <- length(names)
	p <- df <- f <- SS <- rep(0, n.terms + 1)
	sumry <- summary(mod, corr = FALSE)
	SS[n.terms + 1] <- if (missing(error)) sumry$sigma^2*mod$df.residual 
			else error.SS   
	df[n.terms + 1] <- if (missing(error)) mod$df.residual else error.df
	p[n.terms + 1] <- f[n.terms + 1] <- NA
	for (i in 1:n.terms){
		ss <- SS.term(names[i])
		SS[i] <- ss["SS"]
		df[i] <- ss["df"]
		f[i] <- df[n.terms+1]*SS[i]/(df[i]*SS[n.terms + 1])
		p[i] <- pf(f[i], df[i], df[n.terms + 1], lower.tail = FALSE)
	}    
	result <- data.frame(SS, df, f, p)
	row.names(result) <- c(names,"Residuals")
	names(result) <- c("Sum Sq", "Df", "F value", "Pr(>F)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Anova Table (Type II tests)\n", 
			paste("Response:", responseName(mod)))
	result
}

# type III

Anova.III.lm <- function(mod, error, singular.ok=FALSE, ...){
	if (!missing(error)){
		error.df <- df.residual(error)
		error.SS <- deviance(error)
	}
	else {
		error.df <- df.residual(mod)
		error.SS <- deviance(mod)
	}
	intercept <- has.intercept(mod)
	I.p <- diag(length(coefficients(mod)))
	Source <- term.names(mod)
	n.terms <- length(Source)
	p <- df <- f <- SS <- rep(0, n.terms + 1)
	assign <- mod$assign
	not.aliased <- !is.na(coef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	for (term in 1:n.terms){
		subs <- which(assign == term - intercept)
		hyp.matrix <- I.p[subs,,drop=FALSE]
		hyp.matrix <- hyp.matrix[, not.aliased, drop=FALSE]
		hyp.matrix <- hyp.matrix[!apply(hyp.matrix, 1, function(x) all(x == 0)), , drop=FALSE]
		if (nrow(hyp.matrix) == 0){
			SS[term] <- NA
			df[term] <- 0
			f[term] <- NA
			p[term] <- NA
		}
		else {
			test <- if (missing(error)) linearHypothesis(mod, hyp.matrix, 
								singular.ok=singular.ok, ...)
					else linearHypothesis(mod, hyp.matrix, error.SS=error.SS, error.df=error.df, 
								singular.ok=singular.ok, ...)
			SS[term] <- test$"Sum of Sq"[2]
			df[term] <- test$"Df"[2]
			f[term] <- test$"F"[2]
			p[term] <- test$"Pr(>F)"[2]
		}
	}
	Source[n.terms + 1] <- "Residuals"
	SS[n.terms + 1] <- error.SS
	df[n.terms + 1] <- error.df
	p[n.terms + 1] <- f[n.terms + 1] <- NA
	result <- data.frame(SS, df, f, p)
	row.names(result) <- Source
	names(result) <- c("Sum Sq", "Df", "F value", "Pr(>F)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Anova Table (Type III tests)\n", paste("Response:", responseName(mod)))
	result
}

# generalized linear models

Anova.glm <- function(mod, type=c("II","III", 2, 3), test.statistic=c("LR", "Wald", "F"), 
		error, error.estimate=c("pearson", "dispersion", "deviance"), singular.ok, ...){
	type <- as.character(type)
	type <- match.arg(type)
	if (has.intercept(mod) && length(coef(mod)) == 1 
			&& (type == "2" || type == "II")) {
		type <- "III"
		warning("the model contains only an intercept: Type III test substituted")
	}
	if (missing(singular.ok)){
		singular.ok <- type == "2" || type == "II"
	}
	test.statistic <- match.arg(test.statistic)
	error.estimate <- match.arg(error.estimate)
	switch(type,
			II=switch(test.statistic,
					LR=Anova.II.LR.glm(mod, singular.ok=singular.ok),
					Wald=Anova.default(mod, type="II", singular.ok=singular.ok),
					F=Anova.II.F.glm(mod, error, error.estimate, singular.ok=singular.ok)),
			III=switch(test.statistic,
					LR=Anova.III.LR.glm(mod, singular.ok=singular.ok),
					Wald=Anova.default(mod, type="III", singular.ok=singular.ok),
					F=Anova.III.F.glm(mod, error, error.estimate, singular.ok=singular.ok)),
			"2"=switch(test.statistic,
					LR=Anova.II.LR.glm(mod, singular.ok=singular.ok),
					Wald=Anova.default(mod, type="II", singular.ok=singular.ok),
					F=Anova.II.F.glm(mod, error, error.estimate, singular.ok=singular.ok)),
			"3"=switch(test.statistic,
					LR=Anova.III.LR.glm(mod, singular.ok=singular.ok),
					Wald=Anova.default(mod, type="III", singular.ok=singular.ok),
					F=Anova.III.F.glm(mod, error, error.estimate, singular.ok=singular.ok)))
}


# type III

# LR test

Anova.III.LR.glm <- function(mod, singular.ok=FALSE, ...){
	if (!singular.ok && any(is.na(coef(mod))))
		stop("there are aliased coefficients in the model")
	Source <- if (has.intercept(mod)) term.names(mod)[-1]
			else term.names(mod)
	n.terms <- length(Source)
	p <- df <- LR <- rep(0, n.terms)
	dispersion <- summary(mod, corr = FALSE)$dispersion
	deviance <- deviance(mod)/dispersion
	for (term in 1:n.terms){
		mod.1 <- drop1(mod, scope=eval(parse(text=paste("~",Source[term]))))
		LR[term] <- (mod.1$Deviance[2]/dispersion)-deviance
		df[term] <- mod.1$Df[2]
		p[term] <- pchisq(LR[term], df[term], lower.tail = FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- Source
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova","data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type III tests)\n", paste("Response:", responseName(mod)))
	result
}

# F test

Anova.III.F.glm <- function(mod, error, error.estimate, singular.ok=FALSE, ...){
    if (!singular.ok && any(is.na(coef(mod))))
        stop("there are aliased coefficients in the model")
    fam <- family(mod)$family
    if ((fam == "binomial" || fam == "poisson") && error.estimate == "dispersion"){
        warning("dispersion parameter estimated from the Pearson residuals, not taken as 1")
        error.estimate <- "pearson"
    }
    if (missing(error)) error <- mod
    df.res <- df.residual(error)
    error.SS <- switch(error.estimate,
        pearson=sum(residuals(error, "pearson")^2, na.rm=TRUE),
        dispersion=df.res*summary(error, corr = FALSE)$dispersion,
        deviance=deviance(error))
    Source <- if (has.intercept(mod)) term.names(mod)[-1]
    else term.names(mod)
    n.terms <- length(Source)
    p <- df <- f <- SS <-rep(0, n.terms+1)
    f[n.terms+1] <- p[n.terms+1] <- NA
    df[n.terms+1] <- df.res
    SS[n.terms+1] <- error.SS
    dispersion <- error.SS/df.res
    deviance <- deviance(mod)
    for (term in 1:n.terms){
        mod.1 <- drop1(mod, scope=eval(parse(text=paste("~",Source[term]))))
        df[term] <- mod.1$Df[2]
        SS[term] <- mod.1$Deviance[2] - deviance
        f[term] <- (SS[term]/df[term])/dispersion
        p[term] <- pf(f[term], df[term], df.res, lower.tail = FALSE)
    }
    result <- data.frame(SS, df, f, p)
    row.names(result) <- c(Source, "Residuals")
    names(result) <- c("SS", "Df", "F", "Pr(>F)")
    class(result) <- c("anova","data.frame")
    attr(result, "heading") <- c("Analysis of Deviance Table (Type III tests)\n", 
        paste("Response:", responseName(mod)), 
        paste("Error estimate based on",
            switch(error.estimate, 
                pearson="Pearson residuals", dispersion="estimated dispersion", 
                deviance="deviance"), "\n"))
    result
}

# type II

# LR test

Anova.II.LR.glm <- function(mod, singular.ok=TRUE, ...){
	if (!singular.ok && any(is.na(coef(mod))))
		stop("there are aliased coefficients in the model")
	# (some code adapted from drop1.glm)
	which.nms <- function(name) which(asgn == which(names == name))
	fac <- attr(mod$terms, "factors")
	names <- if (has.intercept(mod)) term.names(mod)[-1]
			else term.names(mod)
	n.terms <- length(names)
	X <- model.matrix(mod)
	y <- mod$y
	if (is.null(y)) y <- model.response(model.frame(mod), "numeric")
	wt <- mod$prior.weights
	if (is.null(wt)) wt <- rep(1, length(y))
	asgn <- attr(X, 'assign')
	df <- p <- LR <- rep(0, n.terms)
	dispersion <- summary(mod, corr = FALSE)$dispersion
	for (term in 1:n.terms){
		rels <- names[relatives(names[term], names, fac)]
		exclude.1 <- as.vector(unlist(sapply(c(names[term], rels), which.nms)))
		mod.1 <- glm.fit(X[, -exclude.1, drop = FALSE], y, wt, offset = mod$offset, 
				family = mod$family, control = mod$control)
		dev.1 <- deviance(mod.1)
		mod.2 <- if (length(rels) == 0) mod
				else {
					exclude.2 <- as.vector(unlist(sapply(rels, which.nms)))
					glm.fit(X[, -exclude.2, drop = FALSE], y, wt, offset = mod$offset, 
							family = mod$family, control = mod$control)
				}
		dev.2 <- deviance(mod.2)
		df[term] <- df.residual(mod.1) - df.residual(mod.2)
		if (df[term] == 0) LR[term] <- p[term] <- NA
		else {
			LR[term] <- (dev.1 - dev.2)/dispersion
			p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
		}
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- 
			c("Analysis of Deviance Table (Type II tests)\n", paste("Response:", responseName(mod)))
	result
}


# F test

Anova.II.F.glm <- function(mod, error, error.estimate, singular.ok=TRUE, ...){
    # (some code adapted from drop1.glm)
    if (!singular.ok && any(is.na(coef(mod))))
        stop("there are aliased coefficients in the model")
    fam <- family(mod)$family
    if ((fam == "binomial" || fam == "poisson") && error.estimate == "dispersion"){
        warning("dispersion parameter estimated from the Pearson residuals, not taken as 1")
        error.estimate <- "pearson"
    }
    which.nms <- function(name) which(asgn == which(names == name))
    if (missing(error)) error <- mod
    df.res <- df.residual(error)
    error.SS <- switch(error.estimate,
        pearson = sum(residuals(error, "pearson")^2, na.rm=TRUE),
        dispersion = df.res*summary(error, corr = FALSE)$dispersion,
        deviance = deviance(error))
    fac <- attr(mod$terms, "factors")
    names <- if (has.intercept(mod)) term.names(mod)[-1]
    else term.names(mod)
    n.terms <- length(names)
    X <- model.matrix(mod)
    y <- mod$y
    if (is.null(y)) y <- model.response(model.frame(mod), "numeric")
    wt <- mod$prior.weights
    if (is.null(wt)) wt <- rep(1, length(y))
    asgn <- attr(X, 'assign')
    p <- df <- f <- SS <- rep(0, n.terms+1)
    f[n.terms+1] <- p[n.terms+1] <- NA
    df[n.terms+1] <- df.res
    SS[n.terms+1] <- error.SS
    dispersion <- error.SS/df.res
    for (term in 1:n.terms){
        rels <- names[relatives(names[term], names, fac)]
        exclude.1 <- as.vector(unlist(sapply(c(names[term], rels), which.nms)))
        mod.1 <- glm.fit(X[, -exclude.1, drop = FALSE], y, wt, offset = mod$offset, 
            family = mod$family, control = mod$control)
        dev.1 <- deviance(mod.1)
        mod.2 <- if (length(rels) == 0) mod
        else {
            exclude.2 <- as.vector(unlist(sapply(rels, which.nms)))
            glm.fit(X[, -exclude.2, drop = FALSE], y, wt, offset = mod$offset, 
                family = mod$family, control = mod$control)
        }
        dev.2 <- deviance(mod.2)
        df[term] <- df.residual(mod.1) - df.residual(mod.2)
        if (df[term] == 0) SS[term] <- f[term] <- p[term] <- NA
        else {
            SS[term] <- dev.1 - dev.2
            f[term] <- SS[term]/(dispersion*df[term])
            p[term] <- pf(f[term], df[term], df.res, lower.tail=FALSE)
        }
    }
    result <- data.frame(SS, df, f, p)
    row.names(result) <- c(names, "Residuals")
    names(result) <- c("SS", "Df", "F", "Pr(>F)")
    class(result) <- c("anova", "data.frame")
    attr(result, "heading") <- c("Analysis of Deviance Table (Type II tests)\n", 
        paste("Response:", responseName(mod)),
        paste("Error estimate based on",
            switch(error.estimate,
                pearson="Pearson residuals", 
                dispersion="estimated dispersion", 
                deviance="deviance"), "\n"))
    result
}

# multinomial logit models (via multinom in the nnet package)

Anova.multinom <-
		function (mod, type = c("II", "III", 2, 3), ...)
{
	type <- as.character(type)
	type <- match.arg(type)
	if (has.intercept(mod) && length(coef(mod)) == 1 
			&& (type == "2" || type == "II")) {
		type <- "III"
		warning("the model contains only an intercept: Type III test substituted")
	}
	switch(type,
			II = Anova.II.multinom(mod, ...),
			III = Anova.III.multinom(mod, ...),
			"2" = Anova.II.multinom(mod, ...),
			"3" = Anova.III.multinom(mod, ...))
}

Anova.II.multinom <- function (mod, ...)
{
	which.nms <- function(name) which(asgn == which(names ==
								name))
	fac <- attr(mod$terms, "factors")
	names <- if (has.intercept(mod)) term.names(mod)[-1]
			else term.names(mod)
	n.terms <- length(names)
	X <- model.matrix(mod)
	y <- model.response(model.frame(mod))
	wt <- mod$weights
	asgn <- attr(X, "assign")
	p <- LR <- rep(0, n.terms)
	df <- df.terms(mod)
	for (term in 1:n.terms) {
		rels <- names[relatives(names[term], names, fac)]
		exclude.1 <- as.vector(unlist(sapply(c(names[term], rels),
								which.nms)))
		mod.1 <-if (n.terms > 1) multinom(y ~ X[, -c(1, exclude.1)], weights=wt, trace=FALSE)
				else multinom(y ~ 1, weights=wt, race=FALSE)
		dev.1 <- deviance(mod.1)
		mod.2 <- if (length(rels) == 0)
					mod
				else {
					exclude.2 <- as.vector(unlist(sapply(rels, which.nms)))
					multinom(y ~ X[, -c(1, exclude.2)], weights=wt, trace=FALSE)
				}
		dev.2 <- deviance(mod.2)
		LR[term] <- dev.1 - dev.2
		p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type II tests)\n",
			paste("Response:", responseName(mod)))
	result
}

Anova.III.multinom <- function (mod, ...)
{
	names <- if (has.intercept(mod)) term.names(mod)[-1]
			else term.names(mod)
	n.terms <- length(names)
	X <- model.matrix(mod)
	y <- model.response(model.frame(mod))
	wt <- mod$weights
	asgn <- attr(X, "assign")
	p <- LR <- rep(0, n.terms)
	df <- df.terms(mod)
	deviance <- deviance(mod)
	for (term in 1:n.terms) {
		mod.1 <- if (n.terms > 1) multinom(y ~ X[, term != asgn][, -1], weights=wt, trace=FALSE)
				else multinom(y ~ 1, weights=wt, trace=FALSE)
		LR[term] <- deviance(mod.1) - deviance
		p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type III tests)\n",
			paste("Response:", responseName(mod)))
	result
}


# proportional-odds logit models (via polr in the MASS package)

Anova.polr <- function (mod, type = c("II", "III", 2, 3), ...)
{
	type <- as.character(type)
	type <- match.arg(type)
	if (has.intercept(mod) && length(coef(mod)) == 1 
			&& (type == "2" || type == "II")) {
		type <- "III"
		warning("the model contains only an intercept: Type III test substituted")
	}
	switch(type,
			II = Anova.II.polr(mod, ...),
			III = Anova.III.polr(mod, ...),
			"2" = Anova.II.polr(mod, ...),
			"3" = Anova.III.polr(mod, ...))
}

Anova.II.polr <- function (mod, ...)
{
  if (!requireNamespace("MASS")) stop("MASS package is missing")
	which.nms <- function(name) which(asgn == which(names ==
								name))
	fac <- attr(mod$terms, "factors")
	names <- term.names(mod)
	n.terms <- length(names)
	X <- model.matrix(mod)
	y <- model.response(model.frame(mod))
	wt <- model.weights(model.frame(mod))
	asgn <- attr(X, "assign")
	p <- LR <- rep(0, n.terms)
	df <- df.terms(mod)
	for (term in 1:n.terms) {
		rels <- names[relatives(names[term], names, fac)]
		exclude.1 <- as.vector(unlist(sapply(c(names[term], rels),
								which.nms)))
		mod.1 <- if (n.terms > 1) polr(y ~ X[, -c(1, exclude.1)], weights=wt)
				else polr(y ~ 1, weights=wt)
		dev.1 <- deviance(mod.1)
		mod.2 <- if (length(rels) == 0)
					mod
				else {
					exclude.2 <- as.vector(unlist(sapply(rels, which.nms)))
					polr(y ~ X[, -c(1, exclude.2)], weights=wt)
				}
		dev.2 <- deviance(mod.2)
		LR[term] <- dev.1 - dev.2
		p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type II tests)\n",
			paste("Response:", responseName(mod)))
	result
}

Anova.III.polr <- function (mod, ...)
{
  if (!requireNamespace("MASS")) stop("MASS package is missing")
	names <- term.names(mod)
	n.terms <- length(names)
	X <- model.matrix(mod)
	y <- model.response(model.frame(mod))
	wt <- model.weights(model.frame(mod))
	asgn <- attr(X, "assign")
	p <- LR <- rep(0, n.terms)
	df <- df.terms(mod)
	deviance <- deviance(mod)
	for (term in 1:n.terms) {
		mod.1 <- if (n.terms > 1) polr(y ~ X[, term != asgn][, -1], weights=wt)
				else polr(y ~ 1, weights=wt)
		LR[term] <- deviance(mod.1) - deviance
		p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type III tests)\n",
			paste("Response:", responseName(mod)))
	result
}

# multivariate linear models

# the following 3 functions copied from the stats package (not exported from stats)

Pillai <- function (eig, q, df.res) {
    test <- sum(eig/(1 + eig))
    p <- length(eig)
    s <- min(p, q)
    n <- 0.5 * (df.res - p - 1)
    m <- 0.5 * (abs(p - q) - 1)
    tmp1 <- 2 * m + s + 1
    tmp2 <- 2 * n + s + 1
    c(test, (tmp2/tmp1 * test)/(s - test), s * tmp1, s * tmp2)
}

Wilks <- function (eig, q, df.res) {
    test <- prod(1/(1 + eig))
    p <- length(eig)
    tmp1 <- df.res - 0.5 * (p - q + 1)
    tmp2 <- (p * q - 2)/4
    tmp3 <- p^2 + q^2 - 5
    tmp3 <- if (tmp3 > 0) 
        sqrt(((p * q)^2 - 4)/tmp3)
    else 1
    c(test, ((test^(-1/tmp3) - 1) * (tmp1 * tmp3 - 2 * tmp2))/p/q, 
      p * q, tmp1 * tmp3 - 2 * tmp2)
}

HL <- function (eig, q, df.res) {
    test <- sum(eig)
    p <- length(eig)
    m <- 0.5 * (abs(p - q) - 1)
    n <- 0.5 * (df.res - p - 1)
    s <- min(p, q)
    tmp1 <- 2 * m + s + 1
    tmp2 <- 2 * (s * n + 1)
    c(test, (tmp2 * test)/s/s/tmp1, s * tmp1, tmp2)
}

Roy <- function (eig, q, df.res) {
    p <- length(eig)
    test <- max(eig)
    tmp1 <- max(p, q)
    tmp2 <- df.res - tmp1 + q
    c(test, (tmp2 * test)/tmp1, tmp1, tmp2)
}

has.intercept.mlm <- function (model, ...) 
	any(row.names(coefficients(model)) == "(Intercept)")


Anova.mlm <- function(mod, type=c("II","III", 2, 3), SSPE, error.df, idata, 
		idesign, icontrasts=c("contr.sum", "contr.poly"), imatrix,
		test.statistic=c("Pillai", "Wilks", "Hotelling-Lawley", "Roy"),...){
	wts <- if (!is.null(mod$weights)) mod$weights else rep(1, nrow(model.matrix(mod)))
	type <- as.character(type)
	type <- match.arg(type)
	test.statistic <- match.arg(test.statistic)
	if (missing(SSPE)) SSPE <- wcrossprod(residuals(mod), w=wts)
	if (missing(idata)) {
		idata <- NULL
		idesign <- NULL
	}
	if (missing(imatrix)) imatrix <- NULL
	error.df <- if (missing(error.df)) df.residual(mod)
			else error.df
	switch(type,
			II=Anova.II.mlm(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test.statistic, ...),
			III=Anova.III.mlm(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test.statistic, ...),
			"2"=Anova.II.mlm(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test.statistic, ...),
			"3"=Anova.III.mlm(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test.statistic, ...))
}

Anova.III.mlm <- function(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test, ...){
	intercept <- has.intercept(mod)
	V <- solve(crossprod(model.matrix(mod)))
	p <- nrow(coefficients(mod))
	I.p <- diag(p)
	terms <- term.names(mod)
	n.terms <- length(terms)
	assign <- mod$assign
	if (is.null(idata) && is.null(imatrix)){
		if ((n.terms == 0) && intercept) {
			Test <- linearHypothesis(mod, 1, SSPE=SSPE, ...)
			result <- list(SSP=Test$SSPH, SSPE=SSPE, df=1, error.df=error.df,
					terms="(Intercept)", repeated=FALSE, type="III", test=test)
			class(result) <- "Anova.mlm"
			return(result)
		}
		SSP <- as.list(rep(0, n.terms))
		df <- rep(0, n.terms)
		names(df) <- names(SSP) <- terms
		for (term in 1:n.terms){
			subs <- which(assign == term - intercept)
			hyp.matrix <- I.p[subs,,drop=FALSE]
			Test <- linearHypothesis(mod, hyp.matrix, SSPE=SSPE, ...)
			SSP[[term]] <- Test$SSPH
			df[term]<- length(subs)
		}
		result <- list(SSP=SSP, SSPE=SSPE, df=df, error.df=error.df, terms=terms,
				repeated=FALSE, type="III", test=test)
	}
	else {
		if (!is.null(imatrix)){
			X.design <- do.call(cbind, imatrix)
			ncols <- sapply(imatrix, ncol)
			end <- cumsum(ncols)
			start <- c(1, (end + 1))[-(length(end) + 1)]
			cols <- mapply(seq, from=start, to=end)
			iterms <- names(end)
			names(cols) <- iterms
			check.imatrix(X.design, iterms)
		}
		else {
			if (is.null(idesign)) stop("idesign (intra-subject design) missing.")
			for (i in 1:length(idata)){
				if (is.null(attr(idata[,i], "contrasts"))){
					contrasts(idata[,i]) <- if (is.ordered(idata[,i])) icontrasts[2]
							else icontrasts[1]
				}
			}
			X.design <- model.matrix(idesign, data=idata)
			i.intercept <- has.intercept(X.design)
			iterms <- term.names(idesign)
			if (i.intercept) iterms <- c("(Intercept)", iterms)
			check.imatrix(X.design)
		}
		df <- rep(0, n.terms*length(iterms))
		hnames <- rep("", length(df))
		P <- SSPEH <- SSP <- as.list(df)
		i <- 0
		for (iterm in iterms){
			for (term in 1:n.terms){
				subs <- which(assign == term - intercept)
				hyp.matrix <- I.p[subs,,drop=FALSE]
				i <- i + 1
				Test <- linearHypothesis(mod, hyp.matrix, SSPE=SSPE, 
						idata=idata, idesign=idesign, icontrasts=icontrasts, iterms=iterm, 
						check.imatrix=FALSE, P=imatrix[[iterm]], singular.ok=TRUE, ...)
				SSP[[i]] <- Test$SSPH
				SSPEH[[i]] <- Test$SSPE
				P[[i]] <- Test$P
				df[i] <- length(subs)
				hnames[i] <- if (iterm == "(Intercept)") terms[term]
						else if (terms[term] == "(Intercept)") iterm
						else paste(terms[term], ":", iterm, sep="")
			}
		}
		names(df) <- names(SSP) <- names(SSPEH) <- names(P) <- hnames
		result <- list(SSP=SSP, SSPE=SSPEH, P=P, df=df, error.df=error.df,
				terms=hnames, repeated=TRUE, type="III", test=test, 
				idata=idata, idesign=idesign, icontrasts=icontrasts, imatrix=imatrix,
				singular=Test$singular)       
	}
	class(result) <- "Anova.mlm"
	result
}

Anova.II.mlm <- function(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test, ...){
	wts <- if (!is.null(mod$weights)) mod$weights else rep(1, nrow(model.matrix(mod)))
	V <- solve(wcrossprod(model.matrix(mod), w=wts))
	SSP.term <- function(term, iterm){
		which.term <- which(term == terms)
		subs.term <- which(assign == which.term)
		relatives <- relatives(term, terms, fac)
		subs.relatives <- NULL
		for (relative in relatives) subs.relatives <- c(subs.relatives, which(assign==relative))
		hyp.matrix.1 <- I.p[subs.relatives,,drop=FALSE]
		hyp.matrix.2 <- I.p[c(subs.relatives, subs.term),,drop=FALSE]
		if (missing(iterm)){
			SSP1 <- if (length(subs.relatives) == 0) 0 
					else linearHypothesis(mod, hyp.matrix.1, SSPE=SSPE, V=V, singular.ok=TRUE, ...)$SSPH
			SSP2 <- linearHypothesis(mod, hyp.matrix.2, SSPE=SSPE, V=V, singular.ok=TRUE, ...)$SSPH
			return(SSP2 - SSP1)
		}
		else {
			SSP1 <- if (length(subs.relatives) == 0) 0 
					else linearHypothesis(mod, hyp.matrix.1, SSPE=SSPE, V=V, 
								idata=idata, idesign=idesign, iterms=iterm, icontrasts=icontrasts, P=imatrix[[iterm]], singular.ok=TRUE, ...)$SSPH
			lh2 <- linearHypothesis(mod, hyp.matrix.2, SSPE=SSPE, V=V, 
					idata=idata, idesign=idesign, iterms=iterm, icontrasts=icontrasts, P=imatrix[[iterm]], singular.ok=TRUE, ...)
			return(list(SSP = lh2$SSPH - SSP1, SSPE=lh2$SSPE, P=lh2$P, singular=lh2$singular))
		}
	}
	fac <- attr(mod$terms, "factors")
	intercept <- has.intercept(mod)
	p <- nrow(coefficients(mod))
	I.p <- diag(p)
	assign <- mod$assign
	terms <- term.names(mod)
	if (intercept) terms <- terms[-1]
	n.terms <- length(terms)
	if (n.terms == 0){
		message("Note: model has only an intercept; equivalent type-III tests substituted.")
		return(Anova.III.mlm(mod, SSPE, error.df, idata, idesign, icontrasts, imatrix, test, ...))
	}
	if (is.null(idata) && is.null(imatrix)){
		SSP <- as.list(rep(0, n.terms))
		df <- rep(0, n.terms)
		names(df) <- names(SSP) <- terms
		for (i in 1:n.terms){
			SSP[[i]] <- SSP.term(terms[i])
			df[i]<- df.terms(mod, terms[i])
		}    
		result <- list(SSP=SSP, SSPE=SSPE, df=df, error.df=error.df, terms=terms,
				repeated=FALSE, type="II", test=test)
	}
	else {
		if (!is.null(imatrix)){
			X.design <- do.call(cbind, imatrix)
			ncols <- sapply(imatrix, ncol)
			end <- cumsum(ncols)
			start <- c(1, (end + 1))[-(length(end) + 1)]
			cols <- mapply(seq, from=start, to=end)
			iterms <- names(end)
			names(cols) <- iterms
			check.imatrix(X.design, iterms)     
		}
		else {
			if (is.null(idesign)) stop("idesign (intra-subject design) missing.")
			for (i in 1:length(idata)){
				if (is.null(attr(idata[,i], "contrasts"))){
					contrasts(idata[,i]) <- if (is.ordered(idata[,i])) icontrasts[2]
							else icontrasts[1]
				}
			}
			X.design <- model.matrix(idesign, data=idata)
			iintercept <- has.intercept(X.design)
			iterms <- term.names(idesign)
			if (iintercept) iterms <- c("(Intercept)", iterms)
			check.imatrix(X.design)
		}
		df <- rep(0, (n.terms + intercept)*length(iterms))
		hnames <- rep("", length(df))
		P <- SSPEH <- SSP <- as.list(df)
		i <- 0
		for (iterm in iterms){
			if (intercept){
				i <- i + 1
				hyp.matrix.1 <- I.p[-1,,drop=FALSE]
				SSP1 <- linearHypothesis(mod, hyp.matrix.1, SSPE=SSPE, V=V, 
						idata=idata, idesign=idesign, iterms=iterm, icontrasts=icontrasts, 
						check.imatrix=FALSE, P=imatrix[[iterm]], singular.ok=TRUE, ...)$SSPH
				lh2 <- linearHypothesis(mod, I.p, SSPE=SSPE, V=V, 
						idata=idata, idesign=idesign, iterms=iterm, icontrasts=icontrasts, 
						check.imatrix=FALSE, P=imatrix[[iterm]], singular.ok=TRUE, ...)
				SSP[[i]] <- lh2$SSPH - SSP1
				SSPEH[[i]] <- lh2$SSPE
				P[[i]] <- lh2$P
				df[i] <- 1
				hnames[i] <- iterm
			}
			for (term in 1:n.terms){
				subs <- which(assign == term)
				i <- i + 1
				Test <- SSP.term(terms[term], iterm)
				SSP[[i]] <- Test$SSP
				SSPEH[[i]] <- Test$SSPE
				P[[i]] <- Test$P
				df[i]<- length(subs)
				hnames[i] <- if (iterm == "(Intercept)") terms[term]
						else paste(terms[term], ":", iterm, sep="")
			}
		}
		names(df) <- names(P) <- names(SSP) <- names(SSPEH) <- hnames
		result <- list(SSP=SSP, SSPE=SSPEH, P=P, df=df, error.df=error.df,
				terms=hnames, repeated=TRUE, type="II", test=test,
				idata=idata, idesign=idesign, icontrasts=icontrasts, imatrix=imatrix,
				singular=Test$singular)       
	}
	class(result) <- "Anova.mlm"
	result
}

print.Anova.mlm <- function(x, ...){
	if ((!is.null(x$singular)) && x$singular) stop("singular error SSP matrix; multivariate tests unavailable\ntry summary(object, multivariate=FALSE)")
	test <- x$test
	repeated <- x$repeated
	ntests <- length(x$terms)
	tests <- matrix(NA, ntests, 4)
	if (!repeated) SSPE.qr <- qr(x$SSPE) 
	for (term in 1:ntests){
		# some of the code here adapted from stats:::summary.manova
		eigs <- Re(eigen(qr.coef(if (repeated) qr(x$SSPE[[term]]) else SSPE.qr,
								x$SSP[[term]]), symmetric = FALSE)$values)
		tests[term, 1:4] <- switch(test,
				Pillai = Pillai(eigs, x$df[term], x$error.df),
				Wilks = Wilks(eigs, x$df[term], x$error.df),
				"Hotelling-Lawley" = HL(eigs, x$df[term], x$error.df),
				Roy = Roy(eigs, x$df[term], x$error.df))
	}
	ok <- tests[, 2] >= 0 & tests[, 3] > 0 & tests[, 4] > 0
	ok <- !is.na(ok) & ok
	tests <- cbind(x$df, tests, pf(tests[ok, 2], tests[ok, 3], tests[ok, 4], 
					lower.tail = FALSE))
	rownames(tests) <- x$terms
	colnames(tests) <- c("Df", "test stat", "approx F", "num Df", "den Df", "Pr(>F)")
	tests <- structure(as.data.frame(tests), 
			heading = paste("\nType ", x$type, if (repeated) " Repeated Measures",
					" MANOVA Tests: ", test, " test statistic", sep=""), 
			class = c("anova", "data.frame"))
	print(tests)      
	invisible(x)
}

# path <-  "D:/R-package-sources/car/R"
# files <- list.files(path, pattern=".*\\.R")
# files <- paste(path, files, sep="/")
# for (file in files) source(file)

# summary.Anova.mlm and print.summary.Anova.mlm methods
#  with contributions from Gabriel Baud-Bovy
summary.Anova.mlm <- function (object, test.statistic, univariate=TRUE, multivariate=TRUE, ...) {
    GG <- function(SSPE, P) { # Greenhouse-Geisser correction
        p <- nrow(SSPE)
        if (p < 2) 
            return(NA)
        lambda <- eigen(SSPE %*% solve(t(P) %*% P))$values
        lambda <- lambda[lambda > 0]
        ((sum(lambda)/p)^2)/(sum(lambda^2)/p)
    }
    HF <- function(gg, error.df, p) { # Huynh-Feldt correction
        ((error.df + 1) * p * gg - 2)/(p * (error.df - p * gg))
    }
    mauchly <- function(SSD, P, df) {
        # most of this function borrowed from stats:::mauchly.test.SSD
        if (nrow(SSD) < 2) 
            return(c(NA, NA))
        Tr <- function(X) sum(diag(X))
        p <- nrow(P)
        I <- diag(p)
        Psi <- t(P) %*% I %*% P
        B <- SSD
        pp <- nrow(SSD)
        U <- solve(Psi, B)
        n <- df
        logW <- log(det(U)) - pp * log(Tr(U/pp))
        rho <- 1 - (2 * pp^2 + pp + 2)/(6 * pp * n)
        w2 <- (pp + 2) * (pp - 1) * (pp - 2) * (2 * pp^3 + 6 * 
                pp^2 + 3 * p + 2)/(288 * (n * pp * rho)^2)
        z <- -n * rho * logW
        f <- pp * (pp + 1)/2 - 1
        Pr1 <- pchisq(z, f, lower.tail = FALSE)
        Pr2 <- pchisq(z, f + 4, lower.tail = FALSE)
        pval <- Pr1 + w2 * (Pr2 - Pr1)
        c(statistic = c(W = exp(logW)), p.value = pval)
    }
    if (missing(test.statistic)) 
        test.statistic <- c("Pillai", "Wilks", "Hotelling-Lawley", "Roy")
    test.statistic <- match.arg(test.statistic, c("Pillai", "Wilks", "Hotelling-Lawley", "Roy"), several.ok = TRUE)
    nterms <- length(object$terms)
    summary.object <- list(type=object$type, repeated=object$repeated, 
        multivariate.tests=NULL, univariate.tests=NULL, 
        pval.adjustments=NULL, sphericity.tests=NULL)
    if (multivariate){
        summary.object$multivariate.tests <- vector(nterms, mode="list")
        names(summary.object$multivariate.tests) <- object$terms 
        summary.object$SSPE <- object$SSPE
        for (term in 1:nterms) {
            hyp <- list(SSPH = object$SSP[[term]], 
                SSPE = if (object$repeated) object$SSPE[[term]] else object$SSPE, 
                P = if (object$repeated) object$P[[term]] else NULL, 
                test = test.statistic, df = object$df[term], 
                df.residual = object$error.df, title = object$terms[term])
            class(hyp) <- "linearHypothesis.mlm"
            summary.object$multivariate.tests[[term]] <- hyp
        }
    }
    if (object$repeated && univariate) {
        singular <- object$singular
        error.df <- object$error.df
        table <- matrix(0, nterms, 6)
        table2 <- matrix(0, nterms, 4)
        table3 <- matrix(0, nterms, 2)
        rownames(table3) <- rownames(table2) <- rownames(table) <- object$terms
        colnames(table) <- c("SS", "num Df", "Error SS", "den Df", "F", "Pr(>F)")
        colnames(table2) <- c("GG eps", "Pr(>F[GG])", "HF eps","Pr(>F[HF])")
        colnames(table3) <- c("Test statistic", "p-value")
        if (singular) 
            warning("Singular error SSP matrix:\nnon-sphericity test and corrections not available")
        for (term in 1:nterms) {
            SSP <- object$SSP[[term]]
            SSPE <- object$SSPE[[term]]
            P <- object$P[[term]]
            p <- ncol(P)
            PtPinv <- solve(t(P) %*% P)
            gg <- if (!singular) GG(SSPE, P) else NA
            table[term, "SS"] <- sum(diag(SSP %*% PtPinv))
            table[term, "Error SS"] <- sum(diag(SSPE %*% PtPinv))
            table[term, "num Df"] <- object$df[term] * p
            table[term, "den Df"] <- error.df * p
            table[term, "F"] <- (table[term, "SS"]/table[term, "num Df"])/
                (table[term, "Error SS"]/table[term, "den Df"])
            table[term, "Pr(>F)"] <- pf(table[term, "F"], table[term, "num Df"], table[term, "den Df"], 
                lower.tail = FALSE)
            table2[term, "GG eps"] <- gg
            table2[term, "HF eps"] <- if (!singular) HF(gg, error.df, p) else NA
            table3[term, ] <- if (!singular) mauchly(SSPE, P, object$error.df) else NA
        }
        table3 <- na.omit(table3)
        if (nrow(table3) > 0) {
            table2[, "Pr(>F[GG])"] <- pf(table[, "F"], table2[, "GG eps"] * 
                    table[, "num Df"], table2[, "GG eps"] * table[, "den Df"], 
                lower.tail = FALSE)
            table2[, "Pr(>F[HF])"] <- pf(table[, "F"], pmin(1, table2[, "HF eps"]) * 
                    table[, "num Df"], pmin(1, table2[, "HF eps"]) * table[, "den Df"], 
                lower.tail = FALSE)
            table2 <- na.omit(table2)
            if (any(table2[, "HF eps"] > 1)) warning("HF eps > 1 treated as 1")
        }
        class(table3) <- class(table) <- "anova"
        summary.object$univariate.tests <- table
        summary.object$pval.adjustments <- table2
        summary.object$sphericity.tests <- table3
    }
    class(summary.object) <- "summary.Anova.mlm"
    summary.object
}

print.summary.Anova.mlm <- function(x, digits = getOption("digits"), ... ) {
    if (!is.null(x$multivariate.tests)) {
        cat(paste("\nType ", x$type, if (x$repeated) 
            " Repeated Measures", " MANOVA Tests:\n", sep = ""))
        if (!x$repeated) {
            cat("\nSum of squares and products for error:\n")
            print(x$SSPE, digits = digits)
        }
        for (term in 1:length(x$multivariate.tests)) {
            cat(paste("\n------------------------------------------\n", 
                "\nTerm:", names(x$multivariate.tests)[term], "\n"))
            print(x$multivariate.tests[[term]], digits = digits, SSPE = x$repeated, ...)
        }
    }
    if  (!is.null(x$univariate.tests)) {
        cat("\nUnivariate Type", x$type, "Repeated-Measures ANOVA Assuming Sphericity\n\n")
        print(x$univariate.tests)
        if (nrow(x$sphericity.tests) > 0) {
            cat("\n\nMauchly Tests for Sphericity\n\n")
            print(x$sphericity.tests)
            cat("\n\nGreenhouse-Geisser and Huynh-Feldt Corrections\n", 
                "for Departure from Sphericity\n\n")
            table <- x$pval.adjustments[, 1:2, drop = FALSE]
            class(table) <- "anova"
            print(table)
            cat("\n")
            table <- x$pval.adjustments[, 3:4, drop = FALSE]
            class(table)
            print(table)
        }
    }
    invisible(x)
}

Anova.manova <- function(mod, ...){
	class(mod) <- c("mlm", "lm")
	Anova(mod, ...)
}

Manova <- function(mod, ...){
	UseMethod("Manova")
}

Manova.mlm <- function(mod, ...){
	Anova(mod, ...)
}

# Cox regression models

df.residual.coxph <- function(object, ...){    
	object$n - sum(!is.na(coef(object)))
}

alias.coxph <- function(model){
	if(any(which <- is.na(coef(model)))) return(list(Complete=which))
	else list()
}

logLik.coxph <- function(object, ...) object$loglik[2]

Anova.coxph <- function(mod, type=c("II","III", 2, 3), test.statistic=c("LR", "Wald"), ...){
	type <- as.character(type)
	type <- match.arg(type)
	test.statistic <- match.arg(test.statistic)
	if (length((mod$rscore) > 0) && (test.statistic == "LR")){ 
		warning("LR tests unavailable with robust variances\nWald tests substituted")
		test.statistic <- "Wald"
	}
	switch(type,
			II=switch(test.statistic,
					LR=Anova.II.LR.coxph(mod),
					Wald=Anova.default(mod, type="II", test.statistic="Chisq", vcov.=vcov(mod))),
			III=switch(test.statistic,
					LR=Anova.III.LR.coxph(mod),
					Wald=Anova.default(mod, type="III", test.statistic="Chisq", vcov.=vcov(mod))),
			"2"=switch(test.statistic,
					LR=Anova.II.LR.coxph(mod),
					Wald=Anova.default(mod, type="II", test.statistic="Chisq", vcov.=vcov(mod))),
			"3"=switch(test.statistic,
					LR=Anova.III.LR.coxph(mod),
					Wald=Anova.default(mod, type="III", test.statistic="Chisq", vcov.=vcov(mod))))
}

Anova.II.LR.coxph <- function(mod, ...){
  if (!requireNamespace("survival")) stop("survival package is missing")
	which.nms <- function(name) which(asgn == which(names == name))
	fac <-attr(terms(mod), "factors")
	names <- term.names(mod)
	n.terms <- length(names)
	if (n.terms < 2) return(anova(mod, test="Chisq"))
	X <- model.matrix(mod)
	asgn <- attr(X, 'assign')
	p <- LR <- rep(0, n.terms)
	df <- df.terms(mod)
	for (term in 1:n.terms){
		rels <- names[relatives(names[term], names, fac)]
		exclude.1 <- as.vector(unlist(sapply(c(names[term], rels), which.nms)))
		mod.1 <- survival::coxph(mod$y ~ X[, -exclude.1, drop = FALSE])
		loglik.1 <- logLik(mod.1)
		mod.2 <- if (length(rels) == 0) mod
				else {
					exclude.2 <- as.vector(unlist(sapply(rels, which.nms)))
					survival::coxph(mod$y ~ X[, -exclude.2, drop = FALSE])
				}
		loglik.2 <- logLik(mod.2)
		LR[term] <- -2*(loglik.1 - loglik.2)
		p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- "Analysis of Deviance Table (Type II tests)"
	result
}

Anova.III.LR.coxph <- function(mod, ...){
  if (!requireNamespace("survival")) stop("survival package is missing")
	which.nms <- function(name) which(asgn == which(names == name))
	fac <-attr(terms(mod), "factors")
	names <- term.names(mod)
	n.terms <- length(names)
	if (n.terms < 2) return(anova(mod, test="Chisq"))
	X <- model.matrix(mod)
	asgn <- attr(X, 'assign')
	df <- df.terms(mod)
	LR <- p <- rep(0, n.terms)
	loglik1 <- logLik(mod)
	for (term in 1:n.terms){
		mod.0 <- survival::coxph(mod$y ~ X[, -which.nms(names[term])])
		LR[term] <- -2*(logLik(mod.0) - loglik1)
		p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
	}
	result <- data.frame(LR, df, p)
	row.names(result) <- names
	names(result) <- c("LR Chisq", "Df","Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result,"heading") <- "Analysis of Deviance Table (Type III tests)"
	result
}

# parametric survival regression models

alias.survreg <- function(model){
	if(any(which <- diag(vcov(model)) < 1e-10)) return(list(Complete=which))
	else list()
}

logLik.survreg <- function(object, ...) object$loglik[2]

Anova.survreg <- function(mod, type=c("II","III", 2, 3), test.statistic=c("LR", "Wald"), ...){
	type <- as.character(type)
	type <- match.arg(type)
	test.statistic <- match.arg(test.statistic)
	if (length((mod$rscore) > 0) && (test.statistic == "LR")){ 
		warning("LR tests unavailable with robust variances\nWald tests substituted")
		test.statistic <- "Wald"
	}
	switch(type,
			II=switch(test.statistic,
					LR=Anova.II.LR.survreg(mod),
					Wald=Anova.II.Wald.survreg(mod)),
			III=switch(test.statistic,
					LR=Anova.III.LR.survreg(mod),
					Wald=Anova.III.Wald.survreg(mod)),
			"2"=switch(test.statistic,
					LR=Anova.II.LR.survreg(mod),
					Wald=Anova.II.Wald.survreg(mod)),
			"3"=switch(test.statistic,
					LR=Anova.III.LR.survreg(mod),
					Wald=Anova.III.Wald.survreg(mod)))
}

Anova.II.LR.survreg <- function(mod, ...){
  if (!requireNamespace("survival")) stop("survival package is missing")
  dist <- mod$dist
  scale <- mod$call$scale
  weights <- model.frame(mod)$"(weights)"
  arg.list <- list(dist=dist)
  if (!is.null(scale)) arg.list$scale <- scale
  if (!is.null(weights)) arg.list$weights <- weights
  which.nms <- function(name) which(asgn == which(names == name))
  fac <-attr(terms(mod), "factors")
  names <- term.names(mod)
  X <- model.matrix(mod)
  asgn <- attr(X, 'assign')
  asgn <- asgn[asgn != 0]
  if (has.intercept(mod)){
    int <- which(names == "(Intercept)")
    X <- X[, -int]
    names <- names[-int]
  }
  n.terms <- length(names)
  if (n.terms < 2) return(anova(mod))
  p <- LR <- rep(0, n.terms)
  df <- df.terms(mod)
  y <- model.frame(mod)[,1]
  for (term in 1:n.terms){
    rels <- names[relatives(names[term], names, fac)]
    exclude.1 <- as.vector(unlist(sapply(c(names[term], rels), which.nms)))
    arg.list$formula <- y ~ X[, -exclude.1, drop = FALSE]
    mod.1 <- do.call(survival::survreg, arg.list)
    #    mod.1 <- survival::survreg(y ~ X[, -exclude.1, drop = FALSE])
    loglik.1 <- logLik(mod.1)
    mod.2 <- if (length(rels) == 0) mod
    else {
      arg.list$formula <- y ~ X[, -exclude.2, drop = FALSE]
      exclude.2 <- as.vector(unlist(sapply(rels, which.nms)))
      do.call(survival::survreg, arg.list)     
      #     survival::survreg(y ~ X[, -exclude.2, drop = FALSE])
    }
    loglik.2 <- logLik(mod.2)
    LR[term] <- -2*(loglik.1 - loglik.2)
    p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
  }
  result <- data.frame(LR, df, p)
  row.names(result) <- names
  names(result) <- c("LR Chisq", "Df", "Pr(>Chisq)")
  class(result) <- c("anova", "data.frame")
  attr(result, "heading") <- "Analysis of Deviance Table (Type II tests)"
  result
}

Anova.III.LR.survreg <- function(mod, ...){
  if (!requireNamespace("survival")) stop("survival package is missing")
  dist <- mod$dist
  scale <- mod$call$scale
  weights <- model.frame(mod)$"(weights)"
  arg.list <- list(dist=dist)
  if (!is.null(scale)) arg.list$scale <- scale
  if (!is.null(weights)) arg.list$weights <- weights
  which.nms <- function(name) which(asgn == which(names == name))
  fac <-attr(terms(mod), "factors")
  names <- term.names(mod)
  X <- model.matrix(mod)
  asgn <- attr(X, 'assign')
  asgn <- asgn[asgn != 0]
  if (has.intercept(mod)){
    int <- which(names == "(Intercept)")
    X <- X[, -int]
    names <- names[-int]
  }
  n.terms <- length(names)
  if (n.terms < 2) return(anova(mod))
  p <- LR <- rep(0, n.terms)
  df <- df.terms(mod)
  y <- model.frame(mod)[,1]
  loglik1 <- logLik(mod)
  for (term in 1:n.terms){
    arg.list$formula <- y ~ X[, -which.nms(names[term])]
    mod.0 <- do.call(survival::survreg, arg.list)
    #    mod.0 <- survival::survreg(y ~ X[, -which.nms(names[term])])
    LR[term] <- -2*(logLik(mod.0) - loglik1)
    p[term] <- pchisq(LR[term], df[term], lower.tail=FALSE)
  }
  result <- data.frame(LR, df, p)
  row.names(result) <- names
  names(result) <- c("LR Chisq", "Df","Pr(>Chisq)")
  class(result) <- c("anova", "data.frame")
  attr(result,"heading") <- "Analysis of Deviance Table (Type III tests)"
  result
}

Anova.II.Wald.survreg <- function(mod){
	V <- vcov(mod)
	p <- which(rownames(V) == "Log(scale)")
	if (length(p) > 0) V <- V[-p, -p]
	Anova.II.default(mod, V, test="Chisq")
}

Anova.III.Wald.survreg <- function(mod){
	V <- vcov(mod)
	p <- which(rownames(V) == "Log(scale)")
	if (length(p) > 0) V <- V[-p, -p]
	Anova.III.default(mod, V, test="Chisq")
}

# Default Anova() method: requires methods for vcov() (if vcov. argument not specified) and coef().

Anova.default <- function(mod, type=c("II","III", 2, 3), test.statistic=c("Chisq", "F"), 
		vcov.=vcov(mod), singular.ok, ...){
    if (is.function(vcov.)) vcov. <- vcov.(mod)
	type <- as.character(type)
	type <- match.arg(type)
	test.statistic <- match.arg(test.statistic)
	if (missing(singular.ok))
		singular.ok <- type == "2" || type == "II"
	switch(type,
			II=Anova.II.default(mod, vcov., test.statistic, singular.ok=singular.ok),
			III=Anova.III.default(mod, vcov., test.statistic, singular.ok=singular.ok),
			"2"=Anova.II.default(mod, vcov., test.statistic, singular.ok=singular.ok),
			"3"=Anova.III.default(mod, vcov., test.statistic, singular.ok=singular.ok))
}

Anova.II.default <- function(mod, vcov., test, singular.ok=TRUE, ...){
	hyp.term <- function(term){
		which.term <- which(term==names)
		subs.term <- which(assign==which.term)
		relatives <- relatives(term, names, fac)
		subs.relatives <- NULL
		for (relative in relatives) 
			subs.relatives <- c(subs.relatives, which(assign==relative))
		hyp.matrix.1 <- I.p[subs.relatives,,drop=FALSE]
		hyp.matrix.1 <- hyp.matrix.1[, not.aliased, drop=FALSE]
		hyp.matrix.2 <- I.p[c(subs.relatives,subs.term),,drop=FALSE]
		hyp.matrix.2 <- hyp.matrix.2[, not.aliased, drop=FALSE]       
		hyp.matrix.term <- if (nrow(hyp.matrix.1) == 0) hyp.matrix.2
				else t(ConjComp(t(hyp.matrix.1), t(hyp.matrix.2), vcov.))            
		hyp.matrix.term <- hyp.matrix.term[!apply(hyp.matrix.term, 1, 
						function(x) all(x == 0)), , drop=FALSE]
		if (nrow(hyp.matrix.term) == 0)
			return(c(statistic=NA, df=0))            
		hyp <- linearHypothesis.default(mod, hyp.matrix.term, 
				vcov.=vcov., test=test, singular.ok=singular.ok, ...)
		if (test=="Chisq") c(statistic=hyp$Chisq[2], df=hyp$Df[2])
		else c(statistic=hyp$F[2], df=hyp$Df[2])
	}
	not.aliased <- !is.na(coef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	fac <- attr(mod$terms, "factors")
	intercept <- has.intercept(mod)
	p <- length(coefficients(mod))
	I.p <- diag(p)
	assign <- attr(model.matrix(mod), "assign")
	assign[!not.aliased] <- NA
	names <- term.names(mod)
	if (intercept) names <- names[-1]
	n.terms <- length(names)
	df <- c(rep(0, n.terms), df.residual(mod))
	if (inherits(mod, "coxph")){
		assign <- assign[assign != 0]
		clusters <- grep("^cluster\\(", names)
		if (length(clusters) > 0) {
			names <- names[-clusters]
			df <- df[-clusters]
		}
	}
	p <- teststat <- rep(0, n.terms + 1)
	teststat[n.terms + 1] <- p[n.terms + 1] <- NA
	for (i in 1:n.terms){
		hyp <- hyp.term(names[i])
		teststat[i] <- abs(hyp["statistic"])
		df[i] <- abs(hyp["df"])
		p[i] <- if (test == "Chisq") 
					pchisq(teststat[i], df[i], lower.tail=FALSE) 
				else pf(teststat[i], df[i], df[n.terms + 1], lower.tail=FALSE)
	}    
	result <- data.frame(df, teststat, p)
	row.names(result) <- c(names,"Residuals")
	names(result) <- c ("Df", test, if (test == "Chisq") "Pr(>Chisq)" 
					else "Pr(>F)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type II tests)\n", 
			paste("Response:", responseName(mod)))
	result
}

Anova.III.default <- function(mod, vcov., test, singular.ok=FALSE, ...){
	intercept <- has.intercept(mod)
	p <- length(coefficients(mod))
	I.p <- diag(p)
	names <- term.names(mod)
	n.terms <- length(names)
	assign <- attr(model.matrix(mod), "assign")
	df <- c(rep(0, n.terms), df.residual(mod))
	if (inherits(mod, "coxph")){
		if (intercept) names <- names[-1]
		assign <- assign[assign != 0]
		clusters <- grep("^cluster\\(", names)
		if (length(clusters) > 0) {
			names <- names[-clusters]
			df <- df[-clusters]
		}
	}
	if (intercept) df[1] <- 1
	teststat <- rep(0, n.terms + 1)
	p <- rep(0, n.terms + 1)
	teststat[n.terms + 1] <- p[n.terms + 1] <- NA
	not.aliased <- !is.na(coef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	for (term in 1:n.terms){
		subs <- which(assign == term - intercept)        
		hyp.matrix <- I.p[subs,,drop=FALSE]
		hyp.matrix <- hyp.matrix[, not.aliased, drop=FALSE]
		hyp.matrix <- hyp.matrix[!apply(hyp.matrix, 1, function(x) all(x == 0)), , drop=FALSE]        
		if (nrow(hyp.matrix) == 0){
			teststat[term] <- NA
			df[term] <- 0
			p[term] <- NA
		}
		else {
			hyp <- linearHypothesis.default(mod, hyp.matrix, 
					vcov.=vcov., test=test, singular.ok=singular.ok, ...)
			teststat[term] <- if (test=="Chisq") hyp$Chisq[2] else hyp$F[2]
			df[term] <- abs(hyp$Df[2])
			p[term] <- if (test == "Chisq") 
						pchisq(teststat[term], df[term], lower.tail=FALSE) 
					else pf(teststat[term], df[term], df[n.terms + 1], lower.tail=FALSE)
		}
	}
	result <- data.frame(df, teststat, p)
	row.names(result) <- c(names, "Residuals")
	names(result) <- c ("Df", test, if (test == "Chisq") "Pr(>Chisq)" 
					else "Pr(>F)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type III tests)\n", 
			paste("Response:", responseName(mod)))
	result
}

## functions for mixed models

# the following function, not exported, to make car consistent with CRAN and development versions of lme4 and with nlme

fixef <- function (object){
	if (isS4(object)) {
        if (!inherits(object, "merMod")) object@fixef
        else lme4::fixef(object)
	}
    else object$coefficients$fixed
}

Anova.merMod <- function(mod, type=c("II","III", 2, 3), 
                         test.statistic=c("Chisq", "F"),
                         vcov.=vcov(mod), singular.ok, ...){
    if (is.function(vcov.)) vcov. <- vcov.(mod)
    type <- as.character(type)
    type <- match.arg(type)
    test.statistic <- match.arg(test.statistic)
    if (missing(singular.ok))
        singular.ok <- type == "2" || type == "II"
    Anova.mer(mod=mod, type=type, test.statistic=test.statistic, vcov.=vcov.,
              singular.ok=singular.ok, ...)
}

Anova.mer <- function(mod, type=c("II","III", 2, 3), test.statistic=c("Chisq", "F"),
		vcov.=vcov(mod), singular.ok, ...){
    if (is.function(vcov.)) vcov. <- vcov.(mod)
	type <- as.character(type)
	type <- match.arg(type)
	test.statistic <- match.arg(test.statistic)
	if (missing(singular.ok))
		singular.ok <- type == "2" || type == "II"
	switch(type,
			II=Anova.II.mer(mod, test=test.statistic, vcov., singular.ok=singular.ok),
			III=Anova.III.mer(mod, test=test.statistic,  vcov., singular.ok=singular.ok),
			"2"=Anova.II.mer(mod, test=test.statistic, vcov., singular.ok=singular.ok),
			"3"=Anova.III.mer(mod, test=test.statistic, vcov., singular.ok=singular.ok))
}

Anova.II.mer <- function(mod, vcov., singular.ok=TRUE, test=c("Chisq", "F"), ...){
	hyp.term <- function(term){
		which.term <- which(term==names)
		subs.term <- which(assign==which.term)
		relatives <- relatives(term, names, fac)
		subs.relatives <- NULL
		for (relative in relatives) 
			subs.relatives <- c(subs.relatives, which(assign==relative))
		hyp.matrix.1 <- I.p[subs.relatives,,drop=FALSE]
		hyp.matrix.1 <- hyp.matrix.1[, not.aliased, drop=FALSE]
		hyp.matrix.2 <- I.p[c(subs.relatives,subs.term),,drop=FALSE]
		hyp.matrix.2 <- hyp.matrix.2[, not.aliased, drop=FALSE]       
		hyp.matrix.term <- if (nrow(hyp.matrix.1) == 0) hyp.matrix.2
				else t(ConjComp(t(hyp.matrix.1), t(hyp.matrix.2), vcov.))            
		hyp.matrix.term <- hyp.matrix.term[!apply(hyp.matrix.term, 1, 
						function(x) all(x == 0)), , drop=FALSE]
		if (nrow(hyp.matrix.term) == 0)
			return(c(statistic=NA, df=0))            
		hyp <- linearHypothesis(mod, hyp.matrix.term, 
				vcov.=vcov., singular.ok=singular.ok, test=test, ...)
		if (test == "Chisq") return(c(statistic=hyp$Chisq[2], df=hyp$Df[2]))
		else return(c(statistic=hyp$F[2], df=hyp$Df[2], res.df=hyp$Res.Df[2]))
	}
	test <- match.arg(test)
	not.aliased <- !is.na(fixef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	fac <- attr(terms(mod), "factors")
	intercept <- has.intercept(mod)
	p <- length(fixef(mod))
	I.p <- diag(p)
	if (!missing(vcov.)){
		vcov. <- if (test == "F"){
#					if (!require("pbkrtest")) stop("pbkrtest package required for F-tests on linear mixed model")
					as.matrix(vcovAdj(mod, details=0))
				}
				else vcov(mod)
	}
	assign <- attr(model.matrix(mod), "assign")
	assign[!not.aliased] <- NA
	names <- term.names(mod)
	if (intercept) names <- names[-1]
	n.terms <- length(names)
	p <- teststat <- df <- res.df <- rep(0, n.terms)
	for (i in 1:n.terms){
		hyp <- hyp.term(names[i])
		teststat[i] <- abs(hyp["statistic"])
		df[i] <- abs(hyp["df"])
		res.df[i] <- hyp["res.df"]
		p[i] <- if (test == "Chisq") pchisq(teststat[i], df[i], lower.tail=FALSE) 
				else pf(teststat[i], df[i], res.df[i], lower.tail=FALSE)
	} 
	if (test=="Chisq"){
		result <- data.frame(teststat, df, p)
		row.names(result) <- names
		names(result) <- c ("Chisq", "Df", "Pr(>Chisq)")
		class(result) <- c("anova", "data.frame")
		attr(result, "heading") <- c("Analysis of Deviance Table (Type II Wald chisquare tests)\n", 
				paste("Response:", responseName(mod)))
	}
	else {
		result <- data.frame(teststat, df, res.df, p)
		row.names(result) <- names
		names(result) <- c ("F", "Df", "Df.res", "Pr(>F)")
		class(result) <- c("anova", "data.frame")
		attr(result, "heading") <- c("Analysis of Deviance Table (Type II Wald F tests with Kenward-Roger df)\n", 
				paste("Response:", responseName(mod)))
	}
	result
}

Anova.III.mer <- function(mod, vcov., singular.ok=FALSE, test=c("Chisq", "F"), ...){
	intercept <- has.intercept(mod)
	p <- length(fixef(mod))
	I.p <- diag(p)
	names <- term.names(mod)
	n.terms <- length(names)
	assign <- attr(model.matrix(mod), "assign")
	p <- teststat <- df <- res.df <- rep(0, n.terms)
	if (intercept) df[1] <- 1
	not.aliased <- !is.na(fixef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	if (!missing(vcov.)){
		vcov. <- if (test == "F"){
#					if (!require("pbkrtest")) stop("pbkrtest package required for F-tests on linear mixed model")
					as.matrix(vcovAdj(mod, details=0))
				}
				else vcov(mod)
	}
	for (term in 1:n.terms){
		subs <- which(assign == term - intercept)        
		hyp.matrix <- I.p[subs,,drop=FALSE]
		hyp.matrix <- hyp.matrix[, not.aliased, drop=FALSE]
		hyp.matrix <- hyp.matrix[!apply(hyp.matrix, 1, function(x) all(x == 0)), , drop=FALSE]        
		if (nrow(hyp.matrix) == 0){
			teststat[term] <- NA
			df[term] <- 0
			p[term] <- NA
		}
		else {
			hyp <- linearHypothesis(mod, hyp.matrix, test=test,
					vcov.=vcov., singular.ok=singular.ok, ...)
			if (test == "Chisq"){
				teststat[term] <-  hyp$Chisq[2] 
				df[term] <- abs(hyp$Df[2])
				p[term] <- pchisq(teststat[term], df[term], lower.tail=FALSE) 
			}
			else{
				teststat[term] <-  hyp$F[2]
				df[term] <- abs(hyp$Df[2])
				res.df[term]=hyp$Res.Df[2]
				p[term] <- pf(teststat[term], df[term], res.df[term], lower.tail=FALSE)
			}
		}
	}
	if (test == "Chisq"){
		result <- data.frame(teststat, df, p)
		row.names(result) <- names
		names(result) <- c ("Chisq", "Df", "Pr(>Chisq)")
		class(result) <- c("anova", "data.frame")
		attr(result, "heading") <- c("Analysis of Deviance Table (Type III Wald chisquare tests)\n", 
				paste("Response:", responseName(mod)))
	}
	else {
		result <- data.frame(teststat, df, res.df, p)
		row.names(result) <- names
		names(result) <- c ("F", "Df", "Df.res", "Pr(>F)")
		class(result) <- c("anova", "data.frame")
		attr(result, "heading") <- c("Analysis of Deviance Table (Type III Wald F tests with Kenward-Roger df)\n", 
				paste("Response:", responseName(mod)))
	}
	result
}

Anova.lme <- function(mod, type=c("II","III", 2, 3),
		vcov.=vcov(mod), singular.ok, ...){
    if (is.function(vcov.)) vcov. <- vcov.(mod)
	type <- as.character(type)
	type <- match.arg(type)
	if (missing(singular.ok))
		singular.ok <- type == "2" || type == "II"
	switch(type,
			II=Anova.II.lme(mod, vcov., singular.ok=singular.ok),
			III=Anova.III.lme(mod, vcov., singular.ok=singular.ok),
			"2"=Anova.II.lme(mod, vcov., singular.ok=singular.ok),
			"3"=Anova.III.lme(mod, vcov., singular.ok=singular.ok))
}

Anova.II.lme <- function(mod, vcov., singular.ok=TRUE, ...){
	hyp.term <- function(term){
		which.term <- which(term==names)
		subs.term <- which(assign==which.term)
		relatives <- relatives(term, names, fac)
		subs.relatives <- NULL
		for (relative in relatives) 
			subs.relatives <- c(subs.relatives, which(assign==relative))
		hyp.matrix.1 <- I.p[subs.relatives,,drop=FALSE]
		hyp.matrix.1 <- hyp.matrix.1[, not.aliased, drop=FALSE]
		hyp.matrix.2 <- I.p[c(subs.relatives,subs.term),,drop=FALSE]
		hyp.matrix.2 <- hyp.matrix.2[, not.aliased, drop=FALSE]       
		hyp.matrix.term <- if (nrow(hyp.matrix.1) == 0) hyp.matrix.2
				else t(ConjComp(t(hyp.matrix.1), t(hyp.matrix.2), vcov.))            
		hyp.matrix.term <- hyp.matrix.term[!apply(hyp.matrix.term, 1, 
						function(x) all(x == 0)), , drop=FALSE]
		if (nrow(hyp.matrix.term) == 0)
			return(c(statistic=NA, df=0))            
		hyp <- linearHypothesis(mod, hyp.matrix.term, 
				vcov.=vcov., singular.ok=singular.ok, ...)
		c(statistic=hyp$Chisq[2], df=hyp$Df[2])
	}
	not.aliased <- !is.na(fixef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	fac <- attr(terms(mod), "factors")
	intercept <- has.intercept(mod)
	p <- length(fixef(mod))
	I.p <- diag(p)
	assign <- attr(model.matrix(mod), "assign")
	assign[!not.aliased] <- NA
	names <- term.names(mod)
	if (intercept) names <- names[-1]
	n.terms <- length(names)
	p <- teststat <- df <- rep(0, n.terms)
	for (i in 1:n.terms){
		hyp <- hyp.term(names[i])
		teststat[i] <- abs(hyp["statistic"])
		df[i] <- abs(hyp["df"])
		p[i] <- pchisq(teststat[i], df[i], lower.tail=FALSE) 
	}    
	result <- data.frame(teststat, df, p)
	row.names(result) <- names
	names(result) <- c("Chisq", "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type II tests)\n", 
			paste("Response:", responseName(mod)))
	result
}

Anova.III.lme <- function(mod, vcov., singular.ok=FALSE, ...){
	intercept <- has.intercept(mod)
	p <- length(coefficients(mod))
	I.p <- diag(p)
	names <- term.names(mod)
	n.terms <- length(names)
	assign <- attr(model.matrix(mod), "assign")
	df <- rep(0, n.terms)
	if (intercept) df[1] <- 1
	p <- teststat <-rep(0, n.terms)
	not.aliased <- !is.na(fixef(mod))
	if (!singular.ok && !all(not.aliased))
		stop("there are aliased coefficients in the model")
	for (term in 1:n.terms){
		subs <- which(assign == term - intercept)        
		hyp.matrix <- I.p[subs,,drop=FALSE]
		hyp.matrix <- hyp.matrix[, not.aliased, drop=FALSE]
		hyp.matrix <- hyp.matrix[!apply(hyp.matrix, 1, function(x) all(x == 0)), , drop=FALSE]        
		if (nrow(hyp.matrix) == 0){
			teststat[term] <- NA
			df[term] <- 0
			p[term] <- NA
		}
		else {
			hyp <- linearHypothesis(mod, hyp.matrix, 
					vcov.=vcov., singular.ok=singular.ok, ...)
			teststat[term] <-  hyp$Chisq[2] 
			df[term] <- abs(hyp$Df[2])
			p[term] <- pchisq(teststat[term], df[term], lower.tail=FALSE) 
		}
	}
	result <- data.frame(teststat, df, p)
	row.names(result) <- names
	names(result) <- c ("Chisq",  "Df", "Pr(>Chisq)")
	class(result) <- c("anova", "data.frame")
	attr(result, "heading") <- c("Analysis of Deviance Table (Type III tests)\n", 
			paste("Response:", responseName(mod)))
	result
}

Anova.svyglm <- function(mod, ...) Anova.default(mod, ...)

Anova.rlm <- function(mod, ...) Anova.default(mod, test.statistic="F", ...)

library(synapseClient)
synapseLogin()

q1f <- synGet("syn2775267", downloadLocation='.')
q2f <- synGet("syn2775268", downloadLocation='.')
q3f <- synGet("syn2775269", downloadLocation='.')

load('q1f.submissions.metadata.RData')
load('q2f.submissions.metadata.RData')
load('q3f.submissions.metadata.RData')

## Do we want to be strict about excluding submissions that
## were accepted when the leaderboards were officially supposed
## to be closed?
filter_on_timestamps = FALSE

for (abr in c("q1f", "q2f", "q3f")) {

    df <- get(paste0(abr,".submissions.metadata"))

    ## curses upon you, stringsAsFactors!
    for (i in which(sapply(df, class)=='factor')) {
        df[[i]] <- as.character(df[[i]])
    }

    ## remove bogus columns
    df <- df[,-which(colnames(df) %in% c('entityId.1', 'submission_number'))]

    ## remove admin team users
    ## 1421212 = Chris Bare
    ##  377358 = Chris Bare
    ##  273995 = Mette Peters
    df <- df[!df$userId %in% c(273995, 1421212, 377358),]

    ## correct fat-fingered team names
    df$team[df$team=='ATeam with Organizers'] <- 'ATeam of Organizers'
    df$team[df$team=='BIAS'] <- 'UNC-BIAS'
    df$team[df$team=='BAIS'] <- 'UNC-BIAS'
    df$team[grep("guanlab", df$team , ignore.case=T)] <- 'GuanLab_UMich'

    ## filter based on eligible time stamps:
    ## By Saturday 10/18 7am GMT
    ## Between Thursday 10/23 7pm GMT and Friday 10/24 7pm GMT
    ## But, we made an exception for the 'Chipmunks' team...
    if (filter_on_timestamps) {
        eligible <- (df$createdOn < "2014-10-18T07:00:00" |
                     (df$createdOn > "2014-10-23T19:00:00" & df$createdOn < "2014-10-24T19:00:00") |
                     df$team == 'Chipmunks')
        if (nrow(df) > sum(eligible)) {
            print(sprintf("Excluding from %s based on dates:", abr))
            print(df[!eligible, c('id', 'createdOn', 'userId', 'team', 'final_rank')])
        }
        df <- df[eligible,]
    }

    ## select the latest two submissions from each team
    two_latest_submissions <- lapply(unique(df$team), function(team) {
        df_team <- df[ df$team==team, ]
        df_team <- df_team[ order(df_team$createdOn), ]
        df_team[ max(1,nrow(df_team)-1):max(1, nrow(df_team)), ]
    })

    df_latest_two <- do.call(rbind, two_latest_submissions)

    assign(paste0(abr, ".eligible.submissions.metadata"), df_latest_two)
}

save(q1f.eligible.submissions.metadata, file='q1f.eligible.submissions.metadata.RData')
save(q2f.eligible.submissions.metadata, file='q2f.eligible.submissions.metadata.RData')
save(q3f.eligible.submissions.metadata, file='q3f.eligible.submissions.metadata.RData')

# syn2786256
# syn2786258
# syn2786260

synStore(File('q1f.eligible.submissions.metadata.RData', parentId="syn2773668"), used="syn2775267", executed="syn2786177")
synStore(File('q2f.eligible.submissions.metadata.RData', parentId="syn2773668"), used="syn2775268", executed="syn2786177")
synStore(File('q3f.eligible.submissions.metadata.RData', parentId="syn2773668"), used="syn2775269", executed="syn2786177")

# changed point marking, 25 November 2009 by S. Weisberg
#  deleted the cutoff for Cook's D, and the coloring of the circles
#  inserted default labeling of the id.n largest Cook D.
# 13 January 2009: changed to label points by all of hatvalues,
#  studentized residuals, and Cook's Ds. J. Fox
# 14 April 2010: set id.n = 0. J. Fox
# 23 April 2010: rewrote point marking, S. Weisberg
# 10 May 2010: fixed computation of n
# 2014-04-19: use labels for returned table rownames. J. Fox

# moved from Rcmdr 5 December 2006

influencePlot <- function(model, ...){
  UseMethod("influencePlot")
}

influencePlot.lm <- function(model, scale=10,  
                             xlab="Hat-Values", ylab="Studentized Residuals",
                             labels, id.method = "noteworthy",
                             id.n = if(id.method[1]=="identify") Inf else 0, 
                             id.cex=1, id.col=palette()[1], ...){ 
  hatval <- hatvalues(model)
  rstud <- rstudent(model)
  if (missing(labels)) labels <- names(rstud)
  cook <- sqrt(cooks.distance(model))
  scale <- scale/max(cook, na.rm=TRUE)
  p <- length(coef(model))
  n <- sum(!is.na(rstud))
  #	cutoff <- sqrt(4/(n - p))
  plot(hatval, rstud, xlab=xlab, ylab=ylab, type='n', ...)
  abline(v=c(2, 3)*p/n, lty=2)
  abline(h=c(-2, 0, 2), lty=2)
  #	points(hatval, rstud, cex=scale*cook, 
  #			col=ifelse(cooks <- cook > cutoff, col[2], col[1]))
  points(hatval, rstud, cex=scale*cook, ...)
  if(id.method != "identify"){
    which.rstud <- order(abs(rstud), decreasing=TRUE)[1:id.n]
    which.cook <- order(cook, decreasing=TRUE)[1:id.n]
    which.hatval <- order(hatval, decreasing=TRUE)[1:id.n]
    which.all <- union(which.rstud, union(which.cook, which.hatval))
    id.method <- which.all
  }
  noteworthy <- showLabels(hatval, rstud, labels=labels, id.method=id.method, 
                           id.n=id.n, id.cex=id.cex, id.col=id.col)
  if (length(noteworthy > 0)){
    result <- data.frame(StudRes=rstud[noteworthy], Hat=hatval[noteworthy],
                         CookD=cook[noteworthy])
    rownames(result) <- labels[noteworthy]
    return(result)
  }
  else return(invisible(NULL))
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

plot.proximity.rsf <- function (x, plot = TRUE, ...) {
   if (sum(inherits(x, c("rsf", "grow"), TRUE) == c(1, 2)) != 2 &
      sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) != 2)
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, predict)'")
  if (is.null(x$proximity))
    stop("Proximity is NULL.  Re-run analysis with proximity set to 'TRUE'.")
  if (length(x$proximity) == 1) return()
  proximity <- matrix(0, x$n, x$n)
  count <- 0
  for (k in 1:x$n){
    proximity[k,1:k] <- x$proximity[(count+1):(count+k)]
    proximity[1:k,k] <- proximity[k,1:k]
    count <- count+k
  }
  proximity <- proximity/diag(proximity)
  if (plot) {
    loc <- cmdscale(sqrt(1-proximity))
    old.par <- par(no.readonly = TRUE)
    par(mfrow = c(1,1))
    plot(loc[,1], -loc[,2], type="n", xlab="", ylab="", main="cmdscale(Ensemble Mortality)")
    if (sum(x$cens == 1) > 1 & sum(x$cens == 0) > 1) {
      text(loc[,1], -loc[,2],
           pmax(1, ceiling(100*(x$mortality -
                      min(x$mortality, na.rm = TRUE))/diff(range(x$mortality, na.rm = TRUE)))),
           col = 3*x$cens+1,
           cex = 0.8)
    }
    else {
      text(loc[,1], -loc[,2],
           pmax(1, ceiling(100*(x$mortality -
                      min(x$mortality, na.rm = TRUE))/diff(range(x$mortality, na.rm = TRUE)))),
           cex = 0.8)
    }
    par(old.par)
  }
  invisible(proximity)
}
plot.proximity <- plot.proximity.rsf

require(rms)
require(MASS)
require(survival)
require(predictiveModeling)
require(gbm)
require(caret)
#source("CreateMetageneSpace.R")

if(!require(DreamBox7)){
  download.file("http://dl.dropbox.com/u/11986954/Dream7BCC/DreamBox7_0.212.tar.gz", destfile="./DreamBox7_0.212.tar.gz")
  install.packages("./DreamBox7_0.212.tar.gz", repos=NULL)
  library(DreamBox7)
}

setRefClass(Class = "PredictiveModel")

#' GoldiModel
#'
#' Modified from DemoClinicalOnlyModel from BCC challenge.
#'
#' @author Wei-Yi Cheng, Tai-Hsien Ou Yang, and Dimitris Anastassiou
#' @export

GoldiModel <- setRefClass(Class  = "GoldiModel",
                          contains = "PredictiveModel",
                          fields   = c("model", "attractome", "cnvome",  "annot", "annot.cnv", "predictions", "ocgenes", "chosenProbes", "chosenProbes_g", "mdns"),
                          methods  = list(
                            
                            initialize = function(...){
                              	data(attractome.minimalist)
				.self$attractome = attractome.minimalist
				data(map)
                              	.self$annot = map
				data(oncogenes)
				.self$ocgenes = oncogenes
				data(metacnv)
				.self$cnvome = metacnv
				data(cnvmap)
				.self$annot.cnv = cnvmap
                              return(.self)
                            },
                            
                            customTrain = function(exprData, copyData, clinicalFeaturesData,clinicalSurvData,...)
                            {
                              if(class(clinicalSurvData) != "Surv"){
                                stop("Expecting 'responseData' object of type 'Surv'")
                              }
				ntrees = 1500
				#meta.cnv = CreateMetageneSpace(exprs(copyData), .self$cnvome, .self$annot.cnv)$metaSpace
                              # no need for cnv data, remove it
                              rm(copyData)
				clnc = lazyImputeDFClncFULL(clinicalFeaturesData)
                              	clinical <- expandClncFULL(clnc)

			cat("Create metagene space...");flush.console()
                              o = CreateMetageneSpace(exprs(exprData), .self$attractome, .self$annot)
				meta = o$metaSpace
				.self$chosenProbes = o$pbs
                              o = CreateMetageneSpace(exprs(exprData), .self$ocgenes, .self$annot)
				gs = o$metaSpace
				.self$chosenProbes_g = o$pbs
				tp53 = gs["TP53_g",]
				gs = t(apply(gs, 1, function(x){ x - median(x)}))
				
				ls = meta["ls",]
				col11a1 = exprs(exprData)["ILMN_2392803",]
				.self$mdns = apply(meta, 1, median)
				meta = t(apply(meta, 1, function(x){ x - median(x)}))
				#meta = meta - matrix(.self$mdns, nrow=nrow(meta), ncol=ncol(meta))
			#===== Conditioning mesenchymal transition metagene by lymph node status
				idx = (clinical[,"lymph_nodes_positive"]<1 & clinical[,"size"] < 30)
				mes.lymphneg = meta["mt",] * idx
				.self$mdns = c(.self$mdns, median(mes.lymphneg[idx]))
				mes.lymphneg[idx] = mes.lymphneg[idx] - median(mes.lymphneg[idx])
				meta = rbind(meta, mes.lymphneg)
				col11a1.lymphneg30 = col11a1 * idx
				col11a1.lymphneg30[idx] = col11a1.lymphneg30[idx] - median(col11a1.lymphneg30[idx])

				idx = (clinical[,"lymph_nodes_positive"] > 3)
				ls.lymphpos = ls * idx
				.self$mdns = c(.self$mdns, median(ls.lymphpos[idx]))
				ls.lymphpos[idx] = ls.lymphpos[idx] - median(ls.lymphpos[idx])
				meta = rbind(meta, ls.lymphpos)

				idx = (meta["er",] < 0 & meta["erbb2", ] < 0)
				ls.erneg = ls * idx
				.self$mdns = c(.self$mdns, median(ls.erneg[idx]))
				ls.erneg[idx] = ls.erneg[idx] - median(ls.erneg[idx])
				meta = rbind(meta, ls.erneg)
				
				names(.self$mdns) = rownames(meta)

				lymph = clinical[,"lymph_nodes_positive"]
				lsxlym = ls *lymph
				lsxlym = lsxlym - median(lsxlym)

				idx = meta["er",] < 0
				tp53.erneg = tp53 * idx
				tp53.erneg[idx] = tp53.erneg[idx] - median(tp53.erneg[idx])
				gs = rbind(gs, tp53.erneg)

				meta = rbind(meta, gs)

				#idx = meta["ls",] < 0
				#chr17p12 = meta.cnv["chr17p12",]
				#chr17p12.lsneg = chr17p12 * idx
				#meta = rbind(meta, chr17p12.lsneg)
			rm(exprData)

				#meta = rbind(meta, meta.cnv)

                        cat("done!\n");flush.console()
			
#===== 1. AIC models metagenes only =======
                        cat("1.  Training model with metagenes ...");flush.console()
                              #X = cbind(data.frame(t(meta))#[c("mitotic", "erbb2", "er", "chr7p11.2", "mes.lymphneg"),]))
				#	,clinical)
				X = data.frame(t(meta))
                              upper = terms(clinicalSurvData~(.), data = X)
                              coxmodel = step(coxph(clinicalSurvData~(.), data=X), scope=upper, direction="both", k=2, trace=FALSE)
                        cat("done!\n");flush.console()
#===== 2. GBM model =========
			cat("2.  Training gbm model...");flush.console()
				X = data.frame(t(meta))
				gbmmodel = gbm.cvrun(clinicalSurvData~.,data=X, distribution="coxph", shrinkage=0.002, n.trees=ntrees, interaction.depth=6, cv.folds=5, verbose=F, seed=913) # my bday ;D
			cat("done!\n");flush.console()
#===== 3. AIC models clinical only =====
			cat("3.  Training AIC model using only clinical features...");flush.console()
				X = clinical
                                upper = terms(clinicalSurvData~(.), data = X)
				cm = step(coxph(clinicalSurvData~1, data=X),scope=upper, direction="both", k=2, trace=FALSE)
                        cat("done!\n");flush.console()
#===== 4. GBM model =====
			cat("4.  Training gbm model...");flush.console()
				X = X[, attr(cm$terms, "term.labels")]
                                cgbm <- gbm.cvrun(clinicalSurvData~., data=X ,distribution="coxph", shrinkage=0.002, n.trees=ntrees, interaction.depth=10, cv.folds=5, verbose=F, seed=53) 
			cat("done!\n");flush.console()
#===== 5. AIC models on recycled features =======
                        cat("5.  Training AIC model with recycled features ...");flush.console()
                              #X = cbind(data.frame(t(meta))#[c("mitotic", "erbb2", "er", "chr7p11.2", "mes.lymphneg"),]))
				#	,clinical)
				X = cbind(data.frame(t(meta)), clinical)
				X = X[, removeTaggedFeatures(colnames(X), c(  attr(coxmodel$terms, "term.labels"), attr(cm$terms,"term.labels")   ))]
				#X = X[, setdiff(colnames(X), c(  attr(coxmodel$terms, "term.labels"), attr(cm$terms,"term.labels")   ))]
				#X = cbind(data.frame(t(meta)))
				#X = X[, setdiff(colnames(X), attr(coxmodel$terms, "term.labels") )]

                              upper = terms(clinicalSurvData~., data = X)
                              recycle = step(coxph(clinicalSurvData~(.), data=X), scope=upper, direction="both", k=2, trace=FALSE)
                        cat("done!\n");flush.console()

#===== 6. KNN model ======
			cat("6. Creating KNN database ...");flush.console()
			t = clinicalSurvData[,1]
			defSurvSamples = which(clinicalSurvData[,2]==1 | clinicalSurvData[,1] > 365 * 10)
			ccdi = getAllCCDIWz(meta, clinicalSurvData)
			#idx = ccdi[c("er", "mitotic", "puf60", "erbb2", "chr7p11.2", "ls", "mt", "chr15q26.1"
			#	, "VEGFA_g", "TP53_g","chr17q21.31", "chr19q13.2", "chrXp11.23")]
			idx = ccdi[c( "mitotic", "erbb2","ls", "mt", "chr7p11.2")]
			knnmodel = list()
			knnmodel$x.train = list(meta=meta[names(idx), defSurvSamples], time=t[defSurvSamples], concordance=idx)
			
			#clnc = lazyImputeDFClnc(clinicalFeaturesData)
			knnmodel$c.train = preproClncKNN(clnc, clinicalSurvData, ccdi.upper=0.6, ccdi.lower=0.4)

			cat("done!\n");flush.console()
#===== 7. Training cox model using minimal features =======
                        cat("7. Training clinical model with minimalist features...");flush.console()
				X = data.frame( cbind(meta["mitotic",], meta["ls.erneg",], clinical$lymph_nodes_positive, meta["mes.lymphneg",], meta["susd3",], clinical$age_at_diagnosis, clinical$tr.RT, clinical$tr.CT) )
				colnames(X) = c("CIN", "LYM_ERNeg", "lymNum", "MES_lymNumNeg", "SUSD3", "age", "tr.RT", "tr.CT")
				
                              cox.a = coxph(clinicalSurvData~., data=X)
                        cat("done!\n");

#===== 8. Training GBM model using minimal features =========
			cat("8. Training gbm model...");flush.console()
                        	#gbmmodel = gbm.fit(X,clinicalSurvData,distribution="coxph", shrinkage=0.001, n.trees=2000, interaction.depth=7, bag.fraction=1, train.fraction=1, verbose=F)
                                gbm.a <- gbm.cvrun(clinicalSurvData~., data=X ,distribution="coxph", shrinkage=0.002, n.trees=ntrees, interaction.depth=8, cv.folds=5, verbose=F, seed=913) #seed = my birthday :D !
			cat("done!\n");flush.console()
#===== 9. Training cox model using minimal features =======
                        cat("9. Training model with oncogene minimalist features...");flush.console()
				X = data.frame( cbind(meta["zmynd10",], col11a1.lymphneg30, clinical$age_at_diagnosis, clinical$tr.RT, clinical$tr.CT, meta["ls.erneg",], meta["TP53_g",], lsxlym, meta["VEGFA_g",]) )
				colnames(X) = c("ZMYND10", "COL11A1g_lymNumNeg", "age", "RT", "CT", "lym.erneg", "TP53g", "VEGFAg")
				
                              cox.b = coxph(clinicalSurvData~., data=X)
                        cat("done!\n");

#===== 10. Training GBM model using minimal features =========
			cat("10. Training gbm model...");flush.console()
                        	#gbmmodel = gbm.fit(X,clinicalSurvData,distribution="coxph", shrinkage=0.001, n.trees=2000, interaction.depth=7, bag.fraction=1, train.fraction=1, verbose=F)
                                gbm.b <- gbm.cvrun(clinicalSurvData~., data=X ,distribution="coxph", shrinkage=0.002, n.trees=ntrees, interaction.depth=8, cv.folds=5, verbose=F, seed=503) #seed = my birthday :D !
			cat("done!\n");flush.console()

                              .self$model <- list(coxmodel=coxmodel, 
						gbmmodel=gbmmodel, 
						cm=cm, 
						cgbm=cgbm, 
						recycle = recycle,
						knnmodel=knnmodel,
						cox.a=cox.a,
						gbm.a=gbm.a,
						cox.b=cox.b,
						gbm.b=gbm.b
						)
                            },
#================================
#
# customPredict
#
#====================================

                            customPredict = function(exprData, copyData, clinicalFeaturesData)
                            {
				#meta.cnv = CreateMetageneSpace(exprs(copyData), .self$cnvome, .self$annot.cnv)$metaSpace
                              rm(copyData)

				clnc = lazyImputeDFClncFULL(clinicalFeaturesData)
                              	clinical <- expandClncFULL(clnc)

                        cat("Create metagene space...");flush.console()
                              #meta = CreateMetageneSpace(exprs(exprData), .self$attractome, .self$annot)$metaSpace
                              meta = CreateMetageneSpace(exprs(exprData), chosenProbes = .self$chosenProbes)
				#meta = t(sapply(.self$chosenProbes, function(pbs){apply(exprs(exprData)[pbs,], 2, mean)}))
				#meta = t( sapply(.self$attractome, function(pbs){ apply(exprs(exprData)[pbs,] , 2, function(a){mean(a, na.rm=TRUE)}) }  ) )
                              gs = CreateMetageneSpace(exprs(exprData), chosenProbes = .self$chosenProbes_g)
				tp53 = gs["TP53_g",]
				gs = t(apply(gs, 1, function(x){ x - median(x)}))
				ls = meta["ls",]
				col11a1 = exprs(exprData)["ILMN_2392803",]
				meta = t(apply(meta, 1, function(x){ x - median(x)}))
				#meta = t(sapply(rownames(meta), function(a){meta[a,] - .self$mdns[a]}))
			#===== Conditioning mesenchymal transition metagene by lymph node status
				idx = (clinical[,"lymph_nodes_positive"]<1 & clinical[,"size"] < 30)
				mes.lymphneg = meta["mt",] * idx
				mes.lymphneg[idx] = mes.lymphneg[idx] - median(mes.lymphneg[idx])
				#mes.lymphneg[idx] = mes.lymphneg[idx] - .self$mdns["mes.lymphneg"]
				meta = rbind(meta, mes.lymphneg)
				col11a1.lymphneg30 = col11a1 * idx
				col11a1.lymphneg30[idx] = col11a1.lymphneg30[idx] - median(col11a1.lymphneg30[idx])
				
				idx = (clinical[,"lymph_nodes_positive"] > 3)
				ls.lymphpos = ls * idx
				ls.lymphpos[idx] = ls.lymphpos[idx] - median(ls.lymphpos[idx])
				#ls.lymphpos[idx] = ls.lymphpos[idx] - .self$mdns["ls.lymphpos"]
				meta = rbind(meta, ls.lymphpos)
				#meta = rbind(meta, gs)

				idx = (meta["er",] < 0 & meta["erbb2", ] < 0)
				ls.erneg = ls * idx
				ls.erneg[idx] = ls.erneg[idx] - median(ls.erneg[idx])
				#ls.erneg[idx] = ls.erneg[idx] - .self$mdns["ls.erneg"]
				meta = rbind(meta, ls.erneg)

				idx = meta["er",] < 0
				tp53.erneg = tp53 * idx
				tp53.erneg[idx] = tp53.erneg[idx] - median(tp53.erneg[idx])
				gs = rbind(gs, tp53.erneg)

				meta = rbind(meta, gs)

				#idx = meta["ls",] < 0
				#chr17p12 = meta.cnv["chr17p12",]
				#chr17p12.lsneg = chr17p12 * idx
				#meta = rbind(meta, chr17p12.lsneg)

				lymph = clinical[,"lymph_nodes_positive"]
				lsxlym = ls *lymph
				lsxlym = lsxlym - median(lsxlym)
			rm(exprData)
				#meta = rbind(meta, meta.cnv)
                        cat("done!\n");flush.console()
				p = matrix(NA, nrow=length(.self$model), ncol=nrow(clinical))
#===== 1. Predict using metagenes only model =====
			cat("1.  Predicting using metagenes AIC model...");flush.console()
				X = data.frame(t(meta))
                              p[1,] = predict(.self$model$coxmodel, X)
                        cat("done!\n");flush.console()
#===== 2. Predict using Attractor + clinical GBM model =====
			cat("2.  Predicting using gbm model...");flush.console()
                              X = data.frame(t(meta))
                              best.iter=gbm.perf(.self$model$gbmmodel, method="cv", plot.it=FALSE)
			      cat("Best iter: ", best.iter, "\n", sep="");flush.console()
			      p[2,] = predict.gbm(.self$model$gbmmodel, X, best.iter)
			      #p2 = predict.gbm(.self$model[[2]], X, 1500)
			cat("done!\n");flush.console()
#===== 3. Predict using clinical only model =====
			cat("3.  Predicting using clinical AIC model...");flush.console()
				X = clinical
                              p[3,] = predict(.self$model$cm, X)
			cat("done!\n");flush.console()
#===== 4. Predict using gbm model =====
			cat("4.  Predicting using clinical GBM model...");flush.console()
				X = X[, attr(.self$model$cm$terms, "term.labels")]
                              best.iter=gbm.perf(.self$model$cgbm, method="cv", plot.it=FALSE)
			      cat("Best iter: ", best.iter, "\n", sep="");flush.console()
			      p[4,] = predict.gbm(.self$model$cgbm, X, best.iter)
			cat("done!\n");flush.console()
#===== 5. Predict using recycled model =====
			cat("5.  Predicting using recycle model...");flush.console()
				#X = cbind(data.frame(t(meta)))
				#X = X[, setdiff(colnames(X), attr(.self$model$coxmodel$terms, "term.labels") )]
				X = cbind(data.frame(t(meta)), clinical)
				X = X[, removeTaggedFeatures(colnames(X), c(  attr(.self$model$coxmodel$terms, "term.labels"), attr(.self$model$cm$terms,"term.labels")   ))]
				#X = X[, setdiff(colnames(X), c(  attr(.self$model$coxmodel$terms, "term.labels"), attr(.self$model$cm$terms,"term.labels")   ))]
                              p[5,] = predict(.self$model$recycle, X)
                        cat("done!\n");flush.console()

#===== 6. Predict using KNN model =====
			cat("6.  Predicting using KNN model ...");flush.console()
				knnmodel = .self$model$knnmodel
				qX = meta[names(knnmodel$x.train$concordance),]
				qC = clnc[,colnames(knnmodel$c.train$clinical)]
				qC = t(preproClncKNN(qC, isFactorIn=knnmodel$c.train$isFactor, dwIn=knnmodel$c.train$distWeight)$clinical)
				wvec = c(abs(knnmodel$x.train$concordance-0.5), abs(knnmodel$c.train$concordance-0.5))
				qAll = rbind(qX, qC)
				trainDB = rbind(knnmodel$x.train$meta, t(knnmodel$c.train$clinical))
				trainTime = knnmodel$x.train$time
				out=ewknn.predict(trainDB, trainTime, qAll, wvec, k=floor(0.1*ncol(trainDB)))
				p[6,] = out
                        cat("done!\n");flush.console()
#===== 7. Predict using minimalist model =====
			cat("7.  Predicting using protective minimalist model ...");flush.console()
				X = data.frame( cbind(meta["mitotic",], meta["ls.erneg",], clinical$lymph_nodes_positive, meta["mes.lymphneg",], meta["susd3",], clinical$age_at_diagnosis, clinical$tr.RT, clinical$tr.CT) )
				colnames(X) = c("CIN", "LYM_ERNeg", "lymNum", "MES_lymNumNeg", "SUSD3", "age", "tr.RT", "tr.CT")
                              p[7,] = predict(.self$model$cox.a, X)
                        cat("done!\n");flush.console()
#===== 8. Predict using minimalist model =====
			cat("8.  Predicting using gbm model...");flush.console()
                              best.iter=gbm.perf(.self$model$gbm.a, method="cv", plot.it=FALSE)
			      cat("Best iter: ", best.iter, "\n", sep="");flush.console()
			      p[8,] = predict.gbm(.self$model$gbm.a, X, best.iter)
			      #p2 = predict.gbm(.self$model[[2]], X, 2000)
			cat("done!\n");flush.console()
#===== 9. Predict using minimalist model =====
			cat("9.  Predicting using oncogene minimalist model ...");flush.console()
				X = data.frame( cbind(meta["zmynd10",], col11a1.lymphneg30, clinical$age_at_diagnosis, clinical$tr.RT, clinical$tr.CT, meta["ls.erneg",], meta["TP53_g",], lsxlym, meta["VEGFA_g",]))
				colnames(X) = c("ZMYND10", "COL11A1g_lymNumNeg", "age", "RT", "CT", "lym.erneg", "TP53g", "VEGFAg")
                              p[9,] = predict(.self$model$cox.b, X)
                        cat("done!\n");flush.console()
#===== 10. Predict using minimalist model =====
			cat("10.  Predicting using gbm model...");flush.console()
                              best.iter=gbm.perf(.self$model$gbm.b, method="cv", plot.it=FALSE)
			      cat("Best iter: ", best.iter, "\n", sep="");flush.console()
			      p[10,] = predict.gbm(.self$model$gbm.b, X, best.iter)
			      #p2 = predict.gbm(.self$model[[2]], X, 2000)
			cat("done!\n");flush.console()

#===== Combining predictions =====
				
                              .self$predictions = p
				pout = matrix(NA, nrow=2, ncol=ncol(p))
				pout[1,] = apply(p[c(1:5, 9, 10),], 2, sum) +  365/p[6,]
				pout[2,] = p[7,] + p[8,]
				pz = t(apply(pout, 1, function(x){ (x-mean(x)) / sd(x)}))
                              p = apply(pz, 2, sum)
				#p = apply(pz, 1, mean)
                              return (p)
                            }
                            
                            )
                          )

library(synapseClient)
synapseLogin()

library(tools)

#tar_path = '/bin/tar'
tar_path = '/usr/bin/tar'
if (!file.exists(tar_path)) {
    stop("locate path to the tar utility!")
}

## read either a csv or tab delimited file and return a data frame
read_delim_or_csv <- function(path) {
    if (grepl('.csv$', path)) {
        read.csv(path, stringsAsFactors=FALSE)
    } else {
        read.table(path, header=TRUE, quote="\"", fill=TRUE, stringsAsFactors=FALSE)
    }
}

folder <- synGet("syn2773668")

eids <- c(q1=2480744, q2=2480748, q3=2480750, q1f=2700269, q2f=2700271, q3f=2700273)
evaluations <- lapply(eids, function(eid) synGetEvaluation(eid))

for (abr in names(evaluations)) {

    evaluation <- evaluations[[abr]]

    cat("processing submissions for: ", abr, "\n")

    ## get a list of submissions and download prediction files
    subs <- synGetSubmissions(evaluation$id, status="SCORED", limit=10000)
    subs <- lapply(subs@results, function(sub) synGetSubmission(sub@properties$id))

    cat(sprintf("retrieved %d submissions\n", length(subs)))

    ## load the prediction files into a list
    preds <- lapply(subs, function(sub) read_delim_or_csv(sub@filePath))
    names(preds) <- sapply(subs, function(sub) sub$id)

    cat(sprintf("loaded %d predictions\n", length(preds)))

    rdatafile <- paste0(abr,".submissions.RData")
    save(preds, file=rdatafile)
    file1 <- synStore(File(rdatafile, parentId=folder@properties$id), used='syn2290704', executed='syn2773839')

    cat(sprintf("stored in synapse %s\n", file1@properties$id))

    tar_dir <- evaluation$name
    dir.create(tar_dir)
    source_files <- sapply(subs, function(sub) sub@filePath)
    dest_files <- paste0(tar_dir, '/', sapply(subs, function(sub) sub$id), '.', file_ext(source_files))

    file.copy(from=source_files, to=dest_files)

    tarfile <- paste0(abr,".submissions.tgz")
    tar(tarfile, files=tar_dir, compression="gzip", tar=tar_path)
    file1 <- synStore(File(tarfile, parentId=folder@properties$id), used='syn2290704', executed='syn2773839')

    cat(sprintf("stored in synapse %s\n", file1@properties$id))
}


anno_to_list <- function(annos) {
    results = list()
    atypes = c('stringAnnos', 'doubleAnnos', 'longAnnos')
    for (atype in intersect(atypes, names(annos))) {
        for (anno in annos[[atype]]) {
            results[anno$key] = anno$value
        }
    }
    return (results)
}

anno_to_keys <- function(annos) {
    atypes = c('stringAnnos', 'doubleAnnos', 'longAnnos')
    c(lapply( intersect(atypes, names(annos)), function(atype) {
            sapply(annos[[atype]], function(anno) anno$key)
        }), recursive=T)
}

filter_list <- function(lst, accept_keys) {
    lst[intersect(names(lst), accept_keys)]
}


## capture submission metadata
for (abr in names(evaluations)) {

    evaluation <- evaluations[[abr]]

    cat("processing submissions for: ", abr, "\n")

    ## get a list of submissions and status objects
    subs <- synGetSubmissions(evaluation$id, status="SCORED", limit=10000)
    subs <- subs@results
    statuses <- lapply(subs, function(sub) synGetSubmissionStatus(sub@properties$id))

    cat(sprintf("retrieved %d submissions\n", length(subs)))

    name <- paste0(abr,".submissions.metadata")

    ## Some status objects have extra keys (for example, submission ID 2773627).
    ## To make a data.frame, we need to filter those out, so we end up with a
    ## rectangular data set with all rows having the same columns.
    common_keys <- Reduce(intersect, lapply(statuses, function(status) anno_to_keys(status@properties$annotations)))

    ## create a data.frame holding submission details
    assign(name,
        do.call(rbind, mapply(function(sub, status) {
            as.data.frame(append(
                list(id=sub@properties$id,
                     createdOn=sub@properties$createdOn,
                     modifiedOn=status@properties$modifiedOn,
                     userId=sub@properties$userId,
                     name=sub@properties$name,
                     entityId=sub@properties$entityId,
                     entityId=sub@properties$entityId,
                     version=sub@properties$versionNumber),
                filter_list(anno_to_list(status@properties$annotations), accept_keys=common_keys)),
                stringsAsFactors=FALSE)
        }, subs, statuses, SIMPLIFY=F)))

    rdatafile <- paste0(abr,".submissions.metadata.RData")
    save(list=name, file=rdatafile)
    file1 <- synStore(File(rdatafile, parentId=folder@properties$id), used='syn2290704', executed='syn2773839')

    cat(sprintf("stored in synapse %s\n", file1@properties$id))
}

#' Compute the exact value of concordance index
#'
#' @param predictions a vector of predictions
#' @param observations a matrix containing time and status columns
#' @author Ben Sauerwine
#' @export

exactConcordanceIndex <- function(predictions, observations) {
  count <- 0
  score <- 0
  for (i in 1:(length(observations)/2-1)) {
    for (j in (i+1):(length(observations)/2)) { # For each pair of observations
      if (((observations[i,2] == TRUE) && (observations[j, 2] == TRUE)) || 
        ((observations[i,2] == TRUE) && (observations[j, "time"] >= observations[i,"time"])) || 
        ((observations[j,2] == TRUE) && (observations[i, "time"] >= observations[j,"time"]))) { 
        
        # This pair is comparable.  
        count <- count + 2
        
        if (observations[i, "time"] < observations[j, "time"]) {
          if (predictions[i] > predictions[j]) {
            score <- score + 2
          }
          if (predictions[i] == predictions[j]) {
            score <= score + 1
          }
        }
        
        if (observations[i, "time"] == observations[j, "time"]) {
          if (predictions[i] == predictions[j]) {
            score <- score + 2
          }
        }
        
        if (observations[i, "time"] > observations[j, "time"]) {
          if (predictions[i] < predictions[j]) {
            score <- score + 2
          }
          if (predictions[i] == predictions[j]) {
            score <- score + 1
          }
        }
        
      }
    }
  }
  return(score/count)
}

suppressMessages(library("survival"))
suppressMessages(library("timeROC"))
suppressMessages(library("Bolstad2"))
suppressMessages(library("ROCR"))

# question 1A
# riskScoreGlobal is the global risk score
# riskScore12, riskScore18, riskScore24 are the risk scores at 12, 18 and 24 months
# time is called LKADT_P in the CoreTable meaning the last known follow up time in days
# death is last known follow up status (F=survival, T=death)
# all input parameters are vectors
# returned value is a vector containing:
#  * concordance index
#  * AUC of ROC at 12, 18, and 24 months
#  * integrated AUC (integrated over all time points)
## from Justin: https://mail.google.com/mail/u/1/#inbox/14c8f82a26d23b80
score_q1a<-function(time, death, riskScoreGlobal, riskScore12, riskScore18, riskScore24)
{

  if (missing(riskScore12)) {
    riskScore12 <- riskScoreGlobal
  }
  if (missing(riskScore18)) {
    riskScore18 <- riskScoreGlobal
  }
  if (missing(riskScore24)) {
    riskScore24 <- riskScoreGlobal
  }

  auc12 <- timeROC(T=time,
                  delta=death,
                  marker=riskScore12,
                  cause=1,
                  weighting="marginal",
                  times=12 * 30.5,
                  iid=FALSE)$AUC[2]

  auc18 <- timeROC(T=time,
                   delta=death,
                   marker=riskScore18,
                   cause=1,
                   weighting="marginal",
                   times=18 * 30.5,
                   iid=FALSE)$AUC[2]

  auc24 <- timeROC(T=time,
                   delta=death,
                   marker=riskScore24,
                   cause=1,
                   weighting="marginal",
                   times=24 * 30.5,
                   iid=FALSE)$AUC[2]

  # compute global concordance index
  surv <- Surv(time,death)
  cIndex <- survConcordance(surv ~ riskScoreGlobal)$concordance

  # compute iAUC from 6 to 30 months
  times <- seq(6,30,by=1) * 30.5
  aucs <- timeROC(T=time,
                  delta=death,
                  marker=riskScoreGlobal,
                  cause=1,
                  weighting="marginal",
                  times=times,
                  iid=FALSE)$AUC

  # Simpsons rules for integrating under curve
  iAUC <- sintegral(times, aucs)$int / (max(times) - min(times))

  return (list(cIndex=cIndex, auc12=auc12, auc18=auc18, auc24=auc24, iAUC=iAUC))
}

# question 1B
# predTime is the predicted exact survival time for all patients in days
# LKADT_P is last known follow up time in days
# DEATH is last known follow up status (F=survival, T=death)
# all input parameters are vectors
# returned value is RMSE
score_q1b<-function(predTime,LKADT_P,DEATH)
{
  x=LKADT_P[DEATH==T]
  y=predTime[DEATH==T]
  sqrt(sum((x-y)^2)/length(x))
}

# question 2
# pred is the predicted risk with a higher value corresponding to a higher
# probility of discontinue due to AE before 3 months
# y is the censored true label of discontinue due to AE before 3 month
# y=1 if it happens, 0, otherwise
# both input parameters are vectors
# returned value is AUC of PR
score_q2<-function(pred,y)
{
  ## remove subjects whose discontinuation status is NA
  pred <- pred[!is.na(y)]
  y <- y[!is.na(y)]

  prf=ROCR::performance(ROCR::prediction(pred,y),"prec","rec")
  x=prf@x.values[[1]]
  y=prf@y.values[[1]]
  auc=sum((x[-1]-x[-length(x)])*y[-1])
  auc
}

#unitTestMetabric <- function() {
#  ## TODO: remove the following two lines. the correct way to do this is pkgname::methodname
#  library(survival)
#  library(survcomp)
#  ## tisk-tisk. bad news above.
#  
#  
#  ## load the data
#  data(demoData)
#  
#  checkTrue(exists('exprData_metabric'))
#  #checkTrue(all(rownames(pData(exprData_metabric)) == colnames(exprs(exprData_metabric))))
#  checkTrue(exists('copyData_metabric'))
#  #checkTrue(all(rownames(pData(copyData_metabric)) == colnames(exprs(copyData_metabric))))
#  checkTrue(exists('clinicalData_metabric'))
#  
#  survObj <- Surv(clinicalData_metabric[,"survYears"], clinicalData_metabric[,"survDeath"])
#  
#  #### prepare feature data for predictive modeling by transposing the matrix to have samples on the rows and features on the columns and scaling the columns
#  featureData <-t(createAggregateFeatureDataSet(list(expr = exprData_metabric, copy = copyData_metabric)))
#
#  dataSets_expr_clinical <- filterPredictiveModelData(featureData, survObj, filterFeatureNasBy = "columns")
#  
#  #### Let's make a Cox model now.
#  predictiveModel_cox <- GlmnetModel$new(family="cox")
#  
#  ### as an example that runs quickly, train the model with the first 200 features
#  predictiveModel_cox$customTrain(dataSets_expr_clinical$featureData, dataSets_expr_clinical$responseData)
#  ### get predicted survival values using customPredict
#  trainPredictions <- predictiveModel_cox$customPredict(dataSets_expr_clinical$featureData)
#  ### to evaluate performance calculate concordance.index of the prediction versus observations
#  cIndex_train <- concordance.index(x=trainPredictions, surv.time=dataSets_expr_clinical$responseData[,"time"], surv.event=dataSets_expr_clinical$responseData[,"status"], na.rm=TRUE, alpha= .05)
#  cIndex_train$c.index # returns the cindex1
#  cIndex_train$lower # lower CI bound of cindex1
#  cIndex_train$upper # upper CI bound of cindex1
#  
#  GlmnetModelCV <- GlmnetModel$new(family="cox")
#  
#  cvResults_cox <- crossValidatePredictiveCoxModel(dataSets_expr_clinical$featureData, dataSets_expr_clinical$responseData, GlmnetModelCV, numFolds=5)
#  
#  # by default, 5 fold cross validation
#  cindexTrain<-c()
#  cindexTest<-c()
#  for (i in 1:3){
#    cTrain<-concordance.index(x=cvResults_cox$trainPredictions[[i]], surv.time=cvResults_cox$trainObservations[[i]][,"time"], surv.event=cvResults_cox$trainObservations[[i]][,"status"], na.rm=TRUE, alpha= .05)
#    cindexTrain <- c(cindexTrain,cTrain$c.index)
#    cTest<-concordance.index(x=cvResults_cox$testPredictions[[i]], surv.time=cvResults_cox$testObservations[[i]][,"time"], surv.event=cvResults_cox$testObservations[[i]][,"status"], na.rm=TRUE, alpha= .05)
#    cindexTest <- c(cindexTest,cTest$c.index)
#  }
#  
#  # graphical comparison
#  boxplot(cbind(cindexTrain,cindexTest))
#}
#

\# submissions is a list with all submitted prediction matrices
# observed is the matrix of measured values


# submissions for me is a list with all prediction matrices
N <- 10000
subResults <-list()

# I will save, for each submission, the score and the ranking computed for N resamplings
subResults$score <- matrix(0, nrow=length(submissions), ncol=N)
subResults$ranking <- matrix(0, nrow=length(submissions), ncol=N)


CompoundsID <- colnames(observed)

# this is my scoring function
source("RMSELeaderboard.R")

for (i in 1:N){
  # sample 90% of the compounds (=82 for me)
  SampledCompounds <- CompoundsID[sample(1:length(CompoundsID), 82, replace=FALSE)]
  
  # compute score and ranking
  SampledLeaderboard <- SampledRMSELeaderboard(submissions, observed, SampledCompounds)
  # save the score
  subResults$score[,i] <- SampledLeaderboard$MeanRanking_RMSE
  # save the ranking
  subResults$ranking[,i] <- SampledLeaderboard$TeamsRanking_RMSE
}



### tests: based on ranking
# Team1 in the index of the Team ranked first 
Comp1 <- subResults$ranking[Team1,]

# compare the distribution of the best performin team with the distribution of all other teams using Wilcoxon signed-rank test
tmp<-subResults$ranking[-Team1,]
pVal <- rep(NA, dim(tmp)[1])
for (i in 1:dim(tmp)[1]) {
  Comp2 <- tmp[i,]
  pVal[i] <- wilcox.test(Comp1, Comp2, paired=TRUE)$p.value
}

# False discovery rates (FDR) is calculated using the Benjamini-Hochberg correction
cPVal <- p.adjust(pVal, method="BH")



### tests: based on score
# Team1 in the index of the Team ranked first 
Comp1 <- subResults$score[Team1,]

# compare the distribution of the best performin team with the distribution of all other teams using Wilcoxon signed-rank test
tmp<-subResults$score[-Team1,]
pVal <- rep(NA, dim(tmp)[1])
for (i in 1:dim(tmp)[1]) {
  Comp2 <- tmp[i,]
  pVal[i] <- wilcox.test(Comp1, Comp2, paired=TRUE)$p.value
}

# False discovery rates (FDR) is calculated using the Benjamini-Hochberg correction
cPVal <- p.adjust(pVal, method="BH")

.test <- 
		function(dir=system.file("unitTests", package="predictiveModeling"), testFileRegexp = "^test_.*\\.R$") 
{
	.runTestSuite(dir=dir, testFileRegexp=testFileRegexp, testFuncRegexp="^unitTest.+", suiteName="unit tests") 
}

.integrationTest <- 
		function(dir=system.file("integrationTests", package="predictiveModeling"), testFileRegexp="^test_.*\\.R$")
{
	.runTestSuite(dir=dir, testFileRegexp=testFileRegexp, testFuncRegexp="^integrationTest.+", suiteName="integration tests") 
}

.runTestSuite <- 
		function(dir, testFileRegexp, testFuncRegexp, suiteName) 
{
	
	.failure_details <- function(result) {
		res <- result[[1L]]
		if (res$nFail > 0 || res$nErr > 0) {
			Filter(function(x) length(x) > 0,
					lapply(res$sourceFileResults,
							function(fileRes) {
								names(Filter(function(x) x$kind != "success",
												fileRes))
							}))
		} else list()
	}
	
	require("RUnit", quietly=TRUE) || stop("RUnit package not found")
	RUnit_opts <- getOption("RUnit", list())
	if(.getCache("debug")) {
		RUnit_opts$verbose <- 10L
		RUnit_opts$silent <- FALSE
	} else {
		RUnit_opts$verbose <- 0L
		RUnit_opts$silent <- TRUE
	}
	RUnit_opts$verbose_fail_msg <- TRUE
	options(RUnit = RUnit_opts)
	suite <- defineTestSuite(name=paste("predictiveModeling RUnit Test Suite", suiteName), 
			dirs=dir,
			testFileRegexp=testFileRegexp,
			testFuncRegexp=testFuncRegexp,
			rngKind="default",
			rngNormalKind="default")
	result <- runTestSuite(suite)
	cat("\n\n")
	printTextProtocol(result, showDetails=FALSE)
	if (length(details <- .failure_details(result)) >0) {
		cat("\nTest files with failing tests\n")
		for (i in seq_along(details)) {
			cat("\n  ", basename(names(details)[[i]]), "\n")
			for (j in seq_along(details[[i]])) {
				cat("    ", details[[i]][[j]], "\n")
			}
		}
		cat("\n\n")
		stop(paste(suiteName, " tests failed for package predictiveModeling"))
	}
	result
}

bart = function(
   x.train, y.train, x.test=matrix(0.0,0,0),
   sigest=NA, sigdf=3, sigquant=.90, 
   k=2.0,
   power=2.0, base=.95,
   binaryOffset=0,
   ntree=200,
   ndpost=1000, nskip=100,
   printevery=100, keepevery=1, keeptrainfits=TRUE,
   usequants=FALSE, numcut=100, printcutoffs=0,
   verbose=TRUE
)
{
   binary=FALSE

   if(is.factor(y.train)) {
      if(length(levels(y.train)) != 2) stop("y.train is a factor with number of levels != 2")
      binary = TRUE
      y.train = as.numeric(y.train)-1
   } else {
      if((length(unique(y.train)) == 2) & (max(y.train) == 1) & (min(y.train) == 0)) {
         cat('NOTE: assumming numeric response is binary\n')
         binary = TRUE
      }
   }

   if(is.vector(x.train) | is.factor(x.train)) x.train = data.frame(x=x.train)
   if(is.vector(x.test) | is.factor(x.test)) x.test = data.frame(x=x.test)

   if(is.data.frame(x.train)) {
      if(nrow(x.test)) {
         if(!is.data.frame(x.test)) stop('x.train is a data frame so x.test must be also')
	 xtemp = rbind(x.train,x.test)
	 xmtemp = makeind(xtemp)
	 x.train = xmtemp[1:nrow(x.train),,drop=FALSE]
	 x.test = xmtemp[nrow(x.train) + 1:nrow(x.test),,drop=FALSE]
      } else {
         x.train = makeind(x.train)
      }
   }


   #check input arguments:
   if((!is.matrix(x.train)) || (typeof(x.train)!="double")) stop("argument x.train must be a double matrix")
   if((!is.matrix(x.test)) || (typeof(x.test)!="double")) stop("argument x.test must be a double matrix")
   if(!binary) {
      if((!is.vector(y.train)) || (typeof(y.train)!="double")) stop("argument y.train must be a double vector")
   }
   if(nrow(x.train) != length(y.train)) stop("number of rows in x.train must equal length of y.train")
   if((nrow(x.test) >0) && (ncol(x.test)!=ncol(x.train))) stop("input x.test must have the same number of columns as x.train")
   if((!is.na(sigest)) && (typeof(sigest)!="double")) stop("input sigest must be double")
   if((!is.na(sigest)) && (sigest<0.0)) stop("input sigest must be positive")
   if((mode(sigdf)!="numeric") || (sigdf<0)) stop("input sigdf must be a positive number")
   if((mode(printevery)!="numeric") || (printevery<0)) stop("input printevery must be a positive number")
   if((mode(keepevery)!="numeric") || (keepevery<0)) stop("input keepevery must be a positive number")
   if((mode(sigquant)!="numeric") || (sigquant<0)) stop("input sigquant must be a positive number")
   if((mode(ntree)!="numeric") || (ntree<0)) stop("input ntree must be a positive number")
   if((mode(ndpost)!="numeric") || (ndpost<0)) stop("input ndpost must be a positive number")
   if((mode(nskip)!="numeric") || (nskip<0)) stop("input nskip must be a positive number")
   if((mode(k)!="numeric") || (k<0)) stop("input k must be a positive number")
   if(mode(numcut)!="numeric") stop("input numcut must be a numeric vector")
   if(length(numcut)==1) numcut = rep(numcut,ncol(x.train))
   if(length(numcut) != ncol(x.train)) stop("length of numcut must equal number of columns of x.train")
   numcut = as.integer(numcut)
   if(min(numcut)<1) stop("numcut must be >= 1")
   if(typeof(usequants)  != "logical") stop("input usequants must a logical variable")
   if(typeof(keeptrainfits)  != "logical") stop("input keeptrainfits must a logical variable")
   if(typeof(verbose)  != "logical") stop("input verbose must a logical variable")
   if(mode(printcutoffs)  != "numeric") stop("input printcutoffs must be numeric")
   printcutoffs = as.integer(printcutoffs)
   if(printcutoffs <0) stop("input printcutoffs must be >=0")
   if(power <= 0) stop("power must be positive")
   if(base <= 0) stop("base must be positive")

   rgy = range(y.train)
   y = -.5 + (y.train-rgy[1])/(rgy[2]-rgy[1])

   # if sigest=NA, fit a lm to training data to get the value of sigest...
   # sigest is on the scale of the transformed y, so we do the lm after the scaling above...
   if(!binary) {
      if (is.na(sigest)) {
         templm = lm(y~x.train) 
         sigest = summary(templm)$sigma
      } else {
         sigest = sigest/(rgy[2]-rgy[1]) #put input sigma estimate on transformed scale
      }
   } else {
      sigest=1
   }

   ncskip = floor(nskip/keepevery)
   ncpost = floor(ndpost/keepevery)
   nctot = ncskip + ncpost
   totnd = keepevery*nctot

   if(!binary) {
      binaryOffset = -1000.0
   }

   cres = .C('mbart',as.integer(nrow(x.train)), as.integer(ncol(x.train)), as.integer(nrow(x.test)),
                   as.double(x.train), as.double(y),
                   as.double(x.test),
                   as.double(sigest),   as.integer(sigdf), as.double(sigquant),
                   as.double(k),
		   as.double(power), as.double(base),
		   as.double(binaryOffset),
		   as.integer(ntree),      as.integer(totnd),
                   as.integer(printevery), as.integer(keepevery),  as.integer(keeptrainfits),
                   as.integer(numcut), as.integer(usequants), as.integer(printcutoffs),
		   as.integer(verbose),
                   sdraw=double(nctot), 
                   trdraw=double(nrow(x.train)*nctot),
                   tedraw=double(nrow(x.test)*nctot),
                   vcdraw=integer(ncol(x.train)*nctot))
	
   # now read in the results...
   if(!binary) {
   sigma = cres$sdraw*(rgy[2]-rgy[1])
   first.sigma = sigma[1:ncskip] # we often want the sigma draws 
   sigma = sigma[ncskip+(1:ncpost)]

   # put sigest on the original y scale for output purposes
   sigest = sigest*(rgy[2]-rgy[1]) 
   }

   yhat.train = yhat.test = yhat.train.mean = yhat.test.mean = NULL
   varcount = NULL

   if (keeptrainfits) {
      yhat.train = matrix(cres$trdraw,nrow=nctot,byrow=T)[(ncskip+1):nctot,]
      if(!binary) {
         yhat.train = (rgy[2]-rgy[1])*(yhat.train+.5) + rgy[1]
         yhat.train.mean = apply(yhat.train,2,mean)
      }
   }
   if (nrow(x.test)) {
      yhat.test = matrix(matrix(cres$tedraw,nrow=nctot,byrow=T)[(ncskip+1):nctot,],nrow=nctot-ncskip)
      if(!binary) {
         yhat.test = (rgy[2]-rgy[1])*(yhat.test+.5) + rgy[1]
         yhat.test.mean = apply(yhat.test,2,mean)
      }
   }

   if(binary) {
      if(keeptrainfits) yhat.train = yhat.train + binaryOffset
      if(nrow(x.test)) yhat.test = yhat.test + binaryOffset
   }

   varcount = matrix(cres$vcdraw,nrow=nctot,byrow=T)[(ncskip+1):nctot,]

   if(binary) {
   retval = list(
      call=match.call(),
      yhat.train=yhat.train,
      yhat.test=yhat.test,
      varcount=varcount,
      binaryOffset = binaryOffset
   )
   } else {
   retval = list(
      call=match.call(),
      first.sigma=first.sigma,
      sigma=sigma,
      sigest=sigest,
      yhat.train=yhat.train,
      yhat.train.mean=yhat.train.mean,
      yhat.test=yhat.test,
      yhat.test.mean=yhat.test.mean,
      varcount=varcount,
      y = y.train
   )
   }
   class(retval) = 'bart'
   return(invisible(retval))
}

#############################################
# marginal model plots    Rev 12/30/09
# To do:
# Allow a Groups arg that will draw the plot for the specified group
# BUG:  sd's are WRONG with weights; see cards data
# 15 March 2010 changed to make
#   mmps(lm(longley)) work without specifying data or response
#   fixed bug  when only one plot is requested --- suppress call to par()
#   added 'outerLegend' to label lines
#   modified to work correctly with 
# 28 May 2010 S. Weisberg, fixed bugs in logistic models
#   changed line thickness of mean smooths
#   excluded SD smooth from bernoulli models
#   added grid lines
# 15 August 2010 fixed colors of points to work properly
# 16 January 2011 improved handling of splines and polynomials in mmps to
#    allow plots against base variables (e.g., bs(x, 3) could be
#    replaced by just x in the 'terms' argument to mmps.
# 16 June 2011 allow layout=NA, in which case the layout is not set in this
#  function, so it is the responsibility of the user
# 14 September 2012 improved the smoothers
# 22 September 2012 added conditioning on one categorical regressor
#############################################
marginalModelPlot <- function(...){mmp(...)}
mmp <- function(model, ...){UseMethod("mmp")}

mmp.lm <-
function (model, variable, sd = FALSE,
    xlab = deparse(substitute(variable)),
    smoother = loessLine, smoother.args=list(span=2/3),
    key=TRUE, pch, groups=NULL, ...)
{
    mmp.default(model, variable, sd, xlab, smoother=smoother,
       smoother.args=smoother.args, key, pch=pch, groups=groups, ...)
}

mmp.default <-
function (model, variable, sd = FALSE,
    xlab = deparse(substitute(variable)), smoother=loessLine,
    smoother.args, key=TRUE, pch, groups=NULL,
    col.line = palette()[c(4, 2)], col=palette()[1],
    labels, id.method="y",
    id.n=if(id.method[1]=="identify") Inf else 0,
    id.cex=1, id.col=palette()[1], grid=TRUE, ...)
{
    lwd <- match.call(expand.dots=TRUE)$lwd
    if(missing(pch)) pch <- 1
    groups.col <- col
    if (!is.null(groups)){
         if(is.data.frame(groups)) {
            groups.label <- colnames(groups)[1]
            groups <- groups[,1]
            } else {
         groups.label <- deparse(substitute(groups))
        }
        groups.levels <- unique(na.omit(groups))
        for (j in 1:(length(groups.levels))) {
          pch[groups==groups.levels[j]] <- j
          groups.col[groups==groups.levels[j]] <- palette()[j]}
    }
    if (!is.function(smoother)) {
        smoother <- loessLine
        smoother.args <- list()
        }
    if  (!is.null(attr(model$model, "na.action"))) {
        if (attr(attr(model$model, "na.action"), "class") == "exclude")
            model <- update(model, na.action=na.omit)}
    if (missing(variable)) {
        xlab <- "Fitted values"
        u <- fitted(model)
    } else {
        u <- variable}
    if(missing(labels))
        labels <- names(residuals(model))
    resp <- model.response(model.frame(model))
    plot(u, resp,
        xlab = xlab, ylab = colnames(model$model[1]), type="n", ...)
	  if(grid){
      grid(lty=1, equilogs=FALSE)
      box()}
    points(u, model$model[ , 1], col=groups.col, pch=pch, ...)
    ow <- options(warn=-1)
    on.exit(options(ow))
       smoother.args$lty <- smoother.args$lty.spread <- 1
       smoother.args$lwd <- smoother.args$lwd.spread <- if(is.null(lwd)) 2 else lwd
    if(is.null(groups)) {
       smoother(u, resp, col.line[1], log.x=FALSE, log.y=FALSE, spread=sd,
          smoother.args=smoother.args)
       smoother.args$lty <- smoother.args$lty.spread <- 2
# 11/21/14:  SD smooth under the model corrected by adding the 'offset'
       smoother(u, predict(model), col.line[2], log.x=FALSE, log.y=FALSE, spread=sd,
                smoother.args=smoother.args, offset=sigmaHat(model))
#          smoother.args=smoother.args)
       if(key){
          outerLegend(c("Data", "Model"), lty=1:2, col=col.line,
             bty="n", cex=0.75, fill=col.line, border=col.line, horiz=TRUE,
             offset=0)
          }
    } else {
    for (j in 1:length(groups.levels)) {
       smoother.args$lwd <- if(is.null(lwd)) 1.75 else lwd
       smoother.args$lty <- 1
       sel <- groups == groups.levels[j]
       smoother(u[sel], resp[sel], palette()[j], log.x=FALSE, log.y=FALSE, spread=FALSE,
          smoother.args=smoother.args)
       smoother.args$lty <- 2
       smoother(u[sel], predict(model)[sel], palette()[j], log.x=FALSE, log.y=FALSE, spread=FALSE,
          smoother.args=smoother.args)
    }
       items <- paste(groups.label, groups.levels, sep= " = ")
       col.items <- palette()[1:length(groups.levels)]
       lty.items <- 1
       if(key) plotArrayLegend(location="top",
          items=items, col.items=col.items,
          lty.items=lty.items , lwd.items=2, title="Legend")
    }
    showLabels(u, resp, labels=labels,
           id.method=id.method, id.n=id.n, id.cex=id.cex,
           id.col=id.col)
    }

mmp.glm <- function (model, variable, sd = FALSE,
    xlab = deparse(substitute(variable)), smoother=gamLine,
    smoother.args=list(k=3), key=TRUE, pch, groups=NULL,
    col.line = palette()[c(4, 2)], col=palette()[1],
    labels, id.method="y",
    id.n=if(id.method[1]=="identify") Inf else 0, 
    id.cex=1, id.col=palette()[1], grid=TRUE, ...)
{
    lwd <- match.call(expand.dots=TRUE)$lwd
    if(missing(pch)) pch <- 1
    groups.col <- col
    groups.pch <- match.call(expand.dots=TRUE)$pch
    if(is.null(groups.pch)) groups.pch <- 1
    if (!is.null(groups)){
         if(is.data.frame(groups)) {
            groups.label <- colnames(groups)[1]
            groups <- groups[,1]
            } else {
         groups.label <- deparse(substitute(groups))
        }
        groups.levels <- unique(na.omit(groups))
        for (j in 1:(length(groups.levels))) {
          pch[groups==groups.levels[j]] <- j
          groups.col[groups==groups.levels[j]] <- palette()[j]}
    }
    if (missing(variable)) {
        xlab <- "Linear Predictor"
        u <- fitted(update(model, na.action=na.omit))
    }  else {
        u <- variable }
    if(missing(labels))
        labels <- names(residuals(model)[!is.na(residuals(model))])
    response <- model.response(model.frame(model))
    fam <- model$family$family
    lin <- model$family$link
    pw <- model$prior.weights # relevant only for binomial
    bernoulli <- FALSE
    if(fam == "binomial") {
        if(!any(pw > 1.1)) bernoulli <- TRUE
        if (is.factor(response)) {response <- as.numeric(response) - 1}
        if (is.matrix(response)){response <- response[, 1]/pw}
    }
    plot(u, response, type="n", xlab = xlab, ylab = colnames(model$model[1]))
	  if(grid){
      grid(lty=1, equilogs=FALSE)
      box()}
    points(u, response, col=col, pch=pch, ...)
    ow <- options(warn=-1)
    on.exit(options(ow))
    smoother.args$lty <-  1
    smoother.args$family <- fam
    smoother.args$link <- lin
    smoother.args$weights <- pw 
    model.fit <- if(fam=="binomial") predict(model, type="response")/pw
         else predict(model, type="response")
    if(is.null(groups)) {
       smoother(u, response, col.line[1], log.x=FALSE, log.y=FALSE, spread=FALSE,
       smoother.args=smoother.args)
       smoother.args$lty <-  2 
       smoother(u, model.fit, col.line[2], log.x=FALSE, log.y=FALSE, spread=FALSE,
          smoother.args=smoother.args)       
       if(key){ outerLegend(c("Data", "Model"), lty=1:2, col=col.line,
          bty="n", cex=0.75, fill=col.line, border=col.line,
          horiz=TRUE, offset=0)
       }
    } else {
    for (j in 1:length(groups.levels)) {
       smoother.args$lwd <- if(is.null(lwd)) 1.75 else lwd
       smoother.args$lty <- 1
       sel <- groups == groups.levels[j]
       smoother(u[sel], response[sel], palette()[j], log.x=FALSE, log.y=FALSE, 
          spread=FALSE, smoother.args=smoother.args)
       smoother.args$lty <- 2
       smoother(u[sel], model.fit[sel], palette()[j], log.x=FALSE, log.y=FALSE,
          spread=FALSE, smoother.args=smoother.args)
    }
       items <- paste(groups.label, groups.levels, sep= " = ")
       col.items <- palette()[1:length(groups.levels)]
       lty.items <- 1
       if(key) plotArrayLegend(location="top",
          items=items, col.items=col.items,
          lty.items=lty.items , lwd.items=2, title="Legend")
    }
    showLabels(u, model$model[, 1], labels=labels,
        id.method=id.method, id.n=id.n, id.cex=id.cex,
        id.col=id.col)
}

marginalModelPlots <- function(...) mmps(...)




mmps <- function(model, terms= ~ ., fitted=TRUE, layout=NULL, ask,
        main, groups, key=TRUE, ...){
  mf <- if(!is.null(terms)) termsToMf(model, terms) else NULL
  labels2 <- attr(attr(mf$mf.vars, "terms"), "term.labels")
  order2 <- attr(attr(mf$mf.vars, "terms"), "order")
  type2 <- rep("good", length(labels2))
  if(length(labels2) > 0) {
    for (j in 1:length(labels2)){
      if(order2[j] > 1) type2[j] <- NA #exclude interatctions
      if(inherits(mf$mf.vars[[labels2[j]]], "factor")) type2[j] <- NA #no factors
      if(inherits(mf$mf.vars[[labels2[j]]], "matrix")) type2[j] <- "original"
      }
    if (any( type2=="original", na.rm=TRUE )){
      p1 <- try(predict(model, type="terms"), silent=TRUE)
      if(class(p1) == "try-error") {type2[type2=="original"] <- NA} else
      warning("Splines and/or polynomials replaced by a fitted linear combination")
      }
  }
  groups <- if (!missing(groups)) {
      termsToMf(model, as.formula(paste("~",deparse(substitute(groups)))))$mf.vars[, 2, drop=FALSE]
      } else {
      if(is.null(mf$mf.groups)) NULL else
                  mf$mf.groups[, 2, drop=FALSE]
      }
# If key=TRUE, determine the coordinates of the key:
  oma3 <- 1.5  # room for title in the outer margin ALWAYS
  mar3 <- if (is.null(groups))  1.5 else .2 +
        if(is.data.frame(groups)) length(unique(groups[, 1])) else
          length(unique(groups))
  nt <- sum(!is.na(type2)) + fitted 
  if (missing(main)) main <- if (nt == 1)
        "Marginal Model Plot" else "Marginal Model Plots"
  if (nt == 0) stop("No plots specified")
  if (nt > 1 & (is.null(layout) || is.numeric(layout))) {
    if(is.null(layout)){
         layout <- switch(min(nt, 9), c(1, 1), c(1, 2), c(2, 2), c(2, 2),
                             c(3, 2), c(3, 2), c(3, 3), c(3, 3), c(3, 3))
    }
    ask <- if(missing(ask) || is.null(ask)) prod(layout)<nt else ask
    }
    op <- if(nt > 1) par(mfrow=layout, ask=ask, no.readonly=TRUE,
              oma=c(0, 0, oma3 , 0), mar=c(5.1, 4.1, mar3, 2.1)) else
          par(oma=c(0, 0, oma3 , 0), mar=c(5.1, 4.1, mar3, 2.1))
    on.exit(par(op))

  legend2 <- function(){ 
     usr <- par("usr")
     coords <-list(x=usr[1], y=usr[3])
     leg <- legend( coords, c("Data", "Model"), lty=1:2, lwd=2, bty="n", 
         cex=0.9, plot=FALSE)
     coords <- list(x = usr[2] - leg$rect$w, y=usr[4] + leg$rect$h)
     legend( coords, c("Data", "Model"), lty=1:2, lwd=2, bty="n", xpd=NA, cex=0.9)
     }
  if (length(labels2) > 0) {
    for (j in 1:length(labels2)) {
      if(!is.na(type2[j])) {
        horiz <- if(type2[j] == "original"){p1[, labels2[j]]} else {
                 if(type2[j] == "good") mf$mf.vars[ , labels2[j]] else NULL}
        lab <- labels2[j]
        mmp(model, horiz, xlab=lab, groups=groups, key=key, ...)
        if(!is.null(groups)) legend2()}
      }
    }
  if(fitted==TRUE) mmp(model, groups=groups, key=key, ...)
  if(!is.null(groups)) legend2()
  mtext(side=3, outer=TRUE, main, line=0.1, cex=1.2)
  if(any(is.na(type2))) warning("Interactions and/or factors skipped")
  invisible()
  }
    

Rmsd<-function(x,y) {
	# Calculates RMSD between two matrices or vectors of equal size
	#
	# Args:
	#	true: ground truth file
	#	predicted: prediction file
	#
	# Returns:
	# 	RMSD of predictions
	#
	RMSD<-sqrt(mean((x-y)^2))
	return(RMSD)
}


FileRmsd<-function(true,predicted) {
	# Calculates RMSD given a ground truth file and prediction file
	#
	# Args:
	#	true: ground truth file
	#	predicted: prediction file
	#
	# Returns:
	# 	RMSD of predictions
	#
	# Example usage:
	#	source("Code/file_rmsd.R")
	#	error<-Rmsd("GroundTruth-train-cvtest_1of10","Avg--Lasso-train-cvtrain_1of10-train-cvtest_1of10-randomForest-train-cvtrain_1of10-train-cvtest_1of10")
	true_data<-read.csv(paste("Predictions/",true,".txt",sep=""),sep=",",header=FALSE)
	colnames(true_data)<-c("subject_id","true_slope")
	predicted_data<-read.csv(paste("Predictions/",predicted,".txt",sep=""),sep=",",header=FALSE)
	colnames(predicted_data)<-c("subject_id","predicted_slope")
	all_data<-merge(true_data,predicted_data,all=TRUE)
	RMSD<-Rmsd(all_data$true_slope,all_data$predicted_slope)
	print(paste("RMSD:",RMSD))
	return(RMSD)
}

FileArgsRmsd <- function(method,train.name,test.name,method.args) {
	# Calculates RMSD given a set of arguments used to create the prediction 
	#
	# Args:
	#	method: name of method file used to create predictions
	#	train.name: base name of training set
	#	test.name: base name of test set
	#	method.args: arguments passed into method to make prediction 
	#
	# Returns:
	# 	RMSD of predictions
	#
	# Example usage:
	#	rmsd<-FileArgsRmsd("RandomForestTrain","train-cvtrain_1of10","train-cvtest_1of10",method.args=list(R=1,corr.bias=FALSE,pls=FALSE,prune=FALSE,std=FALSE,features=c("static","alsfrs","fvc","svc","vital"), slope.features=NULL))

	# Get name of ground truth file
	truth.file <- paste("Predictions/GroundTruth-",test.name,".txt",sep="")
	
	# Get name of prediction file
	pred.file<-GetPredictionFilename(method,train.name,test.name,method.args)

	# Get ground truth data
	truth<-read.csv(truth.file,sep=",",header=FALSE)
	
	# Get prediction data
	pred<-read.csv(pred.file,sep=",",header=FALSE)
	
	# Calculate RMSD
	RMSD<-Rmsd(truth[,2],pred[,2])
	
	print(paste("RMSD:",RMSD))
	
	return(RMSD)
}

# 2010-09-05: J. Fox: allow xlab argument, pass through ...
# 2013-08-19: J. Fox: remove loading of stats package

symbox <- function(x, ...){
	UseMethod("symbox")
}

symbox.formula <- function(formula, data=NULL, subset, na.action=NULL, ylab, ...){
	variable <- all.vars(formula)
	if (length(variable) != 1) stop("the formula must specify one variable")
	m <- match.call(expand.dots = FALSE)
	if (is.matrix(eval(m$data, parent.frame()))) 
		m$data <- as.data.frame(data)
	m$ylab <- m$... <- NULL
	m$na.action <- na.action
	m[[1]] <- as.name("model.frame")
	mf <- eval(m, parent.frame())
	if (missing(ylab)) ylab <- paste("Transformations of", variable)
	symbox(as.vector(mf[[1]]), ylab=ylab, ...)
}

symbox.default <- function(x, powers = c(-1, -0.5, 0, 0.5, 1), start=0, trans=bcPower, 
		xlab="Powers", ylab, ...) {
    if (!(is.vector(x) && is.numeric(x))) stop("x should be a numeric vector.")
	if (missing(ylab)) ylab <- deparse(substitute(x))
    x <- x + start
	result <- lapply(powers, function(lambda) trans(x, lambda))
	names <- as.character(powers)
	names[powers == 0] <- "log"
	names(result) <- names
	result <- as.data.frame(scale(do.call(cbind, result)))
    boxplot(result, xlab=xlab, ylab=ylab, yaxt="n", ...)
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

.onAttach <- function(libname, pkgname) {
    rsf.version <- read.dcf(file=system.file("DESCRIPTION", package=pkgname), 
                      fields="Version")
    packageStartupMessage(paste("\n",
                                pkgname,
                                rsf.version,
                                "\n",
                                "\n",
                                "Type rsf.news() to see new features, changes, and bug fixes.",
                                "\n",
                                "\n"))
}

#-------------------------------------------------------------------------------
# Revision history:
# 2009-09-16: optionally allow models with aliased coefficients J. Fox
# 2012-04-04: modified to allow weighted linear models. J. Fox
#-------------------------------------------------------------------------------

# Heteroscedasticity-corrected standard errors (White adjustment) (J. Fox)

hccm <- function(model, ...){
	#last modified 12 Dec 2000 by J. Fox
	UseMethod("hccm")
}

#hccm.lm <- function (model, type = c("hc3", "hc0", "hc1", "hc2", "hc4"), 
#		singular.ok=TRUE, ...) {
#	if (!is.null(weights(model))) 
#		stop("requires unweighted lm")
#	type <- match.arg(type)
#	if (any(aliased <- is.na(coef(model))) && !singular.ok)
#		stop("there are aliased coefficients in the model")
#	sumry <- summary(model, corr = FALSE)
#	s2 <- sumry$sigma^2
#	V <- sumry$cov.unscaled
#	if (type == FALSE) 
#		return(s2 * V)
#	e <- na.omit(residuals(model))
#	X <- model.matrix(model)[, !aliased]
#	df.res <- df.residual(model)
#	n <- length(e)
#	h <- hat(X)
#	p <- ncol(X)
#	factor <- switch(type, hc0 = 1, hc1 = df.res/n, hc2 = 1 - 
#					h, hc3 = (1 - h)^2, hc4 = (1 - h)^pmin(4, n * h/p))
#	V %*% t(X) %*% apply(X, 2, "*", (e^2)/factor) %*% V
#}

hccm.lm <-function (model, type = c("hc3", "hc0", "hc1", "hc2", "hc4"), 
		singular.ok = TRUE, ...) {
	e <- na.omit(residuals(model))
	removed <- attr(e, "na.action")
	wts <- if (is.null(weights(model))) 1 
			else weights(model)
	type <- match.arg(type)
	if (any(aliased <- is.na(coef(model))) && !singular.ok) 
		stop("there are aliased coefficients in the model")
	sumry <- summary(model, corr = FALSE)
	s2 <- sumry$sigma^2
	V <- sumry$cov.unscaled
	if (type == FALSE) 
		return(s2 * V)
	h <- hatvalues(model)
	if (!is.null(removed)){
		wts <- wts[-removed]
		h <- h[-removed]
	}
	X <- model.matrix(model)[, !aliased]
	df.res <- df.residual(model)
	n <- length(e)
	e <- wts*e
	p <- ncol(X)
	factor <- switch(type, hc0 = 1, hc1 = df.res/n, 
			hc2 = 1 - h, hc3 = (1 - h)^2, hc4 = (1 - h)^pmin(4, n * h/p))
	V %*% t(X) %*% apply(X, 2, "*", (e^2)/factor) %*% V
}

hccm.default<-function(model, ...){
	#last modified 12 Dec 2000 by J. Fox
	stop("requires an lm object")
}

# positions of names in a data frame (J. Fox)

# last modified 30 April 2010 by J. Fox

which.names <- function(names, object){
    row.names <- if (inherits(object, "data.frame")) row.names(object) else object
    check <- outer(row.names, names, '==')
    if (!all(matched <- apply(check, 2, any))) 
        warning(paste(paste(names[!matched], collapse=", "), "not matched"))
    which(apply(check, 1, any))
    }
	
whichNames <- function(...) which.names(...)

PredictCv <- function(predictor, args=list(), data.name, num.cv) {
	# Run a given predictor on each cross-validation train-test split.
	#
	# Args:
	#	predictor: the predictor function to run; will be called as
	#		predictor(train.name, test.name, args)
	#	args: list of additional arguments used by predictor
	# 	data.name: base name of RDA file used to generate cv data
	#	num.cv: number of cross-validation folds
	#
	# Example Usage:
	#	PredictCv(GroundTruthPredict, list(), "train", 10)

	# Run predictor on each CV train-test split
	file.pattern <- "%s-cv%s_%sof%d"
	for (fold in 1:num.cv) {
		train.name <- sprintf(file.pattern,data.name,"train",fold,num.cv)
		test.name <- sprintf(file.pattern,data.name,"test",fold,num.cv)
		predictor(train.name, test.name, args)
	}
}

require(synapseClient)

#' Script to evaluate an uploaded model with source code from Synapse
#'
#' Function used by model evaluation harness to score submitted models.
#' @param submittedModelId the Synapse ID of the submitted model
#' @param trainingData training data used for evaluation. Loaded by default from Synapse if not specified.
#' @param testData test data used for evaluation. Loaded by default from Synapse if not specified.
#' @author Adam Margolin
#' @export

evaluateMetabricModelFromCode <- function(submittedModelId, trainingData=NULL, testData=NULL){
  print(paste("Model Synapse ID", submittedModelId))
  if(is.null(trainingData)){
    trainingData <- loadMetabricTrainingData()
  }
  if(is.null(testData)){
    testData <- loadMetabricTestData(loadSurvData=TRUE)
  }
  
  submittedModelLayer <- loadEntity(submittedModelId)
  
  for (curFile in submittedModelLayer$files[grepl(".R$", submittedModelLayer$files)]){
    print(paste(submittedModelLayer$cacheDir, curFile, sep="/"))
    source(paste(submittedModelLayer$cacheDir, curFile, sep="/"))
  }
  
  trainedModel <- submittedModelLayer$objects[["trainedModel"]]
  
  if (is.null(trainedModel)) {
    trainedModel <- submittedModelLayer$objects[[1]]
  }
  
  trainPredictions <- trainedModel$customPredict(trainingData$exprData, trainingData$copyData, trainingData$clinicalFeaturesData)
  trainPerformance <- SurvivalModelPerformance$new(as.numeric(trainPredictions), trainingData$clinicalSurvData)
  cIndex_train <- trainPerformance$getExactConcordanceIndex()
  
  testPredictions <- trainedModel$customPredict(testData$exprData, testData$copyData, testData$clinicalFeaturesData)
  testPerformance <- SurvivalModelPerformance$new(as.numeric(testPredictions), testData$clinicalSurvData)
  cIndex_test <- testPerformance$getExactConcordanceIndex()
  
  print(propertyValue(submittedModelLayer, "name"))
  print(paste("train concordance.index =", cIndex_train))
  print(paste("test concordance.index =", cIndex_test))
  cat("\n")
}

#' Load training data for the metabric competition
#'
#' Loads data for gene expression, copy number, clinical covariates and clinical survival times for the training dataset
#' used to train predicitve models.
#'
#' @return a list with elements: exprData, containing an ExpressionSet of gene expression features;
#' copyData, containing an ExpressionSet of copy number features; clinicalFeaturesData, containing an
#' AnnotatedDataFrame of clinical covariates; and clinicalSurvData, containing a Surv object
#' of survival times and censor values.
#' @author Adam Margolin, Matt Furia, Erhan Bilal
#' @export


loadMetabricTrainingData <- function(){

  ##
  ## subroutine for generating error message when user has not signed
  ## terms of use
  ##
  touMsg <- function(){
    "You must sign the Terms of Use before gaining access to the Metabric data.
Please visit https://synapse.sagebase.org/#Synapse:syn1125612 and click the
'Download' button."
  }

  ##
  ## subroutine for generating error message when entity contains no data
  ##
  missingMsg <- function(id){
    sprintf("Unable to load data for synapse id %s. Please visit support.sagebase.org for assistance.",
            id)
  }

  ##
  ## subroutine for fetching an entity's ID based on parent id and name
  ##
  doIdQry <- function(parent, name){
    ## genrate the error message for a query retuning no results
    qryMsg <- function(which){
      sprintf("Unable to find data entity '%s'. Please visit support.sagebase.org for assistance.",
            which)
    }

    ## build the query string
    makeQry <- function(parent, name){
      sprintf("select id from entity where entity.parentId == '%s' && entity.name == '%s'", parent, name)
    }

    qryString <- makeQry(parent, name)
    result <- synapseQuery(qryString)
    id <- result$entity.id

    if(is.null(id))
      stop(qryMsg(name))

    id
  }

  ## entity id for the Metabric Project
  METABRICID <- 'syn1125147'

  ## entity names to be retrieved
  entities <- list(
    exprData = 'Training METABRIC Gene Expression Data',
    copyData = 'Training METABRIC Copy Number Data',
    clinicalFeaturesData = 'Training METABRIC Clinical Features Data',
    clinicalSurvData = 'Training METABRIC Clinical Survival Data',
    clinicalSurvData_ds = 'Training METABRIC Clinical Survival Data (Disease Specific)'
  )

  ## initialize return value
  retVal <- list()

  ## return data for each of the entities
  for(i in 1:length(entities)){
    ## get the entity id
    entityId <- doIdQry(METABRICID, entities[[i]])

    ## load the entity
    entity <- loadEntity(entityId)

    ## check for data
    if(length(entity$objects) == 0L){
      ## on the first iteration, it's most likely that the user
      ## hasn't signed the terms of use. If on subsequent iterations
      ## it is likely that the data were deleted from Synapse
      switch(i,
        "1" = stop(touMsg()),
         stop(missingMsg(entityId))
      )

    }else{
      ## data was found. add to the return value
      retVal[[names(entities)[i]]] <- entity$objects[[1]]
    }
  }

  ## return the list containing the Metabric data
  retVal
}

boxCox <- function(object,...) UseMethod("boxCox")

boxCox.formula <- function (object, lambda = seq(-2, 2, 1/10), plotit = TRUE, interp = (plotit &&
    (m < 100)), eps = 1/50, xlab = expression(lambda), ylab = "log-Likelihood",family="bcPower",
    ...)
{
    m <- length(lambda)
    object <- lm(object, y = TRUE, qr = TRUE, ...)
    result <- NextMethod()
    if (plotit)
        invisible(result)
    else result
}

boxCox.lm <- function (object, lambda = seq(-2, 2, 1/10), plotit = TRUE, interp = (plotit &&
    (m < 100)), eps = 1/50, xlab = expression(lambda), ylab = "log-Likelihood",
    family="bcPower", ...)
{
    m <- length(lambda)
    if (is.null(object$y) || is.null(object$qr))
        object <- update(object, y = TRUE, qr = TRUE, ...)
    result <- NextMethod()
    if (plotit)
        invisible(result)
    else result
}

boxCox.default <- function(object,
    lambda = seq(-2, 2, 1/10), plotit = TRUE, interp = (plotit &&
        (m < 100)), eps = 1/50, xlab = expression(lambda), ylab = "log-Likelihood",
        family="bcPower", grid=TRUE, ...)
{                
    fam <- match.fun(family)
    if (is.null(object$y) || is.null(object$qr))
        stop(paste(deparse(substitute(object)), "does not have both 'qr' and 'y' components"))
    y <- object$y
    n <- length(y)              
    xqr <- object$qr
    xl <- loglik <- as.vector(lambda)
    m <- length(xl)
    for (i in 1L:m) {
        yt <- fam(y,xl[i],j=TRUE)
        loglik[i] <- -n/2 * log(sum(qr.resid(xqr, yt)^2))
    }
    if (interp) {
        sp <- spline(xl, loglik, n = 100)
        xl <- sp$x
        loglik <- sp$y
        m <- length(xl)
    }
    if (plotit) {
        mx <- (1L:m)[loglik == max(loglik)][1L]
        Lmax <- loglik[mx]
        lim <- Lmax - qchisq(19/20, 1)/2
        plot(xl, loglik, xlab = xlab, ylab = ylab, type = "n",
            ylim = range(loglik, lim))
   	    if(grid){
          grid(lty=1, equilogs=FALSE)
          box()}
        lines(xl, loglik)
        plims <- par("usr")
        abline(h = lim, lty = 2)
        y0 <- plims[3L]
        scal <- (1/10 * (plims[4L] - y0))/par("pin")[2L]
        scx <- (1/10 * (plims[2L] - plims[1L]))/par("pin")[1L]
        text(xl[1L] + scx, lim + scal, " 95%")
        la <- xl[mx]
        if (mx > 1 && mx < m)
            segments(la, y0, la, Lmax, lty = 2)
        ind <- range((1L:m)[loglik > lim])
        if (loglik[1L] < lim) {
            i <- ind[1L]
            x <- xl[i - 1] + ((lim - loglik[i - 1]) * (xl[i] -
                xl[i - 1]))/(loglik[i] - loglik[i - 1])
            segments(x, y0, x, lim, lty = 2)
        }
        if (loglik[m] < lim) {
            i <- ind[2L] + 1
            x <- xl[i - 1] + ((lim - loglik[i - 1]) * (xl[i] -
                xl[i - 1]))/(loglik[i] - loglik[i - 1])
            segments(x, y0, x, lim, lty = 2)
        }
    }
    list(x = xl, y = loglik)
}

#' filterPredictiveModelData filters
#'
#' Filters feature and response data as specificied by the users based on rows or columns that contain NAs.
#' features with low variance, or features not correlated with response.
#' 
#' @param featureData
#' @param responseData
#' @return a list of the filtered feature and response data
#' @author Adam Margolin
#' @export
filterPredictiveModelData <- 
		function(featureData, responseData, filterResponseNas = TRUE, filterFeatureNasBy = "columns", featureVarianceThreshold=0, corPValThresh = NULL)
{    
    if(filterResponseNas){
      isNas <- is.na(responseData)
      featureData <- featureData[!isNas,]
      responseData <- responseData[!isNas]
    }
    
    if(filterFeatureNasBy == "columns"){
      featureData <- filterNasFromMatrix(dataMatrix=featureData, filterBy = filterFeatureNasBy)
    }else if(filterFeatureNasBy == "rows" || filterFeatureNasBy == "both"){
     ###after filtering, need to reassign response data to match rows retained in feature data
      featureData <- filterNasFromMatrix(dataMatrix=featureData, filterBy = filterFeatureNasBy)
      responseData <- responseData[rownames(featureData)]
    }
    
    if(!is.na(featureVarianceThreshold) && !is.null(featureVarianceThreshold) ){
      variances <- apply(featureData, 2, var)
      if(any(variances<=featureVarianceThreshold | is.na(variances) )){
        featureData <- featureData[, -which(variances<=featureVarianceThreshold | is.na(variances))] 
      }
    }
  
    if(!is.null(corPValThresh) && !is.na(corPValThresh) ){
      featureCorrs <- apply(featureData, 2, "cor.test", responseData)
      featurePVals <- sapply(featureCorrs, FUN=function(x)x$p.value)
      
      sigFeatures <- which(featurePVals < corPValThresh)
      featureData <- featureData[,sigFeatures]
    }
    
    #sbf(featureData, responseData, sbfControl = sbfControl(functions = gamScores))
    #use filter() function
    list(featureData = featureData, responseData = responseData)
}

# 21 May 2010: small changes to output when there is just one model. J. Fox 
# 15 Aug 2010: changed name of function to compareCoefs to avoid name clash. J. Fox
# 18 May 2011: check for 'mer' objects, and handle them correctly. S. Weisberg
#  8 Sep 2011: check for 'lme' objects, and handle them correctly. S. Weisberg
# 11 Jan 2012: fix to work with any 'S4' object with a coef() method. 
#   suggested by David Hugh-Jones  University of Warwick http://davidhughjones.googlepages.com 
# 3 May 2012:  fixed bug if models are less than full rank.
# 17 Sept 2012: suppressing printing calls when there are none. J. Fox
# 22 June 2013: tweaks for lme4. J. Fox
# 26 Sept 2014: cleaned up printing of calls. J. Fox

compareCoefs <- function (..., se = TRUE, print = TRUE, digits = 3) {
    splitExpr <- function(expr, width=getOption("width") - 4, at="[ ,=]"){
        if (length(grep("\n", expr)) >0 ){
            cmds <- strsplit(expr, "\n")[[1]]
            allcmds <- character(length(cmds))
            for (i in 1:length(cmds))
                allcmds[i] <- splitExpr(cmds[i], width=width, at=at)
            return(paste(allcmds, collapse="\n"))
        }
        if (nchar(expr) <= width) return(expr)
        where <- gregexpr(at, expr)[[1]]
        if (where[1] < 0) return(expr)
        singleQuotes <- gregexpr("'", expr)[[1]]
        doubleQuotes <- gregexpr('"', expr)[[1]]
        comment <- regexpr("#", expr)
        if (singleQuotes[1] > 0 && (singleQuotes[1] < doubleQuotes[1] || doubleQuotes[1] < 0 ) && (singleQuotes[1] < comment[1] || comment[1] < 0 )){
            nquotes <- length(singleQuotes)
            if (nquotes < 2) stop("unbalanced quotes")
            for(i in seq(nquotes/2))
                where[(where > singleQuotes[2 * i - 1]) & (where < singleQuotes[2 * i])] <- NA
            where <- na.omit(where)
        }  
        else if (doubleQuotes[1] > 0 && (doubleQuotes[1] < singleQuotes[1] || singleQuotes[1] < 0) && (doubleQuotes[1] < comment[1] || comment[1] < 0 )){
            nquotes <- length(doubleQuotes)
            if (nquotes < 2) stop("unbalanced quotes")
            for(i in seq(nquotes/2))
                where[(where > doubleQuotes[2 * i - 1]) & (where < doubleQuotes[2 * i])] <- NA
            where <- na.omit(where)
        }
        else if (comment > 0){
            where[where > comment] <- NA
            where <- na.omit(where)
        }
        if (length(where) == 0) return(expr)
        where2 <- where[where <= width]
        where2 <- if (length(where2) == 0) where[1]
        else where2[length(where2)]
        paste(substr(expr, 1, where2), "\n  ", 
            Recall(substr(expr, where2 + 1, nchar(expr)), width, at), sep="")
    } 
    removeExtraQuotes <- function(string) sub("\\\"$", "", sub("^\\\"", 
        "", string))
    squeezeMultipleSpaces <- function(string) gsub(" {2,}", " ", string)
    models <- list(...)
    n.models <- length(models)
    if (n.models < 1) 
        return(NULL)
    getnames <- function(model) {
        if (inherits(model, "merMod") || inherits(model, "mer") | 
                inherits(model, "lme")) 
            names(fixef(model))
        else names(coef(model))
    }
    getcoef <- function(model) {
        if (inherits(model, "merMod") || inherits(model, "mer") | 
                inherits(model, "lme")) 
            fixef(model)
        else coef(model)
    }
    getcall <- function(model) {
        paste(deparse(if (isS4(model))  model@call else model$call), collapse="")
    }
    getvar <- function(model) {
        if (inherits(model, "merMod") || inherits(model, "mer")) 
            as.matrix(vcov(model))
        else vcov(model)
    }
    coef.names <- unique(unlist(lapply(models, getnames)))
    table <- matrix(NA, length(coef.names), n.models * (1 + se))
    rownames(table) <- coef.names
    colnames(table) <- if (se) 
        if (n.models > 1) 
            paste(rep(c("Est.", "SE"), n.models), rep(1:n.models, 
                each = 2))
    else c("Estimate", "Std. Error")
    else if (n.models > 1) 
        paste(rep("Est.", n.models), 1:n.models)
    else "Estimate"
    calls <- !any(sapply(models, getcall) == "NULL")
    if (print == TRUE && calls) 
        cat("\nCall:")
    for (i in 1:n.models) {
        model <- models[[i]]
        fout <- getcall(model)
        mod <- if (n.models > 1) 
            paste(i, ": ", sep = "")
        else ""
        if (print && calls) 
            cat(splitExpr(squeezeMultipleSpaces(paste("\n", mod, removeExtraQuotes(fout[1]), 
                sep = ""))))
        if (print && calls && length(fout) > 1) 
            for (f in fout[-1]) cat("\n", splitExpr(squeezeMultipleSpaces(removeExtraQuotes(f))))
        if (se) {
            ests <- getcoef(model)
            new <- cbind(ests, rep(NA, length(ests)))
            new[!is.na(ests), 2] <- sqrt(diag(getvar(model)))
            table[getnames(model), 2 * (i - 1) + c(1, 2)] <- new
        }
        else table[getnames(model), i] <- getcoef(model)
    }
    if (print == TRUE) {
        cat("\n")
        printCoefmat(table, na.print = "", digits = digits, tst.ind = NULL)
    }
    else table
}

#' Compute the exact value of concordance index (faster version)
#'
#' @param predictions a vector of predictions
#' @param observations a matrix containing time and status columns
#' @author Erhan Bilal
#' @export

exactConcordanceIndexV <- function(predictions, observations) {
  
  xy <- expand.grid(i=1:(length(observations)/2), j=1:(length(observations)/2))
  
  iComparable <- ((xy$i < xy$j) & ((observations[xy$i,2] == TRUE & observations[xy$j, 2] == TRUE) | 
    (observations[xy$i,2] == TRUE & (observations[xy$j,"time"] > observations[xy$i,"time"])) | 
    (observations[xy$j,2] == TRUE & (observations[xy$i,"time"] > observations[xy$j,"time"]))))
  
  add2 <- (iComparable & (observations[xy$i,"time"] < observations[xy$j,"time"] & predictions[xy$i] > predictions[xy$j] | 
    observations[xy$i,"time"] > observations[xy$j,"time"] & predictions[xy$i] < predictions[xy$j] | 
    observations[xy$i,"time"] == observations[xy$j,"time"] & predictions[xy$i] == predictions[xy$j]))

  add1 <- (iComparable & (observations[xy$i,"time"] != observations[xy$j,"time"] & predictions[xy$i] == predictions[xy$j]))
  
  return((2*sum(add2) + sum(add1)) / (2*sum(iComparable)))
  
}  

# revision history
# 2009-09-16: added ... argument to print.summary.powerTransform. J. Fox

### Power families:
basicPower <- function(U,lambda) {
 bp1 <- function(U,lambda){
  if(any(U[!is.na(U)] <= 0)) stop("First argument must be strictly positive.")
  if (abs(lambda) <= 1.e-6) log(U) else (U^lambda)
  }
  out <- U
  out <- if(is.matrix(out) | is.data.frame(out)){
    if(is.null(colnames(out))) colnames(out) <- 
        paste("Z", 1:dim(out)[2],sep="")
    for (j in 1:ncol(out)) {out[, j] <- bp1(out[, j],lambda[j]) 
       colnames(out)[j] <- if(abs(lambda[j]) <= 1.e-6)
           paste("log(", colnames(out)[j],")", sep="") else
           paste(colnames(out)[j], round(lambda[j], 2), sep="^")}
    out}  else
    bp1(out, lambda)
  out}
  
bcPower <- function(U, lambda, jacobian.adjusted=FALSE) {
 bc1 <- function(U, lambda){
  if(any(U[!is.na(U)] <= 0)) stop("First argument must be strictly positive.")
  z <- if (abs(lambda) <= 1.e-6) log(U) else ((U^lambda) - 1)/lambda
  if (jacobian.adjusted == TRUE) {
    z * (exp(mean(log(U), na.rm=TRUE)))^(1-lambda)} else z
  }
  out <- U
  out <- if(is.matrix(out) | is.data.frame(out)){
    if(is.null(colnames(out))) colnames(out) <- 
        paste("Z", 1:dim(out)[2], sep="")
    for (j in 1:ncol(out)) {out[, j] <- bc1(out[, j], lambda[j]) }
    colnames(out) <- paste(colnames(out), round(lambda, 2), sep="^")
    out}  else
    bc1(out, lambda)
  out}
  
yjPower <- function(U, lambda, jacobian.adjusted=FALSE) {
 yj1 <- function(U, lambda){
  nonnegs <- U >= 0
  z <- rep(NA, length(U))
  z[which(nonnegs)] <- bcPower(U[which(nonnegs)]+1, lambda, jacobian.adjusted=FALSE)
  z[which(!nonnegs)] <- -bcPower(-U[which(!nonnegs)]+1, 2-lambda, jacobian.adjusted=FALSE)
  if (jacobian.adjusted == TRUE)
        z * (exp(mean(log((1 + abs(U))^(2 * nonnegs - 1)), na.rm=TRUE)))^(1 -
            lambda)
    else z
  }
  out <- U
  out <- if(is.matrix(out) | is.data.frame(out)){
    if(is.null(colnames(out))) colnames(out) <- 
        paste("Z", 1:dim(out)[2], sep="")
    for (j in 1:ncol(out)) {out[, j] <- yj1(out[, j], lambda[j]) }
    colnames(out) <- paste(colnames(out), round(lambda, 2), sep="^")
    out}  else
    yj1(out, lambda)
  out}
  
powerTransform <- function(object, ...) UseMethod("powerTransform")

powerTransform.default <- function(object, ...) {
   y <- object
   if(!inherits(y, "matrix") & !inherits(y, "data.frame")) {
       y <- matrix(y,ncol=1)
       colnames(y) <- c(paste(deparse(substitute(object))))}
   y <- na.omit(y)
   x <- rep(1, dim(y)[1]) 
   estimateTransform(x, y, NULL, ...)
   }                                    

powerTransform.lm <- function(object,...) {
    mf <- if(is.null(object$model)) 
            update(object, model=TRUE, method="model.frame")$model 
            else object$model
    mt <- attr(mf, "terms")
        y <- model.response(mf, "numeric")
    w <- as.vector(model.weights(mf))
    if (is.null(w)) w <- rep(1, dim(mf)[1])
    if (is.empty.model(mt)) {
        x <- matrix(rep(1,dim(mf)[1]), ncol=1) }
    else {
        x <- model.matrix(mt, mf, contrasts)   } 
  estimateTransform(x, y, w, ...)
  }                                                 
  
powerTransform.formula <- function(object, data, subset, weights, na.action,
  ...) {
    mf <- match.call(expand.dots = FALSE)
    m <- match(c("object", "data", "subset", "weights", "na.action"), 
         names(mf), 0L)
    mf <- mf[c(1L, m)]
    mf$drop.unused.levels <- TRUE
    mf[[1L]] <- as.name("model.frame")
    names(mf)[which(names(mf)=="object")] <- "formula"
    mf <- eval(mf, parent.frame())
    mt <- attr(mf, "terms")
    y <- model.response(mf, "numeric")
    w <- as.vector(model.weights(mf))
    if (is.null(w)) w <- rep(1, dim(mf)[1])
    if (is.empty.model(mt)) {
        x <- matrix(rep(1, dim(mf)[1]), ncol=1) }
    else {
        x <- model.matrix(mt, mf)   } 
  estimateTransform(x, y, w, ...)
  } 

estimateTransform <- function(X, Y, weights=NULL,
   family="bcPower", start=NULL, method="L-BFGS-B", ...) {
   fam <- match.fun(family)
   Y <- as.matrix(Y) # coerces Y to be a matrix.
   X <- as.matrix(X) # coerces X to be a matrix. 
   w <- if(is.null(weights)) 1 else sqrt(weights)
   nc <- dim(Y)[2]
   nr <- nrow(Y)
   xqr <- qr(w * X)       
   llik <- function(lambda){
        (nr/2)*log(((nr - 1)/nr) *
               det(var(qr.resid(xqr, w*fam(Y, lambda, j=TRUE)))))
        }
   llik1d <- function(lambda,Y){
        (nr/2)*log(((nr - 1)/nr) * var(qr.resid(xqr, w*fam(Y, lambda, j=TRUE))))
        }
   if (is.null(start)) {
        start <- rep(1, nc)
        for (j in 1:nc){
            res<- suppressWarnings(optimize(
                    f = function(lambda) llik1d(lambda,Y[ , j, drop=FALSE]),
                    lower=-3, upper=+3))
            start[j] <- res$minimum
            }
        }
   res<-optim(start, llik, hessian=TRUE, method=method,  ...)
   if(res$convergence != 0)
        warning(paste("Convergence failure: return code =", res$convergence))
   res$start<-start
   res$lambda <- res$par
   names(res$lambda) <- 
     if (is.null(colnames(Y))) paste("Y", 1:dim(Y)[2], sep="")
     else colnames(Y)
   roundlam <- res$lambda
   stderr <- sqrt(diag(solve(res$hessian)))
   lamL <- roundlam - 1.96 * stderr
   lamU <- roundlam + 1.96 * stderr
   for (val in rev(c(1, 0, -1, .5, .33, -.5, -.33, 2, -2))) { 
       sel <- lamL <= val & val <= lamU 
    roundlam[sel] <- val
    }
   res$roundlam <- roundlam
   res$par <- NULL
   res$family<-family
   res$xqr <- xqr
   res$y <- Y
   res$x <- X    
   res$weights <- weights
   class(res) <- "powerTransform"
   res
   }
   
testTransform <- function(object, lambda) UseMethod("testTransform")   
   
testTransform.powerTransform <- function(object, 
  lambda=rep(1, dim(object$y)[2])){
   fam <- match.fun(object$family)
   Y <- cbind(object$y) # coerces Y to be a matrix.
   nc <- dim(Y)[2]
   nr <- nrow(Y)
   lam <- if(length(lambda)==1) rep(lambda, nc) else lambda
   xqr <- object$xqr 
   w <- if(is.null(object$weights)) 1 else sqrt(object$weights)  
   llik <- function(lambda){
        (nr/2) * log(((nr - 1)/nr) * 
             det(var(qr.resid(xqr, w*fam(Y, lam,j=TRUE)))))
        }
   LR <- 2 * (llik(lambda) - object$value)
   df <- length(object$lambda)
   pval <- 1-pchisq(LR, df)
   out <- data.frame(LRT=LR, df=df, pval=pval)
   rownames(out) <- 
     c(paste("LR test, lambda = (",
             paste(round(lam, 2), collapse=" "), ")", sep=""))
   out}   

print.powerTransform<-function(x, ...) {
   cat("Estimated transformation parameters \n")
   print(x$lambda)
   invisible(x)}
      
summary.powerTransform<-function(object,...){
    one <- 1==length(object$lambda)
    label <- paste(object$family, 
       (if(one) "Transformation to Normality" else 
                "Transformations to Multinormality"), "\n\n")
    lambda<-object$lambda
    stderr<-sqrt(diag(solve(object$hessian)))
    df<-length(lambda) 
    result <- cbind(lambda, stderr, lambda - 1.96*stderr, lambda + 1.96*stderr)
    rownames(result)<-names(object$lambda)
    colnames(result)<-c("Est.Power", "Std.Err.", "Wald Lower Bound",
                        "Wald Upper Bound")
    tests <- testTransform(object, 0)
    tests <- rbind(tests, testTransform(object, 1))
    if ( !(all(object$roundlam==0) | all(object$roundlam==1) | 
        length(object$roundlam)==1 ))
           tests <- rbind(tests, testTransform(object, object$roundlam))
    out <-  list(label=label, result=result, tests=tests)
    class(out) <- "summary.powerTransform"
    out
    }
    
print.summary.powerTransform <- function(x,digits=4, ...) {
    cat(x$label)
    print(round(x$result, digits))
    cat("\nLikelihood ratio tests about transformation parameters\n")
    print(x$tests)
    }

coef.powerTransform <- function(object, round=FALSE, ...) 
  if(round==TRUE) object$roundlam else object$lambda
  
vcov.powerTransform <- function(object,...) {
  ans <- solve(object$hessian)
  rownames(ans) <- names(coef(object))
  colnames(ans) <- names(coef(object))
  ans}
  
plot.powerTransform <- function(x, z=NULL, round=TRUE, plot=pairs, ...){
  y <- match.fun(x$family)(x$y, coef(x, round=round))
  if (is.null(z)) plot(y, ...) else
   if (is.matrix(z) | is.data.frame(z)) plot(cbind(y, z), ...) else {
    y <- cbind(y,z)
    colnames(y)[dim(y)[2]] <- deparse(substitute(z))
    plot(y, ...) }
    }




  
  

                              

#' createFeatureAndResponseDataList
#'
#' Prepares data for input to predictive modeling by matching column names of feature and response data and creating
#' feature and response matrices with columns in the same order
#'
#' @param featureData a matrix of feature data with samples on rows and features on columns
#' @param responseData a matrix or AnnotatedDataFrame of pheno data with samples on rows and features on columns
#' @return a list containing two items: the feature data and the response data with intersecting sample names
#' 
#' @author Adam Margolin
#' @export

createFeatureAndResponseDataList <- function(featureData, responseData){
  if(is(responseData, "AnnotatedDataFrame")) {
    responseData <- pData(responseData)
  }
  
  if (is.data.frame(responseData) || is.matrix(responseData)){
    commonRowNames <- intersect(rownames(featureData), rownames(responseData))
    featureAndResponseDataList <- list(featureData = featureData[commonRowNames,], responseData = responseData[commonRowNames,])
  }else if (is.numeric(responseData)){
    commonRowNames <- intersect(rownames(featureData), names(responseData))
    featureAndResponseDataList <- list(featureData = featureData[commonRowNames,], responseData = responseData[commonRowNames])
  }else{
    print("error: uknown responseData type")
  }
  
  return(featureAndResponseDataList)
}

unitTestDataFramesAndBiocObjects <- function() {
    
    ## load the data
    data(demoData)
    
    checkTrue(exists('copyData_ccle'))
    checkTrue(all(rownames(pData(copyData_ccle)) == colnames(exprs(copyData_ccle))))
    checkTrue(exists('oncomapData_ccle'))
    checkTrue(all(rownames(pData(oncomapData_ccle)) == colnames(exprs(oncomapData_ccle))))
    checkTrue(exists('drugData_sanger'))
    
    #### First pass dataframes to the methods #####
    
    ## merge our features
    ds_features_cn_mut_ccle <- createAggregateFeatureDataSet(list(copy = exprs(copyData_ccle), 
                                                                  mut = exprs(oncomapData_ccle)))
    checkEquals(nrow(ds_features_cn_mut_ccle), nrow(exprs(copyData_ccle)) + nrow(exprs(oncomapData_ccle)))
    
    
    ## find the intersection of our feature cell lines and response cell lines
    dataSets_ccleFeaturesCnMut_sangerChems <- createFeatureAndResponseDataList(t(ds_features_cn_mut_ccle), 
                                                                               pData(drugData_sanger))
    
    ## Necessary for legacy support (as this unit test)
    dataSets_ccleFeaturesCnMut_sangerChems$featureData <- t(dataSets_ccleFeaturesCnMut_sangerChems$featureData)
    dataSets_ccleFeaturesCnMut_sangerChems$responseData <- t(dataSets_ccleFeaturesCnMut_sangerChems$responseData)
    
    checkEquals(colnames(dataSets_ccleFeaturesCnMut_sangerChems$featureData), 
                colnames(dataSets_ccleFeaturesCnMut_sangerChems$responseData))  
    
    ## sanity check that it is the size we expect
    checkEquals(sum(23224, 33), nrow(dataSets_ccleFeaturesCnMut_sangerChems$featureData))
    checkEquals(324, ncol(dataSets_ccleFeaturesCnMut_sangerChems$featureData))
    checkEquals(23, nrow(dataSets_ccleFeaturesCnMut_sangerChems$responseData))
    checkEquals(324, ncol(dataSets_ccleFeaturesCnMut_sangerChems$responseData))

    #### Next pass ExpressionSets and Annotated dataframes to the methods #####
    
    ## merge our features
    featuresFromBioc <- createAggregateFeatureDataSet(list(copy = copyData_ccle, 
                                                            mut = oncomapData_ccle))
    checkEquals(ds_features_cn_mut_ccle, featuresFromBioc)
    
    ## find the intersection of our feature cell lines and response cell lines
    featuresAndResponseFromBioc <- createFeatureAndResponseDataList(t(featuresFromBioc), 
                                                                    pData(drugData_sanger))
    
    ## Necessary for legacy support (as this unit test)
    featuresAndResponseFromBioc$featureData <- t(featuresAndResponseFromBioc$featureData)
    featuresAndResponseFromBioc$responseData <- t(featuresAndResponseFromBioc$responseData)
    
    checkEquals(dataSets_ccleFeaturesCnMut_sangerChems, featuresAndResponseFromBioc)     
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

rsf <- function(
    formula,#
    data = NULL,#
    ntree = 1000,#
    mtry = NULL,#
    nodesize = NULL,#
    splitrule = NULL,#
    nsplit = 0,#
    importance = c("randomsplit", "permute", "none")[1],#
    big.data = FALSE,#
    na.action = c("na.omit", "na.impute")[1],#
    nimpute = 1,#
    predictorWt = NULL,#
    forest = TRUE,#
    proximity = FALSE,#
    varUsed = NULL,#
    split.depth = FALSE,#
    seed = NULL,#
    do.trace = FALSE,#
    ...)
{
  warning("\nThis package has been deprecated. Please upgrade to the new package 'randomForestSRC'.\n")
  if (!inherits(formula, "formula")) stop("'formula' is not a formula object.")
  if (is.null(data)) stop("'data' is missing.")
  if (!is.data.frame(data)) stop("'data' must be a data frame.")
  mf <- match.call(expand.dots = FALSE)
  m <- match(c("formula","data"), names(mf), 0)
  mf <- mf[c(1, m)]
  mf$drop.unused.levels <- TRUE 
  mf[[1]] <- as.name("model.frame")
  fNames <- all.vars(formula, max.names=1e7)
  if (!( (all.names(formula)[2] == "Survrsf" | all.names(formula)[2] == "Surv")
       & sum(is.element(names(data), fNames[1:2]))==2)) 
    stop("Formula is specified incorrectly.")
  if (sum(inherits(data, c("data.frame", "impute.only"), TRUE) == c(1, 2)) == 2) {
    impute.only <- TRUE
  }
  else {
    impute.only <- FALSE
  }
  if (importance == TRUE)  importance <- "permute"
  if (importance == FALSE) importance <- "none"    
  pt.Time <- is.na(data[,is.element(names(data), fNames[1])])
  pt.Cens <- is.na(data[,is.element(names(data), fNames[2])])
  if (all(pt.Time) | all(pt.Cens))
    stop("All records missing on survival and (or) censoring.  Analysis not meaningful.")
  pt.col <- apply(data, 2, function(x){all(is.na(x))})
  data <- data[, !pt.col]    
  if (nrow(data) <= 2)
    stop("No predictors left in the NA-processed data.  Analysis not meaningful.")
  pt.row <- apply(data, 1, function(x){all(is.na(x))})
  data <- data[!pt.row, ]    
  if (ncol(data) <= 1)
    stop("Less than 2 records in the NA-processed data.  Analysis not meaningful.")
  if (fNames[3] != ".") {
    if (!big.data) {
      predTempNames <- attr(terms(formula), "term.labels")
    }
    else {
      predTempNames <- fNames[-c(1:2)]
    }
  }
  else {
    predTempNames <- names(data)[!is.element(names(data), fNames[1:2])]
    formula <- as.formula(paste(paste("Surv(",fNames[1],",",fNames[2],") ~"),
                                paste(predTempNames, collapse="+")))
  }
  data <- rm.na.levels(data,
        prednames=(if (fNames[3] != ".") fNames[-c(1,2)] else predTempNames))
  get.factor <- extract.factor(data,
        prednames=(if (fNames[3] != ".") fNames[-c(1,2)] else predTempNames))
  xfactor <- get.factor$xfactor
  xfactor.levels <- get.factor$xfactor.levels
  xfactor.order <- get.factor$xfactor.order
  xfactor.order.levels <- get.factor$xfactor.order.levels
  if (na.action != "na.omit" & na.action != "na.impute") na.action <- "na.omit"
  if (!big.data) {
    data <- as.data.frame(data.matrix(data))
    old.na.action <- options()$na.action
    na.keep <- function(x){ x }
    na.takeOut <- function(x){ na.omit(x) }
    if (na.action == "na.omit") options(na.action=na.takeOut) else options(na.action=na.keep)
    data <- as.data.frame(model.matrix(as.formula(paste("~ -1 +",
                 paste(c(fNames[1:2], predTempNames), collapse="+"))), data))
    options(na.action=old.na.action)
  }
  else { 
    data <- data[ , is.element(names(data), c(fNames[1:2], predTempNames))]
    data <- as.data.frame(data.matrix(data))
    if (na.action == "na.omit") {
      data <- na.omit(data)
    }
  }
  predictorNames <- names(data)[!is.element(names(data), fNames[1:2])]
  predictors <- as.matrix(data[,is.element(names(data), predictorNames)])
  rownames(predictors) <- colnames(predictors) <- NULL
  n <- nrow(predictors)
  ncov <- ncol(predictors)
  if (n <= 1)
    stop("Less than two records in the NA-processed data.  Analysis not meaningful.")
  predictorType <- rep("R", ncov)
  if (length(xfactor) > 0) {
    predictorType[is.element(predictorNames, xfactor)] <- "C"
  }
  if (length(xfactor.order) > 0) {
    predictorType[is.element(predictorNames, xfactor.order)] <- "I"
  }
  nsplit <- round(nsplit)
  if (nsplit < 0) stop("Invalid nsplit value specified.")    
  if (is.null(predictorWt)) {
    predictorWt <- rep(1/ncov, ncov)
  }
  else {
    if (any(predictorWt < 0) | length(predictorWt) != ncov | all(predictorWt == 0)) {
      predictorWt <- rep(1/ncov, ncov)
    }
    else {
      predictorWt <-predictorWt/sum(predictorWt)
    }
  }
  ntree <- round(ntree)
  if (ntree < 1) stop("Invalid choice of 'ntree'.  Cannot be less than 1.")
  nimpute <- round(nimpute)
  if (nimpute < 1) stop("Invalid choice of 'nimpute'.  Cannot be less than 1.")
  if (!is.null(mtry)) {
    mtry <- round(mtry)
    if (mtry < 1 | mtry > ncov) mtry <- max(1, min(mtry, ncov))
  }
  else {
    mtry <- max(floor(sqrt(ncov)), 1)
  }
  if (is.null(seed) || abs(seed)<1) seed <- runif(1,1,1e6)
  seed <- -round(abs(seed))
  Time <- data[,is.element(names(data), fNames[1])]
  Cens <- data[,is.element(names(data), fNames[2])]
  nMiss <- sum(is.na(Cens) | is.na(Time) | apply(predictors, 1, function(x){any(is.na(x))}))
  if (all(na.omit(Cens) == 0)) {
    stop("No deaths in data!")
  }
  eventType <- unique(na.omit(Cens))
  if (sum(eventType >= 0) != length(eventType)) {
    stop("Censoring variable must be coded as NA, 0, or greater than 0.")    
  }
  eventType <- eventType[eventType > 0]
  splitrule.names <- c("logrank", "conserve", "logrankscore", "random", "logrankCR")
  if (is.null(splitrule)) {
    if (length(eventType) ==  1) {
      splitrule.idx <- which(splitrule.names == "logrank")
    }
    else {
      splitrule.idx <- which(splitrule.names == "logrankCR")
    }
    splitrule <- splitrule.names[splitrule.idx]
  }
  else {
    splitrule.idx <- which(splitrule.names == splitrule)
    if (length(splitrule.idx) != 1) {
      stop("Invalid split rule specified:  ", splitrule)
    if (length(eventType) ==  1 & splitrule.idx == 5)
      stop("Cannot specify logrankCR splitting for right-censored data")
    }
    if (splitrule == "random" & nsplit == 0) {
      nsplit <- 1
    }
  }
  splitrule.nsplit <- nsplit
  if (!all(na.omit(Time) > 0)) {
    stop("Time must be strictly positive.")
  }
  remove(data)
  nonMissingOutcome <- which(!is.na(Cens) & !is.na(Time))
  nonMissingDeathFlag <- (Cens[nonMissingOutcome] != 0)    
  timeInterest <- sort(unique(Time[nonMissingOutcome[nonMissingDeathFlag]]))
  N <- length(timeInterest)
  if (N <= 1) stop("Less than 2 unique event times.  Analysis not meaningful.")
  if (!is.null(nodesize)) {
    nodesize <- min(round(nodesize), N) 
    if (nodesize < 1) stop("Invalid choice of 'nodesize'. Cannot be less than 1.")
  }
  else {
    nodesize <- min(c(round(0.632*sum(na.omit(Cens) != 0)), c(3, 6)[1+1*(length(eventType) > 1)], N))
  }
  if (impute.only) {
    if (nMiss == 0) stop("data has no missing values, using 'impute' makes no sense")
  }
  else {
    Risk <- apply(cbind(1:length(timeInterest)),
                1,
                function(i, tau, tunq) {sum(tau >= tunq[i])},
                tau = Time[nonMissingOutcome], tunq = timeInterest)
    Risk <- Risk - c(Risk[-1] , 0)
    impute.only <- FALSE
  }   
  if (!is.logical(do.trace)) {
    if (do.trace >= 1) {
      do.trace <- 2^24 * round(do.trace) + 1
    }
    else {
      do.trace <- 0
    }
  }
  else {
    do.trace <- 1 * do.trace
  }
  if (importance == "none") {
    importanceBits <- 0
  }
  else if (importance == "permute") {
    importanceBits <- 2^11 + 0
  }
  else if (importance == "randomsplit") {
    importanceBits <- 2^11 + 2^9
  }
  else {
    stop("Invalid choice for 'importance' option:  ", importance)
  }
  if (is.null(varUsed)) {
    varUsedBits <- 0
  }
  else if (varUsed == "all.trees") {
    varUsedBits <- 2^13 + 0
  }
  else if (varUsed == "by.tree") {
    varUsedBits <- 2^13 + 2^12
  }
  else {
    stop("Invalid choice for 'varUsed' option:  ", varUsed)
  }
  if (impute.only == TRUE) {
    impute.only <- 2^16
  }
  else {
    impute.only <- 0
  }
  nativeOutput <- .Call("rsfGrow",
                        as.integer(do.trace),
                        as.integer(impute.only +
                                   varUsedBits +
                                   importanceBits +
                                   (32 * (if (forest) 1 else 0)) +
                                   (8  * (if (proximity) 1 else 0)) +
                                   (2^15 * (if (split.depth) 1 else 0))),
                        as.integer(seed),
                        as.integer(splitrule.idx), 
                        as.integer(splitrule.nsplit),
                        as.integer(mtry),
                        as.integer(ntree),
                        as.integer(nodesize),
                        as.integer(n),
                        as.double(Time),
                        as.double(Cens),
                        as.integer(ncov),
                        as.numeric(predictors),
                        as.integer(length(timeInterest)),
                        as.double(timeInterest),
                        as.double(predictorWt),
                        as.character(predictorType),
                        as.integer(nimpute))
  if(is.null(nativeOutput)) {
    stop("Error occurred in algorithm.  Please turn trace on for further analysis.")
  }
  if (nMiss > 0) {
    imputedData <- matrix(nativeOutput$imputation, nrow = nMiss, byrow = FALSE)
    imputedIndv <- imputedData[,1]
    imputedData <- as.matrix(imputedData[,-1])
    if (nMiss == 1) imputedData <- t(imputedData)
    if (nimpute > 1) {
      if (nimpute == 2) {
        imputedOOBData <- matrix(nativeOutput$oobImputation, nrow = nMiss, byrow = FALSE)
        imputedOOBData <- as.matrix(imputedOOBData[,-1])
        if (nMiss == 1) imputedOOBData <- t(imputedOOBData)
        Cens[imputedIndv] <- imputedOOBData[, 1]
        Time[imputedIndv] <- imputedOOBData[, 2]
        predictors[imputedIndv, ] <- imputedOOBData[, -1:-2]
      }
      else {
        Cens[imputedIndv] <- imputedData[, 1]
        Time[imputedIndv] <- imputedData[, 2]
        predictors[imputedIndv, ] <- imputedData[, -1:-2]
      }
      imputedIndv    <- NULL
      imputedData    <- NULL
      imputedOOBData <- NULL
    }  
    else {
      colnames(imputedData) <- c(fNames[2], fNames[1], predictorNames)
      imputedData=as.data.frame(imputedData)
    }
  }
  predictors <- as.data.frame(predictors)
  colnames(predictors) <- predictorNames
  if (length(xfactor) > 0) {
    for (k in 1:length(xfactor)) {      
      ptk <- (colnames(predictors) == xfactor[k])
      factor.k <- xfactor.levels[[k]][predictors[ , ptk ]]
      labels.k <- xfactor.levels[[k]][sort(unique(predictors[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL)  
      if (length(setdiff(xfactor.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      predictors[ , ptk] <- xk
    }
  }
  if (length(xfactor.order) > 0) {
    for (k in 1:length(xfactor.order)) {
      ptk <- (colnames(predictors) == xfactor.order[k])
      factor.k <- xfactor.order.levels[[k]][predictors[ , ptk ]]
      labels.k <- xfactor.order.levels[[k]][sort(unique(predictors[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL, ordered = TRUE)
      if (length(setdiff(xfactor.order.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.order.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      predictors[ , ptk] <- xk
    }
  }
  if (length(xfactor) > 0 & nMiss > 0 & nimpute < 2) {
    for (k in 1:length(xfactor)) {
      ptk <- (colnames(imputedData) == xfactor[k])
      factor.k <- xfactor.levels[[k]][imputedData[ , ptk ]]
      labels.k <- xfactor.levels[[k]][sort(unique(imputedData[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL)  
      if (length(setdiff(xfactor.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      imputedData[ , ptk] <- xk
    }
  }
  if (length(xfactor.order) > 0 & nMiss > 0 & nimpute < 2) {
    for (k in 1:length(xfactor.order)) {
      ptk <- (colnames(imputedData) == xfactor.order[k])
      factor.k <- xfactor.order.levels[[k]][imputedData[ , ptk ]]
      labels.k <- xfactor.order.levels[[k]][sort(unique(imputedData[ , ptk ]))]
      xk.org <- xk <- factor(factor.k, labels = labels.k, levels = labels.k, exclude = NULL, ordered = TRUE)
      if (length(setdiff(xfactor.order.levels[[k]], labels.k)) > 0) {
        levels(xk) <- xfactor.order.levels[[k]]
        for (l in 1:length(xk)) { xk[l]  <- xk.org[l] }
      }
      imputedData[ , ptk] <- xk
    }
  }
  if (!is.null(varUsed)) {
    if (varUsed == "all.trees") {
      varUsed <- nativeOutput$varUsed
      names(varUsed) <- predictorNames
    }
    else {
      varUsed <- matrix(nativeOutput$varUsed, nrow = ntree, byrow = TRUE)
      colnames(varUsed) <- predictorNames
    }
  }
  if (forest) {
    nativeArray <- as.data.frame(cbind(nativeOutput$treeID,
                                       nativeOutput$nodeID,
                                       nativeOutput$parmID,
                                       nativeOutput$contPT,
                                       nativeOutput$mwcpSZ))
    names(nativeArray) <- c("treeID", "nodeID", "parmID", "contPT", "mwcpSZ")
    nativeFactorArray <- nativeOutput$mwcpPT
    forest <- list(nativeArray = nativeArray,
                   nativeFactorArray = nativeFactorArray,
                   timeInterest = timeInterest, 
                   predictorNames = predictorNames,
                   seed = nativeOutput$seed,
                   predictors = predictors,
                   formula = formula,
                   time = Time,
                   cens = Cens)
    class(forest) <- c("rsf", "forest")
  }
  else {
    forest <- NULL
  }
  if ((length(eventType) > 1) & (splitrule.idx >= 4)) {
    n.event <- length(eventType) + 1
    ens.names <- list(NULL, NULL, c("CHF", paste("condCHF.", 1:(n.event-1), sep = "")))
    err.names <- list(c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")), NULL)
    vimp.names <- list(c("CHF", paste("condCHF.", 1:(n.event - 1), sep = "")), predictorNames)
    poe.names <- list(paste("event.", 1:(n.event - 1), sep = ""), NULL)
  }
  else {
    Cens[Cens != 0 & !is.na(Cens)] <-  min(Cens[Cens != 0 & !is.na(Cens)])
    n.event <- 1
    ens.names <- list(NULL, NULL, NULL)
    vimp.names <- list(NULL, predictorNames)
    err.names <- list(NULL, NULL)
  }
  if (!impute.only) {
    mortality <- apply(array(nativeOutput$fullEnsemble, c(n, length(timeInterest), n.event))[,,1],
                     1, function(x, wt) {sum(x*wt)}, wt = Risk)
    oob.mortality <- apply(array(nativeOutput$oobEnsemble, c(n, length(timeInterest), n.event))[,,1],
                     1,function(x, wt) {sum(x*wt)}, wt = Risk)
  }
  make.vec <- function(x) {
    if (!is.null(dim(x)) && nrow(x) == 1) {
      x.names <- colnames(x)
      x <- c(x)
      names(x) <- x.names
      x
    }
    else {
      x
    }
  }
  if (importance != "none") {
      VIMP <- make.vec(matrix(nativeOutput$importance, ncol = ncov, 
                    byrow = TRUE, dimnames = vimp.names)[1:n.event,, drop = FALSE] -
      matrix(nativeOutput$performance, ncol = ntree, byrow = TRUE,
                    dimnames = err.names)[1:n.event, ntree])
  }
  else {
    VIMP <- NULL
  }
  if (impute.only) {
    nativeOutput$fullEnsemble <- nativeOutput$oobEnsemble <- 
    nativeOutput$fullPOE <- nativeOutput$oobPOE <- mortality <- oob.mortality <-
    nativeOutput$performance <- nativeOutput$leafCount <- VIMP <- forest <-
    nativeOutput$proximity <- varUsed <-  NULL
  }
  rsfOutput <- list(
    call = match.call(),
    formula = formula,
    n = n,
    ndead = sum(na.omit(Cens) != 0),
    ntree = ntree,
    nimpute = nimpute,                      
    mtry = mtry,
    nodesize = nodesize,
    splitrule = splitrule,
    nsplit = nsplit,
    time = Time,
    cens = Cens,
    timeInterest = timeInterest,
    predictorNames = predictorNames,
    predictorWt = predictorWt,
    predictors = predictors,
    ensemble = (if (!is.null(nativeOutput$fullEnsemble))
       array(nativeOutput$fullEnsemble, c(n, length(timeInterest), n.event), dimnames=ens.names)[,,1:n.event]
       else NULL),
    oob.ensemble = (if (!is.null(nativeOutput$oobEnsemble))
        array(nativeOutput$oobEnsemble,  c(n, length(timeInterest), n.event), dimnames=ens.names)[,,1:n.event]
       else NULL),
    poe = (if (!is.null(nativeOutput$fullPOE))
           matrix(nativeOutput$fullPOE, ncol=n, byrow=TRUE, dimnames=poe.names) else NULL),
    oob.poe = (if (!is.null(nativeOutput$oobPOE))
           matrix(nativeOutput$oobPOE, ncol=n, byrow=TRUE, dimnames=poe.names) else NULL),
    mortality = mortality,
    oob.mortality = oob.mortality,
    err.rate = (if (!is.null(nativeOutput$performance))
                matrix(nativeOutput$performance, ncol=ntree, byrow=TRUE, dimnames=err.names)[1:n.event, ]
                else NULL),
    leaf.count = nativeOutput$leafCount,
    importance = VIMP,
    forest = forest,
    proximity = nativeOutput$proximity,
    varUsed = varUsed,
    imputedIndv = (if (nMiss > 0) imputedIndv else NULL),
    imputedData = (if (nMiss > 0) imputedData else NULL),
    splitDepth  = (if (split.depth) matrix(nativeOutput$splitDepth, nrow=n, byrow=FALSE) else NULL)
  )
  if (!big.data) {
    class(rsfOutput) <- c("rsf", "grow")
  }
  else {
    class(rsfOutput) <- c("rsf", "grow", "bigdata")
  }
  return(rsfOutput)
}

### R code from vignette source 'metabricCompetitionDemo_diseaseSpecificSurvival.Rnw'

###################################################
### code chunk number 1: loadLibraries
###################################################
library(predictiveModeling)
library(BCC)
library(survival)
library(MASS)


###################################################
### code chunk number 2: loadData
###################################################
## Before downloading data from the R client you must sign the terms of use through the web client.
## This is done by attempting to download any dataset included in the competition and agreeing to the terms of use.
## For example, clicking the "Download" link at https://synapse.sagebase.org/\#Synapse:syn375502 will bring up
## the terms of use dialogue if you have not already agreed to them.

# synapseLogin() ### not required if configured for automatic login
trainingData <- loadMetabricTrainingData()


###################################################
### code chunk number 3: defineModelClassFile
###################################################
modelClassFile <- "~/BCC/R/DemoModel.R"
source(modelClassFile)


###################################################
### code chunk number 4: trainModel
###################################################
demoPredictiveModel <- DemoModel$new()
### class can be instantiated directly from source file with the syntax:
### demoPredictiveModel <- source(modelClassFile)$value$new()
demoPredictiveModel$customTrain(trainingData$exprData, trainingData$copyData,
                                trainingData$clinicalFeaturesData, trainingData$clinicalSurvData_ds)
trainPredictions <- demoPredictiveModel$customPredict(trainingData$exprData, trainingData$copyData,
                                                      trainingData$clinicalFeaturesData)


###################################################
### code chunk number 5: computeTrainCIndex
###################################################
trainPerformance <- SurvivalModelPerformance$new(trainPredictions, trainingData$clinicalSurvData)
print(trainPerformance$getExactConcordanceIndex())


###################################################
### code chunk number 6: runModelOnTestDataset
###################################################
testData <- loadMetabricTestData(loadSurvData=FALSE)
testPredictions <- demoPredictiveModel$customPredict(testData$exprData, testData$copyData,
                                                     testData$clinicalFeaturesData)


###################################################
### code chunk number 7: submitModel
###################################################
myModelName = "Erhan demo model" #change this name to something unique
submitCompetitionModel(modelName = myModelName, trainedModel=demoPredictiveModel,
                       rFiles=c(modelClassFile), parentDatasetId="syn1419781")
onWeb("syn1419781")
## model results will display automatically at http://validation.bcc.sagebase.org/bcc-leaderboard-ds.php


###################################################
### code chunk number 8: crossValidateModel
###################################################
cvPerformance <- crossValidatePredictiveSurvivalModel(DemoModel$new(), trainingData$exprData,
                                                      trainingData$copyData,
                                                      trainingData$clinicalFeaturesData,
                                                      trainingData$clinicalSurvData_ds, numFolds = 3)


###################################################
### code chunk number 9: computeCvPerformance
###################################################
cvPerformance$trainPerformanceCV$getFoldCIndices()
cvPerformance$testPerformanceCV$getFoldCIndices()

#' Create a default trControl object for use with caret
#'
#' @return trainControl
#' @seealso caret::trainControl
#' @author Adam Margolin
#' @export
defaultTrainControl <- 
		function()
{
	caret::trainControl(method = "cv", number=3, returnResamp="all", verboseIter=TRUE)
}

#' createENetTuneGrid
#' 
#' Create a tuning grid appropriate for elastic net models 
#'
#' @param lambdamin
#' @param lambdamax
#' @param lambdas a specific vector of lambdas to use instead of the range specified by the lambdamin and lambdamax parameters
#' @param alphamin
#' @param alphamax
#' @param alphas a specific vector of alphas to use instead of the range specified by the alphamin and alphamax parameters
#' @param len number of rows desired in the resulting tuning grid
#' @param verbose whether to print verbose information about the tuning grid
#' @return the tuning grid
#'
#' @author Adam Margolin
#' @export

createENetTuneGrid <- 
		function(lambdamin=-5, lambdamax=0, lambdas=NULL, alphas=NULL, alphamin=NULL, len=5, verbose=TRUE) 
{
	if(is.null(alphas) & is.null(alphamin))
		## The default for alphas
		alphas <- c( 10^(-5:-1),seq(.2,1, by=0.1))
	if(is.null(alphas) & !is.null(alphamin))
		## If we don't want to test all the low alpha values
		alphas <- round(seq(alphamin, 1, length=len), 2)
	## otherwise, use the provided list of alphas
	len <- length(alphas)
  if (is.null(lambdas)){
	  lambdas <- exp(seq(lambdamin, lambdamax, length = 25 * len))
  }
	message(paste("Testing", length(alphas), "values of alpha from", round(min(alphas),5), "to", round(max(alphas),5)))
	message(paste("Testing", length(lambdas), "values of lambda from", round(min(lambdas),3), "to", round(max(lambdas), 3)))
	enetGrid <- expand.grid(.alpha = alphas,
			.lambda = lambdas)
	enetGrid
}

setRefClass(Class = "PredictiveModel")

#' CaretModel
#'
#' A class in the PredictiveModel class hierarchy that wraps models returned from caret.
#' This class allows all methods implemented in the caret machine learning package to plug into pipelines
#' using the PredictiveModeling API by wrapping all caret methods to implement customTrain() and customPredict()
#' methods.
#'
#' @author Adam Margolin
#' @export

CaretModel <- setRefClass(Class = "CaretModel",
                          contains="PredictiveModel",
                          fields=c("model", "modelType"),
                          methods = list(
                            initialize = function(modelType, ...){
                              .self$modelType = modelType
                              
                              return(.self)
                            },
                            
                            rawCaretModel = function(){
                              return(.self$model)
                            },
                            
                            copy = function() {
                              
                              result <- CaretModel$new(.self$modelType)
                              result$model <- .self$model
                              
                              return(result)
                            },
                            
                            customTrain = function(featureData, responseData, trControl = trainControl(), # trControl = defaultTrainControl(),
                                             tuneGrid = NULL, ...){
                              .self$model <- caret::train(featureData, 
                                responseData, 
                                 method = .self$modelType,
                                 preProcess = NULL, # preProcess = c("center", "scale"),
                                 tuneLength = 4,
                                 trControl = trControl,
                                  tuneGrid = tuneGrid,
                                  ...
                                )
                            },
                            
                            customPredict = function(featureData){
                              predictedResponse <- predict(.self$model, featureData)
                              return(predictedResponse)
                            }
                          )
                          )

setRefClass(Class = 'PredictiveModel')

#' PredictiveModelResults
#'
#' A class to hold results from PredictiveModels
#' @author Adam Margolin
#' @export

PredictiveModelResults <- setRefClass(Class = 'PredictiveModelResults',
            
            fields = list(predictiveModel='PredictiveModel',
		          features='matrix',
		          trainIndices='numeric',
		          testIndices='numeric',
		          predictedValues='numeric',
		          observedValues='numeric'),
            
            methods = list(
              initialize = function(predictiveModel, features, trainIndices, testIndices, predictedValues, observedValues, ...){
                .self$predictiveModel <- predictiveModel
                .self$features <- features
                .self$trainIndices <- trainIndices
                .self$testIndices <- testIndices
                .self$predictedValues <- predictedValues
                .self$observedValues <- observedValues
                
                return(.self)
              }
              
            )
	)

#' createAggregateFeatureDataSet
#'
#' Combines multiple datasets into a feature matrix.
#' Takes a list of matrices or ExpressionSets and rbinds them using their intersection of column names. The key value
#' for each dataset given as a argument is pre-pended to the name of the features of that dataset.
#'
#' @author Adam Margolin
#' @export

createAggregateFeatureDataSet <- 
		function(dataSetList)
{

    ## If its a list of ExpressionSets, convert them to data frames
    if(is(dataSetList[[1]], "ExpressionSet")) {
      dataSetList <- lapply(dataSetList, exprs)
    }
  
	## Retrieve the column names from each feature set and determine
	## the names in common
	colNamesList <- lapply(dataSetList, colnames)
	commonColNames <- Reduce('intersect', colNamesList)
	
	## For each datset, append the name of the dataset to each feature 
	for (curDsName in names(dataSetList)){
		rownames(dataSetList[[curDsName]]) <- sapply(rownames(dataSetList[[curDsName]]),
				function(rowName) { paste(rowName, curDsName, sep="_")}, USE.NAMES = FALSE)
	}
	
	## For each feature set, make a matrix with only the column
	## names in common and then rbind the matrices together
	ds_common_featList <- lapply(dataSetList, function(x){x[,commonColNames]})
	ds_feat <- do.call("rbind", ds_common_featList)
	
	ds_feat
}

# Quantile-comparison plots (J. Fox)

# last modified 30 September 2009 by J. Fox
# November 2009 by S. Weisberg -- changed to use showLabels for point identification
# 14 April 2010: set id.n = 0. J. Fox
# 1 June 2010: set reps=100 in qqPlot.lm. J. Fox
# 28 June 2010: fixed labeling bug S. Weisberg
# 11 March 2011: moved up ... argument. J. Fox
# 23 May 2012: line="none" now honored in qqPlot.default. J. Fox
# 2 May 2013: qqPlot.lm() now works with "aov" objects (fixing problem reported by Thomas Burk). J. Fox

qqp <- function(...) qqPlot(...)

qqPlot<-function(x, ...) {
	UseMethod("qqPlot")
}

qqPlot.default <- function(x, distribution="norm", ..., ylab=deparse(substitute(x)),
		xlab=paste(distribution, "quantiles"), main=NULL, las=par("las"),
		envelope=.95,  
		col=palette()[1], col.lines=palette()[2], lwd=2, pch=1, cex=par("cex"), 
		line=c("quartiles", "robust", "none"), 
		labels = if(!is.null(names(x))) names(x) else seq(along=x),
		id.method = "y", 
		id.n = if(id.method[1]=="identify") Inf else 0,
		id.cex=1, id.col=palette()[1], grid=TRUE)
{
	line <- match.arg(line)
	good <- !is.na(x)
	ord <- order(x[good])
	ord.x <- x[good][ord]
	ord.lab <- labels[good][ord]
	q.function <- eval(parse(text=paste("q", distribution, sep="")))
	d.function <- eval(parse(text=paste("d", distribution, sep="")))
	n <- length(ord.x)
	P <- ppoints(n)
	z <- q.function(P, ...)
	plot(z, ord.x, type="n", xlab=xlab, ylab=ylab, main=main, las=las)
	if(grid){
		grid(lty=1, equilogs=FALSE)
		box()}
	points(z, ord.x, col=col, pch=pch, cex=cex)
	if (line == "quartiles" || line == "none"){
		Q.x <- quantile(ord.x, c(.25,.75))
		Q.z <- q.function(c(.25,.75), ...)
		b <- (Q.x[2] - Q.x[1])/(Q.z[2] - Q.z[1])
		a <- Q.x[1] - b*Q.z[1]
		if (line == "quartiles") abline(a, b, col=col.lines, lwd=lwd)
	}
	if (line=="robust") {
		coef <- coef(rlm(ord.x ~ z))
		a <- coef[1]
		b <- coef[2]
		abline(a, b, col=col.lines, lwd=lwd)
	}
	conf <- if (envelope == FALSE) .95 else envelope
	zz <- qnorm(1 - (1 - conf)/2)
	SE <- (b/d.function(z, ...))*sqrt(P*(1 - P)/n)
	fit.value <- a + b*z
	upper <- fit.value + zz*SE
	lower <- fit.value - zz*SE
	if (envelope != FALSE) {
		lines(z, upper, lty=2, lwd=lwd, col=col.lines)
		lines(z, lower, lty=2, lwd=lwd, col=col.lines)
	}
	showLabels(z, ord.x, labels=ord.lab,
			id.method = id.method, id.n = id.n, id.cex=id.cex, id.col=id.col)
}

qqPlot.lm <- function(x, xlab=paste(distribution, "Quantiles"),
		ylab=paste("Studentized Residuals(", deparse(substitute(x)), ")", sep=""), main=NULL,
		distribution=c("t", "norm"), line=c("robust", "quartiles", "none"), las=par("las"),
		simulate=TRUE, envelope=.95,  reps=100, 
		col=palette()[1], col.lines=palette()[2], lwd=2, pch=1, cex=par("cex"),
		labels, id.method = "y", 
		id.n = if(id.method[1]=="identify") Inf else 0, id.cex=1, 
		id.col=palette()[1], grid=TRUE, ...){
	result <- NULL
	distribution <- match.arg(distribution)
	line <- match.arg(line)
	rstudent <- rstudent(x)
	if (missing(labels)) labels <- names(rstudent)
	good <- !is.na(rstudent)
	rstudent <- rstudent[good]
	labels <- labels[good]
	sumry <- summary.lm(x)
	res.df <- sumry$df[2]
	if(!simulate)
		result <- qqPlot(rstudent, distribution=if (distribution == "t") "t" else "norm", df=res.df-1, line=line,
				main=main, xlab=xlab, ylab=ylab, las=las, envelope=envelope, 
				col=col, col.lines=col.lines, lwd=lwd, pch=pch, cex=cex,
				labels=labels, id.method=id.method, id.n=id.n, id.cex=id.cex,
				id.col=id.col, ...)
	else {
		n <- length(rstudent)        
		ord <- order(rstudent)
		ord.x <- rstudent[ord]
		ord.lab <- labels[ord]
		P <- ppoints(n)
		z <- if (distribution == 't') qt(P, df=res.df-1) else qnorm(P)
		plot(z, ord.x, type="n", xlab=xlab, ylab=ylab, main=main, las=las)
		if(grid) grid(lty=1, equilogs=FALSE)
		points(z, ord.x, pch=pch, col=col, cex=cex)
		yhat <- na.omit(fitted.values(x))
		S <- sumry$sigma
		Y <- matrix(yhat, n, reps) + matrix(rnorm(n*reps, sd=S), n, reps)
		X <- model.matrix(x)
		rstud <- apply(rstudent(lm(Y ~ X - 1)), 2, sort)
		lower <- apply(rstud, 1, quantile, prob=(1 - envelope)/2)
		upper <- apply(rstud, 1, quantile, prob=(1 + envelope)/2)
		lines(z, upper, lty=2, lwd=lwd, col=col.lines)
		lines(z, lower, lty=2, lwd=lwd, col=col.lines)
		if (line == "quartiles"){
			Q.x <- quantile(rstudent, c(.25,.75))
			Q.z <- if (distribution == 't') qt(c(.25,.75), df=res.df - 1) else qnorm(c(.25,.75))
			b <- (Q.x[2] - Q.x[1])/(Q.z[2] - Q.z[1])
			a <- Q.x[1] - b*Q.z[1]
			abline(a, b, col=col.lines, lwd=lwd)
		}
		if (line=="robust"){
			coef <- coefficients(rlm(ord.x~z))
			a <- coef[1]
			b <- coef[2]
			abline(a, b, col=col.lines, lwd=lwd)
		}                   
		result <- showLabels(z, ord.x,labels=ord.lab,  
				id.method = id.method, id.n = id.n, id.cex=id.cex, id.col=id.col)
	}
	if (length(result) == 0) invisible(result) else if (is.numeric(result)) sort(result) else result
}

qqPlot.glm <- function(x, ...){
	stop("QQ plot for studentized residuals not available for glm")
}

#' Perform one iteration of model training on a portion of the data
#'
#' @param testIndices
#' @param featureData
#' @param responseData
#' @param method either an instance of PredictiveModel or a string holding the name of one of the machine learning methods that caret supports
#' @param trControl defaults to defaultTrainControl
#' @return an instance of PredictiveModelResults
#' @author Nicole Deflaux
#' @export
trainPartition <-
		function(testIndices, featureData, responseData, model, trControl = defaultTrainControl(), ...) {
	message("Getting Training Indices")
	trainIndices <- setdiff(seq(along=responseData), testIndices)
	
  message("Selecting Features")
	trainFeatures <- featureData[trainIndices,]
	testFeatures <- featureData[testIndices,]
	trainResponse <- responseData[trainIndices]
	testResponse <- responseData[testIndices]
	
  # Need to generate the model if the argument is instaed a type of machine learning that caret supports
	if (is.character(model)){
    model <- CaretModel$new(modelType=model)
	}
  
	model$customTrain(trainFeatures, trainResponse, filterData=FALSE, trControl=trControl, ...)
  
  prediction_train <- model$customPredict(trainFeatures)
  prediction_test <- model$customPredict(testFeatures)
	
	predictedValues <- vector(mode='numeric', length=length(responseData))
	predictedValues[trainIndices] <- prediction_train
	predictedValues[testIndices] <- prediction_test
	
	message("creating PredictiveModelResults object")
	PredictiveModelResults$new(predictiveModel=model, 
												 features=featureData, 
												 trainIndices=trainIndices,
												 testIndices=testIndices,
												 predictedValues=predictedValues, 
												 observedValues=responseData)	
}

####**********************************************************************
####**********************************************************************
####
####  RANDOM SURVIVAL FOREST 3.6.4
####
####  Copyright 2013, Cleveland Clinic Foundation
####
####  This program is free software; you can redistribute it and/or
####  modify it under the terms of the GNU General Public License
####  as published by the Free Software Foundation; either version 2
####  of the License, or (at your option) any later version.
####
####  This program is distributed in the hope that it will be useful,
####  but WITHOUT ANY WARRANTY; without even the implied warranty of
####  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
####  GNU General Public License for more details.
####
####  You should have received a copy of the GNU General Public
####  License along with this program; if not, write to the Free
####  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
####  Boston, MA  02110-1301, USA.
####
####  Written by:
####    Hemant Ishwaran, Ph.D.
####    Director of Statistical Methodology
####    Professor, Division of Biostatistics
####    Clinical Research Building, Room 1058
####    1120 NW 14th Street
####    University of Miami, Miami FL 33136
####
####    email:  hemant.ishwaran@gmail.com
####    URL:    http://web.ccs.miami.edu/~hishwaran
####    --------------------------------------------------------------
####    Udaya B. Kogalur, Ph.D.
####    Adjunct Staff
####    Dept of Quantitative Health Sciences
####    Cleveland Clinic Foundation
####    
####    Kogalur & Company, Inc.
####    5425 Nestleway Drive, Suite L1
####    Clemmons, NC 27012
####
####    email:  commerce@kogalur.com
####    URL:    http://www.kogalur.com
####    --------------------------------------------------------------
####
####**********************************************************************
####**********************************************************************

print.rsf <- function(x, ...) {
  if (sum(inherits(x, c("rsf", "forest"), TRUE) == c(1, 2)) == 2) {
    print.default(x)
    return()
  }
  if (!is.null(x$cens)) {
    events  <- na.omit(x$cens)[na.omit(x$cens) > 0]
    n.event <- length(unique(events))
    event.freq <- paste(tapply(events, events, length), collapse = ", ")
  }
  else {
    n.event <- 1
  }
  if (!is.null(x$err.rate)) {
    x$err.rate <- rbind(x$err.rate)
    err.rate <- round(100*x$err.rate[, ncol(x$err.rate)], 2) 
    if (!all(is.na(err.rate))) {
      err.rate <- paste(err.rate, "%", collapse=", ", sep = "")
    }
    else {
      err.rate <- NULL
    }
  }
  else {
    err.rate <- NULL
  }
  if (is.null(x$nsplit)) x$nsplit <- 0
  if (sum(inherits(x, c("rsf", "grow"), TRUE) == c(1, 2)) != 2 &
      sum(inherits(x, c("rsf", "predict"), TRUE) == c(1, 2)) != 2)
    stop("This function only works for objects of class `(rsf, grow)' or '(rsf, predict)'.")
  if (sum(inherits(x, c("rsf", "grow"), TRUE) == c(1, 2)) == 2) {
    cat("\nCall:\n", deparse(x$call), "\n\n")
    cat("                         Sample size: ", x$n,                 "\n", sep="")
    if (n.event == 1) {
      cat("                    Number of deaths: ", x$ndead,             "\n", sep="")
    }
    else {
      cat("                    Number of events: ", event.freq,          "\n", sep="")
    }
    if (!is.null(x$imputedIndv)) {
      cat("                    Was data imputed: ", "yes",               "\n", sep="")
      cat("                         Missingness: ",
          round(100*length(x$imputedIndv)/x$n,2), "%\n", sep="")      
    }
    cat("                     Number of trees: ", x$ntree,             "\n",sep="")
    cat("          Minimum terminal node size: ", x$nodesize,          "\n", sep="")
    cat("       Average no. of terminal nodes: ", mean(x$leaf.count),  "\n", sep="")
    cat("No. of variables tried at each split: ", x$mtry,              "\n", sep="")
    cat("              Total no. of variables: ", length(x$predictorNames), "\n", sep="")
    if (x$nsplit > 0 & x$splitrule != "random") {
      cat("                      Splitting rule: ", paste(x$splitrule,"*random*"),         "\n", sep="")
      cat("       Number of random split points: ", x$nsplit                   ,         "\n", sep="")
    }
    else {
      cat("                      Splitting rule: ", x$splitrule,         "\n", sep="")
    } 
    cat("              Estimate of error rate: ", err.rate,            "\n\n", sep="")
  }
  else {
    cat("\nCall:\n", deparse(x$call), "\n\n")
    cat("  Sample size of test (predict) data: ", x$n,                 "\n", sep="")
    if (!is.null(x$cens)) {
      if (n.event == 1) {
        cat("       Number of deaths in test data: ", x$ndead,             "\n", sep="")
      }
      else {
        cat("       Number of events in test data: ", event.freq,           "\n", sep="")
      }
    }
    if (!is.null(x$imputedData)) {
      cat("               Was test data imputed: ", "yes",               "\n", sep="")
      cat("                         Missingness: ",
          round(100*length(x$imputedIndv)/x$n,2), "%\n", sep="")      
    }
    cat("                Number of grow trees: ", x$ntree,             "\n",sep="")
    cat("  Average no. of grow terminal nodes: ", mean(x$leaf.count),  "\n", sep="")
    cat("         Total no. of grow variables: ", length(x$predictorNames), "\n", sep="")  
    if (!is.null(err.rate)) {
      cat("                     Test error rate: ", err.rate, "\n\n", sep="")
    }
  }
}

#' Load training data for the metabric competition
#'
#' Loads data for gene expression, copy number, clinical covariates and clinical survival times for the training dataset
#' used to train predicitve models.
#'
#' @return a list with elements: exprData, containing an ExpressionSet of gene expression features;
#' copyData, containing an ExpressionSet of copy number features; clinicalFeaturesData, containing an
#' AnnotatedDataFrame of clinical covariates; and clinicalSurvData, containing a Surv object
#' of survival times and censor values.
#' @author Adam Margolin
#' @export

loadMetabricTrainingData_federation <- function(){
  metabricTrainingData <- list()
  
  idExpressionLayer <- "160776"
  expressionLayer <- loadEntity(idExpressionLayer)
  metabricTrainingData$exprData <- expressionLayer$objects[[1]]
  
  idCopyLayer <- "160778"
  copyLayer <- loadEntity(idCopyLayer)
  metabricTrainingData$copyData <- copyLayer$objects[[1]]
  
  idClinicalFeaturesLayer <- "160780"
  clinicalFeaturesLayer <- loadEntity(idClinicalFeaturesLayer)
  metabricTrainingData$clinicalFeaturesData <- clinicalFeaturesLayer$objects[[1]]@data
  
  idClinicalSurvLayer <- "160782"
  clinicalSurvLayer <- loadEntity(idClinicalSurvLayer)
  metabricTrainingData$clinicalSurvData <- clinicalSurvLayer$objects[[1]]
  
  return(metabricTrainingData)
}

## Process test data files to create submission templates
## and scoring
## 
## This is scratch code to preserve the steps I took to
## create the files used by the scoring code in
## validate_and_score.R  -chris
############################################################

ROSMAP.MMSE <- read.csv('data/answers/ROSMAP.MMSE.csv', stringsAsFactors=FALSE)
id.tr <- data.frame(id=ROSMAP.MMSE$id, projid=as.integer(gsub("(MAP|ROS)0*", "", ROSMAP.MMSE$id)), stringsAsFactors=F)

lb <- read.csv('/Users/chris/.synapseCache/191/582191/ADChallenge_ROSMAP_Q1_Leaderboard.csv', stringsAsFactors=F)
lb$id <- id.tr$id[match(lb$projid, id.tr$projid)]
lb <- lb[lb$fu_year==0,c(9,3,4,5,6,7,8)]

ROSMAP.MMSE$Subject = as.integer(gsub("(ROS|MAP0*)","",ROSMAP.MMSE$id))
rosmap <- ROSMAP.MMSE[,c(ncol(ROSMAP.MMSE),1:8)]



discordance <- read.csv('/Users/chris/Documents/work/projects/alzheimers_challenge/data/answers/ROSMAP.discordance.csv')
discordance$Subject = as.integer(gsub("(ROS|MAP0*)","",discordance$id))

q1 <- rosmap[,c('Subject','MMSEbl')]
colnames(q1) <- c('Subject', 'MMSE_24')
write.table(q1, file='q1.txt', quote=F, sep='\t', row.names=F, col.names=T)

q2 <- data.frame(Subject=discordance$Subject, Rank=NA, Confidence=runif(length(discordance$Subject),0,1), Discordance=NA)
q2$Rank <- rank(1-q2$Confidence)
q2$Discordance <- ifelse(q2$Confidence > 0.5, 1, 0)
write.table(q2, file='q2.txt', quote=F, sep='\t', row.names=F, col.names=T)

## flip these bastard labels!
q2_observed <- read.table('data/scoring/q2.observed.txt', header=T, stringsAsFactors=F)
q2_observed$actual_discordance_string <- ifelse(q2_observed$actual_discordance == 1, 'discordant', 'concordant')








library(synapseClient)
synapseLogin('chris.bare')

ad_working_group_project_id <- 'syn2343636'
folder <- 'syn2773668'
eids <- c(2480744, 2480748, 2480750, 2700269, 2700271, 2700273)

#' Load test data for the metabric competition
#'
#' Loads data for gene expression, copy number, clinical covariates and clinical survival times for the test dataset
#' used to evlauate model scores.
#'
#' @param loadSurvData specifies if survival data is loaded. Should be set to false to users who do not have access
#' to validation data. Set to true for automated model evaluation harness.
#' @return a list with elements: exprData, containing an ExpressionSet of gene expression features;
#' copyData, containing an ExpressionSet of copy number features; clinicalFeaturesData, containing an
#' AnnotatedDataFrame of clinical covariates; and clinicalSurvData, if loadSurvData=TRUE, containing a Surv object
#' of survival times and censor values.
#' @author Adam Margolin
#' @export

loadMetabricTestData_federation <- function(loadSurvData=FALSE){
  metabricTestData <- list()
  
  idExpressionLayer <- "160784"
  expressionLayer <- loadEntity(idExpressionLayer)
  metabricTestData$exprData <- expressionLayer$objects[[1]]
  
  idCopyLayer <- "160786"
  copyLayer <- loadEntity(idCopyLayer)
  metabricTestData$copyData <- copyLayer$objects[[1]]
  
  idClinicalFeaturesLayer <- "160788"
  clinicalFeaturesLayer <- loadEntity(idClinicalFeaturesLayer)
  metabricTestData$clinicalFeaturesData <- clinicalFeaturesLayer$objects[[1]]@data
  
  if(loadSurvData){
    idClinicalSurvLayer <- "160790"
    clinicalSurvLayer <- loadEntity(idClinicalSurvLayer)
    metabricTestData$clinicalSurvData <- clinicalSurvLayer$objects[[1]]
  }
  
  return(metabricTestData)
}

require(MASS)
require(survival)
require(predictiveModeling)
require(randomSurvivalForest)

setRefClass(Class = "PredictiveModel")

#' DemoModel
#'
#' Simple example of an implementatiopn of a predictive model used in the package demo example and used as a baseline
#' to evaluate performance of other models. This model builds a random survival forest using clinical covariates
#' known to relate to breast cancer survival, gene expression and copy number data. It also imputes missing covariates.
#' NAs should be expected in all clinical covariates, in both training and test data sets.
#' 
#' @author Erhan Bilal
#' @export

DemoModel <- setRefClass(Class  = "DemoModel",
    contains = "PredictiveModel",
    fields   = c("rsf.model.fit"),
    methods  = list(
        initialize = function(...){
            return(.self)
        },
                                       
        customTrain = function(exprData, copyData, clinicalFeaturesData,clinicalSurvData,...) {
            if(class(clinicalSurvData) != "Surv"){
                stop("Expecting 'responseData' object of type 'Surv'")
            }
            # Extract the expression data
            exprData.exprs <- exprs(exprData)
            copyData.exprs <- exprs(copyData)          
            rowsWithoutNas <- rowSums(is.na(copyData.exprs)) == 0
            copyData.exprs <- copyData.exprs[rowsWithoutNas,]
            
            # Calculate the Genomic Instability Index
            GII <- colSums(copyData.exprs < -1 | copyData.exprs > 1) / sum(rowsWithoutNas)
            
            # Pick some relevant genes
            # Estrogen pathway genes
            ER_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1678535"),]
            PR_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1811014"),]
            # HER2 amplicon genes
            ERBB2_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1728761"),]
            GRB7_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1740762"),]
            # Immune response genes
            CXCL10_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1791759"),]
            STAT1_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1691364"),]
            GBP1_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_2148785"),]
            GZMA_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1779324"),]
            CD19_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1782704"),]            
                        
            # Merge the new features with the clinical covariates
            featureData <- cbind(clinicalFeaturesData,GII,ER_exp,PR_exp,ERBB2_exp,GRB7_exp,CXCL10_exp,STAT1_exp,
                                 GBP1_exp,GZMA_exp,CD19_exp)
            
            survTime <- clinicalSurvData[,1]
            survStatus <- clinicalSurvData[,2]          
            
            # Fit a random survival forest with tree based imputation of NAs in the clinical covariates
            .self$rsf.model.fit <- rsf(Surv(time,status) ~ age_at_diagnosis + size + lymph_nodes_positive + grade + 
                                       ER_IHC_status + HER2_SNP6_state + Treatment + ER.Expr + PR.Expr + GII + 
                                       CXCL10_exp + STAT1_exp + GBP1_exp + GZMA_exp + CD19_exp, 
                                       data=data.frame(featureData,time=survTime,status=survStatus), 
                                       ntree=1000, na.action="na.impute", splitrule="logrank", nsplit=1, 
                                       importance="randomsplit", seed=-1)
                                                     
                                         
        },
                                       
        customPredict = function(exprData, copyData, clinicalFeaturesData){
            exprData.exprs <- exprs(exprData)
            copyData.exprs <- exprs(copyData)
            rowsWithoutNas <- rowSums(is.na(copyData.exprs)) == 0
            copyData.exprs <- copyData.exprs[rowsWithoutNas,]
            
            # Calculate the Genomic Instability Index
            GII <- colSums(copyData.exprs < -1 | copyData.exprs > 1) / sum(rowsWithoutNas)
            # Estrogen pathway genes
            ER_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1678535"),]
            PR_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1811014"),]
            # HER2 amplicon genes
            ERBB2_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1728761"),]
            GRB7_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1740762"),]
            # Immune response genes
            CXCL10_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1791759"),]
            STAT1_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1691364"),]
            GBP1_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_2148785"),]
            GZMA_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1779324"),]
            CD19_exp <- exprData.exprs[which(rownames(exprData.exprs) == "ILMN_1782704"),]            
            
            featureData <- cbind(clinicalFeaturesData,GII,ER_exp,PR_exp,ERBB2_exp,GRB7_exp,CXCL10_exp,STAT1_exp,
                                 GBP1_exp,GZMA_exp,CD19_exp)
            
            predictedResponse <- predict(object=.self$rsf.model.fit, na.action="na.impute", test=featureData)$mortality
            return(predictedResponse)
        }
    )
)

#' Plot a heatmap displaying predictive features selected by a regression model.
#'
#' Plots a heatmap displaying selected features, with regression weights displayed to the left of each feature, and 
#' response values displayed below the feature heatmap.
#'
#' @author Adam Margolin
#' @export

plotPredictiveModelHeatmap <- 
		function(coefs, featureData, responseData, featureNames=NULL, featurePerc=NULL,
				responseLabel="", suffix, outputFile = NULL, heatmapThresh=3, responseName="sensitivity", cex.factor=1) 
{
	if(is.null(outputFile)) {
    		x11(width=11, height=10)
    } else {
      if(grepl('pdf$', outputFile, perl=TRUE)) {
            pdf(file = outputFile, width = 11, height = 10)
      } else {
            jpeg(file = outputFile, width=11, height=10, units='in', res=600)
	  }   
	}
  
  if(is.matrix(responseData)){
      message("Error: responseData must be a vector")
#     if(nrow(responseData) != 1){
#       message("Error: if responseData is a matrix it must contain 1 row")
#     }else{
#       responseData_tmp <- responseData
#       responseData <- as.numeric(responseData)
#       names(responseData) <- rownames(responseData_tmp)
#     }
  }
	
	isNas <- is.na(responseData)
	featureData <- featureData[,!isNas]
	responseData <- responseData[!isNas]
	featureData <- t(scale(t(featureData)))
	
	redblue.colors <- colorRampPalette(c("#67001F", "#B2182B", "#D6604D", "#F4A582", "#FDDBC7",
					"#F7F7F7", "#D1E5F0", "#92C5DE", "#4393C3", "#2166AC", "#053061"))
	
	## coefss
	#coefs <- eNet$beta
	
	coefs <- coefs[coefs != 0 & !is.na(coefs)]
	coefs <- coefs[order(coefs)]
	
	if (NROW(coefs)>50) {
		## 100 first coefss
		coefs100idx <- which(abs(coefs)>=sort(abs(coefs), decreasing=TRUE)[50])
		coefs <- coefs[coefs100idx]
	}
	
	## unscale factors back to binary values
	for (row in which(apply(featureData, 1, function(x) length(unique(x)))==2)) {
		featureData[row,] <- heatmapThresh * (as.numeric(factor(featureData[row,]))-1)
	}
	
	features <- names(coefs)
	if (!is.null(featureNames)){
		hmLabels <- featureNames
	}else{
		hmLabels <- features
	}
	
	if (is.null(featurePerc)) {
		barplotcol <- "darkblue"
	} else {
		## barplotcol <- as.character(lapply(as.numeric(featurePerc)^2, function(n) rgb(0,0,139,(n*256), maxColorValue=256)))
		barplotcol <- unlist(lapply(as.numeric(featurePerc)^2, function(x) rgb(colorRamp(c("#E2E2F2", "darkblue"))(x), maxColorValue=255)))
	}
	
	cl <- intersect(names(responseData), colnames(featureData))
	clustmatrix <- data.matrix(featureData[features,
					names(responseData[order(responseData[cl])]), drop=FALSE])
	
	clustmatrix[clustmatrix < -heatmapThresh] <- -heatmapThresh
	clustmatrix[clustmatrix >  heatmapThresh] <-  heatmapThresh
	
  rep.par <- par(no.readonly=TRUE)
	layout(matrix(c(1,2,0,3),2,2,byrow=TRUE), heights=c(8,1), widths=c(1,5))
	## weights barplot
	par(mar=c(2.5,.5,3.8,0), las=1, mgp=c(3,.6,0))
	plot(0, xlim=c(min(coefs, 0), max(coefs, 0)), xlab="", ylab="", type="n", axes=FALSE)
	par(usr=c(par("usr")[1:2], 0, length(coefs)))
	abline(h=c(0,length(coefs)), col="grey", lty=2, lwd=1)
	barplot(coefs, add=TRUE, horiz=TRUE, border=NA, col=barplotcol, space=0, cex.axis=.7, axes=FALSE)
	axis(1, cex.axis=.7, line=.6)
	mtext("weights", 1, line=2.2)
	## heatmap
	par(mar=c(2.5,2,3.8,11), las=1)
	image(1:ncol(clustmatrix), 1:nrow(clustmatrix), t(clustmatrix), col=rev(redblue.colors(200)), ylab="", xlab="",
			zlim=c(-heatmapThresh,heatmapThresh), main=responseName, yaxt="n", cex.main=1.5*cex.factor)
	if(nrow(clustmatrix)<4) par(yaxp=c(1, nrow(clustmatrix), max(nrow(clustmatrix)-1, 1)))
	axis(2)
	axis(4,
			at=1:length(features), labels=hmLabels,
			cex.axis=cex.factor*min((ifelse(length(features)<=130, .2, 0) + .7/log10(length(features))), 1.3),
			tick=FALSE)
	par(xpd=TRUE)
	segments(-100, par("usr")[3], par("usr")[1], col="grey", lty=2, lwd=1) ; segments(-100, par("usr")[4], par("usr")[1], col="grey", lty=2, lwd=1)
	segments(par("usr")[1], par("usr")[3], par("usr")[1], -100, col="grey", lty=2, lwd=1) ; segments(par("usr")[2], par("usr")[3], par("usr")[2], -100, col="grey", lty=2, lwd=1)
	## colorscale
	par(new=TRUE, mar=c(52,46,.5,.5), mgp=c(3,.7,0), xpd=FALSE)
	image(seq(-heatmapThresh,heatmapThresh,length.out=200),1, as.matrix(seq(-heatmapThresh,heatmapThresh,length.out=200)),
			col=rev(redblue.colors(200)), axes=FALSE, xlab="", ylab="")
	axis(1, cex.axis=.7)
	## Response scatter plot
	par(mar=c(3,2,0,11), las=1, mgp=c(3,2,1), las=2, xpd=TRUE)
	plot(responseData[order(responseData[cl])], xlab="", ylab="", 
			xaxt="n", yaxt="n", cex.axis=.5, type="n", frame.plot=FALSE)
	par(usr=c(0, length(cl), par("usr")[3:4]), xpd=TRUE)
	responseVals <- responseData[order(responseData[cl])]
	abline(v=c(0, length(cl)), col="grey", lty=2, lwd=1)
	#print(responseVals)
	#responseVals <- scale(responseVals)
	#print(responseVals)
	points((1:length(cl))-.5, responseVals,
			col=unlist(lapply(scale01(responseVals), function(x) rgb(RdBlBu.ramp(x), maxColorValue=255))), cex=.9, pch=20)
	## axis(4, at=pretty(range(responseData[,cl]), n=3), labels=pretty(range(responseData[,cl]), n=3))
	axis(4)
	axis(4, at=mean(range(responseData[cl])), labels=paste(responseName, responseName, sep="\n"), tick=FALSE, line=1.8, cex.axis=1.2*cex.factor)
	par(rep.par)
	
	if(!is.null(outputFile)){
		dev.off()
	}
}

#' removes rows and or columns from a matrix that contain NA values
#'
#' @author Adam Margolin
#' @export

filterNasFromMatrix <- function(dataMatrix, filterBy = "rows"){
  if (filterBy == "rows"){
    rowsWithoutNas <- rowSums(is.na(dataMatrix)) == 0
    dataMatrix <- dataMatrix[rowsWithoutNas,]
  }else if (filterBy == "columns"){
    columnsWithoutNas <- colSums(is.na(dataMatrix)) == 0
    dataMatrix <- dataMatrix[, columnsWithoutNas]
  }else if (filterBy == "both"){
    rowsWithoutNas <- rowSums(is.na(dataMatrix)) == 0
    columnsWithoutNas <- colSums(is.na(dataMatrix)) == 0
    dataMatrix <- dataMatrix[rowsWithoutNas, columnsWithoutNas]
  }else{
    message(paste("Not filtering anything because unknown filterBy argument:", filterBy))
  }
  
  return(dataMatrix)
}

# Scatterplot Smoothers (J. Fox and S. Weisberg)

# Sept 17, 2012 moved from scatterplot.R to scatterplotSmoothers.R
# June 18, 2014 Fixed bug in gamLine so the smoother.arg link="linkname" works; thanks to Hani Christoph
# 2014-08-19: Make sure that Matrix and MatrixModels packages are available to quantregLine(). 
#             Can't substitute requireNamespace() for require() for gam and quantreg packages. John
# 2014-11-21: Added 'offset' argument with default 0:  offset= sigmaHat(model) for use with
#             marginal model plots.  Fixed spread smooths as well
# 2015-01-27: gam() and s() now imported from mgcv rqss(), qss(), and fitted.rqss() from quantreg. John

default.arg <- function(args.list, arg, default){
    if (is.null(args.list[[arg]])) default else args.list[[arg]]
}

loessLine <- function(x, y, col, log.x, log.y, spread=FALSE, smoother.args,
               draw=TRUE, offset=0) {
    lty <- default.arg(smoother.args, "lty", 1)
    lwd <- default.arg(smoother.args, "lwd", 2)
    lty.spread <- default.arg(smoother.args, "lty.spread", 2)
    lwd.spread <- default.arg(smoother.args, "lwd.spread", 1)
    span <- default.arg(smoother.args, "span", 0.5)
    family <- default.arg(smoother.args, "family", "symmetric")
    degree <- default.arg(smoother.args, "degree", 2)
    iterations <- default.arg(smoother.args, "iterations", 4)
    if (log.x) x <- log(x)
    if (log.y) y <- log(y)
    valid <- complete.cases(x, y)
    x <- x[valid]
    y <- y[valid]
    ord <- order(x)
    x <- x[ord]
    y <- y[ord]
    warn <- options(warn=-1)
    on.exit(options(warn))
# mean smooth
    fit <- try(loess(y ~ x, span=span, family=family, degree=degree,
                    control=loess.control(iterations=iterations)), silent=TRUE)
    if (class(fit)[1] != "try-error"){
            if (log.x) x <- exp(x)
            y <- if (log.y) exp(fitted(fit)) else fitted(fit)
            if(draw)lines(x, y, lwd=lwd, col=col, lty=lty) else
               out <- list(x=x, y=y)
            }
    else{ options(warn)
          warning("could not fit smooth")
          return()}
# spread smooth, if requested
    if(spread) {
        res <- residuals(fit)
        pos <- res > 0
        pos.fit <- try(loess(I(res^2) ~ x, span=span, degree=0, family=family, subset=pos,
                        control=loess.control(iterations=1)),
                        silent=TRUE)
        neg.fit <- try(loess(I(res^2) ~ x, span=span, degree=0, family=family, subset=!pos,
                        control=loess.control(iterations=1)),
                        silent=TRUE)
        if(class(pos.fit)[1] != "try-error"){
            y.pos <- if (log.y) exp(fitted(fit) + sqrt(offset^2 + predict(pos.fit, newdata=data.frame(x=x))))
                     else fitted(fit) + sqrt(offset^2 + predict(pos.fit, newdata=data.frame(x=x)))
            if(draw) {lines(x, y.pos, lwd=lwd.spread, lty=lty.spread, col=col)}
                else {out$x.pos <- x
                      out$y.pos <- y.pos}
            }
        else{ options(warn)
            warning("could not fit positive part of the spread")
            }
        if(class(neg.fit)[1] != "try-error"){
            y.neg <- if (log.y) exp(fitted(fit) - sqrt(offset^2 + predict(neg.fit, data.frame(x=x))))
                     else fitted(fit) - sqrt(offset^2 + predict(neg.fit, data.frame(x=x)))
            if(draw) lines(x, y.neg, lwd=lwd.spread, lty=lty.spread, col=col)
                 else {out$x.neg <- x
                      out$y.neg <- y.neg}
            }
        else {options(warn)
            warning("could not fit negative part of the spread") }
        }
    if(!draw) return(out)
    }


gamLine <- function(x, y, col, log.x, log.y, spread=FALSE, smoother.args,
              draw=TRUE, offset=0) {
#    if (!require("mgcv")) stop("mgcv package missing")
    lty <- default.arg(smoother.args, "lty", 1)
    lwd <- default.arg(smoother.args, "lwd", 2)
    lty.spread <- default.arg(smoother.args, "lty.spread", 2)
    lwd.spread <- default.arg(smoother.args, "lwd.spread", 1)
    fam <- default.arg(smoother.args, "family", gaussian)
    link <- default.arg(smoother.args, "link", NULL)
# June 18, 2014
    fam <- if(is.character(fam)) eval(parse(text=fam)) else fam
    link <- if(is.character(link)) make.link(link) else link
# end
    k <- default.arg(smoother.args, "k", -1)
    bs <- default.arg(smoother.args, "bs", "tp")
    if (is.character(family)) family <- eval(parse(text=family))
    weights <- default.arg(smoother.args, "weights", NULL)
    spread <- spread && identical(fam, gaussian) && is.null(link)
    if (log.x) x <- log(x)
    if (log.y) y <- log(y)
    valid <- complete.cases(x, y)
    x <- x[valid]
    y <- y[valid]
    ord <- order(x)
    x <- x[ord]
    y <- y[ord]
    w <-if (is.null(weights)) rep(1, length(y))
    else weights[valid][ord]
    warn <- options(warn=-1)
    on.exit(options(warn))
# new June 18, 2014
    fam1 <- if(is.null(link)) fam else fam(link)
    fit <- try(gam(y ~ s(x, k=k, bs=bs), weights=w, family=fam1))
# end bug fix.
    if (class(fit)[1] != "try-error"){
            if (log.x) x <- exp(x)
            y <- if (log.y) exp(fitted(fit)) else fitted(fit)
            if (draw) lines(x, y, lwd=lwd, col=col, lty=lty) else
               out <- list(x=x, y=y)
            }
    else{ options(warn)
          warning("could not fit smooth")
          return()}
    if(spread) { 
        res <- residuals(fit)
        pos <- res > 0
        pos.fit <- try(gam(I(res^2) ~ s(x, k=k, bs=bs), subset=pos), silent=TRUE)
        neg.fit <- try(gam(I(res^2) ~ s(x, k=k, bs=bs), subset=!pos), silent=TRUE)
        if(class(pos.fit)[1] != "try-error"){
            y.pos <- if (log.y) exp(fitted(fit) + sqrt(offset^2 + predict(pos.fit, data.frame(x=x))))
            else fitted(fit) + sqrt(offset^2 + predict(pos.fit, data.frame(x=x)))
            if(draw) lines(x, y.pos, lwd=lwd.spread, lty=lty.spread, col=col)
               else {out$x.pos <- x
                     out$y.pos <- y.pos}
            }
        else{ options(warn)
            warning("could not fit positive part of the spread")
            }
        if(class(neg.fit)[1] != "try-error"){
            y.neg <- if (log.y) exp(fitted(fit) - sqrt(offset^2 + predict(neg.fit, data.frame(x=x))))
            else fitted(fit) - sqrt(offset^2 + predict(neg.fit, data.frame(x=x)))
            if(draw) lines(x, y.neg, lwd=lwd.spread, lty=lty.spread, col=col)
               else {out$x.neg <- x
                     out$y.neg <- y.neg}
            }
        else {options(warn)
            warning("could not fit negative part of the spread") }
        }
    if(!draw) return(out)
    }

quantregLine <- function(x, y, col, log.x, log.y, spread=FALSE, smoother.args,
                   draw=TRUE, offset=0) {
#    if (!require("quantreg")) stop("quantreg package missing")
    if (!package.installed("Matrix")) stop("the Matrix package is missing")
    if (!package.installed("MatrixModels")) stop("the MatrixModels package is missing")
    if (!package.installed("SparseM")) stop("the SparseM package is missing")
    lty <- default.arg(smoother.args, "lty", 1)
    lwd <- default.arg(smoother.args, "lwd", 2)
    lty.spread <- default.arg(smoother.args, "lty.spread", 2)
    lwd.spread <- default.arg(smoother.args, "lwd.spread", 1)
    if (log.x) x <- log(x)
    if (log.y) y <- log(y)
    lambda <- default.arg(smoother.args, "lambda", IQR(x))
    valid <- complete.cases(x, y)
    x <- x[valid]
    y <- y[valid]
    ord <- order(x)
    x <- x[ord]
    y <- y[ord]
    if (!spread){
        fit <- rqss(y ~ qss(x, lambda=lambda))
        if (log.x)  x <- exp(x)
        y <-if (log.y) exp(fitted(fit)) else fitted(fit)
        if(draw) lines(x, y, lwd=lwd, col=col, lty=lty)  else
           out <- list(x=x, y=x)
    }
    else{
        fit <- rqss(y ~ qss(x, lambda=lambda))
        q1fit <- rqss(y ~ qss(x, lambda=lambda), tau=0.25)
        q3fit <- rqss(y ~ qss(x, lambda=lambda), tau=0.75)
        if (log.x) x <- exp(x)
        y <- if(log.y) exp(fitted(fit)) else fitted(fit)
        y.q1 <- if(log.y) exp(fitted(q1fit)) else fitted(q1fit)
        y.q3 <- if(log.y) exp(fitted(q3fit)) else fitted(q3fit)
# 11/22/14:  adjust for offset
        y.q1 <- y - sqrt( (y-y.q1)^2 + offset^2)
        y.q3 <- y + sqrt( (y-y.q3)^2 + offset^2)
        if(draw) lines(x, y, lwd=lwd, col=col, lty=lty) else
           out <- list(x=x, y=y)
        if(draw) lines(x, y.q1, lwd=lwd.spread, lty=lty.spread, col=col) else
           {out$x.neg <- x
            out$y.neg <- y.q1}
        if(draw) lines(x, y.q3, lwd=lwd.spread, lty=lty.spread, col=col) else
           {out$x.neg <- x
            out$y.neg <- y.q1}
    }
    if(!draw) return(out)
}

# 3D scatterplots and point identification via rgl

# checked in 23 December 2009 by J. Fox
# 5 January 2010: fixed axis labeling in scatter3d.formula. J. Fox
# 13 May 2010: changed default id.n to conform to showLabels
# 30 July 2010: checks for rgl
# 23 October 2010: added surface.alpha and ellipsoid.alpha arguments
# 2012-03-02: fixed some argument abbreviations. J. Fox
# 2013-02-20: fixed error message, docs for surface.col argument. J. Fox
# 2013-08-20: changed rgl:::rgl.projection to rgl::rgl.projection; more such fixes to come. J. Fox
# 2013-08-31: rgl functions used now exported; got rid of ::: and ::. J. Fox
# 2014-08-04: changed name of identify3d() to Identify3d(). J. Fox
# 2014-08-17: added calls to requireNamespace and :: as needed. J. Fox
# 2014-09-04: J. Fox: empty groups produce warning rather than error

scatter3d <- function(x, ...){
	if (!requireNamespace("rgl")) stop("rgl package missing")
	UseMethod("scatter3d")
}

scatter3d.formula <- function(formula, data, subset, radius, xlab, ylab, zlab, labels, ...){
	na.save <- options(na.action=na.omit)
	on.exit(options(na.save))
	m <- match.call(expand.dots=FALSE)
	if (is.matrix(eval(m$data, sys.frame(sys.parent())))) 
		m$data <- as.data.frame(data)
	m$na.action <- na.pass
	m$labels <- m$xlab <- m$ylab <- m$zlab <- m$... <- NULL
	m[[1]] <- as.name("model.frame")
	formula <- as.character(c(formula))
	formula <- as.formula(sub("\\|", "+", formula))
	m$formula <- formula
	X <- eval(m, parent.frame())
	if ("(radius)" %in% names(X)){
		radius <- X[, "(radius)"]
		X <- X[, names(X) != "(radius)"]
	}
	else radius <- 1
	names <- names(X)
	if (missing(xlab)) xlab <- names[2]
	if (missing(ylab)) ylab <- names[1]
	if (missing(zlab)) zlab <- names[3]
	if (missing(labels)) labels <- rownames(X)
	if (ncol(X) == 3) 
		scatter3d(X[,2], X[,1], X[,3], xlab=xlab, ylab=ylab, zlab=zlab, labels=labels, radius=radius, ...)
	else if (ncol(X) == 4) 
		scatter3d(X[,2], X[,1], X[,3], groups=X[,4], xlab=xlab, ylab=ylab, zlab=zlab, labels=labels, radius=radius, ...)
	else stop("incorrect scatter3d formula")
}

scatter3d.default <- function(x, y, z,
		xlab=deparse(substitute(x)), ylab=deparse(substitute(y)),
		zlab=deparse(substitute(z)), axis.scales=TRUE, revolutions=0, bg.col=c("white", "black"),
		axis.col=if (bg.col == "white") c("darkmagenta", "black", "darkcyan")
				else c("darkmagenta", "white", "darkcyan"),
		surface.col=c("blue", "green", "orange", "magenta", "cyan", "red", "yellow", "gray"),
		surface.alpha=0.5,
		neg.res.col="red", pos.res.col="green",
		square.col=if (bg.col == "white") "black" else "gray", point.col="yellow",
		text.col=axis.col, grid.col=if (bg.col == "white") "black" else "gray",
		fogtype=c("exp2", "linear", "exp", "none"),
		residuals=(length(fit) == 1), surface=TRUE, fill=TRUE, grid=TRUE, grid.lines=26,
		df.smooth=NULL, df.additive=NULL,
		sphere.size=1, radius=1, threshold=0.01, speed=1, fov=60, 
		fit="linear", groups=NULL, parallel=TRUE, ellipsoid=FALSE, level=0.5, ellipsoid.alpha=0.1,
		id.method=c("mahal", "xz", "y", "xyz", "identify", "none"), 
		id.n=if (id.method == "identify") Inf else 0,
		labels=as.character(seq(along=x)), offset = ((100/length(x))^(1/3)) * 0.02,
		model.summary=FALSE, ...){
	if (!requireNamespace("rgl")) stop("rgl package missing")
	if (!requireNamespace("mgcv")) stop("mgcv package missing")
	id.method <- match.arg(id.method)
	if (residuals == "squares"){
		residuals <- TRUE
		squares <- TRUE
	}
	else squares <- FALSE
	summaries <- list()
	if ((!is.null(groups)) && (nlevels(groups) > length(surface.col)))
		stop(sprintf("Number of groups (%d) exceeds number of colors (%d)",
				nlevels(groups), length(surface.col)))
	if ((!is.null(groups)) && (!is.factor(groups))) stop("groups variable must be a factor")
    counts <- table(groups)
    if (any(counts == 0)){
        levels <- levels(groups)
        warning("the following groups are empty: ", paste(levels[counts == 0], collapse=", "))
        groups <- factor(groups, levels=levels[counts != 0])
    }
	bg.col <- match.arg(bg.col)
	fogtype <- match.arg(fogtype)
	if ((length(fit) > 1) && residuals && surface)
		stop("cannot plot both multiple surfaces and residuals")
	xlab  # cause these arguments to be evaluated
	ylab
	zlab
	rgl::rgl.clear()
	rgl::rgl.viewpoint(fov=fov)
	rgl::rgl.bg(color=bg.col, fogtype=fogtype)
	if (id.method == "identify"){
		xg <- x
		yg <- y
		zg <- z
		ggroups <- groups
		glabels <- labels
	}
	valid <- if (is.null(groups)) complete.cases(x, y, z)
			else complete.cases(x, y, z, groups)
	x <- x[valid]
	y <- y[valid]
	z <- z[valid]
	labels <- labels[valid]
	minx <- min(x)
	maxx <- max(x)
	miny <- min(y)
	maxy <- max(y)
	minz <- min(z)
	maxz <- max(z)
	if (axis.scales){
		lab.min.x <- nice(minx)
		lab.max.x <- nice(maxx)
		lab.min.y <- nice(miny)
		lab.max.y <- nice(maxy)
		lab.min.z <- nice(minz)
		lab.max.z <- nice(maxz)
		minx <- min(lab.min.x, minx)
		maxx <- max(lab.max.x, maxx)
		miny <- min(lab.min.y, miny)
		maxy <- max(lab.max.y, maxy)
		minz <- min(lab.min.z, minz)
		maxz <- max(lab.max.z, maxz)
		min.x <- (lab.min.x - minx)/(maxx - minx)
		max.x <- (lab.max.x - minx)/(maxx - minx)
		min.y <- (lab.min.y - miny)/(maxy - miny)
		max.y <- (lab.max.y - miny)/(maxy - miny)
		min.z <- (lab.min.z - minz)/(maxz - minz)
		max.z <- (lab.max.z - minz)/(maxz - minz)
	}
	if (!is.null(groups)) groups <- groups[valid]
	x <- (x - minx)/(maxx - minx)
	y <- (y - miny)/(maxy - miny)
	z <- (z - minz)/(maxz - minz)
	size <- sphere.size*((100/length(x))^(1/3))*0.015
	radius <- radius/median(radius)
	if (is.null(groups)){
		if (size > threshold) rgl::rgl.spheres(x, y, z, color=point.col, radius=size*radius)
		else rgl::rgl.points(x, y, z, color=point.col)
	}
	else {
		if (size > threshold) rgl::rgl.spheres(x, y, z, color=surface.col[as.numeric(groups)], radius=size*radius)
		else rgl::rgl.points(x, y, z, color=surface.col[as.numeric(groups)])
	}
	if (!axis.scales) axis.col[1] <- axis.col[3] <- axis.col[2]
	rgl::rgl.lines(c(0,1), c(0,0), c(0,0), color=axis.col[1])
	rgl::rgl.lines(c(0,0), c(0,1), c(0,0), color=axis.col[2])
	rgl::rgl.lines(c(0,0), c(0,0), c(0,1), color=axis.col[3])
	rgl::rgl.texts(1, 0, 0, xlab, adj=1, color=axis.col[1])
	rgl::rgl.texts(0, 1.05, 0, ylab, adj=1, color=axis.col[2])
	rgl::rgl.texts(0, 0, 1, zlab, adj=1, color=axis.col[3])
	if (axis.scales){
		rgl::rgl.texts(min.x, -0.05, 0, lab.min.x, col=axis.col[1])
		rgl::rgl.texts(max.x, -0.05, 0, lab.max.x, col=axis.col[1])
		rgl::rgl.texts(0, -0.1, min.z, lab.min.z, col=axis.col[3])
		rgl::rgl.texts(0, -0.1, max.z, lab.max.z, col=axis.col[3])
		rgl::rgl.texts(-0.05, min.y, -0.05, lab.min.y, col=axis.col[2])
		rgl::rgl.texts(-0.05, max.y, -0.05, lab.max.y, col=axis.col[2])
	}
	if (ellipsoid) {
		dfn <- 3
		if (is.null(groups)){
			dfd <- length(x) - 1
			ell.radius <- sqrt(dfn * qf(level, dfn, dfd))
			ellips <- ellipsoid(center=c(mean(x), mean(y), mean(z)),
					shape=cov(cbind(x,y,z)), radius=ell.radius)
			if (fill) rgl::shade3d(ellips, col=surface.col[1], alpha=ellipsoid.alpha, lit=FALSE)
			if (grid) rgl::wire3d(ellips, col=surface.col[1], lit=FALSE)
		}
		else{
			levs <- levels(groups)
			for (j in 1:length(levs)){
				group <- levs[j]
				select.obs <- groups == group
				xx <- x[select.obs]
				yy <- y[select.obs]
				zz <- z[select.obs]
				dfd <- length(xx) - 1
				ell.radius <- sqrt(dfn * qf(level, dfn, dfd))
				ellips <- ellipsoid(center=c(mean(xx), mean(yy), mean(zz)),
						shape=cov(cbind(xx,yy,zz)), radius=ell.radius)
				if (fill) rgl::shade3d(ellips, col=surface.col[j], alpha=ellipsoid.alpha, lit=FALSE)
				if (grid) rgl::wire3d(ellips, col=surface.col[j], lit=FALSE)
				coords <- ellips$vb[, which.max(ellips$vb[1,])]
				if (!surface) rgl::rgl.texts(coords[1] + 0.05, coords[2], coords[3], group,
							col=surface.col[j])
			}
		}
	}
	if (surface){
		vals <- seq(0, 1, length.out=grid.lines)
		dat <- expand.grid(x=vals, z=vals)
		for (i in 1:length(fit)){
			f <- match.arg(fit[i], c("linear", "quadratic", "smooth", "additive"))
			if (is.null(groups)){
				mod <- switch(f,
						linear = lm(y ~ x + z),
						quadratic = lm(y ~ (x + z)^2 + I(x^2) + I(z^2)),
						smooth = if (is.null(df.smooth)) mgcv::gam(y ~ s(x, z))
								else mgcv::gam(y ~ s(x, z, fx=TRUE, k=df.smooth)),
						additive = if (is.null(df.additive)) mgcv::gam(y ~ s(x) + s(z))
								else mgcv::gam(y ~ s(x, fx=TRUE, k=df.additive[1]+1) +
													s(z, fx=TRUE, k=(rev(df.additive+1)[1]+1)))
				)
				if (model.summary) summaries[[f]] <- summary(mod)
				yhat <- matrix(predict(mod, newdata=dat), grid.lines, grid.lines)
				if (fill) rgl::rgl.surface(vals, vals, yhat, color=surface.col[i], alpha=surface.alpha, lit=FALSE)
				if(grid) rgl::rgl.surface(vals, vals, yhat, color=if (fill) grid.col
									else surface.col[i], alpha=surface.alpha, lit=FALSE, front="lines", back="lines")
				if (residuals){
					n <- length(y)
					fitted <- fitted(mod)
					colors <- ifelse(residuals(mod) > 0, pos.res.col, neg.res.col)
					rgl::rgl.lines(as.vector(rbind(x,x)), as.vector(rbind(y,fitted)), as.vector(rbind(z,z)),
							color=as.vector(rbind(colors,colors)))
					if (squares){
						res <- y - fitted
						xx <- as.vector(rbind(x, x, x + res, x + res))
						yy <- as.vector(rbind(y, fitted, fitted, y))
						zz <- as.vector(rbind(z, z, z, z))
						rgl::rgl.quads(xx, yy, zz, color=square.col, alpha=surface.alpha, lit=FALSE)
						rgl::rgl.lines(xx, yy, zz, color=square.col)
					}
				}
			}
			else{
				if (parallel){
					mod <- switch(f,
							linear = lm(y ~ x + z + groups),
							quadratic = lm(y ~ (x + z)^2 + I(x^2) + I(z^2) + groups),
							smooth = if (is.null(df.smooth)) mgcv::gam(y ~ s(x, z) + groups)
									else mgcv::gam(y ~ s(x, z, fx=TRUE, k=df.smooth) + groups),
							additive = if (is.null(df.additive)) mgcv::gam(y ~ s(x) + s(z) + groups)
									else mgcv::gam(y ~ s(x, fx=TRUE, k=df.additive[1]+1) +
														s(z, fx=TRUE, k=(rev(df.additive+1)[1]+1)) + groups)
					)
					if (model.summary) summaries[[f]] <- summary(mod)
					levs <- levels(groups)
					for (j in 1:length(levs)){
						group <- levs[j]
						select.obs <- groups == group
						yhat <- matrix(predict(mod, newdata=cbind(dat, groups=group)), grid.lines, grid.lines)
						if (fill) rgl::rgl.surface(vals, vals, yhat, color=surface.col[j], alpha=surface.alpha, lit=FALSE)
						if (grid) rgl::rgl.surface(vals, vals, yhat, color=if (fill) grid.col
											else surface.col[j], alpha=surface.alpha, lit=FALSE, front="lines", back="lines")
						rgl::rgl.texts(1, predict(mod, newdata=data.frame(x=1, z=1, groups=group)), 1,
								paste(group, " "), adj=1, color=surface.col[j])
						if (residuals){
							yy <- y[select.obs]
							xx <- x[select.obs]
							zz <- z[select.obs]
							fitted <- fitted(mod)[select.obs]
							res <- yy - fitted
							rgl::rgl.lines(as.vector(rbind(xx,xx)), as.vector(rbind(yy,fitted)), as.vector(rbind(zz,zz)),
									col=surface.col[j])
							if (squares) {
								xxx <- as.vector(rbind(xx, xx, xx + res, xx + res))
								yyy <- as.vector(rbind(yy, fitted, fitted, yy))
								zzz <- as.vector(rbind(zz, zz, zz, zz))
								rgl::rgl.quads(xxx, yyy, zzz, color=surface.col[j], alpha=surface.alpha, lit=FALSE)
								rgl::rgl.lines(xxx, yyy, zzz, color=surface.col[j])
							}
						}
					}
				}
				else {
					levs <- levels(groups)
					for (j in 1:length(levs)){
						group <- levs[j]
						select.obs <- groups == group
						mod <- switch(f,
								linear = lm(y ~ x + z, subset=select.obs),
								quadratic = lm(y ~ (x + z)^2 + I(x^2) + I(z^2), subset=select.obs),
								smooth = if (is.null(df.smooth)) mgcv::gam(y ~ s(x, z), subset=select.obs)
										else mgcv::gam(y ~ s(x, z, fx=TRUE, k=df.smooth), subset=select.obs),
								additive = if (is.null(df.additive)) mgcv::gam(y ~ s(x) + s(z), subset=select.obs)
										else mgcv::gam(y ~ s(x, fx=TRUE, k=df.additive[1]+1) +
															s(z, fx=TRUE, k=(rev(df.additive+1)[1]+1)), subset=select.obs)
						)
						if (model.summary) summaries[[paste(f, ".", group, sep="")]] <- summary(mod)
						yhat <- matrix(predict(mod, newdata=dat), grid.lines, grid.lines)
						if (fill) rgl::rgl.surface(vals, vals, yhat, color=surface.col[j], alpha=surface.alpha, lit=FALSE)
						if (grid) rgl::rgl.surface(vals, vals, yhat, color=if (fill) grid.col
											else surface.col[j], alpha=surface.alpha, lit=FALSE, front="lines", back="lines")
						rgl::rgl.texts(1, predict(mod, newdata=data.frame(x=1, z=1, groups=group)), 1,
								paste(group, " "), adj=1, color=surface.col[j])
						if (residuals){
							yy <- y[select.obs]
							xx <- x[select.obs]
							zz <- z[select.obs]
							fitted <- fitted(mod)
							res <- yy - fitted
							rgl::rgl.lines(as.vector(rbind(xx,xx)), as.vector(rbind(yy,fitted)), as.vector(rbind(zz,zz)),
									col=surface.col[j])
							if (squares) {
								xxx <- as.vector(rbind(xx, xx, xx + res, xx + res))
								yyy <- as.vector(rbind(yy, fitted, fitted, yy))
								zzz <- as.vector(rbind(zz, zz, zz, zz))
								rgl::rgl.quads(xxx, yyy, zzz, color=surface.col[j], alpha=surface.alpha, lit=FALSE)
								rgl::rgl.lines(xxx, yyy, zzz, color=surface.col[j])
							}
						}
					}
				}
			}
		}
	}
	else levs <- levels(groups)
	if (id.method == "identify"){
		Identify3d(xg, yg, zg, axis.scales=axis.scales, groups=ggroups, labels=glabels, 
				col=surface.col, offset=offset)
	}
	else if (id.method != "none"){
		if (is.null(groups)) 
			showLabels3d(x, y, z, labels, id.method=id.method, id.n=id.n, col=surface.col[1])
		else {
			for (j in 1:length(levs)){
				group <- levs[j]
				select.obs <- groups == group
				showLabels3d(x[select.obs], y[select.obs], z[select.obs], labels[select.obs], 
						id.method=id.method, id.n=id.n, col=surface.col[j])
			}
		}
	}
	if (revolutions > 0) {
		for (i in 1:revolutions){
			for (angle in seq(1, 360, length.out=360/speed)) rgl::rgl.viewpoint(-angle, fov=fov)
		}
	}
	if (model.summary) return(summaries) else return(invisible(NULL))
}

# the following function is a slight modification of rgl.select3d() in the rgl package,
#   altered to pass through arguments (via ...) to rgl.select()

car.select3d <- function (...) {
  if (!requireNamespace("rgl")) stop("rgl package is missing")
	rgl::.check3d()
	rect <- rgl::rgl.select(...)
	llx <- rect[1]
	lly <- rect[2]
	urx <- rect[3]
	ury <- rect[4]
	if (llx > urx) {
		temp <- llx
		llx <- urx
		urx <- temp
	}
	if (lly > ury) {
		temp <- lly
		lly <- ury
		ury <- temp
	}
	proj <- rgl::rgl.projection()
	function(x, y, z) {
		pixel <- rgl::rgl.user2window(x, y, z, projection = proj)
		apply(pixel, 1, function(p) (llx <= p[1]) && (p[1] <=
								urx) && (lly <= p[2]) && (p[2] <= ury) && (0 <= p[3]) &&
							(p[3] <= 1))
	}
}

Identify3d  <- function (x, y, z, axis.scales=TRUE, groups = NULL, labels = 1:length(x),
		col = c("blue", "green", "orange", "magenta", "cyan", "red", "yellow", "gray"),
		offset = ((100/length(x))^(1/3)) * 0.02){
  if (!requireNamespace("rgl")) stop("rgl package is missing")
    if (!is.null(groups)){
        counts <- table(groups)
        if (any(counts == 0)){
            levels <- levels(groups)
            warning("the following groups are empty: ", paste(levels[counts == 0], collapse=", "))
            groups <- factor(groups, levels=levels[counts != 0])
        }
    }
	valid <- if (is.null(groups))
				complete.cases(x, y, z)
			else complete.cases(x, y, z, groups)
	labels <- labels[valid]
	x <- x[valid]
	y <- y[valid]
	z <- z[valid]
	groups <- groups[valid]
	minx <- min(x)
	maxx <- max(x)
	miny <- min(y)
	maxy <- max(y)
	minz <- min(z)
	maxz <- max(z)
	if (axis.scales){
		lab.min.x <- nice(minx)
		lab.max.x <- nice(maxx)
		lab.min.y <- nice(miny)
		lab.max.y <- nice(maxy)
		lab.min.z <- nice(minz)
		lab.max.z <- nice(maxz)
		minx <- min(lab.min.x, minx)
		maxx <- max(lab.max.x, maxx)
		miny <- min(lab.min.y, miny)
		maxy <- max(lab.max.y, maxy)
		minz <- min(lab.min.z, minz)
		maxz <- max(lab.max.z, maxz)
		min.x <- (lab.min.x - minx)/(maxx - minx)
		max.x <- (lab.max.x - minx)/(maxx - minx)
		min.y <- (lab.min.y - miny)/(maxy - miny)
		max.y <- (lab.max.y - miny)/(maxy - miny)
		min.z <- (lab.min.z - minz)/(maxz - minz)
		max.z <- (lab.max.z - minz)/(maxz - minz)
	}
	x <- (x - minx)/(maxx - minx)
	y <- (y - miny)/(maxy - miny)
	z <- (z - minz)/(maxz - minz)
	rgl::rgl.bringtotop()
	identified <- character(0)
	groups <- if (!is.null(groups))
				as.numeric(groups[valid])
			else rep(1, length(x))
	repeat {
		f <- car.select3d(button="right")
		which <- f(x, y, z)
		if (!any(which))
			break
		rgl::rgl.texts(x[which], y[which] + offset, z[which], labels[which],
				color = col[groups][which])
		identified <- c(identified, labels[which])
	}
	unique(identified)
}

showLabels3d <- function(x, y, z, labels,
		id.method = "identify", id.n=length(x), col=c("blue"), 
		res=y - mean(y), range.x=range(x), range.z=range(z), 
		offset = ((100/length(x))^(1/3)) * 0.02) {
  if (!requireNamespace("rgl")) stop("rgl package is missing")
	if (id.method == "none") return(NULL)
	if(id.n > 0L) {
		if (missing(labels))
			labels <- as.character(seq(along=x))
		getPoints <- function(w) {
			names(w) <- labels
			iid <- seq(length=id.n)
			ws <- w[order(-w)[iid]]
			match(names(ws), labels)
		}
		ind <-  switch(id.method,
				xz = getPoints(rowSums(qr.Q(qr(cbind(1, x, z))) ^ 2)),
				y = getPoints(abs(res)),
				xyz = union(getPoints(abs(x - mean(x))), union(abs(z - mean(z)),
								getPoints(abs(res)))),
				mahal= getPoints(rowSums(qr.Q(qr(cbind(1, x, y, z))) ^ 2)))
		rgl::rgl.texts(x[ind], y[ind] + offset, z[ind], labels[ind],
				color = col)
		return(labels[ind])
	} 
}

ellipsoid <- function(center=c(0, 0, 0), radius=1, shape=diag(3), n=30){
  if (!requireNamespace("rgl")) "rgl package is missing"
	# adapted from the shapes3d demo in the rgl package
	degvec <- seq(0, 2*pi, length.out=n)
	ecoord2 <- function(p) c(cos(p[1])*sin(p[2]), sin(p[1])*sin(p[2]), cos(p[2]))
	v <- t(apply(expand.grid(degvec,degvec), 1, ecoord2))
	v <- center + radius * t(v %*% chol(shape))
	v <- rbind(v, rep(1,ncol(v)))
	e <- expand.grid(1:(n-1), 1:n)
	i1 <- apply(e, 1, function(z) z[1] + n*(z[2] - 1))
	i2 <- i1 + 1
	i3 <- (i1 + n - 1) %% n^2 + 1
	i4 <- (i2 + n - 1) %% n^2 + 1
	i <- rbind(i1, i2, i4, i3)
	rgl::qmesh3d(v, i)
}

#' Perform cross validation on a preditive model, this model supports Cox model and predictiveModeling
#'
#' @param featureData
#' @param responseData
#' @param model either an instance of PredictiveModel or a string holding the name of one of the machine learning methods that caret supports
#' @param numFolds defaults to 5
#' @param trControl defaults to defaultTrainControl
#' @return a list of PredictiveModelPerformance one per fold
#' @seealso defaultTrainControl
#' @author Adam Margolin
#' @export
crossValidatePredictiveSurvivalModel <- function(model, exprData, copyData, clinicalFeaturesData, clinicalSurvData, numFolds = 5, ...){
    sampleNamesList <- list(colnames(exprs(exprData)), colnames(exprs(copyData), rownames(clinicalFeaturesData), rownames(clinicalSurvData)))
    commonSampleNames <- Reduce("intersect", sampleNamesList)
    
    exprData <- exprData[,commonSampleNames]
    copyData <- copyData[,commonSampleNames]
    clinicalFeaturesData <- clinicalFeaturesData[commonSampleNames,]
    clinicalSurvData <- clinicalSurvData[commonSampleNames,]
    
    #-----------------------------------------------------------------------
    # Split the data into training and test partitions
    # -----------------------------------------------------------------------
    set.seed(3)
    foldIndices <- createFolds(1:length(commonSampleNames), k=numFolds, list=TRUE)
    
    message("Training partitions")
    
    modelResults <- foreach(fold = foldIndices) %do% {
      foldModel <- model$copy()
      foldModel$customTrain(exprData[,-fold], copyData[,-fold], clinicalFeaturesData[-fold,], clinicalSurvData[-fold,])
      
      trainPerformance <- SurvivalModelPerformance$new(as.numeric(foldModel$customPredict(exprData[,-fold], copyData[,-fold], clinicalFeaturesData[-fold,])),
                                                       clinicalSurvData[-fold,])
      testPerformance <- SurvivalModelPerformance$new(as.numeric(foldModel$customPredict(exprData[,fold], copyData[,fold], clinicalFeaturesData[fold,])),
                                                      clinicalSurvData[fold,])
      return(list(trainPerformance=trainPerformance, testPerformance=testPerformance) )
    }
    
#     foldTestPredictions <- foreach(i=1:numFolds) %do% modelResults[[i]]$customPredict(exprData[,foldIndices[[i]]], 
#                                                                                       copyData[,foldIndices[[i]]], clinicalFeaturesData[foldIndices[[i]],])
#     
#     foldTrainPredictions <- foreach(i=1:numFolds) %do% modelResults[[i]]$customPredict(exprData[,-foldIndices[[i]]], 
#                                                                                        copyData[,-foldIndices[[i]]], clinicalFeaturesData[-foldIndices[[i]],])
#     
#     foldTestObservations <- foreach(i=1:numFolds) %do% clinicalSurvData[foldIndices[[i]],]
#     
#     foldTrainObservations <- foreach(i=1:numFolds) %do% clinicalSurvData[-foldIndices[[i]],]
#     
#     foldResults <- list(trainPredictions = foldTrainPredictions, trainObservations = foldTrainObservations,
#                 testPredictions = foldTestPredictions, testObservations = foldTestObservations)
#     
#     modelPerformance <- PredictiveModelPerformance$new(foldResults)
#     return(modelPerformance)
    trainPerformanceCV <- SurvivalModelPerformanceCV$new(lapply(modelResults, function(x){x$trainPerformance}))
    testPerformanceCV <- SurvivalModelPerformanceCV$new(lapply(modelResults, function(x){x$testPerformance}))
    
    return(list(trainPerformanceCV = trainPerformanceCV, testPerformanceCV = testPerformanceCV))
  }

integrationTest_aggregateFeatureData <- function () {
    library("Biobase")
    
    ## Load Data from Synapse
    idExpressionLayer <- "48344"
    expressionLayer <- loadEntity(idExpressionLayer)
    exprSet <- expressionLayer$objects$exprSet
    
    idCopyLayer <- "48339"
    copyLayer <- loadEntity(idCopyLayer)
    copySet <- copyLayer$objects$copySet
    
    idOncomapLayer <- "48341"
    oncomapLayer <- loadEntity(idOncomapLayer)
    oncomapSet <- oncomapLayer$objects$oncomapSet
    
    idSangerLayer <- "48337"
    sangerLayer <- loadEntity(idSangerLayer)
    sangerADF <- sangerLayer$objects$sangerADF
    
    checkTrue(exists('exprSet'))
    checkTrue(all(rownames(pData(exprSet)) == colnames(exprs(exprSet))))
    checkTrue(exists('copySet'))
    checkTrue(all(rownames(pData(copySet)) == colnames(exprs(copySet))))
    checkTrue(exists('oncomapSet'))
    checkTrue(all(rownames(pData(oncomapSet)) == colnames(exprs(oncomapSet))))
    checkTrue(exists('sangerADF'))
    
    checkEquals("X143B_BONE", colnames(exprs(copySet))[1])
    checkEquals(883, length(colnames(exprs(copySet))))
    
    checkEquals("X143B_BONE", colnames(exprs(exprSet))[1])
    checkEquals(807, length(colnames(exprs(exprSet))))
    checkEquals(807, length(intersect(colnames(exprs(copySet)), colnames(exprs(exprSet))))) # all are found in the larger set
    
    checkEquals("X143B_BONE", colnames(exprs(oncomapSet))[1])
    checkEquals(786, length(colnames(exprs(oncomapSet))))
    checkEquals(786, length(intersect(colnames(exprs(copySet)), colnames(exprs(oncomapSet))))) # all are found in the larger set
    
    checkEquals(760, length(Reduce('intersect', list(colnames(exprs(copySet)), colnames(exprs(exprSet)), colnames(exprs(oncomapSet))))))
    checkEquals(883, length(Reduce('union', list(colnames(exprs(copySet)), colnames(exprs(exprSet)), colnames(exprs(oncomapSet))))))
    
    checkEquals(23, ncol(pData(sangerADF)))
    checkEquals(524, nrow(pData(sangerADF)))
    checkEqualsNumeric(log10(76833.806), pData(sangerADF)['HUO3N1_BONE', 'Go_6976'])
    checkEqualsNumeric(log10(336.972), pData(sangerADF)['OVCAR8_OVARY', 'MG-132'])
    checkEqualsNumeric(log10(1.29E+00), pData(sangerADF)['ISTMEL1_SKIN', 'Docetaxel'])
}
